      program RecursiveCGR2
c --- This program uses Fuller's recursion to calculate the Clebsh-Gordon
c     coefficients. Subroutine CGR2 does it using Wigner 3j symbols.
c     In the output, lower case "a" is for Gaunt coefficients and
c     upper case "A" is for Clebsh-Gordon coefficients.

      integer m,n,mu,nu,p
      real a(0:50)
      print *,' '
      print *,'Enter n,m,nu,mu'
      read *,n,m,nu,mu
      print *,' '

      call FullerRec(m,n,-mu,nu,a)
      if (m.ge.0) x1=1.0/fac3(n+m,n-m+1)
      if (m.lt.0) x1=fac3(n-m,n+m+1)
      if (mu.ge.0) x2=fac3(nu+mu,nu-mu+1)
      if (mu.lt.0) x2=1.0/fac3(nu-mu,nu+mu+1)
      pfac=((-1)**mu)*sqrt((2*nu+1)*(2*n+1)*x1*x2/12.56637)

      print *,'n,m,nu,mu =',n,m,nu,mu
      print *,'---------------------------'
      print *,'  p     recursive a     direct a     recursive A',
     &   '    direct A'
      do 3 p=n+nu,max(abs(n-nu),abs(m-mu)),-2
        if (m-mu.ge.0) x3=fac3(p+m-mu,p-m+mu+1)
        if (m-mu.lt.0) x3=1.0/fac3(p-m+mu,p+m-mu+1)
        print *,p,a(p),gcoef(m,n,-mu,nu,p),
     &    pfac*sqrt(x3/(2*(p)+1))*a(p),cgr2(n,m,nu,mu,p,m-mu)
  3   continue
      stop 
      end
c-----------------------------------------------------------------

      Subroutine FullerRec(m,n,mu,nu,ag)
      integer m,n,mu,nu,p
      parameter (nn=50)
      real ag(0:nn),lpha

      if (m.eq.0.and.mu.eq.0) then
          CALL INITG(n,m,nu,mu,ag(n+nu),ag(n+nu-2))
          if (n.ne.nu) then
            DO P=n+nu,abs(n-nu)+4,-2
              ag(p-4)=ag(p-2)*lpha(n,nu,p-2)/lpha(n,nu,p-3)
            ENDDO
          else if (n.eq.nu) then
            DO P=n+nu,4,-2
              XNUM=FLOAT((P+2*M-2)*(P+2*N-1)*(2*N-P+3)*(P-2)*(2*P-7))
              XDNM=FLOAT((P-2*M-3)*(P+2*N-2)*(2*N-P+4)*(P-3)*(2*P-3))
	      AG(P-4)=XNUM*AG(P-2)/XDNM
            ENDDO
          end if
       return
       end if

        CALL INITG(n,m,nu,mu,ag(n+nu),ag(n+nu-2))

        if (n.eq.nu .and. m.eq.mu) then
          DO P=n+nu,abs(m+mu)+4,-2
            XNUM=FLOAT((P+2*M-2)*(P+2*N-1)*(2*N-P+3)*(P-2)*(2*P-7))
            XDNM=FLOAT((P-2*M-3)*(P+2*N-2)*(2*N-P+4)*(P-3)*(2*P-3))
            AG(P-4)=XNUM*AG(P-2)/XDNM
          ENDDO
          return
        end if

        DO 5 P=n+nu,max(abs(n-nu),abs(m+mu))+4,-2
          ip2 = mu*(p+nu)   + m*(nu+1)
          ip4 = mu*(p-nu-3) - m*(nu+1)
          afctr=A(m,n,mu,nu+1,p-1)

          IF (ABS(AFCTR).GT.1.0e-16) THEN

            IF (IP2.NE.0 .AND. IP4.NE.0) THEN
        CHI1 =AFCTR*B(M,N,MU,-NU-2,P-3)*B(M,N,MU,NU,P-4)
        CHI2A=A(M,N,MU,NU+1,P-3)*B(M,N,MU,NU,P-2)*E(M,N,MU,-NU-2,P-1)
        CHI2B=A(M,N,MU,NU+1,P-1)*B(M,N,MU,-NU-2,P-3)*E(M,N,MU,NU,P-2)
        CHI2C=A(M,N,MU,NU+1,P-1)*A(M,N,MU,NU+2,P-2)*A(M,N,MU,NU+1,P-3)
        CHI2 =CHI2A+CHI2B+((NU+1)**2-MU**2)*CHI2C
        CHI3 =A(M,N,MU,NU+1,P-3)*E(M,N,MU,-NU-2,P-1)*E(M,N,MU,NU,P)
              AG(P-4)=-(CHI2*AG(P-2)+CHI3*AG(P))/CHI1

	    ELSE 
   	      JJN=NU
	      JNU=N
  	      JM=MU
	      JMU=M
         CHI1=A(JM,JJN,JMU,JNU+1,P-1)*B(JM,JJN,JMU,-JNU-2,P-3)
     + 	      *B(JM,JJN,JMU,JNU,P-4)
         CHI2A=A(JM,JJN,JMU,JNU+1,P-3)*B(JM,JJN,JMU,JNU,P-2)
     +	      *E(JM,JJN,JMU,-JNU-2,P-1)
	 CHI2B=A(JM,JJN,JMU,JNU+1,P-1)*B(JM,JJN,JMU,-JNU-2,P-3)
     + 	      *E(JM,JJN,JMU,JNU,P-2)
	 CHI2C=A(JM,JJN,JMU,JNU+1,P-1)*A(JM,JJN,JMU,JNU+2,P-2)
     +	      *A(JM,JJN,JMU,JNU+1,P-3)
	 CHI2=CHI2A+CHI2B+((JJN+1)**2-JMU**2)*CHI2C 
         CHI3=A(JM,JJN,JMU,JNU+1,P-3)*E(JM,JJN,JMU,-JNU-2,P-1)
     + 	      *E(JM,JJN,JMU,JNU,P)
	      AG(P-4)=-(CHI2*AG(P-2)+CHI3*AG(P))/CHI1
	    ENDIF

	  ELSE IF (ABS(AFCTR).LE.1.0e-16) THEN 
            call initg(n,m,nu-1,mu,dum,dumm2)
	    XNUM1=(NU+MU)*A(M,N,MU,NU+1,P-3)*dumm2
	    XNUM2=-E(M,N,MU,-NU-1,P-2)*AG(P-2)
	    XDNM=B(M,N,MU,-NU-1,P-4)
	    AG(P-4)=(XNUM1+XNUM2)/XDNM
	  ENDIF

  5       continue
        return
        end
c---------------------------------------------------------------

      Subroutine INITG(n,m,nu,mu,annu,annum2)
      integer n,m,nu,mu,top,bot
      real fac1,fac2,fac3,fac4
      ix=max(n,nu)
      iy=min(n,nu)
      ixx=max(n-m,nu-mu)
      iyy=min(n-m,nu-mu)
      annu=fac2(2*iy-1)*fac3(ixx+iyy,ixx+1)/
     &     fac4(2*ix+2*iy-1,2*ix+1)/fac1(iyy)
      top=(n+n+nu+nu-3)*((n+nu-1)*(n*nu+m*mu*(n+n+nu+nu-1))-
     &    (m+mu)*(nu*m*(nu+nu-1)+n*mu*(n+n-1)))
      bot=(n+n-1)*(nu+nu-1)*(n+nu-m-mu)*(n+nu-m-mu-1)
      annum2=real(top)*annu/real(bot)
      return
      end
c--------------------------------------------------------------

      Function FAC1(n)
      real i,j,fac1
      i=1.0
      do 1 j=real(n),1.0,-1.0
        i=i*j
  1   continue
      fac1=i
      return
      end 
c--------------------------------------------------------------

      Function FAC2(n)
      real i,j,fac2
      i=1.0
      do 1 j=real(n),1.0,-2.0
        i=i*j
  1   continue
      fac2=i
      return
      end 
c--------------------------------------------------------------

      Function FAC3(ns,ne)
      real i,j,fac3
      i=1.0
      do 1 j=real(ns),real(ne),-1.0
        i=i*j
  1   continue
      fac3=i
      return
      end
c--------------------------------------------------------------

      Function FAC4(ns,ne)
      real i,j,fac4
      i=1.0
      do 1 j=real(ns),real(ne),-2.0
        i=i*j
  1   continue
      fac4=i
      return
      end
c--------------------------------------------------------------

      Function A(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      A=float((M-MU)*(P+1)*P-(M+MU)*(N-NU+1)*(N+NU))
      return
      end
c--------------------------------------------------------------

      Function B(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      B=float((P-M-MU+1)*(MU*(P-NU+1)-M*(NU+1))*(-N+NU+P+1)
     +       *(N+NU+P+2))/float(2*p+1)
      return
      end
c--------------------------------------------------------------

      Function E(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      E=float((P+M+MU)*(MU*(P+NU)+M*(NU+1))*(N+NU-P+1)
     +       *(N-NU+P))/float(2*p+1)
      return
      end
c----------------------------------------------------------------

      Real Function LPHA(n,nu,p)
      cp=real((n+nu+p+1)*(n-nu+p))/real(2*p+1)
      cm=real((n+nu-p+1)*(n-nu-p))/real(-2*p+1)
      LPHA=cp*cm
      return
      end
c-----------------------------------------------------------
      Function GCOEF(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      real x1,x2,x3,fac3
      if (m.ge.0) x1=fac3(n+m,n-m+1)
      if (m.lt.0) x1=1.0/fac3(n-m,n+m+1)
      if (mu.ge.0) x2=fac3(nu+mu,nu-mu+1)
      if (mu.lt.0) x2=1.0/fac3(nu-mu,nu+mu+1)
      if (m+mu.ge.0) x3=1.0/fac3(p+m+mu,p-m-mu+1)
      if (m+mu.lt.0) x3=fac3(p-m-mu,p+m+mu+1)
      gcoef=((-1)**(m+mu))*(2*p+1)*sqrt(x1*x2*x3)*
     &      ThreeJ(n,nu,p,0,0,0)*ThreeJ(n,nu,p,m,mu,-m-mu)
      return
      end
c------------------------------------------------------------

      FUNCTION CGR2(L,M,L1,M1,L2,M2)
C --- THIS SUBROUTINE GENERATES THE GAUNT COEFFICIENTS,
C     WHICH IS THE INTEGRAL OF THREE SPHERICAL HARMONICS
C     WITH THE FIRST ONE CONJUGATED.
 
      PI=3.1415927
      CGR2=(-1)**M*SQRT(FLOAT(2*L+1)*
     & FLOAT(2*L1+1)*FLOAT(2*L2+1)/4./PI)*
     & THREEJ(L,L1,L2,0,0,0)*THREEJ(L,L1,L2,-M,M1,M2)
      RETURN
      END 
c-------------------------------------------------------------

      FUNCTION THREEJ(J1,J2,J3,M1,M2,M3)
C --- THIS SUBROUTINE GENERATES THE 3-J COEFFICIENTS.
C     REF: GOTTFRIED: QUANTUM MECHANICS (VOL. 1)
 
      THREEJ=(-1)**(J1-J2-M3)/SQRT(2.*FLOAT(J3)+1.)*
     & CLGO(J1,M1,J2,M2,J3,-M3)
      RETURN
      END 
c-------------------------------------------------------------

      FUNCTION CLGO(J1,M1,J2,M2,J,M)
C --- THIS SUBROUTINE GENERATES THE CG-COEFFICIENTS. 
C     REF: M. ABRAMOWITZ, ET.AL., HANDBOOK... ETC.

      IF((J1+J2-J) .LT. 0)GOTO 100
      IF((J1-J2+J) .LT. 0)GOTO 100
      IF((-J1+J2+J) .LT. 0)GOTO 100
      IF(IABS(M1) .GT. J1)GOTO 100
      IF(IABS(M2) .GT. J2)GOTO 100
      IF(IABS(M) .GT. J)GOTO 100
      IF((M1+M2) .NE. M)GOTO 100
 
      SUM=0.
      DO 150 K=0,10000
      IF((J1+J2-J-K) .LT. 0)GOTO 200
      IF((J1-M1-K) .LT. 0)GOTO 200
      IF((J2+M2-K) .LT. 0)GOTO 200
      IF((J-J2+M1+K) .LT. 0)GOTO 150
      IF((J-J1-M2+K) .LT. 0)GOTO 150
 
      ALFAC=1/2.*(ALGAMA(FLOAT(J1+M1+1))+ALGAMA(FLOAT(J1-M1+1))+
     & ALGAMA(FLOAT(J2+M2+1))+
     & ALGAMA(FLOAT(J2-M2+1))+ALGAMA(FLOAT(J+M+1))+
     & ALGAMA(FLOAT(J-M+1)))-(ALGAMA(FLOAT(K+1))+ 
     & ALGAMA(FLOAT(J1+J2-J-K+1))+
     & ALGAMA(FLOAT(J1-M1-K+1))+ALGAMA(FLOAT(J2+M2-K+1))+
     & ALGAMA(FLOAT(J-J2+M1+K+1))+ALGAMA(FLOAT(J-J1-M2+K+1)))
 
      FAC=EXP(ALFAC)*(-1)**K
      SUM=SUM+FAC
 150  CONTINUE
 200  CONTINUE
 
      ALFO=1/2.*(ALGAMA(FLOAT(J1+J2-J+1))+ALGAMA(FLOAT(J+J1-J2+1))+
     & ALGAMA(FLOAT(J+J2-J1+1))-ALGAMA(FLOAT(J+J1+J2+2)))
      FO=EXP(ALFO)*SQRT(2.*FLOAT(J)+1.) 
      CLGO=SUM*FO
      GOTO 120
 100  CLGO=0
 120  RETURN
      END 
c-------------------------------------------------------------------

      REAL FUNCTION ALGAMA(XX)
c     from pg. 157 of "Numerical Recipes" by Press,
c     Flannery, Teukolsky, and Vettering.
      real *8 cof(6),stp,half,one,fpf,tmp,ser
      data cof,stp/76.18009173d0,-86.50532033d0,24.01409822d0,
     &   -1.231739516d0,.120858003d-2,-.536382d-5,2.50662827465d0/
      data half,one,fpf/0.5d0,1.0d0,5.5d0/
      algama0=0.0
      pi=3.1415927
      nflag=0
      if (xx .eq. 0.0) then
        algama=algama0
        go to 1000
      else if (xx .lt. 1.0) then
        xx=(-1.0)*xx+1.0
        nflag=1
      end if
      x=xx-one
      tmp=x+fpf
      tmp=(x+half)*log(tmp)-tmp
      ser=one
      do 10 j=1,6
        x=x+one
        ser=ser+cof(j)/x
 10   continue
      algama=tmp+log(stp*ser)
      if (nflag .eq. 1) then
        algama=log(pi)-algama-log(sin(pi*xx))
      end if
 1000 return
      end
