      program Circles
c --- This program divides a large circle into numerous small squares.
c     The sum of the areas of the squares = the circle's area.

      parameter (nx=50)
      real area(-nx:nx,-nx:nx),xc(-nx:nx,-nx:nx),yc(-nx:nx,-nx:nx)
      real rho(-nx:nx,-nx:nx)
      integer lflag,rflag,tflag,bflag
      open (7,file='circleout')

      print *,' '
      print *,'Enter radius of composite circle'
      read *,rbig
 100  print *,' '
      print *,'Enter number of divisions (odd integer)'
      print *,'  Program currently set for # divisions <=',2*nx-1
      read *,ntotal
      if (real(ntotal)/2.0.eq.real(ntotal/2)) then
        print *,' '
        print *,'Total number of divisions must be an ODD INTEGER.'
        go to 100
      end if
      print *,' '     

      write(7,*)'R =',rbig
      write(7,*)'A =',3.1415927*(rbig**2)

      r=rbig/ntotal
      n=(ntotal-1)/2
      rbig2=rbig**2
      ifull=0
      iempty=0
      ipart=0

      do 1 ix=-n,n
        do 2 iy=-n,n
          area(ix,iy)=0.0
          dist1=r**2 * ((real(2*abs(ix)+1))**2+real((2*abs(iy)+1))**2)
          dist2=r**2 * ((real(2*abs(ix)-1))**2+real((2*abs(iy)-1))**2)
          if (dist1.le.rbig2) then
            area(ix,iy)=(2.0*r)**2
            xc(ix,iy)=r*real(2*ix)
            yc(ix,iy)=r*real(2*iy)
            ifull=ifull+1
          else if (dist2.ge.rbig2) then
            iempty=iempty+1
          else
            area(ix,iy)=-1.0
            ipart=ipart+1
          end if 
  2     continue
  1   continue
      print *,'Total squares :',ntotal**2
      print *,' '
      print *,'      Full squares    :',ifull,'     ',
     &        real(ifull)/real(ntotal**2)
      print *,'      Empty squares   :',iempty,'    ',
     &        real(iempty)/real(ntotal**2)
      print *,'      Partial squares :',ipart,'     ',
     &        real(ipart)/real(ntotal**2)
      write(7,*)' '
      write(7,*)'# divisions =',ntotal,'        # circles =',ntotal**2
      write(7,*)'      Full squares    :',ifull,'     ',
     &        real(ifull)/real(ntotal**2)
      write(7,*)'      Empty squares   :',iempty,'    ',
     &        real(iempty)/real(ntotal**2)
      write(7,*)'      Partial squares :',ipart,'     ',
     &        real(ipart)/real(ntotal**2)
      write(7,*)' '
      print *,' '
      print *,'Coordinates of circle centers, radaii, and areas',
     &        ' written to file "circleout".'
      print *,' '

      do 3 ix=0,n
        do 4 iy=0,n
          if (area(ix,iy).eq.-1.0) then
            xleft=r*real(2*ix-1)
            xright=r*real(2*ix+1)
            ybot=r*real(2*iy-1)
            ytop=r*real(2*iy+1)

            xbot=sqrt(rbig2-ybot**2)
            xtop=sqrt(rbig2-ytop**2)
            yleft=sqrt(rbig2-xleft**2)
            yright=sqrt(rbig2-xright**2)
     
            lflag=0
            rflag=0
            tflag=0
            bflag=0

c ---       rbig intersects side q if qflag=1
            if (ybot.le.yleft  .AND. ytop.ge.yleft)   lflag=1
            if (ybot.le.yright .AND. ytop.ge.yright)  rflag=1
            if (xleft.le.xtop  .AND. xright.ge.xtop)  tflag=1
            if (xleft.le.xbot  .AND. xright.ge.xbot)  bflag=1

            if (lflag.eq.1.AND.rflag.eq.1) then
              call Partial1(ix,iy,r,yleft,yright,
     &                      xc(ix,iy),yc(ix,iy),area(ix,iy))
            else if (lflag.eq.1.AND.bflag.eq.1) then
              call Partial2(ix,iy,r,xbot,yleft,
     &                      xc(ix,iy),yc(ix,iy),area(ix,iy))
            else if (tflag.eq.1.AND.bflag.eq.1) then
              call Partial4(ix,iy,r,xtop,xbot,
     &                      xc(ix,iy),yc(ix,iy),area(ix,iy))
            else if (tflag.eq.1.AND.rflag.eq.1) then
              call Partial3(ix,iy,r,xtop,yright,
     &                      xc(ix,iy),yc(ix,iy),area(ix,iy))
            else   
              print *,'Partial Square ',ix,iy,' did not fit one of the',
     &                ' four catagories.'
            end if

            xc(ix,-iy)=xc(ix,iy)
            xc(-ix,-iy)=-xc(ix,iy)
            xc(-ix,iy)=-xc(ix,iy)
            yc(ix,-iy)=-yc(ix,iy)
            yc(-ix,-iy)=-yc(ix,iy)
            yc(-ix,iy)=yc(ix,iy)
            area(ix,-iy)=area(ix,iy)
            area(-ix,-iy)=area(ix,iy)
            area(-ix,iy)=area(ix,iy)
          end if
  4     continue
  3   continue

      sum=0.0
      write(7,*)' Grid  Point           Coordinate'
      write(7,*)' -----------        ----------------'
      write(7,*)'   x     y          x              y             ',
     &          'rho             area'
      write(7,*)'  ---   ---        ---            ---            ',
     &          '---             ----'
      do 5 ix=-n,n
        do 6 iy=-n,n
          rho(ix,iy)=sqrt(area(ix,iy)/3.1415927)
          if (area(ix,iy).eq.0.) go to 6
          write(7,*)ix,'  ',iy,'    ',xc(ix,iy),'    ',yc(ix,iy),
     &              '    ',rho(ix,iy),'     ',area(ix,iy)
          sum=sum+area(ix,iy)
  6     continue
  5   continue
      write(7,*)' '
      write(7,*)'Large circle radius =',rbig
      abig=3.1415927*rbig**2
      write(7,*)'Large circle area   =',abig
      write(7,*)' '
      write(7,*)'Total area of the ',ntotal**2,' squares =',sum
      write(7,*)'  ',ntotal**2-iempty,' contributed to total area'
      write(7,*)'  ',iempty,' were completely outside large circle'
      write(7,*)' '
      write(7,*)'Area Percent Error =',(abig-sum)/sum*100.0
  10  continue
      stop
      end
c--------------------------------------------------------------------
      Subroutine Partial1(ix,iy,r,yl,yr,xcm,ycm,area)
c --- left side and right side intersected by large circle
      xk=r*real(2*ix-1)
      yk=r*real(2*iy-1)
      xq=r*real(2*ix+1)
 
      xa=(xk+xq)/2.0
      ya=(yk+yr)/2.0
      a1=(xq-xk)*(yr-yk)
      if (ix.ne.0) then
        xb=(2.0*xk+xq)/3.0
        yb=(2.0*yr+yl)/3.0
        a2=0.5*(xq-xk)*(yl-yr)
      else
        xb=0.0
        yb=(2.0*yr+r*real(2*iy+1))/3.0
        a2=r*(r*real(2*iy+1)-yr)
      end if
      area=a1+a2

      xcm=(xa*a1+xb*a2)/area
      ycm=(ya*a1+yb*a2)/area
      return
      end
c--------------------------------------------------------------------

      Subroutine Partial2(ix,iy,r,xb,yl,xcm,ycm,area)
c --- bottom and left side intersected by large circle
      xk=r*real(2*ix-1)
      yk=r*real(2*iy-1)
      xcm=(2.0*xk+xb)/3.0
      ycm=(2.0*yk+yl)/3.0
      area=0.5*(xb-xk)*(yl-yk)
      return
      end
c--------------------------------------------------------------------
 
      Subroutine Partial3(ix,iy,r,xt,yr,xcm,ycm,area)
c --- top and right side intersected by large circle
      xk=r*real(2*ix-1)
      yk=r*real(2*iy-1)
      yl=r*real(2*iy+1)
      xq=r*real(2*ix+1)
 
      a1=(xt-xk)*(yr-yk)
      a2=(xt-xk)*(yl-yr)
      a3=(xq-xt)*(yr-yk)
      a4=0.5*(xq-xt)*(yl-yr)
      area=a1+a2+a3+a4

      xa=(xk+xt)/2.0
      ya=(yr+yk)/2.0
      xb=xa
      yb=(yl+yr)/2.0
      xc=(xq+xt)/2.0
      yc=ya
      xd=(2.0*xt+xq)/3.0
      yd=(2.0*yr+yl)/3.0

      xcm=(xa*a1+xb*a2+xc*a3+xd*a4)/area
      ycm=(ya*a1+yb*a2+yc*a3+yd*a4)/area
      return
      end
c--------------------------------------------------------------------
       
      Subroutine Partial4(ix,iy,r,xt,xb,xcm,ycm,area)
c --- top and bottom intersected by large circle
      xk=r*real(2*ix-1)
      yk=r*real(2*iy-1)
      yl=r*real(2*iy+1)
 
      xa=(xk+xt)/2.0
      ya=(yk+yl)/2.0

      a1=(xt-xk)*(yl-yk)
      if (iy.ne.0) then
        xc=(2.0*xt+xb)/3.0
        yc=(2.0*yk+yl)/3.0
        a2=0.5*(xb-xt)*(yl-yk)
      else
        xc=(2.0*xt+r*real(2*ix+1))/3.0
        yc=0.0
        a2=r*(r*real(2*ix+1)-xt)
      end if
      area=a1+a2

      xcm=(xa*a1+xc*a2)/area
      ycm=(ya*a1+yc*a2)/area
      return
      end
