      program FullerRec
c --- Dr. Fuller sent me the basics of this program.
c     I have changed it to suit our purposes.

      integer m,n,mu,nu,p
      real ag(0:200),lpha
      open(7,file='fullout')

c --- i1 counts number of Gaunt coefficients calculated without any zeros.
c --- i24 counts number of p2 and p4 zeros encountered
c --- i5 counts number of p5 zeros encountered
      i1=2
      i24=0
      i5=0

      print *,'Enter n,m,nu,mu'
      read *,n,m,nu,mu       

c --- Calculate starting values for recursion: a(p=n+nu) & a(p=n+nu-2).
      CALL INITG(n,m,nu,mu,ag(n+nu),ag(n+nu-2))

c --- If m=mu=0 can use z-translation simplification from Bruning & Lo.
      if(m.eq.0.and.mu.eq.0.and.n.ne.nu) then
        DO P=n+nu,abs(n-nu)+4,-2
          ag(p-4)=ag(p-2)*lpha(n,nu,p-2)/lpha(n,nu,p-3)
        ENDDO
        stop
      end if

c --- If n=nu and m=mu can use 2 term recursion: Eq(77) in Fuller's thesis.
      if (n.eq.nu .and. m.eq.mu) then
        DO P=n+nu,abs(m+mu)+4,-2
          XNUM=FLOAT((P+2*M-2)*(P+2*N-1)*(2*N-P+3)*(P-2)*(2*P-7))
          XDNM=FLOAT((P-2*M-3)*(P+2*N-2)*(2*N-P+4)*(P-3)*(2*P-3))
          AG(P-4)=XNUM*AG(P-2)/XDNM
        ENDDO
        stop
      end if

c --- Start general recursion.
      DO 1 P=n+nu,max(abs(n-nu),abs(m+mu))+4,-2
        ip2 = mu*(p+nu)   + m*(nu+1)
        ip4 = mu*(p-nu-3) - m*(nu+1)
        afctr=A(m,n,mu,nu+1,p-1)

c --- AFCTR is the A in the first coefficient of Fuller.
c --- If we have not hit any of the zeros of the first coefficient...
        IF (ABS(AFCTR).GT.1.0e-16) THEN

c --- If we have not hit a p2 or p4 zero...
          IF (IP2.NE.0 .AND. IP4.NE.0) THEN
            CHI1 =AFCTR*B(M,N,MU,-NU-2,P-3)*B(M,N,MU,NU,P-4)
            CHI2A=A(M,N,MU,NU+1,P-3)*B(M,N,MU,NU,P-2)*
     &            E(M,N,MU,-NU-2,P-1)
            CHI2B=A(M,N,MU,NU+1,P-1)*B(M,N,MU,-NU-2,P-3)*
     &            E(M,N,MU,NU,P-2)
            CHI2C=A(M,N,MU,NU+1,P-1)*A(M,N,MU,NU+2,P-2)*
     &            A(M,N,MU,NU+1,P-3)
            CHI2 =CHI2A+CHI2B+((NU+1)**2-MU**2)*CHI2C
            CHI3 =A(M,N,MU,NU+1,P-3)*E(M,N,MU,-NU-2,P-1)*E(M,N,MU,NU,P)
            AG(P-4)=-(CHI2*AG(P-2)+CHI3*AG(P))/CHI1
            i1=i1+1

c --- If we have hit a p2 or p4 zero, interchange (n,m) and (nu,mu).
          ELSE 
          i24=i24+1

c --- Check to see if interchanging indices moves from p2 to p4 or vice versa.
c     If so, then calculate Gaunt coefficient directly.
c     See Chapter 2, Eq(62) in my thesis.
          if (m*m*(nu+1)+mu*mu*(n+1)+m*mu*(n+nu+3).eq.0) then
            ag(p-4)=gcoef(m,n,mu,nu,p-4)
            go to 1
          end if

   	    JJN=NU
	    JNU=N
  	    JM=MU
	    JMU=M
            CHI1=A(JM,JJN,JMU,JNU+1,P-1)*B(JM,JJN,JMU,-JNU-2,P-3)
     + 	      *B(JM,JJN,JMU,JNU,P-4)
            CHI2A=A(JM,JJN,JMU,JNU+1,P-3)*B(JM,JJN,JMU,JNU,P-2)
     +	      *E(JM,JJN,JMU,-JNU-2,P-1)
	    CHI2B=A(JM,JJN,JMU,JNU+1,P-1)*B(JM,JJN,JMU,-JNU-2,P-3)
     + 	      *E(JM,JJN,JMU,JNU,P-2)
	    CHI2C=A(JM,JJN,JMU,JNU+1,P-1)*A(JM,JJN,JMU,JNU+2,P-2)
     +	      *A(JM,JJN,JMU,JNU+1,P-3)
c           CHI2=CHI2A+CHI2B+((JJN+1)**2-JMU**2)*CHI2C 
	    CHI2=CHI2A+CHI2B+((JNU+1)**2-JMU**2)*CHI2C 
            CHI3=A(JM,JJN,JMU,JNU+1,P-3)*E(JM,JJN,JMU,-JNU-2,P-1)
     + 	      *E(JM,JJN,JMU,JNU,P)
	    AG(P-4)=-(CHI2*AG(P-2)+CHI3*AG(P))/CHI1
          ENDIF

c --- If we hit a p5 zero, we must deviate from the recursion in p.
c     Use Eq(82) in Fuller's thesis.
        ELSE IF (ABS(AFCTR).LE.1.0e-16) THEN 
          i5=i5+1
          call initg(n,m,nu-1,mu,dum,dumm2)
          XNUM1=(NU+MU)*A(M,N,MU,NU+1,P-3)*dumm2
          XNUM2=-E(M,N,MU,-NU-1,P-2)*AG(P-2)
          XDNM=B(M,N,MU,-NU-1,P-4)
          AG(P-4)=(XNUM1+XNUM2)/XDNM
        ENDIF

 1    continue

      i2=0
      write(7,*)'  m  n  mu  nu  p      Fuller       Direct'
      write(7,*)'  -  -  --  --  -      ------       ------'
      DO 2 P=n+nu,max(abs(n-nu),abs(m+mu)),-2
        i2=i2+1
        write(7,*)m,n,mu,nu,p,ag(p),gcoef(m,n,mu,nu,p)
 2    continue

      write(7,*)' '
      write(7,*)i2-i1,' zeros were encountered while calculating the',
     &          i2,' Gaunt coefficients.'
      write(7,*)i24,' of the',i2-i1,' zeros were of the p2 or p4',
     &          ' variety.'
      write(7,*)i5,' of the',i2-i1,' zeros were of the p5 variety.'
      print *,' '
      print *,'Gaunt coefficients written to file "fullout"'
      print *,' '
      stop
      end
c---------------------------------------------------------------

      Subroutine INITG(n,m,nu,mu,annu,annum2)
c --- Calculates starting values for recursion: p=n+nu & p=n+nu-2
      integer n,m,nu,mu,top,bot
      real fac1,fac2,fac3,fac4
      ix=max(n,nu)
      iy=min(n,nu)
      ixx=max(n-m,nu-mu)
      iyy=min(n-m,nu-mu)
      annu=fac2(2*iy-1)*fac3(ixx+iyy,ixx+1)/
     &     fac4(2*ix+2*iy-1,2*ix+1)/fac1(iyy)
      top=(n+n+nu+nu-3)*((n+nu-1)*(n*nu+m*mu*(n+n+nu+nu-1))-
     &    (m+mu)*(nu*m*(nu+nu-1)+n*mu*(n+n-1)))
      bot=(n+n-1)*(nu+nu-1)*(n+nu-m-mu)*(n+nu-m-mu-1)
      if (bot.eq.0) then
        annum2=0.0
        return
      end if
      annum2=float(top)*annu/float(bot)
      return
      end
c--------------------------------------------------------------

      Function FAC1(n)
c --- Fac1(n) = n!
      real i,j,fac1
      i=1.0
      do 1 j=float(n),1.0,-1.0
        i=i*j
  1   continue
      fac1=i
      return
      end 
c--------------------------------------------------------------

      Function FAC2(n)
c --- Fac2(n) = n!!
      real i,j,fac2
      i=1.0
      do 1 j=float(n),1.0,-2.0
        i=i*j
  1   continue
      fac2=i
      return
      end 
c--------------------------------------------------------------

      Function FAC3(ns,ne)
c --- Fac3(ns,ne) = ne*(ne+1)*(ne+2)*...*(ns-1)*ns
      real i,j,fac3
      i=1.0
      do 1 j=float(ns),float(ne),-1.0
        i=i*j
  1   continue
      fac3=i
      return
      end
c--------------------------------------------------------------

      Function FAC4(ns,ne)
c --- Fac4(ns,ne) = ns*(ns-2)*(ns-4)*...*(ne+2)*ne
      real i,j,fac4
      i=1.0
      do 1 j=float(ns),float(ne),-2.0
        i=i*j
  1   continue
      fac4=i
      return
      end
c--------------------------------------------------------------

      Function A(m,n,mu,nu,p)
c --- This is capital A from Fuller's equations.
      integer m,n,mu,nu,p
      A=float((M-MU)*(P+1)*P-(M+MU)*(N-NU+1)*(N+NU))
      return
      end
c--------------------------------------------------------------

      Function B(m,n,mu,nu,p)
c --- This is capital B from Fuller's equations.
      integer m,n,mu,nu,p
      B=float((P-M-MU+1)*(MU*(P-NU+1)-M*(NU+1))*(-N+NU+P+1)
     +       *(N+NU+P+2))/float(2*p+1)
      return
      end
c--------------------------------------------------------------

      Function E(m,n,mu,nu,p)
c --- This is capital C from Fuller's equations. (using E was Fuller's idea)
      integer m,n,mu,nu,p
      E=float((P+M+MU)*(MU*(P+NU)+M*(NU+1))*(N+NU-P+1)
     +       *(N-NU+P))/float(2*p+1)
      return
      end
c----------------------------------------------------------------

      Real Function LPHA(n,nu,p)
c --- This is from Bruning & Lo's simplified z-axis translation.
c     Used when m=mu=0.
      integer n,nu,p
      cp=float((n+nu+p+1)*(n-nu+p))/float(2*p+1)
      cm=float((n+nu-p+1)*(n-nu-p))/float(-2*p+1)
      LPHA=cp*cm
      return
      end

c-----------------------------------------------------------

      Function GCOEF(m,n,mu,nu,p)
c --- Calculates Gaunt coefficients directly using Wigner 3j symbols.
      integer m,n,mu,nu,p
      real x1,x2,x3,fac3
      if (m.ge.0) x1=fac3(n+m,n-m+1)
      if (m.lt.0) x1=1.0/fac3(n-m,n+m+1)
      if (mu.ge.0) x2=fac3(nu+mu,nu-mu+1)
      if (mu.lt.0) x2=1.0/fac3(nu-mu,nu+mu+1)
      if (m+mu.ge.0) x3=1.0/fac3(p+m+mu,p-m-mu+1)
      if (m+mu.lt.0) x3=fac3(p-m-mu,p+m+mu+1)
      gcoef=((-1)**(m+mu))*(2*p+1)*sqrt(x1*x2*x3)*
     &      ThreeJ(n,nu,p,0,0,0)*ThreeJ(n,nu,p,m,mu,-m-mu)
      return
      end
c---------------------------------------------------------------
   
      REAL FUNCTION ALGAMA(XX)
c --- "Numerical Recipes" by Press,Flannery, Teukolsky, and Vettering.

      real *8 cof(6),stp,half,one,fpf,tmp,ser
      data cof,stp/76.18009173d0,-86.50532033d0,24.01409822d0,
     &   -1.231739516d0,.120858003d-2,-.536382d-5,2.50662827465d0/
      data half,one,fpf/0.5d0,1.0d0,5.5d0/
      algama0=0.0
      pi=3.1415927
      nflag=0
c     xx=-1.5
      if (xx .eq. 0.0) then
        algama=algama0
        go to 1000
      else if (xx .lt. 1.0) then
        xx=(-1.0)*xx+1.0
        nflag=1
      end if
      x=xx-one
      tmp=x+fpf
      tmp=(x+half)*log(tmp)-tmp
      ser=one
      do 10 j=1,6
        x=x+one
        ser=ser+cof(j)/x
 10   continue
      algama=tmp+log(stp*ser)
c     write(*,*) algama
      if (nflag .eq. 1) then
        algama=log(pi)-algama-log(sin(pi*xx))
      end if
c     write(*,*) algama
 1000 return
      end
C------------------------------------------------------------

      FUNCTION CGR2(L,M,L1,M1,L2,M2)
c --- THIS SUBROUTINE GENERATES THE GAUNT COEFFICIENTS, WHICH IS THE
c     INTEGRAL OF THREE SPHERICAL HARMONICS WITH THE FIRST ONE CONJUGATED.
      PI=3.1415927
      CGR2=(-1)**M*SQRT(FLOAT(2*L+1)*FLOAT(2*L1+1)*FLOAT(2*L2+1)/4./PI)*
     &     THREEJ(L,L1,L2,0,0,0)*THREEJ(L,L1,L2,-M,M1,M2)
      RETURN
      END 
C-------------------------------------------------------------

      FUNCTION THREEJ(J1,J2,J3,M1,M2,M3)
c --- GENERATES THE 3-J COEFFICIENTS. GOTTFRIED: QUANTUM MECHANICS (VOL. 1)
      THREEJ=(-1)**(J1-J2-M3)/SQRT(2.*FLOAT(J3)+1.)*
     &       CLGO(J1,M1,J2,M2,J3,-M3)
      RETURN
      END 
c-----------------------------------------------------------

      FUNCTION CLGO(J1,M1,J2,M2,J,M)
c --- THIS SUBROUTINE GENERATES THE CG-COEFFICIENTS. ABRAMOWITZ & STEGUN
      IF((J1+J2-J) .LT. 0)GOTO 100
      IF((J1-J2+J) .LT. 0)GOTO 100
      IF((-J1+J2+J) .LT. 0)GOTO 100
      IF(IABS(M1) .GT. J1)GOTO 100
      IF(IABS(M2) .GT. J2)GOTO 100
      IF(IABS(M) .GT. J)GOTO 100
      IF((M1+M2) .NE. M)GOTO 100
 
      SUM=0.

c --- The upper limit of 10000 is way too big, but that's the way it
c     was when I got this subroutine, so I've kept it.
      DO 150 K=0,10000
 
      IF((J1+J2-J-K) .LT. 0)GOTO 200
      IF((J1-M1-K) .LT. 0)GOTO 200
      IF((J2+M2-K) .LT. 0)GOTO 200
      IF((J-J2+M1+K) .LT. 0)GOTO 150
      IF((J-J1-M2+K) .LT. 0)GOTO 150
 
      ALFAC=1/2.*(ALGAMA(FLOAT(J1+M1+1))+ALGAMA(FLOAT(J1-M1+1))+
     & ALGAMA(FLOAT(J2+M2+1))+
     & ALGAMA(FLOAT(J2-M2+1))+ALGAMA(FLOAT(J+M+1))+
     & ALGAMA(FLOAT(J-M+1)))-(ALGAMA(FLOAT(K+1))+ 
     & ALGAMA(FLOAT(J1+J2-J-K+1))+
     & ALGAMA(FLOAT(J1-M1-K+1))+ALGAMA(FLOAT(J2+M2-K+1))+
     & ALGAMA(FLOAT(J-J2+M1+K+1))+ALGAMA(FLOAT(J-J1-M2+K+1)))
 
      FAC=EXP(ALFAC)*(-1)**K
      SUM=SUM+FAC
 
 150  CONTINUE
 200  CONTINUE
 
      ALFO=1./2.*(ALGAMA(FLOAT(J1+J2-J+1))+ALGAMA(FLOAT(J+J1-J2+1))+
     &     ALGAMA(FLOAT(J+J2-J1+1))-ALGAMA(FLOAT(J+J1+J2+2)))
 
      FO=EXP(ALFO)*SQRT(2.*FLOAT(J)+1.) 
      CLGO=SUM*FO
      GOTO 120
 100  CLGO=0
 120  RETURN
      END 
