      program Spheres
c --- This program divides a large sphere into smaller cubes.
c     Total volume of the cubes = volume of sphere.

      parameter (nx=25)
      real xc(-nx:nx,-nx:nx,-nx:nx), yc(-nx:nx,-nx:nx,-nx:nx)
      real zc(-nx:nx,-nx:nx,-nx:nx), vol(-nx:nx,-nx:nx,-nx:nx)
      integer j(8,8)
      character resp*1
      open (7,file='sphereout')

      print *,' '
      print *,'Enter radius of composite sphere'
      read *,rbig
 100  print *,' '
      print *,'Enter number of divisions (odd integer)'
      print *,'  Program currently set for # divisions <=',2*nx+1
      read *,ntotal
      if (real(ntotal)/2.0.eq.real(ntotal/2)) then
        print *,' '
        print *,'Total number of divisions must be an ODD INTEGER.'
        go to 100
      end if
      print *,' '     
      print *,'Do you wish to create a data file containing the',
     &        ' volumes and coordinate centers of the small spheres?'
      read *,resp
      if (resp.eq.'y') then
        print *,' '
        print *,'That data file could have up to',ntotal**3+4,
     &          ' lines.'
        print *,'Do you still wish to create it?'
        read *,resp
        print *,' '
      end if

      r=rbig/ntotal
      n=(ntotal-1)/2
      rbig2=rbig**2
      ifull=0
      iempty=0
      ipart=0

      do 1 ix=-n,n
        do 2 iy=-n,n
          do 3 iz=-n,n
          vol(ix,iy,iz)=0.0
          dist1=r**2 * ((real(2*abs(ix)+1))**2+(real(2*abs(iy)+1))**2
     &                + (real(2*abs(iz)+1))**2)
          dist2=r**2 * ((real(2*abs(ix)-1))**2+(real(2*abs(iy)-1))**2
     &                + (real(2*abs(iz)-1))**2)
          if (dist1.le.rbig2) then
            vol(ix,iy,iz)=8.0*(r**3)
            xc(ix,iy,iz)=r*real(2*ix)
            yc(ix,iy,iz)=r*real(2*iy)
            zc(ix,iy,iz)=r*real(2*iz)
            ifull=ifull+1
          else if (dist2.ge.rbig2) then
            iempty=iempty+1
          else if (dist1.ge.rbig2.and.dist2.le.rbig2) then
            vol(ix,iy,iz)=-1.0
            xc(ix,iy,iz)=0.0
            yc(ix,iy,iz)=0.0
            zc(ix,iy,iz)=0.0
            ipart=ipart+1
          else
            print *,'******'
            print *,'Cube did not fit in right.'
            print *,'******'
          end if 
  3       continue
  2     continue
  1   continue

      print *,'Total cubes :',ntotal**3
      print *,' '
      print *,'      Full cubes    :',ifull,'     ',
     &        real(ifull)/real(ntotal**3)
      print *,'      Empty cubes   :',iempty,'    ',
     &        real(iempty)/real(ntotal**3)
      print *,'      Partial cubes :',ipart,'     ',
     &        real(ipart)/real(ntotal**3)
      print *,' '
      if (resp.eq.'y') then
        print *,'Volumes and coordinates of sphere centers written',
     &          ' to file "sphereout".'
        print *,' '
      end if

      do 4 ix=0,n
        do 5 iy=0,n
          do 6 iz=0,n
          if (vol(ix,iy,iz).eq.-1.0) then

            x1=r*real(2*ix+1)
            y1=r*real(2*iy-1)
            z1=r*real(2*iz-1)
            x2=r*real(2*ix-1)
            y4=r*real(2*iy+1)
            z5=r*real(2*iz+1)
           
            e12x=sqrt(rbig2-y1**2-z1**2)
            e34x=sqrt(rbig2-y4**2-z1**2)
            e56x=sqrt(rbig2-y1**2-z5**2)
            e78x=sqrt(rbig2-y4**2-z5**2)
       
            e14y=sqrt(rbig2-x1**2-z1**2)
            e23y=sqrt(rbig2-x2**2-z1**2)
            e58y=sqrt(rbig2-x1**2-z5**2)
            e67y=sqrt(rbig2-x2**2-z5**2)

            e15z=sqrt(rbig2-x1**2-y1**2)
            e26z=sqrt(rbig2-x2**2-y1**2)
            e37z=sqrt(rbig2-x2**2-y4**2)
            e48z=sqrt(rbig2-x1**2-y4**2)
           
            do 10 i=1,8
              do 11 k=1,8
                j(i,k)=0
  11          continue
  10        continue
           
            if (e12x.lt.x1.and.e12x.gt.x2) j(1,2)=1
            if (e34x.lt.x1.and.e34x.gt.x2) j(3,4)=1
            if (e56x.lt.x1.and.e56x.gt.x2) j(5,6)=1
            if (e78x.lt.x1.and.e78x.gt.x2) j(7,8)=1
   

            if (e14y.lt.y4.and.e14y.gt.y1) j(1,4)=1
            if (e23y.lt.y4.and.e23y.gt.y1) j(2,3)=1
            if (e58y.lt.y4.and.e58y.gt.y1) j(5,8)=1
            if (e67y.lt.y4.and.e67y.gt.y1) j(6,7)=1

            if (e15z.lt.z5.and.e15z.gt.z1) j(1,5)=1
            if (e26z.lt.z5.and.e26z.gt.z1) j(2,6)=1
            if (e37z.lt.z5.and.e37z.gt.z1) j(3,7)=1
            if (e48z.lt.z5.and.e48z.gt.z1) j(4,8)=1

            if (j(1,2).eq.1.and.j(3,4).eq.1.and.j(5,6).eq.1.and.
     &          j(7,8).eq.1) then
              call Vol1(ix,iy,iz,e12x,e34x,e56x,e78x,r,v,x,y,z) 
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if
              
            if (j(1,4).eq.1.and.j(2,3).eq.1.and.j(5,8).eq.1.and.
     &          j(6,7).eq.1) then
              call Vol1(iy,iz,ix,e14y,e23y,e58y,e67y,r,v,y,z,x)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(1,5).eq.1.and.j(2,6).eq.1.and.j(3,7).eq.1.and.
     &          j(4,8).eq.1) then 
              call Vol1(iz,ix,iy,e15z,e26z,e37z,e48z,r,v,z,x,y)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if
             
            if (j(5,6).eq.1.and.j(6,7).eq.1.and.j(1,2).eq.1.and.
     &          j(2,3).eq.1) then
              call Vol2(ix,iy,iz,e12x,e56x,e23y,e67y,r,v,x,y,z,1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(5,8).eq.1.and.j(1,4).eq.1.and.j(3,4).eq.1.and.
     &          j(7,8).eq.1) then
              call Vol2(ix,iy,iz,e34x,e78x,e14y,e58y,r,v,x,y,z,-1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(2,3).eq.1.and.j(1,4).eq.1.and.j(1,5).eq.1.and.
     &          j(2,6).eq.1) then
              call Vol2(iy,iz,ix,e23y,e14y,e15z,e26z,r,v,y,z,x,1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(6,7).eq.1.and.j(5,8).eq.1.and.j(3,7).eq.1.and.
     &          j(4,8).eq.1) then
              call Vol2(iy,iz,ix,e67y,e58y,e37z,e48z,r,v,y,z,x,-1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(2,6).eq.1.and.j(3,7).eq.1.and.j(1,2).eq.1.and.
     &          j(3,4).eq.1) then
              call Vol2(iz,ix,iy,e26z,e37z,e12x,e34x,r,v,z,x,y,1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(1,5).eq.1.and.j(4,8).eq.1.and.j(5,6).eq.1.and.
     &          j(7,8).eq.1) then
              call Vol2(iz,ix,iy,e15z,e48z,e56x,e78x,r,v,z,x,y,-1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(1,2).eq.1.and.j(2,3).eq.1.and.j(2,6).eq.1) then
              call Vol3(ix,iy,iz,e12x,e23y,e26z,r,v,x,y,z,1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(7,8).eq.1.and.j(5,8).eq.1.and.j(4,8).eq.1) then
              call Vol3(ix,iy,iz,e78x,e58y,e48z,r,v,x,y,z,-1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(2,6).eq.1.and.j(3,7).eq.1.and.j(1,5).eq.1.and.
     &          j(1,4).eq.1.and.j(3,4).eq.1) then
              call Vol4(ix,iy,iz,e15z,e26z,e37z,e34x,e14y,r,v,
     &          x,y,z,1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(1,5).eq.1.and.j(4,8).eq.1.and.j(3,7).eq.1.and.
     &          j(6,7).eq.1.and.j(5,6).eq.1) then
              call Vol4(ix,iy,iz,e15z,e48z,e37z,e67y,e56x,r,v,
     &          x,y,z,-1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(3,4).eq.1.and.j(1,2).eq.1.and.j(5,6).eq.1.and.
     &          j(6,7).eq.1.and.j(3,7).eq.1) then
              call Vol4(iy,iz,ix,e34x,e12x,e56x,e67y,e37z,r,v,
     &          y,z,x,1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(3,4).eq.1.and.j(7,8).eq.1.and.j(5,6).eq.1.and.
     &          j(1,5).eq.1.and.j(1,4).eq.1) then
              call Vol4(iy,iz,ix,e34x,e78x,e56x,e15z,e14y,r,v,
     &          y,z,x,-1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(6,7).eq.1.and.j(2,3).eq.1.and.j(1,4).eq.1.and.
     &          j(1,5).eq.1.and.j(5,6).eq.1) then
              call Vol4(iz,ix,iy,e67y,e23y,e14y,e15z,e56x,r,v,
     &          z,x,y,1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(3,4).eq.1.and.j(1,4).eq.1.and.j(5,8).eq.1.and.
     &          j(6,7).eq.1.and.j(3,7).eq.1) then
              call Vol4(iz,ix,iy,e67y,e58y,e14y,e34x,e37z,r,v,
     &          z,x,y,-1)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

            if (j(3,4).eq.1.and.j(5,6).eq.1.and.j(1,4).eq.1.and.
     &          j(6,7).eq.1.and.j(1,5).eq.1.and.j(3,7).eq.1) then
              call Vol5(ix,iy,iz,e34x,e56x,e14y,e67y,e15z,e37z,r,v,
     &          x,y,z)
              vol(ix,iy,iz)=v
              xc(ix,iy,iz)=x
              yc(ix,iy,iz)=y
              zc(ix,iy,iz)=z
            end if

          end if

          if (vol(ix,iy,iz).lt.0.0) then
            print *,'******'
            print *,'Volume of Cube (ix,iy,iz) = (',ix,iy,iz,') < 0'
            print *,'******'
          end if

          xc( ix, iy,-iz)= xc(ix,iy,iz)
          xc( ix,-iy, iz)= xc(ix,iy,iz)
          xc( ix,-iy,-iz)= xc(ix,iy,iz)
          xc(-ix, iy, iz)=-xc(ix,iy,iz)
          xc(-ix, iy,-iz)=-xc(ix,iy,iz)
          xc(-ix,-iy, iz)=-xc(ix,iy,iz)
          xc(-ix,-iy,-iz)=-xc(ix,iy,iz)

          yc( ix, iy,-iz)= yc(ix,iy,iz)
          yc( ix,-iy, iz)=-yc(ix,iy,iz)
          yc( ix,-iy,-iz)=-yc(ix,iy,iz)
          yc(-ix, iy, iz)= yc(ix,iy,iz)
          yc(-ix, iy,-iz)= yc(ix,iy,iz)
          yc(-ix,-iy, iz)=-yc(ix,iy,iz)
          yc(-ix,-iy,-iz)=-yc(ix,iy,iz)
     
          zc( ix, iy,-iz)=-zc(ix,iy,iz)
          zc( ix,-iy, iz)= zc(ix,iy,iz)
          zc( ix,-iy,-iz)=-zc(ix,iy,iz)
          zc(-ix, iy, iz)= zc(ix,iy,iz)
          zc(-ix, iy,-iz)=-zc(ix,iy,iz)
          zc(-ix,-iy, iz)= zc(ix,iy,iz)
          zc(-ix,-iy,-iz)=-zc(ix,iy,iz)
     
          vol( ix, iy,-iz)=vol(ix,iy,iz)
          vol( ix,-iy, iz)=vol(ix,iy,iz)
          vol( ix,-iy,-iz)=vol(ix,iy,iz)
          vol(-ix, iy, iz)=vol(ix,iy,iz)
          vol(-ix, iy,-iz)=vol(ix,iy,iz)
          vol(-ix,-iy, iz)=vol(ix,iy,iz)
          vol(-ix,-iy,-iz)=vol(ix,iy,iz)

  6       continue
  5     continue
  4   continue

      sum=0.0
      do 7 ix=-n,n
        do 8 iy=-n,n
          do 9 iz=-n,n
            if (vol(ix,iy,iz).ne.0.0) then
              sum=sum+vol(ix,iy,iz)
              if (resp.eq.'y') then
                write(7,*)ix,iy,iz,xc(ix,iy,iz),yc(ix,iy,iz),
     &                    zc(ix,iy,iz),vol(ix,iy,iz)
              end if
            end if
  9       continue
  8     continue
  7   continue

      if (resp.eq.'y') then
        write(7,*)' '
        write(7,*)'# cubes =',ntotal**3,': ',
     &  '      Full =',ifull,'    Partial =',ipart,'   Empty =',iempty
        write(7,*)' '
        write(7,*)'Percent Err. =',
     &            abs(4.18879*rbig**3-sum)/(4.18879*rbig**3)*(100.0)
      end if
      print *,'Exact Volume =',4.18879*rbig**3
      print *,' '
      print *,'Apprx Volume =',sum
      print *,' '
      print*,'Percent Err. =',abs(4.18879*rbig**3-sum)/(4.18879*rbig**3)
     &                        *(100.0)
      stop
      end
c------------------------------------------------------------------

      Subroutine Vol1(iz,ix,iy,a,b,c,d,r,v,zc,xc,yc)
      ref=r*real(2*iz-1)
      aa=a-ref
      bb=b-ref
      cc=c-ref
      dd=d-ref
      v=r*r*(aa+bb+cc+dd)
      xc=2.0*r*ix
      yc=2.0*r*iy
      zc=ref+(aa+bb+cc+dd)/8.0
      return
      end
c------------------------------------------------------------------

      Subroutine Vol2(ix,iy,iz,a,b,c,d,r,v,xc,yc,zc,n)
      if (n.eq.1) then
        refx=r*real(2*ix-1)
        refy=r*real(2*iy-1)
        aa=a-refx
        bb=b-refx
        cc=c-refy
        dd=d-refy
        v=r*(aa+bb)*(cc+dd)/4.0
        xc=refx+(aa+bb)/6.0
        yc=refy+(cc+dd)/6.0
        zc=2.0*r*real(iz)
      else
        refx=r*real(2*ix+1)
        refy=r*real(2*iy+1)
        aa=refx-a
        bb=refx-b
        cc=refy-c
        dd=refy-d
        v=8.0*(r**3)-r*(aa+bb)*(cc+dd)/4.0
        xc=refx-r-(aa+bb)/6.0
        yc=refy-r-(cc+dd)/6.0
        zc=2.0*r*real(iz)
      end if  
      return
      end
c------------------------------------------------------------------

      Subroutine Vol3(ix,iy,iz,a,b,c,r,v,xc,yc,zc,n)
      if (n.eq.1) then
        refx=r*real(2*ix-1)
        refy=r*real(2*iy-1)
        refz=r*real(2*iz-1)
        aa=a-refx
        bb=b-refy
        cc=c-refz
        v=aa*bb*cc/6.0
        xc=refx+aa/3.0
        yc=refy+bb/3.0
        zc=refz+cc/3.0
      else
        refx=r*real(2*ix+1)
        refy=r*real(2*iy+1)
        refz=r*real(2*iz+1)
        aa=refx-a
        bb=refy-b
        cc=refz-c
        v=8.0*(r**3)-aa*bb*cc/6.0
        xc=refx-r-aa/3.0
        yc=refy-r-bb/3.0
        zc=refz-r-cc/3.0
      end if
      return
      end
c------------------------------------------------------------------

      Subroutine Vol4(ix,iy,iz,ee,aa,bb,cc,dd,r,v,x,y,z,n)
      real m
      if (n.eq.1) then
        refx=r*real(2*ix-1)
        refy=r*real(2*iy-1)
        refz=r*real(2*iz-1)
        r2=2.0*r
        a=aa-refz
        b=bb-refz
        c=cc-refx
        d=dd-refy
        e=ee-refz
        capB=b/c
        capE=e/d
        m=(r2-d)/(c-r2)
        de=r2-m*c
        v1=.5*(capB*de-A*m)*(c**2-r2**2) + capB*m*(c**3-r2**3)/3.0 +
     &      capE*((m*c+de)**3 - (m*r2+de)**3)/6.0/m + A*de*(r2-c)
        v2=.5*c*r2*(2.0*A-capB*c-capE*r2)
        v=v1+v2
        x=.33333 + c/12.0/r + refx
        y=.33333 + d/12.0/r + refy
        z=.5*(b*(2.0*r-c)/c+e*(2.0*r-d)/d)
      else 
        refx=r*real(2*ix+1)
        refy=r*real(2*iy+1)
        refz=r*real(2*iz+1)
        a=refz-aa
        b=refz-bb
        c=refy-cc
        d=refx-dd
        e=refz-ee
        capB=b/c
        capE=e/d
        m=(r2-d)/(c-r2)
        de=r2-m*c
        v1=.5*(capB*de-A*m)*(c**2-r2**2) + capB*m*(c**3-r2**3)/3.0 +
     &      capE*((m*c+de)**3 - (m*r2+de)**3)/6.0/m + A*de*(r2-c)
        v2=.5*c*r2*(2.0*A-capB*c-capE*r2)
        v=8.0*(r**3)-v1-v2
        refx=r*real(2*ix-1)
        refy=r*real(2*iy-1)
        refz=r*real(2*iz-1)
        a=aa-refz
        b=bb-refz
        c=cc-refx
        d=dd-refy
        e=ee-refz
        x=.33333 + c/12.0/r + refx
        y=.33333 + d/12.0/r + refy
        z=.5*(b*(2.0*r-c)/c+e*(2.0*r-d)/d)
        x=refx+(r-x)*8.0*(r**3)/v + x
        y=refy+(r-y)*8.0*(r**3)/v + y
        z=refz+(r-z)*8.0*(r**3)/v + z
      end if
      return
      end
c------------------------------------------------------------------

      Function Vol5(ix,iy,iz,x1,x2,y1,y2,z1,z2,r,v,x,y,z)
      refx=r*real(2*ix-1)
      refy=r*real(2*iy-1)
      refz=r*real(2*iz-1)
      x11=x1-refx
      x22=x2-refx
      y11=y1-refy
      y22=y2-refy
      z11=z1-refz
      z22=z2-refz
      v1=(y22+2.0*r)*(x22+2.0*r)*(4.0*r-z11-z22)/16.0
      v2=2.0*r*r*(z11+z22)-(4.0*r-x11)*(4.0*r-y11)*(z11+z22)/16.0
      v=v1+v2
      x=refx+(x11+x22)/6.0
      y=refy+(y11+y22)/6.0
      z=refz+2.0*r/3.0
      return
      end
