
      program scalaraddrec
c --- Chew's recursion for scalar addition theorem coefficients
      parameter (nudim=50)
      complex*16 alpha,SH,alph(-1:1,0:nudim,-nudim:nudim),acheck
      complex*16 al1,al2,al3,sphank,amlt0(0:nudim,-nudim:nudim),coef
      real*8 ap,am,bp,bm,pho,theta,phi,k0,kr,costhe,cosphi,sinphi,SJ
      real*8 bess
      open (14,file='recout')
      open (15,file='recdif')
      rewind (unit=14)
      rewind (unit=15)

      print *,' '
      print*,'Enter (1) to run program to generate a series of',
     &      ' coefficients.'
      print*,'Enter (2) to run program to check a specific coefficient.'
      read *,istart
      print *,' '
      if (istart.eq.1) then
        print *,'Enter n,m, and maximum value of nu.'
        read *,ndest,mdest,numax
        mabs=iabs(mdest)
      else 
        print *,'Enter n,m, nu and mu of coefficient to check.'
        read *,nc,mc,nuc,muc
        ndest=nc
        mdest=mc
        numax=nuc
        mabs=iabs(mdest)
      end if
      print *,' '

      print *,'Enter r,theta,phi.'
      read *,pho,theta,phi
      print *,' '

      print *,'Enter wavenumber k0.'
      read *,k0
      print *,' '

      kr=k0*pho
      costhe=cos(theta)
      cosphi=cos(phi)
      sinphi=sin(phi)

c --- Calculate and store initial values of alpha (n=m=0)

      do 10 nu=0,numax+ndest
        bess=SJ(nu,kr)
        do 20 mu=-nu,nu
          sphank=SH(nu,-mu,costhe,cosphi,sinphi)
          alph(0,nu,mu)=sphank*bess*((-1.0d0)**(mu+nu))*3.544907702d0
 20     continue
 10   continue

c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.

      do 30 n=0,mabs-1
        do 40 nu=0,numax+ndest
          do 50 mu=-nu,nu
            if (abs(mu-1).le.nu-1) then
              alph(1,nu,mu)= (bp(nu-1,mu-1)*alph(0,nu-1,mu-1)+
     &                       bm(nu+1,mu-1)*alph(0,nu+1,mu-1))/bp(n,n)
            else if (abs(mu-1).gt.nu-1) then
              alph(1,nu,mu)= bm(nu+1,mu-1)*alph(0,nu+1,mu-1) /bp(n,n)
            end if
 50       continue
 40     continue
        call update(alph,nudim)
 30   continue

c --- Need to zero alpha(nu,mu,n=mabs-1,m=mabs) to begin next loop.

      do 100 nu=0,numax+ndest-mabs
        do 110 mu=-nu,nu
          alph(-1,nu,mu)=(0.0d0,0.0d0)
 110    continue
 100  continue

c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.

      do 60 n=mabs,ndest-1
       do 70 nu=0,numax+ndest-mabs
        do 80 mu=-nu,nu
         if (mabs.le.n-1)   al1=alph(-1,nu,mu)
         if (mabs.gt.n-1)   al1=(0.0d0,0.0d0)
         if (abs(mu).le.nu-1) al2=alph(0,nu-1,mu)
         if (abs(mu).gt.nu-1) al2=(0.0d0,0.0d0)
         al3=alph(0,nu+1,mu)
         alph(1,nu,mu)=( - am(n,mabs) * al1 + ap(nu-1,mu) * al2
     &                   + am(nu+1,mu) * al3) / ap(n,mabs)     
c        if (n+1.eq.nc .and. nu.eq.nuc .and. mu.eq.muc) then
c          write(15,*)'alpha(',n+1,mabs,nu,mu,') =',alph(1,nu,mu)
c          write(15,*)' direct =',
c    &                  alpha(n+1,mabs,nu,mu,pho,theta,phi,k0)
c          write(15,*)' am,al1 =',am(n,mabs),al1
c          write(15,*)' direct =',
c    &                  alpha(n-1,mabs,nu,mu,pho,theta,phi,k0)
c          write(15,*)' ap,al2 =',ap(nu-1,mu),al2
c          write(15,*)' direct =',
c    &                  alpha(n,mabs,nu-1,mu,pho,theta,phi,k0)
c          write(15,*)' am,al3 =',am(nu+1,mu),al3
c          write(15,*)' direct =',
c    &                  alpha(n,mabs,nu+1,mu,pho,theta,phi,k0)
c          write(15,*)' ap(dnm)=',ap(n,mabs)
c          write(15,*)' '
c       end if
 80      continue
 70    continue
       call update(alph,nudim)
 60   continue

c --- Adjust translation coefficients if mdest < 0.

      do 300 nu=0,numax
        do 310 mu=-nu,nu
c         if (mdest.lt.0) alph(0,nu,mu)= 
c    &                    ((-1)**(mabs-mu))*dconjg(alph(0,nu,-mu))
          if (mdest.lt.0) amlt0(nu,mu)=
     &       ((-1)**(mabs+mu))*dconjg(alph(0,nu,-mu))
 310    continue
 300  continue

c --- Write results to file called "recout".

      write(14,*)'n,m,numax   = ',ndest,mdest,numax
      write(14,*)'r,theta,phi = ',pho,theta,phi
      write(14,*)'wavenumber  = ',k0
      write(14,*)' '
      write(14,*)'First line is the recursively calculated coefficient.'
      write(14,*)'Second line is the directly calculated coefficient.'
      write(14,*)' '
   
      do 200 nu=0,numax
        do 210 mu=-nu,nu
          if (mdest.lt.0) coef=amlt0(nu,mu)
          if (mdest.ge.0) coef=alph(0,nu,mu)
          write(14,*)ndest,mdest,nu,mu,coef
c>>>>          acheck=alpha(ndest,mdest,nu,mu,pho,theta,phi,k0)
c>>>>          write(14,*)'            ',acheck
c>>>>          if (cdabs((coef-acheck)/acheck).ge.1.0d-3) then
c>>>>              write(15,*)'Trouble. (n,m,nu,mu) =',ndest,mdest,nu,mu
c>>>>              write(15,*)'           recursive =',coef
c>>>>              write(15,*)'           direct    =',acheck
c>>>>          end if
 210    continue
 200  continue

      print *,' '
      print *,'Translation coefficients written to file "recout"'
      print *,' '
      print *,'Any recursively calculated coefficients that do not',
     &        ' agree with the'
      print *,'directly calculated coefficients are written to file',
     &        ' "recdif"'
      print *,' '

      stop
      end

c----------------------------------------------------------------------

      Real*8 Function Ap(n,m)
      ap=-sqrt(dfloat(n+m+1)*dfloat(n-m+1)/dfloat(2*n+1)/dfloat(2*n+3))
      return
      end

      Real*8 Function Am(n,m)
      am=sqrt(dfloat(n+m)*dfloat(n-m)/dfloat(2*n+1)/dfloat(2*n-1))
      return
      end

      Real*8 Function Bp(n,m)
      bp=sqrt(dfloat(n+m+2)*dfloat(n+m+1)/dfloat(2*n+1)/dfloat(2*n+3))
      return
      end

      Real*8 Function Bm(n,m)
      bm=sqrt(dfloat(n-m)*dfloat(n-m-1)/dfloat(2*n+1)/dfloat(2*n-1))
      return
      end
c------------------------------------------------------------------------

      subroutine update(a,nudim)
      complex*16 a
      dimension a(-1:1,0:nudim,-nudim:nudim)
      do 1 i=0,nudim
        do 2 j=-nudim,nudim
          a(-1,i,j)=a(0,i,j)
          a(0,i,j)=a(1,i,j)
  2     continue
  1   continue
      return
      end
c------------------------------------------------------------------------

      Complex*16 Function ALPHA(n,m,nu,mu,r,theta,phi,k0)
      complex*16 psum,temp,ai
      real*8 r,theta,phi,k0,fact2a,fact2b,fac1,SJ,DRLGN1,a(0:200),gcoef
      integer n,m,nu,mu,p
      ai  =(0.0d0,1.0d0)
      psum=(0.0d0,0.0d0)
c --- Uncomment these two lines to use Fuller's Gaunt recursion.
c     As it stands now, Gaunt coefficients calculated directly in 
c     subroutine "gcoef" (to play it safe).
c     call Fuller(m,n,-mu,nu,a)
      do 3 p=n+nu,max(abs(n-nu),abs(m-mu)),-2
c       temp=(ai**(p+nu-n))*a(p)*SJ(p,k0*r)*DRLGN1(cos(theta),p,m-mu)
        temp=(ai**(p+nu-n))*gcoef(m,n,-mu,nu,p)*SJ(p,k0*r)*
     &       DRLGN1(cos(theta),p,m-mu)
        psum=psum+temp
  3   continue
      fact2a=((-1.0d0)**m)*sqrt(dfloat(2*n+1)*fac1(n-m)/fac1(n+m))
      fact2b=sqrt(dfloat(2*nu+1)*fac1(nu+mu)/fac1(nu-mu))
      alpha=psum*fact2a*fact2b*exp(ai*(m-mu)*phi)
      return
      end
c------------------------------------------------------------------------

      Subroutine Fuller(m,n,mu,nu,ag)
      integer m,n,mu,nu,p
      real*8 ag(0:200),lpha,a,b,e,gcoef,dum,dumm2,chi1,chi2,chi3
      real*8 xnum,xnum1,xnum2,xdnm,chi2a,chi2b,chi2c,afctr

      if (m.eq.0.and.mu.eq.0) then
          CALL INITG(n,m,nu,mu,ag(n+nu),ag(n+nu-2))
          if (n.ne.nu) then
            DO P=n+nu,abs(n-nu)+4,-2
              ag(p-4)=ag(p-2)*lpha(n,nu,p-2)/lpha(n,nu,p-3)
            ENDDO
          else if (n.eq.nu) then
            DO P=n+nu,4,-2
              XNUM=dFLOAT((P+2*M-2)*(P+2*N-1)*(2*N-P+3)*(P-2)*(2*P-7))
              XDNM=dFLOAT((P-2*M-3)*(P+2*N-2)*(2*N-P+4)*(P-3)*(2*P-3))
	      AG(P-4)=XNUM*AG(P-2)/XDNM
            ENDDO
          end if
       return
       end if

        CALL INITG(n,m,nu,mu,ag(n+nu),ag(n+nu-2))

        if (n.eq.nu .and. m.eq.mu) then
          DO P=n+nu,abs(m+mu)+4,-2
            XNUM=dFLOAT((P+2*M-2)*(P+2*N-1)*(2*N-P+3)*(P-2)*(2*P-7))
            XDNM=dFLOAT((P-2*M-3)*(P+2*N-2)*(2*N-P+4)*(P-3)*(2*P-3))
            AG(P-4)=XNUM*AG(P-2)/XDNM
          ENDDO
          return
        end if

        DO 5 P=n+nu,max(abs(n-nu),abs(m+mu))+4,-2
          ip2 = mu*(p+nu)   + m*(nu+1)
          ip4 = mu*(p-nu-3) - m*(nu+1)

          afctr=A(m,n,mu,nu+1,p-1)
          IF (dABS(AFCTR).GT.1.0d-16) THEN

            IF (IP2.NE.0 .AND. IP4.NE.0) THEN
        CHI1 =AFCTR*B(M,N,MU,-NU-2,P-3)*B(M,N,MU,NU,P-4)
        CHI2A=A(M,N,MU,NU+1,P-3)*B(M,N,MU,NU,P-2)*E(M,N,MU,-NU-2,P-1)
        CHI2B=A(M,N,MU,NU+1,P-1)*B(M,N,MU,-NU-2,P-3)*E(M,N,MU,NU,P-2)
        CHI2C=A(M,N,MU,NU+1,P-1)*A(M,N,MU,NU+2,P-2)*A(M,N,MU,NU+1,P-3)
        CHI2 =CHI2A+CHI2B+((NU+1)**2-MU**2)*CHI2C
        CHI3 =A(M,N,MU,NU+1,P-3)*E(M,N,MU,-NU-2,P-1)*E(M,N,MU,NU,P)
              AG(P-4)=-(CHI2*AG(P-2)+CHI3*AG(P))/CHI1

	    ELSE 
        if (m*m*(nu+1)+mu*mu*(n+1)+m*mu*(n+nu+3).eq.0) then
          ag(p-4)=gcoef(m,n,mu,nu,p-4)
          go to 5
        end if
   	      JJN=NU
	      JNU=N
  	      JM=MU
	      JMU=M
         CHI1=A(JM,JJN,JMU,JNU+1,P-1)*B(JM,JJN,JMU,-JNU-2,P-3)
     + 	      *B(JM,JJN,JMU,JNU,P-4)
         CHI2A=A(JM,JJN,JMU,JNU+1,P-3)*B(JM,JJN,JMU,JNU,P-2)
     +	      *E(JM,JJN,JMU,-JNU-2,P-1)
	 CHI2B=A(JM,JJN,JMU,JNU+1,P-1)*B(JM,JJN,JMU,-JNU-2,P-3)
     + 	      *E(JM,JJN,JMU,JNU,P-2)
	 CHI2C=A(JM,JJN,JMU,JNU+1,P-1)*A(JM,JJN,JMU,JNU+2,P-2)
     +	      *A(JM,JJN,JMU,JNU+1,P-3)
c        CHI2=CHI2A+CHI2B+((JJN+1)**2-JMU**2)*CHI2C 
	 CHI2=CHI2A+CHI2B+((JNU+1)**2-JMU**2)*CHI2C 
         CHI3=A(JM,JJN,JMU,JNU+1,P-3)*E(JM,JJN,JMU,-JNU-2,P-1)
     + 	      *E(JM,JJN,JMU,JNU,P)
	      AG(P-4)=-(CHI2*AG(P-2)+CHI3*AG(P))/CHI1
	    ENDIF

	  ELSE IF (dABS(AFCTR).LE.1.0d-16) THEN 
            call initg(n,m,nu-1,mu,dum,dumm2)
	    XNUM1=(NU+MU)*A(M,N,MU,NU+1,P-3)*dumm2
	    XNUM2=-E(M,N,MU,-NU-1,P-2)*AG(P-2)
	    XDNM=B(M,N,MU,-NU-1,P-4)
	    AG(P-4)=(XNUM1+XNUM2)/XDNM
	  ENDIF

  5       continue
        return
        end
c------------------------------------------------------------------------

	Double precision FUNCTION SJ(n,x)
        implicit double precision (d)
        real*8 db(0:100),x
        integer flag
        parameter (iacc=40)
        
c --- Small argument approximation.
        if (x.lt.0.1d0) then
          dfac=1.0d0
          do 1 i=1,2*n+1,2
            dfac=dfac*dfloat(i)
  1       continue
          SJ=(x**n)/dfac
          return
        end if

c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            SJ=sin(x)/x
            return
        end if
        if (n.eq.1) then
            SJ=sin(x)/x/x-cos(x)/x
            return
        end if
        if (n.eq.2) then
            SJ=(3.0d0/x/x-1.0d0)*sin(x)/x - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        dbessj0=cos(x)/x
        dbessj1=sin(x)/x
        if (x.gt.dfloat(n)) then
            dbjm=dbessj0
            dbj=dbessj1
            do 11 j=0,n-1
                dbjp=(2.0d0*dfloat(j)+1.)/x*dbj-dbjm
                dbjm=dbj
                dbj=dbjp
  11        continue
            SJ=dbj
        else
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            SJ=0.0d0
            db(m+1)=0.0d0
            db(m)=1.0d0
            i=0
            do 12 j=m,1,-1
                db(j-1)=(2.0d0*dfloat(j)+1.)/x*db(j)-db(j+1)
                if (dabs(db(j-1)).gt.1.d10) then
                    db(j-1)=db(j-1)*1.d-10
                    db(j)=db(j)*1.d-10
                    i=i+1
                end if
                if (j.eq.n) flag=i
  12        continue
            dr0=sin(x)/x
            if (db(0).eq.0.0d0) print *,'got 0 in SJ'
            dp=dr0/db(0)
            SJ=db(n)*dp*(1.d10)**(flag-i)
        end if
  13    return
        end
c------------------------------------------------------------------------

      Subroutine INITG(n,m,nu,mu,dannu,dannum2)
      implicit double precision (d,f)
      integer n,m,nu,mu,top,bot,ix,iy,ixx,iyy
      ix=max(n,nu)
      iy=min(n,nu)
      ixx=max(n-m,nu-mu)
      iyy=min(n-m,nu-mu)
      dannu=fac2(2*iy-1)*fac3(ixx+iyy,ixx+1)/
     &     fac4(2*ix+2*iy-1,2*ix+1)/fac1(iyy)
      top=(n+n+nu+nu-3)*((n+nu-1)*(n*nu+m*mu*(n+n+nu+nu-1))-
     &    (m+mu)*(nu*m*(nu+nu-1)+n*mu*(n+n-1)))
      bot=(n+n-1)*(nu+nu-1)*(n+nu-m-mu)*(n+nu-m-mu-1)
      if (bot.eq.0) then
        dannum2=0.0d0
        return
      end if
      dannum2=dfloat(top)*dannu/dfloat(bot)
      return
      end
c------------------------------------------------------------------------

      Real*8Function FAC1(n)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(n),1.0d0,-1.0d0
        i=i*j
  1   continue
      fac1=i
      return
      end 

      Real*8 Function FAC2(n)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(n),1.0d0,-2.0d0
        i=i*j
  1   continue
      fac2=i
      return
      end 

      Real*8 Function FAC3(ns,ne)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(ns),dfloat(ne),-1.0d0
        i=i*j
  1   continue
      fac3=i
      return
      end

      Real*8 Function FAC4(ns,ne)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(ns),dfloat(ne),-2.0d0
        i=i*j
  1   continue
      fac4=i
      return
      end
c------------------------------------------------------------------------

      Real*8 Function A(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      A=dfloat((M-MU)*(P+1)*P-(M+MU)*(N-NU+1)*(N+NU))
      return
      end

      Real*8 Function B(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      B=dfloat((P-M-MU+1)*(MU*(P-NU+1)-M*(NU+1))*(-N+NU+P+1)
     +       *(N+NU+P+2))/dfloat(2*p+1)
      return
      end

      Real*8 Function E(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      E=dfloat((P+M+MU)*(MU*(P+NU)+M*(NU+1))*(N+NU-P+1)
     +       *(N-NU+P))/dfloat(2*p+1)
      return
      end

      Real*8 Function LPHA(n,nu,p)
      real*8 cp,cm
      integer n,nu,p
      cp=dfloat((n+nu+p+1)*(n-nu+p))/dfloat(2*p+1)
      cm=dfloat((n+nu-p+1)*(n-nu-p))/dfloat(-2*p+1)
      LPHA=cp*cm
      return
      end
c------------------------------------------------------------------------

c------------------------------------------------------------------------

      Double precision FUNCTION ALGAMA(XX)
c     from pg. 157 of "Numerical Recipes" by Press,
c     Flannery, Teukolsky, and Vettering.
      real *8 cof(6),stp,half,one,fpf,tmp,ser,pi,xx,algama0,x
      integer nflag,j
      data cof,stp/76.18009173d0,-86.50532033d0,24.01409822d0,
     &   -1.231739516d0,.120858003d-2,-.536382d-5,2.50662827465d0/
      data half,one,fpf/0.5d0,1.0d0,5.5d0/
      algama0=0.0
      pi=4.0d0*atan2(1.0d0,1.0d0)
      nflag=0
      if (xx .eq. 0.0d0) then
        algama=algama0
        go to 1000
      else if (xx .lt. 1.0d0) then
        xx=-xx+1.0d0
        nflag=1
      end if
      x=xx-one
      tmp=x+fpf
      tmp=(x+half)*log(tmp)-tmp
      ser=one
      do 10 j=1,6
        x=x+one
        ser=ser+cof(j)/x
 10   continue
      algama=tmp+log(stp*ser)
      if (nflag .eq. 1) then
        algama=log(pi)-algama-log(sin(pi*xx))
      end if
 1000 return
      end
c------------------------------------------------------------------------

      Real*8 Function GCOEF(m,n,mu,nu,p)

      integer m,n,mu,nu,p
      real*8 x1,x2,x3,fac3,threej

      if (m.ge.0) x1=fac3(n+m,n-m+1)
      if (m.lt.0) x1=1.0/fac3(n-m,n+m+1)

      if (mu.ge.0) x2=fac3(nu+mu,nu-mu+1)
      if (mu.lt.0) x2=1.0/fac3(nu-mu,nu+mu+1)

      if (m+mu.ge.0) x3=1.0/fac3(p+m+mu,p-m-mu+1)
      if (m+mu.lt.0) x3=fac3(p-m-mu,p+m+mu+1)

      gcoef=((-1.0d0)**(m+mu))*dfloat(2*p+1)*sqrt(x1*x2*x3)*
     &      ThreeJ(n,nu,p,0,0,0)*ThreeJ(n,nu,p,m,mu,-m-mu)

      return
      end
c------------------------------------------------------------------------

C	THREEJ(J1,J2,J3,M1,M2,M3) 			JULY 31, 1984
C	THIS SUBROUTINE GENERATES THE 3-J COEFFICIENTS.
C	REF: GOTTFRIED:QUANTUM MECHANICS(VOL.1)
C
	Real*8 FUNCTION THREEJ(J1,J2,J3,M1,M2,M3)
        real*8 clgo
        integer j1,j2,j3,m1,m2,m3
	THREEJ=((-1.0d0)**(J1-J2-M3))/SQRT(dfloat(2*J3+1))*
     &         CLGO(J1,M1,J2,M2,J3,-M3)
	RETURN
	END
c------------------------------------------------------------------------

C	CLGO(J1,M1,J2,M2,J,M)                           AUG. 31, 1984
C	THIS SUBROUTINE GENERATES THE CG-COEFFICIENTS.
C	REF: M.ABRAMOWITZ, ET.AL. HANDBOOK.... ETC.

	Real*8 FUNCTION CLGO(J1,M1,J2,M2,J,M)
        real*8 sum,alfac,algama,alfo
        integer j,j1,j2,m,m1,m2,k
	IF((J1+J2-J).LT.0)GO TO 100
	IF((J1-J2+J).LT.0)GO TO 100
	IF((-J1+J2+J).LT.0)GO TO 100
	IF(IABS(M1).GT.J1)GO TO 100
	IF(IABS(M2).GT.J2)GO TO 100
	IF(IABS(M).GT.J)GO TO 100
	IF((M1+M2).NE.M)GO TO 100

	SUM=0.0d0
	DO 150 K=0,10000
	IF((J1+J2-J-K).LT.0)GO TO 200	
	IF((J1-M1-K).LT.0)GO TO 200	
	IF((J2+M2-K).LT.0)GO TO 200
	IF((J-J2+M1+K).LT.0)GO TO 150	
	IF((J-J1-M2+K).LT.0)GO TO 150	

	ALFAC=.5d0*(ALGAMA(dFLOAT(J1+M1+1))+ALGAMA(dFLOAT(J1-M1+1))
     1        +ALGAMA(dFLOAT(J2+M2+1))
     2        +ALGAMA(dFLOAT(J2-M2+1))     +ALGAMA(dFLOAT(J+M+1))
     3        +ALGAMA(dFLOAT(J-M+1)))     -(ALGAMA(dFLOAT(K+1))
     4        +ALGAMA(dFLOAT(J1+J2-J-K+1))
     5        +ALGAMA(dFLOAT(J1-M1-K+1))   +ALGAMA(dFLOAT(J2+M2-K+1))
     6        +ALGAMA(dFLOAT(J-J2+M1+K+1)) +ALGAMA(dFLOAT(J-J1-M2+K+1)))
	SUM=SUM+EXP(ALFAC)*((-1.0d0)**K)
150	CONTINUE	
200     continue
        ALFO=.5d0*(ALGAMA(dFLOAT(J1+J2-J+1))+ALGAMA(dFLOAT(J+J1-J2+1))
     1            +ALGAMA(dFLOAT(J+J2-J1+1))-ALGAMA(dFLOAT(J+J1+J2+2)))
	CLGO=SUM*EXP(ALFO)*SQRT(dfloat(2*J+1))
	GO TO 120

100	CLGO=0.0d0
120	RETURN
	END
c------------------------------------------------------------------------

      COMPLEX*16 FUNCTION SH(L,M,DX,DPHICOS,DPHISIN) 

      implicit double precision (d)
      COMPLEX*16 AI
      REAL*8 DFAC,DRLGN1,DX,DPHICOS,DPHISIN,pi,top,bot
      INTEGER L,M,MA
      AI=(0.0d0,1.0d0)
      MA=IABS(M)
 
c --- The dfac = sqrt( (L-MA)!/(L+MA)! * (2*L+1)/(4*pi)).
c     However, as MA increases, (L+MA)! overflows the computer.
c     dfac is computed as follows to prevent this from happening.

      pi=4.0d0*atan2(1.0d0,1.0d0)
      top=1.0d0
      do 11 i=1,L-MA
        top=top*dfloat(i)
 11   continue
      bot=sqrt(dfloat(2*l+1)*top)
      do 12 i=1,L+MA
        bot=bot/sqrt(dfloat(i))
 12   continue
      dfac=bot/sqrt(4.0d0*pi)

      IF (M .GE. 0) THEN
        SH=DFAC*DRLGN1(DX,L,MA)*((DPHICOS+AI*DPHISIN)**MA)*
     &      ((-1.d0)**MA)
      ENDIF
      IF (M .LT. 0) THEN
        SH=DFAC*DRLGN1(DX,L,MA)*((DPHICOS-AI*DPHISIN)**MA)
      ENDIF
      RETURN
      END 
      REAL*8 FUNCTION DRLGN1(X,L,M)
      REAL*8 X,PMM,FACT,SOMX2,PMMP1,PLL
      IF(M.LT.0.OR.ABS(X).GT.1.)PAUSE 'bad arguments'
      IF(M.GT.L) THEN
        DRLGN1=0.
        RETURN
      ENDIF
      PMM=1.
      IF(M.GT.0) THEN
        SOMX2=SQRT((1.-X)*(1.+X))
        FACT=1.
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.
11      CONTINUE
      ENDIF
      IF(L.EQ.M) THEN
        DRLGN1=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF(L.EQ.M+1) THEN
          DRLGN1=PMMP1
        ELSE
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
          DRLGN1=PLL
        ENDIF
      ENDIF
      RETURN
      END
