c**********************************************************************
c****module dalphbt
      subroutine dalphbt(zz,theta,phi,k0,nmax,numa,alph,beta,ndim
     &                                            ,nudim,jtune,jcon) 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 21)
      complex alph(ndim,0:nudim)
      complex beta(ndim,0:nudim)
      complex al1,al2,al3
      complex bl1,bl2,bl3
      complex ci
      real z,zz,theta,phi,k0,costhe,theta0,phi0
      real pwork(0:nudd),sbesj(0:nudd),pi,sqrtpi
      complex sbesh(0:nudd)
      complex sphh(0:nudd,-nudd:nudd)
      real factdn,factdnu,factsn,factsnu
      real bpnu,bmnu,bpnn
      real amnu,apnu,apnm,amnm

      ci = (0.0e0,1.0e0)
      pi = acos(-1.0e0)
      sqrtpi = sqrt(4.0e0*pi)
c
      z = zz*k0
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesjh(z,nmx,sbesj,sbesh,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        alph(1,nup)=msign*sphh(nu,0)*sbesh(nu)*sqrtpi*nsign
        beta(1,nup)=msign*sphh(nu,0)*sbesj(nu)*sqrtpi*nsign
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          alph(1,lmp)=msign*sphh(nu,-mu)*sbesh(nu)*sqrtpi
     &                *exp(ci*2.0e0*mu*phi0)*nsign                      
          alph(1,lmm)=msign*sphh(nu,mu)*sbesh(nu)*sqrtpi
     &                *exp(-ci*2.0e0*mu*phi0)*nsign                   
          beta(1,lmp)=msign*sphh(nu,-mu)*sbesj(nu)*sqrtpi
     &                *exp(ci*2.0e0*mu*phi0)*nsign                      
          beta(1,lmm)=msign*sphh(nu,mu)*sbesj(nu)*sqrtpi
     &                *exp(-ci*2.0e0*mu*phi0)*nsign                   
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            alph(npp,num+mu)= (bpnu*alph(npm,nub+mu-1)+
     &                         bmnu*alph(npm,nup+mu-1))/bpnn
            beta(npp,num+mu)= (bpnu*beta(npm,nub+mu-1)+
     &                         bmnu*beta(npm,nup+mu-1))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(npp,num-nu)= (bmnu*alph(npm,nup-nu-1))/bpnn
          beta(npp,num-nu)= (bmnu*beta(npm,nup-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0e0/3.0e0)
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(npp,1)= (bmnu*alph(npm,2))/bpnn
          beta(npp,1)= (bmnu*beta(npm,2))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(nmp,nub+mu)
           al2=alph(nmp,nub+mu)
           bl3=beta(nmp,nup+mu)
           bl3=beta(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(npp,num+mu)= (apnu*al2 + amnu*al3)/apnm     
           beta(npp,num+mu)= (apnu*bl2 + amnu*bl3)/apnm     
 80       continue
          al3=alph(nmp,nup-nu)
          bl3=beta(nmp,nup-nu)
          amnu = sqrt(1.0e0/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,num-nu)= (amnu*al3)/apnm     
          beta(npp,num-nu)= (amnu*bl3)/apnm     
          al3=alph(nmp,nup+nu)
          bl3=beta(nmp,nup+nu)
          alph(npp,num+nu)= (amnu*al3)/apnm     
          beta(npp,num+nu)= (amnu*bl3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(nmp,3)
          bl3=beta(nmp,3)
          amnu = sqrt(1.0e0/3.0e0)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,1)= (amnu*al3)/apnm     
          beta(npp,1)= (amnu*bl3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(nmm,num+mu)
           al2=alph(nmp,nub+mu)
           al3=alph(nmp,nup+mu)
           bl1=beta(nmm,num+mu)
           bl2=beta(nmp,nub+mu)
           bl3=beta(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(npp,num+mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
           beta(npp,num+mu)=(-amnm*bl1 + apnu * bl2
     &                     + amnu * bl3) / apnm     
 85       continue
          al1=alph(nmm,num-nu)
          al3=alph(nmp,nup-nu)
          bl1=beta(nmm,num-nu)
          bl3=beta(nmp,nup-nu)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,num-nu)=(-amnm*al1 + amnu * al3) / apnm     
          beta(npp,num-nu)=(-amnm*bl1 + amnu * bl3) / apnm     
          al1=alph(nmm,num+nu)
          al3=alph(nmp,nup+nu)
          bl1=beta(nmm,num+nu)
          bl3=beta(nmp,nup+nu)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,num+nu)=(-amnm*al1 + amnu * al3) / apnm     
          beta(npp,num+nu)=(-amnm*bl1 + amnu * bl3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(nmm,1)
          al3=alph(nmp,3)
          bl1=beta(nmm,1)
          bl3=beta(nmp,3)
          amnu = sqrt(1.0e0/3.0e0)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,1)=(-amnm*al1 + amnu * al3) / apnm     
          beta(npp,1)=(-amnm*bl1 + amnu * bl3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            alph(npp-m,nup) = msign*(alph(npp+m,nup))
     &                             *exp(2.0e0*ci*(m)*phi0)
            beta(npp-m,nup) = msign*(beta(npp+m,nup))
     &                             *exp(2.0e0*ci*(m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(npp-m,nup+mu) = msign*musign*alph(npp+m,nup-mu)
     &                                *exp(2.0e0*ci*phi0*(mu+m))
              alph(npp-m,nup-mu) = msign*musign*alph(npp+m,nup+mu)
     &                                *exp(2.0e0*ci*phi0*(m-mu))
              beta(npp-m,nup+mu) = msign*musign*beta(npp+m,nup-mu)
     &                                *exp(2.0e0*ci*phi0*(mu+m))
              beta(npp-m,nup-mu) = msign*musign*beta(npp+m,nup+mu)
     &                                *exp(2.0e0*ci*phi0*(m-mu))
 98         continue
 96       continue
 95     continue
 90   continue

      if(jcon .eq. 1) then

      factdn = 1.0e0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*k0/float(2*jnp+1)
        endif
c>>>>        factdn = 1.0e0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0e0
          do 110 jnup = 0,numa
c>>>>            factdnu = filld(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*float(2*jnup+1)/k0
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(np,nup) = beta(np,nup)*factdn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue

      else if(jcon .eq. 2) then

      factsn = 1.0e0/k0
      do 200 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*float(2*jnp-1)/k0
        endif
c>>>        factsn = 1.0e0/fills(jnp,k0)
        do 205 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = k0
          do 210 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*k0/float(2*jnup-1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 215 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(np,nup) = beta(np,nup)*factsn*factsnu
 215        continue
 210      continue
 205    continue
 200  continue

      else

        pause 'jcon must be 1 or 2 in sbeta subroutine'

      endif

  
      factdn = 1.0e0
      do 300 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*k0/float(2*jnp+1)
        endif
c>>>        factdn = 1.0e0/filld(jnp,k0)
        do 305 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = k0
          do 310 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*k0/float(2*jnup-1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 315 jmup = -jnup,jnup
              nup = nupp + jmup
              alph(np,nup) = ci*alph(np,nup)*factdn*factsnu
 315        continue
 310      continue
 305    continue
 300  continue
             
      return
      end
c************************************************************************
c****module spharm
      SUBROUTINE SPHHARM(X,PHI,L,M,SPHH,LD1,LD2,PWORK)
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION PWORK(0:LD1)
      COMPLEX SPHH(0:LD1,-LD2:LD2), CI
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
CC
      CI = (0.0E0,1.0E0)
      PI = ACOS(-1.0E0)
      DO 10 LM = 0,M
        CALL DLEGENDR(X,L,LM,PWORK,LD1) 
        DO 20 LP = LM,L
          SPHH(LP,LM) = CMPLX(PWORK(LP),0.0E0)
 20     CONTINUE
 10   CONTINUE
C
      PIINV = 0.5D0/SQRT(PI)
C
      DO 30 LP = 0,L
        SPHH(LP,0) = PIINV*SQRT(FLOAT(2*LP+1))*SPHH(LP,0)
 30   CONTINUE
C
      IF(L .LT. 150) THEN
        PN = 1.
        DO 40 LP = 1,L
          SIGN = 1.0E0
          FACL = PIINV*SQRT(2.0E0*FLOAT(LP)+1.0E0)
          PN = PN*FLOAT(LP)
          PADD = SQRT(PN)
          PMIN = PN
          DO 50 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD*SQRT(FLOAT(LP+MP))
            PMIN = PMIN/FLOAT(LP-MP+1)   
            FAC = SIGN*FACL*SQRT(PMIN)/PADD
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 50       CONTINUE
 40     CONTINUE
      ELSE
        PN = 0.0
        DO 60 LP = 1,L
          SIGN = 1.0E0
          FACL = PIINV*SQRT(2.0E0*FLOAT(LP)+1.0E0)
          PN = PN + LOG(FLOAT(LP))
          PADD = PN
          PMIN = PN
          DO 70 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD + LOG(FLOAT(LP+MP))
            PMIN = PMIN - LOG(FLOAT(LP-MP+1))   
            FAC = SIGN*FACL*EXP(0.5D0*(PMIN-PADD))
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 70       CONTINUE
 60     CONTINUE
      ENDIF  
C
      RETURN
      END
c**********************************************************************
c****dlegendr
      SUBROUTINE DLEGENDR(X,L,M,PLGNDR,LD1)
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION PLGNDR(0:LD1)
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in DLEGENDR'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
      PMM=1.0E0
      IF(M.GT.0) THEN
        SOMX2=SQRT((1.-X)*(1.+X))
        FACT=1.
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.0E0
11      CONTINUE
      ENDIF
      IF(L.EQ.M) THEN
        PLGNDR(L)=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF(L.EQ.M+1) THEN
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
        ELSE
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PLGNDR(LL)=PLL
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

c****************************************************************
c****module dsbesjh
	subroutine dsbesjh(x,n,sj,csh,nd)
        implicit complex (c)
        implicit real (a-b,d-h,o-z)
        dimension sj(0:nd),csh(0:nd)

        ci = (0.0e0,1.0e0)

        call dsbesy(x,n,sj,nd)
c
        do 5 j = 0,n
          csh(j) = ci*sj(j)
  5     continue
c
        call dsbesj(x,n,sj,nd)
        
        do 10 j = 0,n
          csh(j) = sj(j) + csh(j)
 10     continue
c
        return
        end
c****************************************************************
c****module cdsbesj
        subroutine dsbesj(cx,n,csj,nd)
c>>>        implicit complex (c)
c>>>        implicit real (a-b,d-h,o-z)
        implicit real (a-h,o-z)
        dimension csj(0:nd)
        integer flag
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')

c --- Explicit calculation of low order Bessel functions.
        cxinv = 1.0e0/cx
        if (n.eq.0) then
            csj(0)=sin(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            return
        end if
        if (n.eq.2) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            csj(2)=(3.0e0/cx/cx-1.0e0)*csj(0) - 3.0e0*cos(cx)/cx/cx
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        csj(0)=sin(cx)*cxinv
        csj(1)=(csj(0)-cos(cx))*cxinv
        csjb=csj(0)
        csjm=csj(1)
        if (abs(cx).gt.float(n)) then
            do 11 j=2,n
                csjp=(2.0e0*float(j-1)+1.0e0)*cxinv*csjm-csjb
                csjb=csjm
                csjm=csjp
                csj(j)=csjm
  11        continue
        else
            csj1=csj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            csjm=0.0e0
            csjb=1.0e0
            i=0
            do 12 j=m,1,-1
                csjp=(2.0e0*float(j+1)+1.d0)*cxinv*csjb-csjm
                csjm=csjb
                csjb=csjp
                if(j.le.n) csj(j)=csjp
c>>>>>                write(12,*) j, sjp
                if (abs(csjp).gt.bigno) then
                    csjm=csjm*1.d-10
                    csjb=csjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      csj(lp)=csj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (abs(csj(1)).eq.0.0e0) print *,'got 0 in SJ'
            cdp=csj1/csj(1)
            do 30 jp = 1,n
              csj(jp) = csj(jp)*cdp
  30        continue
        end if
  13    return
        end

c***************************************************************
c****module dsbesy
	subroutine dsbesy(cx,n,csy,nd)
c>>>        implicit complex (c)
c>>>        implicit real (a-b,d-h,o-z)
        implicit real (a-h,o-z)
        dimension csy(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
c
        cxinv = 1.0e0/cx
c        
c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            csy(0)=-cos(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csy(0)=-cos(cx)*cxinv
            csy(1)=csy(0)*cxinv-sin(cx)*cxinv
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        csy(0)=-cos(cx)*cxinv
        csy(1)=csy(0)*cxinv-sin(cx)*cxinv
        csyb=csy(0)
        csym=csy(1)
        do 11 j=2,n
          csyp=(2.0e0*float(j-1)+1.)*cxinv*csym-csyb
          csyb=csym
          csym=csyp
          csy(j)=csym
  11    continue
        return
        end
c------------------------------------------------------------------------
