c****module dsalphap
      subroutine dsalphap(zz,theta,phi,k0,numa,nmax,alph,nudim,
     &                                           ndim,jtune) 
c
c     this routine is for numa > nmax.
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 21)
      complex alph(0:nudim,ndim)
      complex al1,al2,al3
      complex ci
      real z,zz,theta,phi,k0,costhe,theta0,phi0
      real pwork(0:nudd),sbesj(0:nudd),pi,sqrtpi
      complex sbesh(0:nudd)
      complex sphh(0:nudd,-nudd:nudd)
      real factsn,factdnu
      real bpnu,bmnu,bpnn
      real amnu,apnu,apnm,amnm

      ci = (0.0e0,1.0e0)
      pi = acos(-1.0e0)
      sqrtpi = sqrt(4.0e0*pi)
c
      z = zz*k0
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesjh(z,nmx,sbesj,sbesh,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        alph(nup,1)=msign*sphh(nu,0)*sbesh(nu)*sqrtpi
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          alph(lmp,1)=msign*sphh(nu,-mu)*sbesh(nu)*sqrtpi
          alph(lmm,1)=msign*sphh(nu,mu)*sbesh(nu)*sqrtpi
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            alph(num+mu,npp)= (bpnu*alph(nub+mu-1,npm)+
     &                         bmnu*alph(nup+mu-1,npm))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(num-nu,npp)= (bmnu*alph(nup-nu-1,npm))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0e0/3.0e0)
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(1,npp)= (bmnu*alph(2,npm))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(nub+mu,nmp)
           al3=alph(nup+mu,nmp)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(num+mu,npp)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=alph(nup-nu,nmp)
          amnu = sqrt(1.0e0/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(num-nu,npp)= (amnu*al3)/apnm     
          al3=alph(nup+nu,nmp)
          alph(num+nu,npp)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(3,nmp)
          amnu = sqrt(1.0e0/3.0e0)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(1,npp)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(num+mu,nmm)
           al2=alph(nub+mu,nmp)
           al3=alph(nup+mu,nmp)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(num+mu,npp)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=alph(num-nu,nmm)
          al3=alph(nup-nu,nmp)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(num-nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
          al1=alph(num+nu,nmm)
          al3=alph(nup+nu,nmp)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(num+nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(1,nmm)
          al3=alph(3,nmp)
          amnu = sqrt(1.0e0/3.0e0)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(1,npp)=(-amnm*al1 + amnu * al3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            alph(nup,npp-m) = msign*(alph(nup,npp+m))
     &                             *exp(2.0e0*cI*(-m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(nup+mu,npp-m) = msign*musign*alph(nup-mu,npp+m)
     &                                *exp(2.0e0*ci*phi0*(-mu-m))
              alph(nup-mu,npp-m) = msign*musign*alph(nup+mu,npp+m)
     &                                *exp(2.0e0*ci*phi0*(mu-m))
 98         continue
 96       continue
 95     continue
 90   continue
  
      factsn = k0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*k0/float(2*jnp-1)
        endif
c>>>        factdn = 1.0e0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0e0
          do 110 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*k0/float(2*jnup+1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              alph(nup,np) = ci*alph(nup,np)*factsn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue
             
      return
      end
