c****module mainsph
      PROGRAM MAINSPH 
                   
c  ***        nst is total # of spheres in grouping             ***
c  ***           mdm & pdm are matrix dimensions                ***
c  ***                iwa must be >3xmdm                        ***

c --- mdm and pdm must be perfect squares (not necessarily the same)
      integer mdm,pdm,iwa,nst,i,j,k,n,ntm,ntp,nq
      parameter ( nst=18, iwa=100 )
      parameter ( mdm=4,  pdm=16)
      parameter ( nptt = 36 )
 
      complex ab1(mdm,0:nptt),ab2(pdm,0:nptt)
      complex t1(mdm,mdm),taun(pdm,pdm),Tatau(mdm,pdm),taua(pdm,mdm)
      complex tb(mdm,pdm),btb(pdm,pdm),dple,one,ai,tau
      complex eps(nst),epb,einc(pdm),winv(mdm,mdm),a3,b3,c3
      complex an0(mdm,pdm),a0n(pdm,mdm),w2(mdm,pdm),epsef1
      complex bn0(mdm,pdm),b0n(pdm,mdm),ID(mdm,mdm),epsef2
      complex temp1(pdm,mdm),temp2(mdm,pdm),taun1(pdm,pdm),w(mdm,mdm)
      complex wtemp(mdm,mdm),w2temp(mdm,pdm),temp3(mdm,mdm)
      real r(nst),pho(nst),phi(nst),theta(nst),filld,fv
      real wa(iwa),pi,k0,ee,rg,fq,fqeo,pho1,theta1,phi1,ka
      real epsr1,sigma1,epsr2,sigma2
c>>>      complex alphn0(mdm,pdm) 
c>>>      complex betan0(mdm,pdm) 

      open(8,file='phidat')
      open(9,file='thedat')
      open(10,file='phodat')
      open(11,file='raddat')
      open(12,file='epsdat')
      open(13,file='linout')
      open(14,file='dples')

      ntm=int(sqrt(float(mdm)))-1
      ntp=int(sqrt(float(pdm)))-1
      pi=4.0e0*atan2(1.0e0,1.0e0)
      ee=sqrt(.75d0/pi)
      ai  =(0.0,1.0)
      one =(1.0,0.0)
  
c --- Read in sphere position, size, and epsilon data.

      do 1 i=1,nst
        read(8,*)  PHI(i)
        read(9,*)  THETA(i)
        read(10,*) PHO(i)
        read(11,*) R(i)
        read(12,3) EPS(i)
  1   continue
      read(11,*) RG
      read(12,3) EPB
      read(12,4) FQ
  3   Format(f11.4,e9.4)
  4   Format(e9.4)

      k0=2.0e0*pi*fq/3.0d8
      fqeo=fq*8.8419d-12
      fv=(r(1)/rg)**3

      write(*,*) 'grp rad.=',rg,'   epb=',conjg(epb),'  M =',mdm
      write(13,*)'grp rad.=',rg,'   epb=',conjg(epb),'  M =',mdm
      write(*,*) 'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',pdm
      write(13,*)'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',pdm
      write(*,*) 'spread  =',pho(3)-pho(2)
      write(13,*)'spread  =',pho(3)-pho(2)
      write(*,*) ' '
      write(13,*)' '

      write(*,*)  'Fractional Volume             Dipole Term'
      write(*,*)  'new eff. permittivity         new eff. conductivity'
      write(13,*) 'Fractional Volume             Dipole Term'
      write(13,*) 'new eff. permittivity         new eff. conductivity'
      write(13,*)' '

      n = 0
c
      call t1sub(t1,mdm,ntm,fq,epb,eps(n+1),r(n+1),k0)
     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex identity matrix [MxM].

      do 122 i=1,pdm
        do 121 j=1,pdm
          taun(i,j)=(0.0,0.0)
 121    continue
 122  continue

      do 124 i=1,mdm
        do 123 j=1,mdm
          taun(i,j)=t1(i,j)
          ID(i,j)=cmplx(0.0,0.0)
 123    continue
          ID(i,i)=cmplx(1.0,0.0)
 124  continue

c --- Calculate normalized einc [Px1]
      k=1
      do 31 i=0,ntp
        nq=2*i+1
        do 32 j=1,nq
          if(j.eq.(i+1)) einc(k)=(ai**i)*sqrt(4.0e0*pi*float(i+i+1))/
     &                             FILLD(i,k0)
          if(j.ne.(i+1)) einc(k)=(0.0,0.0)
          k=k+1
 32     continue
 31   continue

      do 1000 n=1,nst-1

c --- Calculate normalized 1 sphere scattering matrix for sphere n+1
c     t1static    = (1/S) * t1dynamic    * D

      lp = n
      call t1sub(t1,mdm,ntm,fq,epb,eps(lp+1),r(lp+1),k0)
     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex identity matrix [MxM].

c --- Calculate the normalization matrices (diagonal => column vectors)
c     alphastatic = (1/D) * alphadynamic * S
c     betastaticn0= (1/D) * betadynamic  * D
c     betastatic0n= (1/S) * betadynamic  * S
 
c --- an0 is alpha(n+1,0)    [MxP]

      phi1  =phi(n+1)
      theta1=theta(n+1)
      pho1  =pho(n+1)
c>>>>      call COMAT(an0,mdm,pdm,phi1,theta1,pho1,k0,1,1)
      call dsalpha(pho1,theta1,phi1,k0,ntm,ntp,ab1,mdm,nptt,1)
      call movemtrx(ab1,mdm,4*pdm,an0,mdm,pdm,mdm,pdm)

c>>      do 500 np = 1,pdm
c>>        do 510 mp = 1,mdm
c>>          alphn0(mp,np) = an0(mp,np)
c>> 510    continue
c>> 500  continue

c --- a0n is alpha(0,n+1)    [PxM]

c>>      phi1  =pi+phi(n+1)
c>>      theta1=pi-theta(n+1)
c>>      pho1  =pho(n+1)
c>>>>      call COMAT(a0n,pdm,mdm,phi1,theta1,pho1,k0,1,1)
      call dsalpha(pho1,theta1,phi1,k0,ntp,ntm,ab2,pdm,nptt,-1)
      call movemtrx(ab2,pdm,4*mdm,a0n,pdm,mdm,pdm,mdm)

c --- bn0 is beta(n+1,0)   [MxP]

c>>      phi1  =pi+phi(n+1)
c>>      theta1=theta(n+1)
c>>      pho1  =pho(n+1)
c>>>>      call COMAT(bn0,mdm,pdm,phi1,theta1,pho1,k0,2,1)
      call dsbeta(pho1,theta1,phi1,k0,ntm,ntp,ab1,mdm,nptt,1,1)
      call movemtrx(ab1,mdm,4*pdm,bn0,mdm,pdm,mdm,pdm)

c>>      do 520 np = 1,pdm
c>>        do 525 mp = 1,mdm
c>>          betan0(mp,np) = bn0(mp,np)
c>> 525    continue
c>> 520  continue

c
c --- b0n is beta(0,n+1)   [PxM]

c>>      phi1  =pi+phi(n+1)
c>>      theta1=pi-theta(n+1)
c>>      pho1  =pho(n+1)
c>>>>      call COMAT(b0n,pdm,mdm,phi1,theta1,pho1,k0,2,2)
      call dsbeta(pho1,theta1,phi1,k0,ntp,ntm,ab2,pdm,nptt,-1,2)
      call movemtrx(ab2,pdm,4*mdm,b0n,pdm,mdm,pdm,mdm)

c --- Calculate T(n+1,1)*alpha(n+1,0)*tau(n)   [MxP]

      call mtrxmult(t1,mdm,mdm,an0,mdm,pdm,temp2)
      call mtrxmult(temp2,mdm,pdm,taun,pdm,pdm,Tatau)

c --- Calculate I - T(n+1,1)*alpha(n+1,0)*tau(n)*alpha(0,n+1) [MxM]

      call mtrxmult(Tatau,mdm,pdm,a0n,pdm,mdm,wtemp)
      call mtrxadd(ID,mdm,mdm,wtemp,mdm,mdm,w,-1)

c --- Invert last matrix calculated   [MxM]

      call cminvl(w,winv,wa,mdm,mdm,mdm,iwa)

c --- Calculate beta(n+1,0)+alpha(n+1,0)*tau(n)   [MxP]

c>>      call mtrxmult(an0,mdm,pdm,taun,pdm,pdm,w2temp)
      call mtrxmult(an0,mdm,pdm,taun,pdm,pdm,w2temp)
      call mtrxadd(w2temp,mdm,pdm,bn0,mdm,pdm,w2,1)

c --- Calculate T(n+1,n+1)*beta(n+1,0)   [MxP]

      call mtrxmult(winv,mdm,mdm,t1,mdm,mdm,temp3)
      call mtrxmult(temp3,mdm,mdm,w2,mdm,pdm,tb)
        
c --- Calculate tau(n)*alpha(0,n+1)   [PxM]

      call mtrxmult(taun,pdm,pdm,a0n,pdm,mdm,taua)

c --- Calculate beta(0,n+1)*T(n+1,n+1)*beta(n+1,0)  +       [PxP] 
c               tau(n)*alpha(0,n+1)*T(n+1,n+1)*beta(n+1,0)  [PxP]

      call mtrxadd(b0n,pdm,mdm,taua,pdm,mdm,temp1)
      call mtrxmult(temp1,pdm,mdm,tb,mdm,pdm,btb)
      
c --- Calculate tau(n+1)   [PxP]

      call mtrxadd(taun,pdm,pdm,btb,pdm,pdm,taun1)
c
c --- Calculate the dipole term:  row 3 of tau(n+1) * einc

      dple=(0.0,0.0)
      do 200 j=1,pdm
        dple=dple+taun1(3,j)*einc(j)
  200 continue

c --- Calculate effective permittivity and conductivity

      dple  = dple*ee/ai/k0/rg**3
c----------------------------------------------------------------------
      ka = k0 * rg
      tau= dple*(ka**3)/3.0/ai
      A3 =  15.0*(ka**3) - 18.0*(ka**5) -  45.0*ai*tau -  5.0*ai*(ka**6)
      B3 =  15.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau + 10.0*ai*(ka**6)
      C3 = -30.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau -  5.0*ai*(ka**6)
c----------------------------------------------------------------------
      epsef1= ((1.0+2.0*Dple)/(1.0-Dple))*epb
      epsr1 = real(epsef1)
      sigma1= -aimag(epsef1)*fqeo*2.0*pi
      epsef2= epb * ( -B3 + sqrt(B3*B3-4.0*A3*C3) ) / (2.0*A3)
      epsr2 = real(epsef2)
      sigma2= -aimag(epsef2)*fqeo*2.0*pi
      fv=fv+(r(n+1)/rg)**3

      write(14,*) dple
      write(*,*)  'sphere #',n+1,'      dple =',dple
      write(*,*)  '                   ',epsr2,sigma2
      write(13,*) 'sphere #',n+1,'      dple =',dple
      write(13,*) '                   ',epsr2,sigma2

c     write(*,*) 'eff. permit. =',epsr,'    conductivity =',sigma
c     write(*,*) 'dipole term  =',dple
c     write(13,*)'eff. permit. =',epsr,'    conductivity =',sigma
c     write(13,*)'dipole term  =',dple

      if (n.eq.nst-1) go to 1000

c --- Set tau(n) = tau(n+1) before next pass through loop

      do 300 i=1,mdm
        do 301 j=1,pdm
          taun(i,j)=taun1(i,j)
 301    continue
 300  continue

 1000 continue
      stop
      end

      SUBROUTINE LOWFAPPX(l,f,a,epb,eps,apprx)
      complex apprx,epb,eps,epsr,ai
      real k0,f,a,x1,x2,k,ka,k1,krel

      ai   = cmplx(0.0e0,1.0e0)
      epsr = eps/epb
      k0   = 8.0e0*atan2(1.0e0,1.0e0)*f/3.0d8
      k    = k0*sqrt(real(epb))
      k1   = k0*sqrt(real(eps))
      ka   = k*a
      krel = k1/k

      x2 = 1.0e0
      do 1 j = 1,l+l-1,2
          x2 = x2*float(j)
  1   continue
      x1 = x2*float(l+l+1)

c     top1 = epsr*float(l)* (k1**(l+1))* (k**(l-1))* (a**(l+l-1))/x1/x1
c     top2 =      float(l)* (k1**l)*     (k**l)*     (a**(l+l-1))/x1/x1
c     bot1 = ai * float(l+1) * (krel**l) / float(2*l+1) / k / (a**2)
c     bot2 = -ai*epsr*float(l)* (krel**(l+1))/ k/ float(2*l+1)/ (a**2)
c     apprx=-(top1-top2)/(bot1-bot2)

c --- apprx given below is same as -(top1-top2)/(bot1-bot2)
c     this normalizes to a slightly different number than the static #
c     apprx=-ai*float(l) * (ka**(2*l+1)) * (1.0e0-epsr*krel) / x1 / x2
c    &      / ( 1.0e0 + float(l) * (1.0e0 + epsr * krel) )

c --- apprx given below normalizes to exactly the static approximation
      apprx=-ai * float(l) * (ka**(2*l+1)) * (1.0e0-epsr) / x1 / x2
     &      / ( 1.0e0 + float(l) * (1.0e0 + epsr ) )

      return
      end
      
      Subroutine mtrxmult(a,ar,ac,b,br,bc,c)
      integer ar,ac,br,bc
      complex a,b,c
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ac.ne.br) then
        print *,'*****  Matrix multiplication not defined.  *****'
      end if
      do 60 i = 1,bc
          do 50 j = 1,ar
            c(j,i) = (0.e0,0.e0)
 50     continue
 60   continue
c
      do 30 i = 1,ac
          do 20 k = 1,bc
            do 10 j = 1,ar
                c(j,k) = c(j,k)+a(j,i)*b(i,k)
 10       continue
 20     continue
 30   continue
c
c>>>      do 1 i=1,ar
c>>>        do 2 j=1,bc
c>>>          temp=cmplx(0.0e0,0.0e0)
c>>>          do 3 k=1,ac
c>>>            temp=temp+a(i,k)*b(k,j)
c>>>  3       continue
c>>>          c(i,j)=temp
c>>>  2     continue
c>>>  1   continue
      return
      end
      
      Subroutine mtrxadd(a,ar,ac,b,br,bc,c,isign)
      integer ar,ac,br,bc,isign
      complex a,b,c
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ar.ne.br.OR.ac.ne.bc) then
        print *,'*****  Matrix addition not defined.  *****'
      end if
      do 1 i=1,ar
        do 2 j=1,bc
            c(i,j)=a(i,j)+isign*b(i,j)
  2     continue
  1   continue
      return
      end

      subroutine prntmtrx(a,irow,icol)
      complex a
      dimension a(irow,icol)
c     do 1 i=1,irow
c       do 2 j=1,icol
      do 1 i=1,16
        do 2 j=1,16
          write(14,*) i,j,a(i,j)
  2     continue
  1   continue
      return
      end

      REAL FUNCTION FILLD(i,k0)
      real k0,fac
      integer i
      fac=1.0e0
      do 1 j=1,i+i+1,2
          fac=fac*float(j)
 1    continue
      filld=fac/(k0**i)
      return
      end


      COMPLEX FUNCTION FILLS(i,k0)
      real k0,fac
      integer i
      fac=1.0e0
      do 1 j=1,i+i-1,2
          fac=fac*float(j)
 1    continue
      fills=cmplx(0.0e0,(k0**(i+1))/fac)
      return
      end
      SUBROUTINE ONESPHT(i,f,r,epb,eps,t1)
      complex epb,eps,t1,Hank,Hankd,SH1,denom,num,epsr
      real k0,k,k1,kr,k1r,SJ,f,r,krel,sjdkr,sjdk1r

      k0   = 8.0e0*atan2(1.0e0,1.0e0)*f/3.0d8
      k    = k0*sqrt(real(epb))
      k1   = k0*sqrt(real(eps))
      kr   = k*r
      k1r  = k1*r
      krel = k1/k
      epsr = eps/epb

      Hank   = SH1(i,kr)
      sjdkr  = (i/r) * SJ(i,kr)  - k  * SJ(i+1,kr)
      sjdk1r = (i/r) * SJ(i,k1r) - k1 * SJ(i+1,k1r)
      Hankd  = (i/r) * Hank      - k  * SH1(i+1,kr)

      num   = epsr * krel * sjdk1r * SJ(i,kr) - SJ(i,k1r) * sjdkr
      denom = SJ(i,k1r) * Hankd - epsr * krel * sjdk1r * Hank
      t1    = - num / denom
      return
      end
c     Subroutine t1sub(t1,mdm,pdm,ntm,fq,epb,eps,r,k0)
      Subroutine t1sub(t1,mdm,ntm,fq,epb,eps,r,k0)
      complex t1,epb,eps,temp,FILLS
      real fq,r,k0,FILLD,div
      parameter(div=1.0d6)
c     integer mdm,ntm,i,k,kk,nq,pdm
      integer mdm,ntm,i,k,kk,nq
c     dimension t1(mdm,pdm)
      dimension t1(mdm,mdm)

      do 1 i=1,mdm
c       do 2 j=1,pdm
        do 2 j=1,mdm
          t1(i,j)=cmplx(0.0e0,0.0e0)
 2      continue
 1    continue

      k=1
      do 10 i=0,ntm
c       if (fq.le.div) call LOWFAPPX(i,fq,r,epb,eps,temp)
c       if (fq.gt.div) call ONESPHT(i,fq,r,epb,eps,temp)
        call LOWFAPPX(i,fq,r,epb,eps,temp)
c       call ONESPHT(i,fq,r,epb,eps,temp)
        nq=(2*i)+1
        do 20 kk=1,nq
          t1(k,k)=FILLD(i,k0)*temp/FILLS(i,k0)
c         t1(k,k)=temp
          k=k+1
 20     continue
 10   continue
      return
      end
c cminvl in matman1 in hftlib may be used instead if one has access to
c IMSLIB.
c
c transfer 'c' to the next line to get determinant on the matrix.
c     subroutine cminvl(ca,cb,cd,wa,n,ia)
      subroutine cminvl(ca,cb,wa,n,ia,mp,iwork)
      implicit complex (c)
      real wa
      integer mp,iwork
      dimension ca(mp,mp),cb(mp,mp),cdet(2),wa(iwork)
c
c     cminvl is a driver program that finds the inverse of a matrix
c     by calling cgefa and cgedi from linpack.
c
c     on entry
c
c         ca     a complex matrix preserved on output.
c
c         cb     a complex matrix containing the inverse
c                on output.
c
c         cd     contains the determinant of the matrix ca on
c                output.  If the determinant is not needed, the
c                lower line can be used for the subroutine statement.
c
c         wa     a work real vector of length at least 3*n.
c
c         n      the order of the matrices  ca  and  cb.
c
c         ia     the actual row dimension of the array declared for ca and cb.
c
c     written by W.C. Chew on May 3, 1987.
c
c     transfer from ca to cb.
c
      do 10 i=1,n
      do 10 j=1,n
      cb(i,j)=ca(i,j)
   10 continue
c
c     calls cgefa to condition the matrix.
c
      call cgefa(cb,ia,n,wa(1),info)
c
c     if info is greater than zero, the matrix is singular.
c
      if(info.gt.0) goto 15
c
c     calls cgedi to find inverse and determinant.
c
      call cgedi(cb,ia,n,wa(1),cdet,wa(n+1),11)
c     cd=cdet(1)*10.0**cdet(2)
      return
   15 continue
c
c     write to terminal on Harris.  Need to be changed on other computers.
c
c     write(*,*) ' ** the matrix is singular in cminvl ** '
      return
      end
      subroutine caxpy(n,ca,cx,incx,cy,incy)
c
c     constant times a vector plus a vector.
c     jack dongarra, linpack, 3/11/78.
c
      complex cx(1),cy(1),ca
      integer i,incx,incy,ix,iy,n
c
      if(n.le.0)return
c     if (cabs(real(ca)) + cabs(aimag(ca)) .eq. 0.0e0 ) return
      if (ca.eq.(0.0e0,0.0e0)) return
      if(incx.eq.1.and.incy.eq.1)go to 20
 
c        code for unequal increments or equal increments not equal to 1
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        cy(iy) = cy(iy) + ca*cx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
 
c        code for both increments equal to 1
   20 do 30 i = 1,n
        cy(i) = cy(i) + ca*cx(i)
   30 continue
      return
      end

      subroutine movemtrx(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex ca(ja1,0:ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb2
        do 15 jm = 1,jb1
          cb(jm,jn) = (0.0e0,0.0e0)
 15     continue
 10   continue
      do 20 jn = 1,n2
        do 25 jm = 1,n1
          cb(jm,jn) = ca(jm,jn)
 25     continue
 20   continue
c
      return
      end

        Double precision FUNCTION SJ(n,x)
        implicit double precision (d)
        real db(0:100),x
        integer flag
        parameter (iacc=40)

c --- Small argument approximation.
        if (x.lt.0.1d0) then
          dfac=1.0e0
          do 1 i=1,2*n+1,2
            dfac=dfac*float(i)
  1       continue
          SJ=(x**n)/dfac
          return
        end if

c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            SJ=sin(x)/x
            return
        end if
        if (n.eq.1) then
            SJ=sin(x)/x/x-cos(x)/x
            return
        end if
        if (n.eq.2) then
            SJ=(3.0e0/x/x-1.0e0)*sin(x)/x - 3.0e0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        dbessj0=cos(x)/x
        dbessj1=sin(x)/x
        if (x.gt.float(n)) then
            dbjm=dbessj0
            dbj=dbessj1
            do 11 j=0,n-1
                dbjp=(2.0e0*float(j)+1.)/x*dbj-dbjm
                dbjm=dbj
                dbj=dbjp
  11        continue
            SJ=dbj
        else
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            SJ=0.0e0
            db(m+1)=0.0e0
            db(m)=1.0e0
            i=0
            do 12 j=m,1,-1
                db(j-1)=(2.0e0*float(j)+1.)/x*db(j)-db(j+1)
                if (abs(db(j-1)).gt.1.d10) then
                    db(j-1)=db(j-1)*1.d-10
                    db(j)=db(j)*1.d-10
                    i=i+1
                end if
                if (j.eq.n) flag=i
  12        continue
            dr0=sin(x)/x
            if (db(0).eq.0.0e0) print *,'got 0 in SJ'
            dp=dr0/db(0)
            SJ=db(n)*dp*(1.d10)**(flag-i)
        end if
  13    return
        end

C       GENERATES SPHERICAL HANKEL FUNCTIONS OF THE THIRD KIND
        COMPLEX FUNCTION SH1(L,Z)
        complex ai,wkh1(-1:100)
        real *8 z,SJ
        AI=CMPLX(0.0e0,1.0e0)
        DO 1 I=-1,L
          WKH1(I)=(0.0e0,0.0e0)
  1     continue
        WKH1(-1)=EXP(AI*Z)/Z
        WKH1(0)=-AI*EXP(AI*Z)/Z
        DO 2 I=0,L-1
          WKH1(I+1)=float(2*I+1)/Z*WKH1(I)-WKH1(I-1)
  2     continue
        SH1=cmplx(SJ(l,z),aimag(WKH1(L)))
        RETURN
        END

