
        program testsj
        implicit complex (c)
        parameter (ndim = 100)
        complex csj(0:ndim)
        write(6,*) 'input nmax for spherical bessel function)'
        read(5,*) nmax
        write(6,*) 'input x '
        read(5,*) cx
        x = real(cx)
        do 30 jp = 1,nmax 
          call csbessj(cx,nmax,csj,ndim)
  30    continue
        do 10 jp = 0,nmax
          write(6,*) jp, csj(jp)
 10     continue

        stop 
        end


	subroutine csbessj(cx,n,csj,nd)
        implicit complex (c) 
        complex cx, csj(0:nd)
        integer flag
        parameter (iacc=40,bigni=1.e-10,bigno=1.e+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
        
c --- Explicit calculation of low order Bessel functions.
        cxinv = 1./cx
        if (n.eq.0) then
            csj(0)=sin(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            return
        end if
        if (n.eq.2) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            csj(2)=(3.0d0/cx/cx-1.0e0)*csj(0) - 3.0e0*cos(cx)/cx/cx
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        csj(0)=sin(cx)*cxinv
        csj(1)=csj(0)/cx-cos(cx)*cxinv
        csjb=csj(0)
        csjm=csj(1)
        if (abs(cx).gt.dfloat(n)) then
            do 11 j=2,n
                csjp=(2.0d0*dfloat(j-1)+1.)*cxinv*csjm-csjb
                csjb=csjm
                csjm=csjp
                csj(j)=csjm
  11        continue
        else
            csj1=csj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            csjm=0.0d0
            csjb=1.0d0
            i=0
            do 12 j=m,1,-1
                csjp=(2.0d0*dfloat(j+1)+1.)*cxinv*csjb-csjm
                csjm=csjb
                csjb=csjp
                if(j.le.n) csj(j)=csjp
c>>>>>                write(12,*) j, sjp
                if (abs(csjp).gt.bigno) then
                    csjm=csjm*1.d-10
                    csjb=csjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      csj(lp)=csj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (abs(csj(1)).eq.0.0e0) print *,'got 0 in SJ'
            cdp=csj1/csj(1)
            do 30 jp = 1,n
              csj(jp) = csj(jp)*cdp
  30        continue
        end if
  13    return
        end

