      program gauntcoef
c --- Calculates the Gaunt coefficients the direct way.
c     Useful the quickly get a specific coefficient to check one of the
c     recursive methods.
      integer m,n,mu,nu,p

      print *,'Enter n,m,nu,mu'
      read *,n,m,nu,mu

      do 1 p=n+nu,max(abs(n-nu),abs(m+mu)),-2
      print *,'gcoef(',p,') =',gcoef(m,n,mu,nu,p)
  1   continue

      stop
      end
c-----------------------------------------------------------

      Function GCOEF(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      real x1,x2,x3,fac3
      if (m.ge.0) x1=fac3(n+m,n-m+1)
      if (m.lt.0) x1=1.0/fac3(n-m,n+m+1)
      if (mu.ge.0) x2=fac3(nu+mu,nu-mu+1)
      if (mu.lt.0) x2=1.0/fac3(nu-mu,nu+mu+1)
      if (m+mu.ge.0) x3=1.0/fac3(p+m+mu,p-m-mu+1)
      if (m+mu.lt.0) x3=fac3(p-m-mu,p+m+mu+1)
      gcoef=((-1)**(m+mu))*(2*p+1)*sqrt(x1*x2*x3)*
     &      ThreeJ(n,nu,p,0,0,0)*ThreeJ(n,nu,p,m,mu,-m-mu)
c     gcoef=((-1)**(m+mu))*(2*p+1)*sqrt(Fac1(n+m)*Fac1(nu+mu)*
c    &     Fac1(p-m-mu)/Fac1(n-m)/Fac1(nu-mu)/Fac1(p+m+mu))*
c    &     ThreeJ(n,nu,p,0,0,0)*ThreeJ(n,nu,p,m,mu,-m-mu)
      return
      end
c---------------------------------------------------------------
   
      REAL FUNCTION ALGAMA(XX)

c     from pg. 157 of "Numerical Recipes" by Press,
c     Flannery, Teukolsky, and Vettering.

      real *8 cof(6),stp,half,one,fpf,tmp,ser
      data cof,stp/76.18009173d0,-86.50532033d0,24.01409822d0,
     &   -1.231739516d0,.120858003d-2,-.536382d-5,2.50662827465d0/
      data half,one,fpf/0.5d0,1.0d0,5.5d0/
      algama0=0.0
      pi=3.1415927
      nflag=0
c     xx=-1.5
      if (xx .eq. 0.0) then
        algama=algama0
        go to 1000
      else if (xx .lt. 1.0) then
        xx=(-1.0)*xx+1.0
        nflag=1
      end if
      x=xx-one
      tmp=x+fpf
      tmp=(x+half)*log(tmp)-tmp
      ser=one
      do 10 j=1,6
        x=x+one
        ser=ser+cof(j)/x
 10   continue
      algama=tmp+log(stp*ser)
c     write(*,*) algama
      if (nflag .eq. 1) then
        algama=log(pi)-algama-log(sin(pi*xx))
      end if
c     write(*,*) algama
 1000 return
      end
C------------------------------------------------------------

      FUNCTION CGR2(L,M,L1,M1,L2,M2)
C
C--THIS SUBROUTINE GENERATES THE GAUNT COEFFICIENTS,
C WHICH IS THE INTEGRAL OF THREE SPHERICAL HARMONICS
C WITH THE FIRST ONE CONJUGATED.
C
      PI=3.1415927
      CGR2=(-1)**M*SQRT(FLOAT(2*L+1)*
     & FLOAT(2*L1+1)*FLOAT(2*L2+1)/4./PI)*
     & THREEJ(L,L1,L2,0,0,0)*THREEJ(L,L1,L2,-M,M1,M2)
      RETURN
      END 
C-------------------------------------------------------------

      FUNCTION THREEJ(J1,J2,J3,M1,M2,M3)
C
C--THIS SUBROUTINE GENERATES THE 3-J COEFFICIENTS.
C REF: GOTTFRIED: QUANTUM MECHANICS (VOL. 1)
C
      THREEJ=(-1)**(J1-J2-M3)/SQRT(2.*FLOAT(J3)+1.)*
     & CLGO(J1,M1,J2,M2,J3,-M3)
      RETURN
      END 
c-----------------------------------------------------------

      FUNCTION CLGO(J1,M1,J2,M2,J,M)
C
C--THIS SUBROUTINE GENERATES THE CG-COEFFICIENTS. 
C REF: M. ABRAMOWITZ, ET.AL., HANDBOOK... ETC.
C
      IF((J1+J2-J) .LT. 0)GOTO 100
      IF((J1-J2+J) .LT. 0)GOTO 100
      IF((-J1+J2+J) .LT. 0)GOTO 100
      IF(IABS(M1) .GT. J1)GOTO 100
      IF(IABS(M2) .GT. J2)GOTO 100
      IF(IABS(M) .GT. J)GOTO 100
      IF((M1+M2) .NE. M)GOTO 100
 
      SUM=0.
      DO 150 K=0,10000
 
      IF((J1+J2-J-K) .LT. 0)GOTO 200
      IF((J1-M1-K) .LT. 0)GOTO 200
      IF((J2+M2-K) .LT. 0)GOTO 200
      IF((J-J2+M1+K) .LT. 0)GOTO 150
      IF((J-J1-M2+K) .LT. 0)GOTO 150
 
      ALFAC=1/2.*(ALGAMA(FLOAT(J1+M1+1))+ALGAMA(FLOAT(J1-M1+1))+
     & ALGAMA(FLOAT(J2+M2+1))+
     & ALGAMA(FLOAT(J2-M2+1))+ALGAMA(FLOAT(J+M+1))+
     & ALGAMA(FLOAT(J-M+1)))-(ALGAMA(FLOAT(K+1))+ 
     & ALGAMA(FLOAT(J1+J2-J-K+1))+
     & ALGAMA(FLOAT(J1-M1-K+1))+ALGAMA(FLOAT(J2+M2-K+1))+
     & ALGAMA(FLOAT(J-J2+M1+K+1))+ALGAMA(FLOAT(J-J1-M2+K+1)))
 
      FAC=EXP(ALFAC)*(-1)**K
      SUM=SUM+FAC
 
 150  CONTINUE
 200  CONTINUE
 
      ALFO=1/2.*(ALGAMA(FLOAT(J1+J2-J+1))+ALGAMA(FLOAT(J+J1-J2+1))+
     & ALGAMA(FLOAT(J+J2-J1+1))-ALGAMA(FLOAT(J+J1+J2+2)))
 
      FO=EXP(ALFO)*SQRT(2.*FLOAT(J)+1.) 
      CLGO=SUM*FO
      GOTO 120
 100  CLGO=0
 120  RETURN
      END 
c--------------------------------------------------------------

      Function FAC3(ns,ne)
      real i,j
      i=1.0
      do 1 j=real(ns),real(ne),-1.0
        i=i*j
  1   continue
      fac3=i
      return
      end
