      program scalaraddrec
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudim=20)
      complex*16 alpha,alph(0:nudim,-nudim:nudim,0:nudim,-nudim:nudim)
      complex*16 acheck
      complex*16 al1,al2,al3,sphank,amlt0(0:nudim,-nudim:nudim),coef
      real*8 ap,am,bp,bm,pho,theta,phi,k0,kr,costhe,cosphi,sinphi,SJ
      real*8 bess
      real*8 sbesj(0:nudim),pwork(0:nudim)

      complex*16 sphh(0:nudim,-nudim:nudim)
      open (14,file='recout',status='unknown')
      open (15,file='recdif',status='unknown')

      write(6,*) 'Enter n,m, and maximum value of nu.'
      read(5,*) ndest,mdest,numax
      mabs=iabs(mdest)

      write(6,*) 'Enter r,theta,phi.'
      read(5,*) pho,theta,phi

      write(6,*) 'Enter wavenumber k0.'
      read(5,*) k0

      write(6,*) 'Enter the control parameter lpp = 1 for checking'
      read(5,*) lpp

      kr=k0*pho
      costhe=cos(theta)
      cosphi=cos(phi)
      sinphi=sin(phi)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numax+ndest
      call sphharm(costhe,phi,nmx,nmx,sphh,nudim,nudim,pwork)
      call sbessj(kr,nmx,sbesj,nudim)
      nsign = -1
      do 10 nu=0,numax+ndest
        nsign = -nsign
        nmsign = nsign
        alph(0,0,nu,0)=nmsign*sphh(nu,0)*sbesj(nu)*3.544907702d0
        do 20 mu=1,nu
          nmsign = -nmsign
          alph(0,0,nu,mu)=nmsign*sphh(nu,-mu)*sbesj(nu)*3.544907702d0
          alph(0,0,nu,-mu)=nmsign*sphh(nu,mu)*sbesj(nu)*3.544907702d0
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,mabs-1
        do 40 nu=0,numax+ndest
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            alph(n+1,n+1,nu,mu)= (bpnu*alph(n,n,nu-1,mu-1)+
     &                            bmnu*alph(n,n,nu+1,mu-1))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(n+1,n+1,nu,-nu)= (bmnu*alph(n,n,nu+1,-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(float(2)/float(3))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(n+1,n+1,0,0)= (bmnu*alph(n,n,1,-1))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,mabs
      do 60 n=m,ndest-1
       if(n.eq.m) then
        do 70 nu=0,numax+ndest-m
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(n,m,nu-1,mu)
           al3=alph(n,m,nu+1,mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(n+1,m,nu,mu)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=alph(n,m,nu+1,-nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(n+1,m,nu,-nu)= (amnu*al3)/apnm     
          al3=alph(n,m,nu+1,nu)
          alph(n+1,m,nu,nu)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(n,m,nu+1,nu)
          amnu = sqrt(1./3.)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(n+1,m,nu,nu)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numax+ndest-m
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(n-1,m,nu,mu)
           al2=alph(n,m,nu-1,mu)
           al3=alph(n,m,nu+1,mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(n+1,m,nu,mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=alph(n-1,m,nu,-nu)
          al3=alph(n,m,nu+1,-nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(n+1,m,nu,-nu)=(-amnm*al1 + amnu * al3) / apnm     
          al1=alph(n-1,m,nu,nu)
          al3=alph(n,m,nu+1,nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(n+1,m,nu,nu)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(n-1,m,nu,nu)
          al3=alph(n,m,nu+1,nu)
          amnu = sqrt(1./3.)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(n+1,m,nu,nu)=(-amnm*al1 + amnu * al3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,mabs
        msign = -msign
        do 95 n=m,ndest
          do 96 nu=0,numax
            alph(n,-m,nu,0) = msign*dconjg(alph(n,m,nu,0))
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(n,-m,nu,mu) = msign*musign*dconjg(alph(n,m,nu,-mu))
              alph(n,-m,nu,-mu) = msign*musign*dconjg(alph(n,m,nu,mu))
 98         continue
 96       continue
 95     continue
 90   continue
  
c --- Write results to file called "recout".

      if(lpp .eq. 1) then
      write(14,*)'n,m,numax   = ',ndest,mdest,numax
      write(14,*)'r,theta,phi = ',pho,theta,phi
      write(14,*)'wavenumber  = ',k0
      write(14,*)' '
      write(14,*)'First line is the recursively calculated coefficient.'
      write(14,*)'Second line is the directly calculated coefficient.'
      write(14,*)' '
   
      jnmatch = 0
      do 180 n = 0,ndest
      do 190 m = -n,n
      do 200 nu=0,numax
        do 210 mu=-nu,nu
          write(14,990)n,m,nu,mu,alph(n,m,nu,mu)
          acheck=alpha(n,m,nu,mu,pho,theta,phi,k0)
          write(14,995) acheck
          if (cdabs((alph(n,m,nu,mu)-acheck)/acheck).ge.1.0d-3) then
              write(15,*)'Trouble. (n,m,nu,mu) =',n,m,nu,mu
              write(15,*)'           recursive =', alph(n,m,nu,mu)
              write(15,*)'           direct    =',acheck
              jnmatch = jnmatch + 1
          end if
 210    continue
 200  continue
 190  continue
 180  continue

      write(15,*) 'Number of unmatched coefficients = ', jnmatch
      print *,' '
      print *,'Translation coefficients written to file "recout"'
      print *,' '
      print *,'Any recursively calculated coefficients that do not',
     &        ' agree with the'
      print *,'directly calculated coefficients are written to file',
     &        ' "recdif"'
      print *,' '


      else if(lpp .eq. 2) then

      jnmatch = 0
      do 184 n = 0,ndest
      do 194 m = -n,n
      do 204 nu=0,numax
        do 214 mu=-nu,nu
          acheck=alpha(n,m,nu,mu,pho,theta,phi,k0)
 214    continue
 204  continue
 194  continue
 184  continue

      else if(lpp .eq. 0) then
      
      write(14,*)'n,m,numax   = ',ndest,mdest,numax
      write(14,*)'r,theta,phi = ',pho,theta,phi
      write(14,*)'wavenumber  = ',k0
      write(14,*)' '
      write(14,*)'First line is the recursively calculated coefficient.'
      write(14,*)'Second line is the directly calculated coefficient.'
      write(14,*)' '

      do 185 n = 0,ndest
      do 195 m = -n,n
      do 205 nu=0,numax
        do 215 mu=-nu,nu
          write(14,990)n,m,nu,mu,alph(n,m,nu,mu)
 215    continue
 205  continue
 195  continue
 185  continue

 990  format(4i4, 1p2d19.8)
 995  format(16x, 1p2d19.8)
      print *,' '
      print *,'Translation coefficients written to file "recout"'
      print *,' '
      print *,'Any recursively calculated coefficients that do not',
     &        ' agree with the'
      print *,'directly calculated coefficients are written to file',
     &        ' "recdif"'
      print *,' '

      endif

      stop
      end

c----------------------------------------------------------------------

      Real*8 Function Ap(n,m)
      ap=-sqrt(dfloat(n+m+1)*dfloat(n-m+1)/dfloat(2*n+1)/dfloat(2*n+3))
      return
      end

      Real*8 Function Am(n,m)
      am=sqrt(dfloat(n+m)*dfloat(n-m)/dfloat(2*n+1)/dfloat(2*n-1))
      return
      end

      Real*8 Function Bp(n,m)
      bp=sqrt(dfloat(n+m+2)*dfloat(n+m+1)/dfloat(2*n+1)/dfloat(2*n+3))
      return
      end

      Real*8 Function Bm(n,m)
      bm=sqrt(dfloat(n-m)*dfloat(n-m-1)/dfloat(2*n+1)/dfloat(2*n-1))
      return
      end
c------------------------------------------------------------------------

      subroutine update(a,nudim)
      complex*16 a
      dimension a(-1:1,0:nudim,-nudim:nudim)
      do 1 i=0,nudim
        do 2 j=-nudim,nudim
          a(-1,i,j)=a(0,i,j)
          a(0,i,j)=a(1,i,j)
  2     continue
  1   continue
      return
      end
c------------------------------------------------------------------------

      Complex*16 Function ALPHA(n,m,nu,mu,r,theta,phi,k0)
      complex*16 psum,temp,ai
      real*8 r,theta,phi,k0,fact2a,fact2b,fac1,SJ,DRLGN1,a(0:200),gcoef
      integer n,m,nu,mu,p
      ai  =(0.0d0,1.0d0)
      psum=(0.0d0,0.0d0)
c --- Uncomment these two lines to use Fuller's Gaunt recursion.
c     As it stands now, Gaunt coefficients calculated directly in 
c     subroutine "gcoef" (to play it safe).
c>>>      call Fuller(m,n,-mu,nu,a)
      do 3 p=n+nu,max(abs(n-nu),abs(m-mu)),-2
c>>>        temp=(ai**(p+nu-n))*a(p)*SJ(p,k0*r)*DRLGN1(cos(theta),p,m-mu)
        temp=(ai**(p+nu-n))*gcoef(m,n,-mu,nu,p)*SJ(p,k0*r)*
     &       DRLGN1(cos(theta),p,(m-mu))
        psum=psum+temp
  3   continue
      fact2a=((-1.0d0)**m)*sqrt(dfloat(2*n+1)*fac1(n-m)/fac1(n+m))
      fact2b=sqrt(dfloat(2*nu+1)*fac1(nu+mu)/fac1(nu-mu))
      alpha=psum*fact2a*fact2b*exp(ai*(m-mu)*phi)
      return
      end
c------------------------------------------------------------------------

      Subroutine Fuller(m,n,mu,nu,ag)
      integer m,n,mu,nu,p
      real*8 ag(0:200),lpha,a,b,e,gcoef,dum,dumm2,chi1,chi2,chi3
      real*8 xnum,xnum1,xnum2,xdnm,chi2a,chi2b,chi2c,afctr

      if (m.eq.0.and.mu.eq.0) then
          CALL INITG(n,m,nu,mu,ag(n+nu),ag(n+nu-2))
          if (n.ne.nu) then
            DO P=n+nu,abs(n-nu)+4,-2
              ag(p-4)=ag(p-2)*lpha(n,nu,p-2)/lpha(n,nu,p-3)
            ENDDO
          else if (n.eq.nu) then
            DO P=n+nu,4,-2
              XNUM=dFLOAT((P+2*M-2)*(P+2*N-1)*(2*N-P+3)*(P-2)*(2*P-7))
              XDNM=dFLOAT((P-2*M-3)*(P+2*N-2)*(2*N-P+4)*(P-3)*(2*P-3))
	      AG(P-4)=XNUM*AG(P-2)/XDNM
            ENDDO
          end if
       return
       end if

        CALL INITG(n,m,nu,mu,ag(n+nu),ag(n+nu-2))

        if (n.eq.nu .and. m.eq.mu) then
          DO P=n+nu,abs(m+mu)+4,-2
            XNUM=dFLOAT((P+2*M-2)*(P+2*N-1)*(2*N-P+3)*(P-2)*(2*P-7))
            XDNM=dFLOAT((P-2*M-3)*(P+2*N-2)*(2*N-P+4)*(P-3)*(2*P-3))
            AG(P-4)=XNUM*AG(P-2)/XDNM
          ENDDO
          return
        end if

        DO 5 P=n+nu,max(abs(n-nu),abs(m+mu))+4,-2
          ip2 = mu*(p+nu)   + m*(nu+1)
          ip4 = mu*(p-nu-3) - m*(nu+1)

          afctr=A(m,n,mu,nu+1,p-1)
          IF (dABS(AFCTR).GT.1.0d-16) THEN

            IF (IP2.NE.0 .AND. IP4.NE.0) THEN
        CHI1 =AFCTR*B(M,N,MU,-NU-2,P-3)*B(M,N,MU,NU,P-4)
        CHI2A=A(M,N,MU,NU+1,P-3)*B(M,N,MU,NU,P-2)*E(M,N,MU,-NU-2,P-1)
        CHI2B=A(M,N,MU,NU+1,P-1)*B(M,N,MU,-NU-2,P-3)*E(M,N,MU,NU,P-2)
        CHI2C=A(M,N,MU,NU+1,P-1)*A(M,N,MU,NU+2,P-2)*A(M,N,MU,NU+1,P-3)
        CHI2 =CHI2A+CHI2B+((NU+1)**2-MU**2)*CHI2C
        CHI3 =A(M,N,MU,NU+1,P-3)*E(M,N,MU,-NU-2,P-1)*E(M,N,MU,NU,P)
              AG(P-4)=-(CHI2*AG(P-2)+CHI3*AG(P))/CHI1

	    ELSE 
        if (m*m*(nu+1)+mu*mu*(n+1)+m*mu*(n+nu+3).eq.0) then
          ag(p-4)=gcoef(m,n,mu,nu,p-4)
          go to 5
        end if
   	      JJN=NU
	      JNU=N
  	      JM=MU
	      JMU=M
         CHI1=A(JM,JJN,JMU,JNU+1,P-1)*B(JM,JJN,JMU,-JNU-2,P-3)
     + 	      *B(JM,JJN,JMU,JNU,P-4)
         CHI2A=A(JM,JJN,JMU,JNU+1,P-3)*B(JM,JJN,JMU,JNU,P-2)
     +	      *E(JM,JJN,JMU,-JNU-2,P-1)
	 CHI2B=A(JM,JJN,JMU,JNU+1,P-1)*B(JM,JJN,JMU,-JNU-2,P-3)
     + 	      *E(JM,JJN,JMU,JNU,P-2)
	 CHI2C=A(JM,JJN,JMU,JNU+1,P-1)*A(JM,JJN,JMU,JNU+2,P-2)
     +	      *A(JM,JJN,JMU,JNU+1,P-3)
c        CHI2=CHI2A+CHI2B+((JJN+1)**2-JMU**2)*CHI2C 
	 CHI2=CHI2A+CHI2B+((JNU+1)**2-JMU**2)*CHI2C 
         CHI3=A(JM,JJN,JMU,JNU+1,P-3)*E(JM,JJN,JMU,-JNU-2,P-1)
     + 	      *E(JM,JJN,JMU,JNU,P)
	      AG(P-4)=-(CHI2*AG(P-2)+CHI3*AG(P))/CHI1
	    ENDIF

	  ELSE IF (dABS(AFCTR).LE.1.0d-16) THEN 
            call initg(n,m,nu-1,mu,dum,dumm2)
	    XNUM1=(NU+MU)*A(M,N,MU,NU+1,P-3)*dumm2
	    XNUM2=-E(M,N,MU,-NU-1,P-2)*AG(P-2)
	    XDNM=B(M,N,MU,-NU-1,P-4)
	    AG(P-4)=(XNUM1+XNUM2)/XDNM
	  ENDIF

  5       continue
        return
        end
c------------------------------------------------------------------------

	Double precision FUNCTION SJ(n,x)
        implicit double precision (d)
        real*8 db(0:100),x
        integer flag
        parameter (iacc=40)
        
c --- Small argument approximation.
        if (x.lt.0.1d0) then
          dfac=1.0d0
          do 1 i=1,2*n+1,2
            dfac=dfac*dfloat(i)
  1       continue
          SJ=(x**n)/dfac
          return
        end if

c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            SJ=sin(x)/x
            return
        end if
        if (n.eq.1) then
            SJ=sin(x)/x/x-cos(x)/x
            return
        end if
        if (n.eq.2) then
            SJ=(3.0d0/x/x-1.0d0)*sin(x)/x - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        dbessj0=cos(x)/x
        dbessj1=sin(x)/x
        if (x.gt.dfloat(n)) then
            dbjm=dbessj0
            dbj=dbessj1
            do 11 j=0,n-1
                dbjp=(2.0d0*dfloat(j)+1.)/x*dbj-dbjm
                dbjm=dbj
                dbj=dbjp
  11        continue
            SJ=dbj
        else
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            SJ=0.0d0
            db(m+1)=0.0d0
            db(m)=1.0d0
            i=0
            do 12 j=m,1,-1
                db(j-1)=(2.0d0*dfloat(j)+1.)/x*db(j)-db(j+1)
                if (dabs(db(j-1)).gt.1.d10) then
                    db(j-1)=db(j-1)*1.d-10
                    db(j)=db(j)*1.d-10
                    i=i+1
                end if
                if (j.eq.n) flag=i
  12        continue
            dr0=sin(x)/x
            if (db(0).eq.0.0d0) print *,'got 0 in SJ'
            dp=dr0/db(0)
            SJ=db(n)*dp*(1.d10)**(flag-i)
        end if
  13    return
        end
c------------------------------------------------------------------------

      Subroutine INITG(n,m,nu,mu,dannu,dannum2)
      implicit double precision (d,f)
      integer n,m,nu,mu,top,bot,ix,iy,ixx,iyy
      ix=max(n,nu)
      iy=min(n,nu)
      ixx=max(n-m,nu-mu)
      iyy=min(n-m,nu-mu)
      dannu=fac2(2*iy-1)*fac3(ixx+iyy,ixx+1)/
     &     fac4(2*ix+2*iy-1,2*ix+1)/fac1(iyy)
      top=(n+n+nu+nu-3)*((n+nu-1)*(n*nu+m*mu*(n+n+nu+nu-1))-
     &    (m+mu)*(nu*m*(nu+nu-1)+n*mu*(n+n-1)))
      bot=(n+n-1)*(nu+nu-1)*(n+nu-m-mu)*(n+nu-m-mu-1)
      if (bot.eq.0) then
        dannum2=0.0d0
        return
      end if
      dannum2=dfloat(top)*dannu/dfloat(bot)
      return
      end
c------------------------------------------------------------------------

      Real*8Function FAC1(n)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(n),1.0d0,-1.0d0
        i=i*j
  1   continue
      fac1=i
      return
      end 

      Real*8 Function FAC2(n)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(n),1.0d0,-2.0d0
        i=i*j
  1   continue
      fac2=i
      return
      end 

      Real*8 Function FAC3(ns,ne)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(ns),dfloat(ne),-1.0d0
        i=i*j
  1   continue
      fac3=i
      return
      end

      Real*8 Function FAC4(ns,ne)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(ns),dfloat(ne),-2.0d0
        i=i*j
  1   continue
      fac4=i
      return
      end
c------------------------------------------------------------------------

      Real*8 Function A(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      A=dfloat((M-MU)*(P+1)*P-(M+MU)*(N-NU+1)*(N+NU))
      return
      end

      Real*8 Function B(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      B=dfloat((P-M-MU+1)*(MU*(P-NU+1)-M*(NU+1))*(-N+NU+P+1)
     +       *(N+NU+P+2))/dfloat(2*p+1)
      return
      end

      Real*8 Function E(m,n,mu,nu,p)
      integer m,n,mu,nu,p
      E=dfloat((P+M+MU)*(MU*(P+NU)+M*(NU+1))*(N+NU-P+1)
     +       *(N-NU+P))/dfloat(2*p+1)
      return
      end

      Real*8 Function LPHA(n,nu,p)
      real*8 cp,cm
      integer n,nu,p
      cp=dfloat((n+nu+p+1)*(n-nu+p))/dfloat(2*p+1)
      cm=dfloat((n+nu-p+1)*(n-nu-p))/dfloat(-2*p+1)
      LPHA=cp*cm
      return
      end
c------------------------------------------------------------------------

c------------------------------------------------------------------------

      Double precision FUNCTION ALGAMA(XX)
c     from pg. 157 of "Numerical Recipes" by Press,
c     Flannery, Teukolsky, and Vettering.
      real *8 cof(6),stp,half,one,fpf,tmp,ser,pi,xx,algama0,x
      integer nflag,j
      data cof,stp/76.18009173d0,-86.50532033d0,24.01409822d0,
     &   -1.231739516d0,.120858003d-2,-.536382d-5,2.50662827465d0/
      data half,one,fpf/0.5d0,1.0d0,5.5d0/
      algama0=0.0
      pi=4.0d0*atan2(1.0d0,1.0d0)
      nflag=0
      if (xx .eq. 0.0d0) then
        algama=algama0
        go to 1000
      else if (xx .lt. 1.0d0) then
        xx=-xx+1.0d0
        nflag=1
      end if
      x=xx-one
      tmp=x+fpf
      tmp=(x+half)*log(tmp)-tmp
      ser=one
      do 10 j=1,6
        x=x+one
        ser=ser+cof(j)/x
 10   continue
      algama=tmp+log(stp*ser)
      if (nflag .eq. 1) then
        algama=log(pi)-algama-log(sin(pi*xx))
      end if
 1000 return
      end
c------------------------------------------------------------------------

      Real*8 Function GCOEF(m,n,mu,nu,p)

      integer m,n,mu,nu,p
      real*8 x1,x2,x3,fac3,threej

      if (m.ge.0) x1=fac3(n+m,n-m+1)
      if (m.lt.0) x1=1.0/fac3(n-m,n+m+1)

      if (mu.ge.0) x2=fac3(nu+mu,nu-mu+1)
      if (mu.lt.0) x2=1.0/fac3(nu-mu,nu+mu+1)

      if (m+mu.ge.0) x3=1.0/fac3(p+m+mu,p-m-mu+1)
      if (m+mu.lt.0) x3=fac3(p-m-mu,p+m+mu+1)

      gcoef=((-1.0d0)**(m+mu))*dfloat(2*p+1)*sqrt(x1*x2*x3)*
     &      ThreeJ(n,nu,p,0,0,0)*ThreeJ(n,nu,p,m,mu,-m-mu)

      return
      end
c------------------------------------------------------------------------

C	THREEJ(J1,J2,J3,M1,M2,M3) 			JULY 31, 1984
C	THIS SUBROUTINE GENERATES THE 3-J COEFFICIENTS.
C	REF: GOTTFRIED:QUANTUM MECHANICS(VOL.1)
C
	Real*8 FUNCTION THREEJ(J1,J2,J3,M1,M2,M3)
        real*8 clgo
        integer j1,j2,j3,m1,m2,m3
	THREEJ=((-1.0d0)**(J1-J2-M3))/SQRT(dfloat(2*J3+1))*
     &         CLGO(J1,M1,J2,M2,J3,-M3)
	RETURN
	END
c------------------------------------------------------------------------

C	CLGO(J1,M1,J2,M2,J,M)                           AUG. 31, 1984
C	THIS SUBROUTINE GENERATES THE CG-COEFFICIENTS.
C	REF: M.ABRAMOWITZ, ET.AL. HANDBOOK.... ETC.

	Real*8 FUNCTION CLGO(J1,M1,J2,M2,J,M)
        real*8 sum,alfac,algama,alfo
        integer j,j1,j2,m,m1,m2,k
	IF((J1+J2-J).LT.0)GO TO 100
	IF((J1-J2+J).LT.0)GO TO 100
	IF((-J1+J2+J).LT.0)GO TO 100
	IF(IABS(M1).GT.J1)GO TO 100
	IF(IABS(M2).GT.J2)GO TO 100
	IF(IABS(M).GT.J)GO TO 100
	IF((M1+M2).NE.M)GO TO 100

	SUM=0.0d0
	DO 150 K=0,10000
	IF((J1+J2-J-K).LT.0)GO TO 200	
	IF((J1-M1-K).LT.0)GO TO 200	
	IF((J2+M2-K).LT.0)GO TO 200
	IF((J-J2+M1+K).LT.0)GO TO 150	
	IF((J-J1-M2+K).LT.0)GO TO 150	

	ALFAC=.5d0*(ALGAMA(dFLOAT(J1+M1+1))+ALGAMA(dFLOAT(J1-M1+1))
     1        +ALGAMA(dFLOAT(J2+M2+1))
     2        +ALGAMA(dFLOAT(J2-M2+1))     +ALGAMA(dFLOAT(J+M+1))
     3        +ALGAMA(dFLOAT(J-M+1)))     -(ALGAMA(dFLOAT(K+1))
     4        +ALGAMA(dFLOAT(J1+J2-J-K+1))
     5        +ALGAMA(dFLOAT(J1-M1-K+1))   +ALGAMA(dFLOAT(J2+M2-K+1))
     6        +ALGAMA(dFLOAT(J-J2+M1+K+1)) +ALGAMA(dFLOAT(J-J1-M2+K+1)))
	SUM=SUM+EXP(ALFAC)*((-1.0d0)**K)
150	CONTINUE	
200     continue
        ALFO=.5d0*(ALGAMA(dFLOAT(J1+J2-J+1))+ALGAMA(dFLOAT(J+J1-J2+1))
     1            +ALGAMA(dFLOAT(J+J2-J1+1))-ALGAMA(dFLOAT(J+J1+J2+2)))
	CLGO=SUM*EXP(ALFO)*SQRT(dfloat(2*J+1))
	GO TO 120

100	CLGO=0.0d0
120	RETURN
	END
c------------------------------------------------------------------------

      COMPLEX*16 FUNCTION SH(L,M,DX,DPHICOS,DPHISIN) 

      implicit double precision (d)
      COMPLEX*16 AI
      REAL*8 DFAC,DRLGN1,DX,DPHICOS,DPHISIN,pi,top,bot
      INTEGER L,M,MA
      AI=(0.0d0,1.0d0)
      MA=IABS(M)
 
c --- The dfac = sqrt( (L-MA)!/(L+MA)! * (2*L+1)/(4*pi)).
c     However, as MA increases, (L+MA)! overflows the computer.
c     dfac is computed as follows to prevent this from happening.

      pi=4.0d0*atan2(1.0d0,1.0d0)
      top=1.0d0
      do 11 i=1,L-MA
        top=top*dfloat(i)
 11   continue
      bot=sqrt(dfloat(2*l+1)*top)
      do 12 i=1,L+MA
        bot=bot/sqrt(dfloat(i))
 12   continue
      dfac=bot/sqrt(4.0d0*pi)

      IF (M .GE. 0) THEN
        SH=DFAC*DRLGN1(DX,L,MA)*((DPHICOS+AI*DPHISIN)**MA)*
     &      ((-1.d0)**MA)
      ENDIF
      IF (M .LT. 0) THEN
        SH=DFAC*DRLGN1(DX,L,MA)*((DPHICOS-AI*DPHISIN)**MA)
      ENDIF
      RETURN
      END 

c****module drlgn1
      REAL*8 FUNCTION DRLGN1(DX,N,M)
      real*8 an,am,sum,fac,prefac,pre,dx,algama

      IF (ABS(M) .LE. N) GOTO 60
      DRLGN1=0.0d0
      RETURN
 60   AN=dfloat(n)
      AM=dfloat(m)
      SUM=DX**(N-M)
      FAC=1.0d0
      PREFAC=(ABS((1.d0-DX*DX))**(M/2.d0))*((-1.0d0)**M)
      PRE=EXP(ALGAMA(AN+.5d0)-ALGAMA(.5d0)-ALGAMA(AN-AM+1.d0))*PREFAC
      IF (N-M .LT. 2) GOTO 90
      DO 80 K=2,N-M,2
       FAC=-FAC*dfloat((N-M-K+1)*(N-M-K+2))/dfloat(K*(2*N-K+1))
       SUM=SUM+FAC*(DX**(N-M-K))
 80   CONTINUE
 90   DRLGN1=SUM*PRE*(2.0d0**N)
      RETURN
      END 



	subroutine sbessj(x,n,sj,nd)
        implicit double precision (a-h,o-z)
        real*8 x, sj(0:nd)
        integer flag
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
        
c --- Explicit calculation of low order Bessel functions.
        xinv = 1./x
        if (n.eq.0) then
            sj(0)=sin(x)*xinv
            return
        end if
        if (n.eq.1) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            return
        end if
        if (n.eq.2) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            sj(3)=(3.0d0/x/x-1.0d0)*sj(0) - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        sj(0)=sin(x)*xinv
        sj(1)=sj(0)/x-cos(x)*xinv
        sjb=sj(0)
        sjm=sj(1)
        if (x.gt.dfloat(n)) then
            do 11 j=2,n
                sjp=(2.0d0*dfloat(j-1)+1.)*xinv*sjm-sjb
                sjb=sjm
                sjm=sjp
                sj(j)=sjm
  11        continue
        else
            sj1=sj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            sjm=0.0d0
            sjb=1.0d0
            i=0
            do 12 j=m,1,-1
                sjp=(2.0d0*dfloat(j+1)+1.)*xinv*sjb-sjm
                sjm=sjb
                sjb=sjp
                if(j.le.n) sj(j)=sjp
c>>>>>                write(12,*) j, sjp
                if (dabs(sjp).gt.bigno) then
                    sjm=sjm*1.d-10
                    sjb=sjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      sj(lp)=sj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (sj(1).eq.0.0d0) print *,'got 0 in SJ'
            dp=sj1/sj(1)
            do 30 jp = 1,n
              sj(jp) = sj(jp)*dp
  30        continue
        end if
  13    return
        end
c------------------------------------------------------------------------


      SUBROUTINE SPHHARM(X,PHI,L,M,SPHH,LD1,LD2,PWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PWORK(0:LD1)
      COMPLEX*16 SPHH(0:LD1,-LD2:LD2), CI
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
CC
      CI = (0.0D0,1.0D0)
      PI = ACOS(-1.0D0)
      DO 10 LM = 0,M
        CALL LEGENDR(X,L,LM,PWORK,LD1) 
        DO 20 LP = LM,L
          SPHH(LP,LM) = DCMPLX(PWORK(LP),0.0D0)
 20     CONTINUE
 10   CONTINUE
C
      PIINV = 0.5D0/SQRT(PI)
C
      DO 30 LP = 0,L
        SPHH(LP,0) = PIINV*SQRT(FLOAT(2*LP+1))*SPHH(LP,0)
 30   CONTINUE
C
      IF(L .LT. 150) THEN
        PN = 1.
        DO 40 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*FLOAT(LP)+1.0D0)
          PN = PN*FLOAT(LP)
          PADD = SQRT(PN)
          PMIN = PN
          DO 50 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD*SQRT(FLOAT(LP+MP))
            PMIN = PMIN/FLOAT(LP-MP+1)   
            FAC = SIGN*FACL*SQRT(PMIN)/PADD
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 50       CONTINUE
 40     CONTINUE
      ELSE
        PN = 0.0
        DO 60 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*FLOAT(LP)+1.0D0)
          PN = PN + LOG(FLOAT(LP))
          PADD = PN
          PMIN = PN
          DO 70 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD + LOG(FLOAT(LP+MP))
            PMIN = PMIN - LOG(FLOAT(LP-MP+1))   
            FAC = SIGN*FACL*EXP(0.5D0*(PMIN-PADD))
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 70       CONTINUE
 60     CONTINUE
      ENDIF  
C
      RETURN
      END







      SUBROUTINE LEGENDR(X,L,M,PLGNDR,LD1)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PLGNDR(0:LD1)
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
      PMM=1.
      IF(M.GT.0) THEN
        SOMX2=SQRT((1.-X)*(1.+X))
        FACT=1.
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.
11      CONTINUE
      ENDIF
      IF(L.EQ.M) THEN
        PLGNDR(L)=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF(L.EQ.M+1) THEN
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
        ELSE
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PLGNDR(LL)=PLL
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
        ENDIF
      ENDIF
      RETURN
      END
