

        program testsh
        implicit double precision (a-h,o-z)
        parameter (ndim = 100)
        complex*16 sh(0:ndim)
        write(6,*) 'input nmax for spherical bessel function)'
        read(5,*) nmax
        write(6,*) 'input x '
        read(5,*) x
        do 30 jp = 1,nmax 
          call sbessh(x,nmax,sh,ndim)
  30    continue
        call sbessh(x,nmax,sh,ndim)
        do 10 jp = 0,nmax
          write(6,*) jp, sh(jp)
 10     continue

        stop 
        end

	subroutine sbessh(x,n,sh,nd)
        implicit double precision (a-h,o-z)
        parameter (ndim = 100)
        real*8 x, sj(0:ndim), sy(0:ndim)
        complex*16 ci, sh(0:nd)

        ci = (0.,1.)

        call sbessj(x,n,sj,nd)
        call sbessy(x,n,sy,ndim)
        
        do 10 j = 0,n
          sh(j) = sj(j) + ci*sy(j)
 10     continue
c
        return
        end

	subroutine sbessj(x,n,sj,nd)
        implicit double precision (a-h,o-z)
        real*8 x, sj(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
        
c --- Explicit calculation of low order Bessel functions.
        xinv = 1./x
        if (n.eq.0) then
            sj(0)=sin(x)*xinv
            return
        end if
        if (n.eq.1) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            return
        end if
        if (n.eq.2) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            sj(3)=(3.0d0/x/x-1.0d0)*sj(0) - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        sj(0)=sin(x)*xinv
        sj(1)=sj(0)/x-cos(x)*xinv
        sjb=sj(0)
        sjm=sj(1)
        if (x.gt.dfloat(n)) then
            do 11 j=2,n
                sjp=(2.0d0*dfloat(j-1)+1.)*xinv*sjm-sjb
                sjb=sjm
                sjm=sjp
                sj(j)=sjm
  11        continue
        else
            sj1=sj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            sjm=0.0d0
            sjb=1.0d0
            i=0
            do 12 j=m,1,-1
                sjp=(2.0d0*dfloat(j+1)+1.)*xinv*sjb-sjm
                sjm=sjb
                sjb=sjp
                if(j.le.n) sj(j)=sjp
c>>>>>                write(12,*) j, sjp
                if (dabs(sjp).gt.bigno) then
                    sjm=sjm*1.d-10
                    sjb=sjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      sj(lp)=sj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (sj(1).eq.0.0d0) print *,'got 0 in SJ'
            dp=sj1/sj(1)
            do 30 jp = 1,n
              sj(jp) = sj(jp)*dp
  30        continue
        end if
  13    return
        end
c------------------------------------------------------------------------



	subroutine sbessy(x,n,sy,nd)
        implicit double precision (a-h,o-z)
        real*8 x, sy(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
c
        xinv = 1./x
c        
c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            sy(0)=-cos(x)*xinv
            return
        end if
        if (n.eq.1) then
            sy(0)=-cos(x)*xinv
            sy(1)=sy(0)*xinv-sin(x)*xinv
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        sy(0)=-cos(x)*xinv
        sy(1)=sy(0)*xinv-sin(x)*xinv
        syb=sy(0)
        sym=sy(1)
        do 11 j=2,n
          syp=(2.0d0*dfloat(j-1)+1.)*xinv*sym-syb
          syb=sym
          sym=syp
          sy(j)=sym
  11    continue
        return
        end
c------------------------------------------------------------------------

