c****module mainhh
      PROGRAM MAINHH 
                   
c ****** this program is for high frequency case. All normalization
c        factors have been taken away.
c
c  ***        nst is total # of spheres in grouping             ***
c  ***           mdm & pdm are matrix dimensions                ***
c  ***                iwa must be >3xmdm                        ***

c --- mdm and pdm must be perfect squares (not necessarily the same)
c
c
      implicit real*8 (a-b,d-h,o-z)
      implicit complex*16 (c)
      integer mdm,pdm,iwa,nst,ntm,ntp
      parameter ( mdm=4,  pdm=400)

      complex*16 t1(pdm,pdm)
      complex*16 einc(pdm), eps, epb
      dimension cbs1(pdm),cbs2(pdm)
      real*8 k0

      open(16,file='expara.inp',status='unknown')
      open(20,file='exactf.dat',status='unknown')

      pi=4.0d0*atan2(1.0d0,1.0d0)
      ee=sqrt(.75d0/pi)
      ai  =(0.0,1.0)
      one =(1.0,0.0)
c  
c --- Read in sphere position, size, and epsilon data.
c
      read(16,*) 
      read(16,*) epb
      read(16,*) 
      read(16,*) eps
      read(16,*) 
      read(16,*) pho
      read(16,*) 
      read(16,*) fq
      read(16,*) 
      read(16,*) rr
      read(16,*) 
      read(16,*) rphi 
      read(16,*) 
      read(16,*) nrv 
      read(16,*) 
      read(16,*) lmod
      
     
      ntm=int(sqrt(dfloat(mdm)))-1
      ntp=int(sqrt(dfloat(lmod)))-1
      k0=2.0e0*pi*fq/3.0d8
c
c --- Calculate normalized einc [Px1]
c
      call fieldin(lmod,einc,k0)
c
c      call t1sub(t1,mdm,ntm,fq,epb,eps,pho,k0)
      call stmatrx(t1,lmod,pdm,fq,epb,eps,pho,k0)
     
c
c*****calculate the scattering field from the composite medium
c
      tranrd = 180.0d0/pi
      deltth = pi/dfloat(nrv-1)
      thetar = 0.0d0
c
      do 500 jth = 1,nrv      
c
      call cbassf(rr,thetar,rphi,cbs1,pdm,lmod,k0)
      call cbassf(rr,thetar,rphi+pi,cbs2,pdm,lmod,k0)
c
      cscatt1 = (0.0d0,0.0d0)
      cscatt2 = (0.0d0,0.0d0)
      do 520 jp = 1,lmod
        ctemp = (0.0d0,0.0d0)
        do 510 jq = 1,lmod
          ctemp = ctemp + t1(jp,jq)*einc(jq) 
 510    continue
        cscatt1 = cscatt1 + cbs1(jp)*ctemp
        cscatt2 = cscatt2 + cbs2(jp)*ctemp
 520  continue
c
      write(20,600) thetar*tranrd,abs(cscatt1),
     &             atan2(dimag(cscatt1),dreal(cscatt1))*tranrd, 
     &             atan2(dimag(cscatt2),dreal(cscatt2))*tranrd 
c
      thetar = thetar + deltth
c
 500  continue
c
   
 600  format(2x,f7.2,e12.4,2f7.2)
      

      stop
      end
c****module fieldin
      subroutine fieldin(lpdm,ceinc,wk0)
c
      implicit complex*16 (c)
      implicit real*8 (a-b,d-h,o-z)
c
      dimension ceinc(lpdm)
c
      ci = (0.0d0,1.0d0)
      pi = 3.14159265358979312
c
      ntp = int(sqrt(dfloat(lpdm))) - 1
      k = 1
      cp = 1.0d0
      do 10 jn = 0,ntp
        do 20 jm = -jn,jn
          ceinc(k) = (0.0d0,0.0d0)
          k = k + 1
 20     continue
        ceinc((jn+1)*(jn+1)-jn) = cp*sqrt(4.0d0*pi*dfloat(2*jn+1))
c>>>     &                              /filld(jn,wk0)
        cp = cp*ci
 10   continue
c
      return
      end
c****module stmatrx
      subroutine stmatrx(ct1,mdm,ndm,fq,cepb,ceps,r,wk0)
      implicit complex*16 (c)
      implicit real*8 (a-b,d-h,o-z)
      parameter (mpp = 40)
c
      dimension sbjb(0:mpp+1),csbhb(0:mpp+1)
      dimension sbjs(0:mpp+1),csbhs(0:mpp+1)
      dimension ctemp(0:mpp)
      dimension ct1(ndm,ndm)

      ntm = int(sqrt(float(mdm))) - 1
      wkb  = wk0*sqrt(dreal(cepb))
      wks  = wk0*sqrt(dreal(ceps))
      wkrb  = wkb*r
      wkrs = wks*r
      ckr = wks/wkb
      cepr = ceps/cepb
c   
      do 1 i=1,mdm
c       do 2 j=1,pdm
        do 2 j=1,mdm
          ct1(i,j)=cmplx(0.0d0,0.0d0)
 2      continue
 1    continue
c
      call dsbesjh(wkrb,ntm+1,sbjb,csbhb,mpp+1)
      call dsbesjh(wkrs,ntm+1,sbjs,csbhs,mpp+1)
c
      do 20 jn = 0,ntm
        djb = -sbjb(jn+1) + jn*sbjb(jn)/wkrb
        cdhb = -csbhb(jn+1) + jn*csbhb(jn)/wkrb
        djs = -sbjs(jn+1) + jn*sbjs(jn)/wkrs
        cdhs = -csbhs(jn+1) + jn*csbhs(jn)/wkrs
        cden = sbjs(jn)*cdhb - cepr*ckr*djs*csbhb(jn)
        cnum = cepr*ckr*djs*sbjb(jn) - sbjs(jn)*djb
        ctemp(jn) = cnum/cden
 20   continue
c
      do 30 jn = 0,ntm
        np = (jn+1)*(jn+1) - jn
        do 25 jm = -jn,jn
          nq = np + jm
          ct1(nq,nq) = ctemp(jn)
 25     continue
 30   continue
c
      return
      end
c****module cbassf
      subroutine cbassf(r,theta,phi,cbass,ndim,lnp,wk0)
c
      parameter (nudd = 40)
      implicit real*8 (a-b,d-h,o-z)
      implicit complex*16 (c)
c
      dimension cbass(ndim)
      dimension csphh(0:nudd,-nudd:nudd)
      dimension pwork(0:nudd)
      dimension cbesh(0:nudd)
      dimension sbesj(0:nudd)

c
      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
c
      ntp = int(sqrt(dfloat(lnp))) - 1 
c
      acosthe = cos(theta)
      z = r*wk0
c
      call sphharm(acosthe,phi,ntp,ntp,csphh,nudd,nudd,pwork)
      call dsbesjh(z,ntp,sbesj,cbesh,nudd)
c
      do 20 jn = 0,ntp
        np = (jn+1)*(jn+1) - jn
        do 10 jm = -jn,jn
          nq = np + jm
          cbass(nq) = csphh(jn,jm)*cbesh(jn)
 10     continue
 20   continue
c
      return
      end
c****module movemtrx
      subroutine movemtrx(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex*16 ca(ja1,0:ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb2
        do 15 jm = 1,jb1
          cb(jm,jn) = (0.0d0,0.0d0)
 15     continue
 10   continue
      do 20 jn = 1,n2
        do 25 jm = 1,n1
          cb(jm,jn) = ca(jm,jn)
 25     continue
 20   continue
c
      return
      end
c************************************************************************
c****module spharm
      SUBROUTINE SPHHARM(X,PHI,L,M,SPHH,LD1,LD2,PWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PWORK(0:LD1)
      COMPLEX*16 SPHH(0:LD1,-LD2:LD2), CI
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
CC
      CI = (0.0D0,1.0D0)
      PI = ACOS(-1.0D0)
      DO 10 LM = 0,M
        CALL DLEGENDR(X,L,LM,PWORK,LD1) 
        DO 20 LP = LM,L
          SPHH(LP,LM) = DCMPLX(PWORK(LP),0.0D0)
 20     CONTINUE
 10   CONTINUE
C
      PIINV = 0.5D0/SQRT(PI)
C
      DO 30 LP = 0,L
        SPHH(LP,0) = PIINV*SQRT(DFLOAT(2*LP+1))*SPHH(LP,0)
 30   CONTINUE
C
      IF(L .LT. 150) THEN
        PN = 1.
        DO 40 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*DFLOAT(LP)+1.0D0)
          PN = PN*DFLOAT(LP)
          PADD = SQRT(PN)
          PMIN = PN
          DO 50 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD*SQRT(DFLOAT(LP+MP))
            PMIN = PMIN/DFLOAT(LP-MP+1)   
            FAC = SIGN*FACL*SQRT(PMIN)/PADD
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 50       CONTINUE
 40     CONTINUE
      ELSE
        PN = 0.0
        DO 60 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*DFLOAT(LP)+1.0D0)
          PN = PN + LOG(DFLOAT(LP))
          PADD = PN
          PMIN = PN
          DO 70 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD + LOG(DFLOAT(LP+MP))
            PMIN = PMIN - LOG(DFLOAT(LP-MP+1))   
            FAC = SIGN*FACL*EXP(0.5D0*(PMIN-PADD))
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 70       CONTINUE
 60     CONTINUE
      ENDIF  
C
      RETURN
      END
c**********************************************************************
c****dlegendr
      SUBROUTINE DLEGENDR(X,L,M,PLGNDR,LD1)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PLGNDR(0:LD1)
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in DLEGENDR'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
      PMM=1.0D0
      IF(M.GT.0) THEN
        SOMX2=SQRT((1.-X)*(1.+X))
        FACT=1.
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.0D0
11      CONTINUE
      ENDIF
      IF(L.EQ.M) THEN
        PLGNDR(L)=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF(L.EQ.M+1) THEN
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
        ELSE
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PLGNDR(LL)=PLL
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

c****************************************************************
c****module dsbesjh
	subroutine dsbesjh(x,n,sj,csh,nd)
        implicit complex*16 (c)
        implicit real*8 (a-b,d-h,o-z)
        dimension sj(0:nd),csh(0:nd)

        ci = (0.0d0,1.0d0)

        call dsbesy(x,n,sj,nd)
c
        do 5 j = 0,n
          csh(j) = ci*sj(j)
  5     continue
c
        call dsbesj(x,n,sj,nd)
        
        do 10 j = 0,n
          csh(j) = sj(j) + csh(j)
 10     continue
c
        return
        end
c****************************************************************
c****module cdsbesj
        subroutine dsbesj(cx,n,csj,nd)
c>>>        implicit complex*16 (c)
c>>>        implicit real*8 (a-b,d-h,o-z)
        implicit real*8 (a-h,o-z)
        dimension csj(0:nd)
        integer flag
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')

c --- Explicit calculation of low order Bessel functions.
        cxinv = 1.0d0/cx
        if (n.eq.0) then
            csj(0)=sin(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            return
        end if
        if (n.eq.2) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            csj(2)=(3.0d0/cx/cx-1.0d0)*csj(0) - 3.0d0*cos(cx)/cx/cx
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        csj(0)=sin(cx)*cxinv
        csj(1)=(csj(0)-cos(cx))*cxinv
        csjb=csj(0)
        csjm=csj(1)
        if (abs(cx).gt.dfloat(n)) then
            do 11 j=2,n
                csjp=(2.0d0*dfloat(j-1)+1.0d0)*cxinv*csjm-csjb
                csjb=csjm
                csjm=csjp
                csj(j)=csjm
  11        continue
        else
            csj1=csj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            csjm=0.0d0
            csjb=1.0d0
            i=0
            do 12 j=m,1,-1
                csjp=(2.0d0*dfloat(j+1)+1.d0)*cxinv*csjb-csjm
                csjm=csjb
                csjb=csjp
                if(j.le.n) csj(j)=csjp
c>>>>>                write(12,*) j, sjp
                if (abs(csjp).gt.bigno) then
                    csjm=csjm*1.d-10
                    csjb=csjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      csj(lp)=csj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (abs(csj(1)).eq.0.0e0) print *,'got 0 in SJ'
            cdp=csj1/csj(1)
            do 30 jp = 1,n
              csj(jp) = csj(jp)*cdp
  30        continue
        end if
  13    return
        end

c***************************************************************
c****module dsbesy
	subroutine dsbesy(cx,n,csy,nd)
c>>>        implicit complex*16 (c)
c>>>        implicit real*8 (a-b,d-h,o-z)
        implicit real*8 (a-h,o-z)
        dimension csy(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
c
        cxinv = 1.0d0/cx
c        
c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            csy(0)=-cos(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csy(0)=-cos(cx)*cxinv
            csy(1)=csy(0)*cxinv-sin(cx)*cxinv
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        csy(0)=-cos(cx)*cxinv
        csy(1)=csy(0)*cxinv-sin(cx)*cxinv
        csyb=csy(0)
        csym=csy(1)
        do 11 j=2,n
          csyp=(2.0e0*float(j-1)+1.)*cxinv*csym-csyb
          csyb=csym
          csym=csyp
          csy(j)=csym
  11    continue
        return
        end
c------------------------------------------------------------------------
c****modified by W.C. Chew for complex matrices January 15, 1991.
c
      SUBROUTINE CGAUSSJ(A,N,NP,B,M,MP)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NMAX=850)
      complex*16 a(np,np),b(np,np),dum,pivinv 
      DIMENSION IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                PAUSE 'Singular matrix, IPIV(K).GT.1'
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (abs(A(ICOL,ICOL)).EQ.0.) PAUSE 'Singular matrix, 
     &  ABS(A)=0.'
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=(1.,0.)
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=(0.,0.)
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END

