c****module mainlf
      PROGRAM MAINLF 
c ****** this program is for low frequency case.
c
c  ***        nst is total # of spheres in grouping             ***
c  ***           mdm & pdm are matrix dimensions                ***
c  ***                iwa must be >3xmdm                        ***

c --- mdm and pdm must be perfect squares (not necessarily the same)
c
c
      implicit real (a-b,d-h,o-z)
      implicit complex (c)
      integer mdm,pdm,iwa,nst,i,j,n,ntm,ntp
      parameter ( nst=1600, iwa=100 )
      parameter ( mdm=4,  pdm=64)
      parameter ( nptt = 100)
      parameter ( jnmax = 200*mdm ) 
c>>>      parameter ( jnmax = nst*mdm ) 

      complex caji(jnmax,jnmax),cbj(jnmax,pdm),ctb(jnmax,pdm)
      complex ab1(mdm,0:nptt),ab2(0:nptt,mdm)
      complex t1(mdm,mdm),taun(pdm,pdm),Tatau(mdm,pdm),taua(pdm,mdm)
      complex btb(pdm,pdm),dple,one,ai,tau
      complex eps(nst),epb,einc(pdm),a3,b3,c3
      complex an0(mdm,pdm),a0n(pdm,mdm),anm(mdm,mdm),w2(mdm,pdm)
      complex bn0(mdm,pdm),b0n(pdm,mdm),ID(mdm,mdm),epsef2,epsef1
      complex temp1(pdm,mdm),temp2(mdm,pdm),taun1(pdm,pdm),w(mdm,mdm)
      complex wtemp(mdm,mdm),temp3(mdm,mdm)
      complex czero(mdm,pdm)
      complex cft1(mdm,pdm),cft2(mdm,pdm),cft4(pdm,pdm)
      real r(nst),pho(nst),phi(nst),theta(nst),fv,tolrs,deltr
      real pi,k0,ee,rg,fq,fqeo,pho1,theta1,phi1,ka
      real pho2,theta2,phi2
      real pho3,theta3,phi3
      real epsr1,sigma1,epsr2,sigma2,fvv
      dimension cbs1(pdm),cbs2(pdm)
      dimension cwork(jnmax),ipvt(jnmax),cdet(2)
c>>>      complex alphn0(mdm,pdm) 
c>>>      complex betan0(mdm,pdm) 

      open(8,file='phidat.dat',status='unknown')
      open(9,file='thedat.dat',status='unknown')
      open(10,file='phodat.dat',status='unknown')
      open(11,file='raddat.dat',status='unknown')
      open(12,file='epsdat_',status='unknown')
      open(13,file='linout',status='unknown')
      open(14,file='dples',status='unknown')
      open(26,file='para.inp',status='unknown')
      open(20,file='fscatt.dat',status='unknown')

      pi=4.0e0*atan2(1.0e0,1.0e0)
      ee=sqrt(.75d0/pi)
      ai  =(0.0,1.0)
      one =(1.0,0.0)
  
c --- Read in sphere position, size, and epsilon data.

      fvv = 0.0e0
c
      read(10,*) nscatt
      do 1 i=1,nscatt
        read(8,*)  PHI(i)
        read(9,*)  THETA(i)
        read(10,*) PHO(i)
        read(11,*) R(i)
        read(12,*) EPS(i)
        fvv = fvv + r(i)**3
  1   continue
      read(11,*) RG
c      read(12,3) EPB
c      read(12,4) FQ
  3   Format(f11.4,d9.4)
  4   Format(d9.4)

      read(26,*)
      read(26,*) tolrs
      read(26,*)
      read(26,*) epb
      read(26,*)
      read(26,*) fq
      read(26,*)
      read(26,*) rr
      read(26,*)
      read(26,*) phir 
      read(26,*)
      read(26,*) nrv 
      read(26,*)
      read(26,*) lmod 
      read(26,*)
      read(26,*) nmod
      
     
      ntm=int(sqrt(float(lmod)))-1
      ntp=int(sqrt(float(nmod)))-1
      k0=2.0e0*pi*fq/3.0d8
      fqeo=fq*8.8419d-12
      fv=(r(1)/rg)**3
      fvv = fvv/pho(nscatt)**3

      write(*,*) 'grp rad.=',rg,'   epb=',conjg(epb),'  M =',lmod
      write(13,*)'grp rad.=',rg,'   epb=',conjg(epb),'  M =',lmod
      write(*,*) 'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',nmod
      write(13,*)'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',nmod
      write(*,*) 'spread  =',pho(3)-pho(2)
      write(13,*)'spread  =',pho(3)-pho(2)
      write(*,*) ' '
      write(13,*)' '

      write(*,*)  'Fractional Volume    ', fvv,  '   Dipole Term'
      write(*,*)  'new eff. permittivity         new eff. conductivity'
      write(13,*) 'Fractional Volume    ', fvv,  '   Dipole Term'
      write(13,*) 'new eff. permittivity         new eff. conductivity'
      write(13,*)' '

      do 115 i = 1,mdm
        do 116 j = 1,pdm
          czero(i,j) = (0.0e0,0.0e0)
 116    continue
 115  continue
c
      do 122 i=1,pdm
        do 121 j=1,pdm
          taun(i,j)=(0.0e0,0.0e0)
 121    continue
 122  continue

      do 124 i=1,mdm
        do 123 j=1,mdm
          ID(i,j)=cmplx(0.0e0,0.0e0)
 123    continue
          ID(i,i)=cmplx(1.0e0,0.0e0)
 124  continue

c --- Calculate normalized einc [Px1]

      call fieldin(pdm,einc,k0)
c
      nsct = 0
      do 1000 n=0,nscatt

c --- Find the number of scatterers in each shell

      np = 0
      if(tolrs .gt. 1.0d-12) then
      do 14 ln = nsct+1, nscatt
        lnp = ln
        deltr = pho(lnp+1) - pho(lnp)
        if(deltr .gt. tolrs) goto 15
 14   continue
      else
        ln = nsct+1
        lnp = ln
      endif
 15   np = lnp - nsct

      do 25 jsh = nsct+1,lnp

c --- Calculate normalized 1 sphere scattering matrix for sphere n+1
c     t1static    = (1/S) * t1dynamic    * D

      lp = jsh
      call stmatrx(t1,lmod,mdm,fq,epb,eps(lp),r(lp),k0)
     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex identity matrix [MxM].
c --- Calculate the normalization matrices (diagonal => column vectors)
c     alphastatic = (1/D) * alphadynamic * S
c     betastaticn0= (1/D) * betadynamic  * D
c     betastatic0n= (1/S) * betadynamic  * S
 
c --- an0 is alpha(n+1,0)    [MxP]

      phi1  =phi(lp)
      theta1=theta(lp)
      pho1  =pho(lp)
c
      call dsalpha(pho1,theta1,phi1,k0,ntm,ntp,ab1,mdm,nptt,1)
      call movemtrx(ab1,mdm,nptt,an0,mdm,pdm,lmod,nmod)
c
c --- find T_j(1)*alph_j0*tau_(n) and store the result in cft2	
c
      call cmmult1(t1,an0,mdm,mdm,lmod,lmod,nmod,cft1,pdm,1)
      call cmmult1(cft1,taun,mdm,pdm,lmod,nmod,nmod,cft2,pdm,1)
c
      j1 = (lp-nsct-1)*lmod + 1
c
      do 20 ish = nsct+1,lnp
c
      lq = ish
      phi2  = phi(lq)
      theta2= theta(lq)
      pho2  =pho(lq)
c
c --- a0n is alpha(0,n+1)    [PxM]
c
      call dsalphap(pho2,theta2,phi2,k0,ntp,ntm,ab2,nptt,mdm,-1)
      call movemtrxp(ab2,nptt,mdm,a0n,pdm,mdm,nmod,lmod)
c
c --- find T_j(1)*alph_j0*tau_(n)*alph_0i 
c       and store the result in wtemp 
c
      call cmmult1(cft2,a0n,mdm,pdm,lmod,nmod,lmod,wtemp,mdm,1)
c   
      if(ish .eq. jsh) then
c    
        call mtrxadd(wtemp,mdm,mdm,id,mdm,mdm,w,lmod,lmod,-1)
c
      else
c
c
        call recrdnt(pho1,theta1,phi1,pho2,theta2,phi2,
     &                                 pho3,theta3,phi3)
        call dsalpha(pho3,theta3,phi3,k0,ntm,ntm,ab1,mdm,nptt,-1)
        call movemtrx(ab1,mdm,nptt,anm,mdm,mdm,lmod,lmod)
        call cmmult1(t1,anm,mdm,mdm,lmod,lmod,lmod,temp3,mdm,1)
        call mtrxadd(wtemp,mdm,mdm,temp3,mdm,mdm,w,lmod,lmod,1)
c
      endif
c
c --- w is A_ji in the paper "Generalized Recursive Algorithm ..."
c     now, we need to move to a big matrix caji        
c
      i1 = (lq-nsct-1)*lmod + 1
c
      call movesl(w,caji,mdm,mdm,jnmax,jnmax,lmod,lmod,j1,i1)      
c
 20   continue
c
c --- form the right hand of the equation (9)
c
c --- bn0 is beta(n+1,0)   [MxP]

      call dsbeta(pho1,theta1,phi1,k0,ntm,ntp,ab1,mdm,nptt,1,1)
      call movemtrx(ab1,mdm,nptt,bn0,mdm,pdm,lmod,nmod)

      call cmmult1(t1,bn0,mdm,mdm,lmod,lmod,nmod,w2,pdm,1)
      call mtrxadd(w2,mdm,pdm,cft2,mdm,pdm,temp2,lmod,nmod,1)
      call mtrxadd(czero,mdm,pdm,temp2,mdm,pdm,cft2,lmod,nmod,-1)
c
      call movesl(cft2,cbj,mdm,pdm,jnmax,pdm,lmod,nmod,j1,1)      
c
 25   continue
c
      jlm = np*lmod
c
      write(6,*) 'the size of the matrix is = ',jlm,'X',jlm
c
c --- linear equations solver
c
      call cgefa(caji,jnmax,jlm,ipvt,info)
      call cgedi(caji,jnmax,jlm,ipvt,cdet,cwork,01)
c
      call cmmult1(caji,cbj,jnmax,jnmax,jlm,jlm,nmod,ctb,pdm,1)
c>>>      call cgaussj(caji,jlm,jnmax,cbj,nmod,pdm)
c
      call cinitmtrx(cft4,pdm,pdm)
c
      do 30 ish = nsct+1,lnp
c
c --- b0n is beta(0,n+1)   [PxM]
c
      lq = ish
      phi2  = phi(lq)
      theta2= theta(lq)
      pho2  = pho(lq)
c
      call dsbetap(pho2,theta2,phi2,k0,ntp,ntm,ab2,nptt,mdm,-1,2)
      call movemtrxp(ab2,nptt,mdm,b0n,pdm,mdm,pdm,mdm)
c
      call dsalphap(pho2,theta2,phi2,k0,ntp,ntm,ab2,nptt,mdm,-1)
      call movemtrxp(ab2,nptt,mdm,a0n,pdm,mdm,nmod,lmod)

      call cmmult1(taun,a0n,pdm,pdm,nmod,nmod,lmod,temp1,mdm,1)
      call mtrxadd(temp1,pdm,mdm,b0n,pdm,mdm,taua,nmod,lmod,1)

      i1 = (lq-nsct-1)*mdm + 1
      call movels(ctb,tatau,jnmax,pdm,mdm,pdm,lmod,nmod,i1,1)      
      call cmmult1(taua,tatau,pdm,mdm,nmod,lmod,nmod,btb,pdm,1)
      call mtrxadd(cft4,pdm,pdm,btb,pdm,pdm,cft4,nmod,nmod,1)
c
 30   continue
c
      call mtrxadd(cft4,pdm,pdm,taun,pdm,pdm,taun1,nmod,nmod,1)
c
c --- Calculate the dipole term:  row 3 of tau(n+1) * einc

      dple=(0.0,0.0)
      do 200 j=1,nmod
        dple=dple+taun1(3,j)*einc(j)
  200 continue

c --- Calculate effective permittivity and conductivity

      dple  = dple*ee/ai/k0/rg**3
c----------------------------------------------------------------------
      ka = k0 * rg
      tau= dple*(ka**3)/3.0/ai
      A3 =  15.0*(ka**3) - 18.0*(ka**5) -  45.0*ai*tau -  5.0*ai*(ka**6)
      B3 =  15.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau + 10.0*ai*(ka**6)
      C3 = -30.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau -  5.0*ai*(ka**6)
c----------------------------------------------------------------------
      epsef1= ((1.0+2.0*Dple)/(1.0-Dple))*epb
      epsr1 = real(epsef1)
      sigma1= -aimag(epsef1)*fqeo*2.0*pi
      epsef2= epb * ( -B3 + sqrt(B3*B3-4.0*A3*C3) ) / (2.0*A3)
      epsr2 = real(epsef2)
      sigma2= -aimag(epsef2)*fqeo*2.0*pi
      fv=fv+(r(n+1)/rg)**3

      write(14,*) dple
      write(*,*)  'sphere #',nsct+np,'      dple =',dple
      write(*,*)  '                   ',epsr2,sigma2
      write(13,*) 'sphere #',nsct+np,'      dple =',dple
      write(13,*) '                   ',epsr2,sigma2

c     write(*,*) 'eff. permit. =',epsr,'    conductivity =',sigma
c     write(*,*) 'dipole term  =',dple
c     write(13,*)'eff. permit. =',epsr,'    conductivity =',sigma
c     write(13,*)'dipole term  =',dple

c      if (nsct.eq.nscatt-1) go to 1000

c --- Set tau(n) = tau(n+1) before next pass through loop

      do 300 i=1,nmod
        do 301 j=1,nmod
          taun(i,j)=taun1(i,j)
 301    continue
 300  continue
      nsct = nsct + np
      if(nsct .ge. nscatt) goto 666

 1000 continue
c
  666 continue
c
c*****calculate the scattering field from the composite medium
c
      tranrd = 180.0e0/pi
      deltth = pi/float(nrv-1)
      thetar = 0.0e0
c
      do 500 jth = 1,nrv      
c
      call cbassf(rr,thetar,phir,cbs1,pdm,pdm,k0)
      call cbassf(rr,thetar,phir+pi,cbs2,pdm,pdm,k0)
c
      cscatt1 = (0.0e0,0.0e0)
      cscatt2 = (0.0e0,0.0e0)
      do 520 jp = 1,nmod
        ctemp = (0.0e0,0.0e0)
        do 510 jq = 1,nmod
          ctemp = ctemp + taun(jp,jq)*einc(jq) 
 510    continue
        cscatt1 = cscatt1 + cbs1(jp)*ctemp
        cscatt2 = cscatt2 + cbs2(jp)*ctemp
 520  continue
c
      write(20,600) thetar*tranrd,abs(cscatt1),abs(cscatt2),
     &             atan2(aimag(cscatt1),real(cscatt1))*tranrd, 
     &             atan2(aimag(cscatt2),real(cscatt2))*tranrd 
c
      thetar = thetar + deltth
c
 500  continue
c
   
 600  format(2x,f9.2,2e12.4,2f9.2)
c
      write(20,650) rr, phir*tranrd, (phir+pi)*tranrd
c
 650  format(2x,3f7.2)
c      
      lenbyt=8*(nmod*2) 
      open(unit=36,file='taunmtrx.dat',status='unknown',access='direct',
     &                   form='unformatted',recl=lenbyt)
c
      do 700 jp = 1,nmod
        call pwrite(36,jp,taun(1,jp),nmod)
 700  continue
c
c
      stop
      end
c****module pwrite
      subroutine pwrite(lu,ir,ca,lpp)
c
      implicit complex (c)
c
      dimension ca(lpp)
c
      write(unit=lu,rec=ir) ca
c
      return
      end
c****module fieldin
      subroutine fieldin(lpdm,ceinc,wk0)
c
      implicit complex (c)
      implicit real (a-b,d-h,o-z)
c
      dimension ceinc(lpdm)
c
      ci = (0.0e0,1.0e0)
      pi = 3.14159265358979312
c
      ntp = int(sqrt(float(lpdm))) - 1
      k = 1
      cp = 1.0e0
      do 10 jn = 0,ntp
        do 20 jm = -jn,jn
          ceinc(k) = (0.0e0,0.0e0)
          k = k + 1
 20     continue
        ceinc((jn+1)*(jn+1)-jn) = cp*sqrt(4.0e0*pi*float(2*jn+1))
     &                              /filld(jn,wk0)
        cp = cp*ci
 10   continue
c
      return
      end
c****module cmmult1
      SUBROUTINE CMMULT1(CA,CB,IA,IB,N,M,L,CZ,IZ,IP)
C***********************************************
C     COMPLEX MATRIX MULTIPLICATION
C
C     CZ=CA*CB or CZ=CAT*CB
C     WHERE CAT IS THE COMJUGATE TRANSPOSE OF CA
C
C     IP = 1,   CZ=CA*CB
C     IP = 2,   CZ=CAT*CB
C
C     INPUT
C     IA = LEADING DIMENSION OF CA
C     IB = LEADING DIMENSION OF CB
C     IZ = THE SECOND DIMENSION OF CB(OR CZ)
C     N = NUMBER OF ROWS OF CA
C     M = NUMBER OF ROWS OF CB
C     L = NUMBER OF COLLOMN OF CB(OR CZ)
C***********************************************
      IMPLICIT COMPLEX (C)
      DIMENSION CA(IA,IB),CB(IB,IZ),CZ(IA,IZ)
      DO 60 I = 1,L
        DO 50 J = 1,N
          CZ(J,I) = (0.0E0,0.0E0)
 50     CONTINUE
 60   CONTINUE
C
      IF(IP.EQ.2) GOTO 55
C
      DO 30 I = 1,M
        DO 20 K = 1,L
          DO 10 J = 1,N
                CZ(J,K) = CZ(J,K)+CA(J,I)*CB(I,K)
 10       CONTINUE
 20     CONTINUE
 30   CONTINUE
C
      GOTO 99
 55   DO 90 I = 1,M
        DO 80 K = 1,L
          DO 70 J = 1,N
                CZ(J,K) = CZ(J,K)+CONJG(CA(I,J))*CB(I,K)
 70       CONTINUE
 80     CONTINUE
 90   CONTINUE

 99   RETURN
      END

c****module mtrxadd
      Subroutine Mtrxadd(a,ar,ac,b,br,bc,c,j1,j2,isign)
      integer ar,ac,br,bc,isign
      complex a,b,c
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ar.ne.br.OR.ac.ne.bc) then
        print *,'*****  Matrix addition not defined.  *****'
      end if
      do 1 i=1,j1
        do 2 j=1,j2
            c(i,j)=a(i,j)+isign*b(i,j)
  2     continue
  1   continue
      return
      end
c****module cinitmtrx
      subroutine cinitmtrx(a,jrow,jcol)
      complex a
      dimension a(jrow,jcol)
      do 10 jc = 1,jcol
        do 20 jr = 1,jrow
          a(jr,jc) = (0.0e0,0.0e0)
 20     continue
 10   continue
      return
      end
c****module prntmtrx
      subroutine prntmtrx(a,irow,icol)
      complex a
      dimension a(irow,icol)
c     do 1 i=1,irow
c       do 2 j=1,icol
      do 1 i=1,16
        do 2 j=1,16
          write(14,*) i,j,a(i,j)
  2     continue
  1   continue
      return
      end
c****module filld
      REAL FUNCTION FILLD(i,k0)
      real k0,fac
      integer i
      fac=1.0e0
      do 1 j=1,i+i+1,2
          fac=fac*float(j)
 1    continue
      filld=fac/(k0**i)
      return
      end

c****module fills
      COMPLEX FUNCTION FILLS(i,k0)
      real k0,fac
      integer i
      fac=1.0e0
      do 1 j=1,i+i-1,2
          fac=fac*float(j)
 1    continue
      fills=cmplx(0.0e0,(k0**(i+1))/fac)
      return
      end
c****module stmatrx
      subroutine stmatrx(ct1,mdm,ndm,fq,cepb,ceps,r,wk0)
      implicit complex (c)
      implicit real (a-b,d-h,o-z)
      parameter (mpp = 20)
c
      complex fills
      dimension sbjb(0:mpp+1),csbhb(0:mpp+1)
      dimension sbjs(0:mpp+1),csbhs(0:mpp+1)
      dimension ctemp(0:mpp)
      dimension ct1(ndm,ndm)

      ntm = int(sqrt(float(mdm))) - 1
      wkb  = wk0*sqrt(real(cepb))
      wks  = wk0*sqrt(real(ceps))
      wkrb  = wkb*r
      wkrs = wks*r
      ckr = wks/wkb
      cepr = ceps/cepb
c   
      do 1 i=1,mdm
c       do 2 j=1,pdm
        do 2 j=1,mdm
          ct1(i,j)=cmplx(0.0e0,0.0e0)
 2      continue
 1    continue
c
      call dsbesjh(wkrb,ntm+1,sbjb,csbhb,mpp+1)
      call dsbesjh(wkrs,ntm+1,sbjs,csbhs,mpp+1)
c
      do 20 jn = 0,ntm
        djb = -sbjb(jn+1) + jn*sbjb(jn)/wkrb
        cdhb = -csbhb(jn+1) + jn*csbhb(jn)/wkrb
        djs = -sbjs(jn+1) + jn*sbjs(jn)/wkrs
        cdhs = -csbhs(jn+1) + jn*csbhs(jn)/wkrs
        cden = sbjs(jn)*cdhb - cepr*ckr*djs*csbhb(jn)
        cnum = cepr*ckr*djs*sbjb(jn) - sbjs(jn)*djb
        ctemp(jn) = cnum/cden
 20   continue
c
      do 30 jn = 0,ntm
        np = (jn+1)*(jn+1) - jn
        do 25 jm = -jn,jn
          nq = np + jm
          ct1(nq,nq) = -filld(jn,wk0)*ctemp(jn)/fills(jn,wk0)
 25     continue
 30   continue
c
      return
      end
c****module cbassf
      subroutine cbassf(r,theta,phi,cbass,ndim,lnp,wk0)
c
      parameter (nudd = 30)
      implicit real (a-b,d-h,o-z)
      implicit complex (c)
c
      complex fills
      dimension cbass(ndim)
      dimension csphh(0:nudd,-nudd:nudd)
      dimension pwork(0:nudd)
      dimension cbesh(0:nudd)
      dimension sbesj(0:nudd)

c
      ci = (0.0e0,1.0e0)
      pi = acos(-1.0e0)
c
      ntp = int(sqrt(float(lnp))) - 1 
c
      acosthe = cos(theta)
      z = r*wk0
c
      call sphharm(acosthe,phi,ntp,ntp,csphh,nudd,nudd,pwork)
      call dsbesjh(z,ntp,sbesj,cbesh,nudd)
c
      do 20 jn = 0,ntp
        np = (jn+1)*(jn+1) - jn
        cfills = fills(jn,wk0)
        do 10 jm = -jn,jn
          nq = np + jm
          cbass(nq) = -cfills*csphh(jn,jm)*cbesh(jn)
 10     continue
 20   continue
c
      return
      end
c****module movemtrx
      subroutine movemtrx(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex ca(ja1,0:ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb2
        do 15 jm = 1,jb1
          cb(jm,jn) = (0.0e0,0.0e0)
 15     continue
 10   continue
      do 20 jn = 1,n2
        do 25 jm = 1,n1
          cb(jm,jn) = ca(jm,jn)
 25     continue
 20   continue
c
      return
      end
c****module movemtrxp
      subroutine movemtrxp(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex ca(0:ja1,ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb2
        do 15 jm = 1,jb1
          cb(jm,jn) = (0.0e0,0.0e0)
 15     continue
 10   continue
      do 20 jn = 1,n2
        do 25 jm = 1,n1
          cb(jm,jn) = ca(jm,jn)
 25     continue
 20   continue
c
      return
      end
c****module recrdnt
      subroutine recrdnt(ra,thta,phia,rb,thtb,phib,rc,thtc,phic)
c
      real ra,rb,rc
      real thta,thtb,thtc
      real phia,phib,phic
      real xa,ya,za,xb,yb,zb,xc,yc,zc

      xa = ra*sin(thta)*cos(phia)
      ya = ra*sin(thta)*sin(phia)
      za = ra*cos(thta)
      xb = rb*sin(thtb)*cos(phib)
      yb = rb*sin(thtb)*sin(phib)
      zb = rb*cos(thtb)
c
      xc = xb - xa
      yc = yb - ya
      zc = zb - za
c
      rc = sqrt(xc*xc+yc*yc+zc*zc)
      if (abs(xc) .lt. 1.0e-18 .and. abs(yc) .lt. 1.0e-18) then
        phic = 0.0e0
        if(abs(zc) .lt. 1.0e-18) then
          thtc = 0.0e0
        else
          thtc = atan2(sqrt(xc*xc+yc*yc),zc)
        endif
      else
        thtc = atan2(sqrt(xc*xc+yc*yc),zc)
        phic = atan2(yc,xc)
      endif
c
      return
      end
c****module movesl
      subroutine movesl(ca,cb,jaa,jab,jba,jbb,iar,iac,is,js)
c
c     move data from a small matrix ca to a large matrix cb
c
      implicit complex (c)
c
      dimension ca(jaa,jab),cb(jba,jbb)
c
      do 20 j = 1,iac
        do 10 i = 1,iar
          cb(i+is-1,j+js-1) = ca(i,j)
 10     continue
 20   continue
c
      return
      end
c****module movels
      subroutine movels(ca,cb,jaa,jab,jba,jbb,ibr,ibc,is,js)
c
      implicit complex (c)
c
c     move data from a large matrix ca to a small matrix cb
c
      dimension ca(jaa,jab),cb(jba,jbb)
c
      do 20 j = 1,ibc
        do 10 i = 1,ibr
          cb(i,j) = ca(i+is-1,j+js-1)
 10     continue
 20   continue
c
      return
      end

c**********************************************************************
c****module dsbetap
      subroutine dsbetap(zz,theta,phi,k0,numa,nmax,beta,nudim
     &                                      ,ndim,jtune,jcon) 
c
c     this routine is for numa > nmax 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 30)
      complex beta(0:nudim,ndim)
      complex al1,al2,al3
      complex ci
      real z,zz,theta,phi,k0,costhe,theta0,phi0
      real pwork(0:nudd),pi,sqrtpi
      real sbesj(0:nudd)
      complex sphh(0:nudd,-nudd:nudd)
      real bpnu,bmnu,bpnn
      real amnu,apnu,apnm,amnm
      real factsn,factsnu
      real factdn,factdnu

      ci = (0.0e0,1.0e0)
      pi = acos(-1.0e0)
      sqrtpi = sqrt(4.0e0*pi)
      
      z = zz*k0
c
      if(z .gt. 1.0e-18) then

      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of betaa (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesj(z,nmx,sbesj,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        beta(nup,1)=msign*sphh(nu,0)*sbesj(nu)*sqrtpi
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          beta(lmp,1)=msign*sphh(nu,-mu)*sbesj(nu)*sqrtpi
          beta(lmm,1)=msign*sphh(nu,mu)*sbesj(nu)*sqrtpi
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            beta(num+mu,npp)= (bpnu*beta(nub+mu-1,npm)+
     &                         bmnu*beta(nup+mu-1,npm))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          beta(num-nu,npp)= (bmnu*beta(nup-nu-1,npm))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0e0/3.0e0)
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          beta(1,npp)= (bmnu*beta(2,npm))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      jmp = m  
      do 60 n=jmp,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=beta(nub+mu,nmp)
           al3=beta(nup+mu,nmp)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           beta(num+mu,npp)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=beta(nup-nu,nmp)
          amnu = sqrt(1.0e0/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(num-nu,npp)= (amnu*al3)/apnm     
          al3=beta(nup+nu,nmp)
          beta(num+nu,npp)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=beta(3,nmp)
          amnu = sqrt(1.0e0/3.0e0)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(1,npp)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=beta(num+mu,nmm)
           al2=beta(nub+mu,nmp)
           al3=beta(nup+mu,nmp)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           beta(num+mu,npp)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=beta(num-nu,nmm)
          al3=beta(nup-nu,nmp)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(num-nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
          al1=beta(num+nu,nmm)
          al3=beta(nup+nu,nmp)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(num+nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=beta(1,nmm)
          al3=beta(3,nmp)
          amnu = sqrt(1.0e0/3.0e0)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(1,npp)=(-amnm*al1+amnu*al3)/apnm 
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            beta(nup,npp-m) = msign*(beta(nup,npp+m))
     &                             *exp(2.0e0*ci*(-m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              beta(nup+mu,npp-m) = msign*musign*beta(nup-mu,npp+m)
     &                                *exp(2.0e0*ci*phi0*(-mu-m))
              beta(nup-mu,npp-m) = msign*musign*beta(nup+mu,npp+m)
     &                                *exp(2.0e0*ci*phi0*(mu-m))
 98         continue
 96       continue
 95     continue
 90   continue

      if(jcon .eq. 1) then

      factdn = 1.0e0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*float(2*jnp+1)/k0
        endif
c>>>>        factdn = 1.0e0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0e0
          do 110 jnup = 0,numa
c>>>>            factdnu = filld(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*k0/float(2*jnup+1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(nup,np) = beta(nup,np)*factdn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue

      else if(jcon .eq. 2) then

      factsn = k0
      do 200 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*k0/float(2*jnp-1)
        endif
c>>>        factsn = 1.0e0/fills(jnp,k0)
        do 205 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = 1.0e0/k0
          do 210 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*float(2*jnup-1)/k0
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 215 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(nup,np) = beta(nup,np)*factsn*factsnu
 215        continue
 210      continue
 205    continue
 200  continue

      else

        pause 'jcon must be 1 or 2 in sbeta subroutine'

      endif
c
      else
c
      jnm = (nmax + 1)**2
      jnum = (numa + 1)**2
      do 300 jn = 1,jnm
        do 310 jnu = 1,jnum
          beta(jnu,jn) = (0.0e0,0.0e0)
 310    continue
        beta(jn,jn) = (1.0e0,0.0e0)
 300  continue
c
      endif
c
      return
      end
c**********************************************************************
c****module dsalphap
      subroutine dsalphap(zz,theta,phi,k0,numa,nmax,alph,nudim,
     &                                           ndim,jtune) 
c
c     this routine is for numa > nmax.
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 30)
      complex alph(0:nudim,ndim)
      complex al1,al2,al3
      complex ci
      real z,zz,theta,phi,k0,costhe,theta0,phi0
      real pwork(0:nudd),sbesj(0:nudd),pi,sqrtpi
      complex sbesh(0:nudd)
      complex sphh(0:nudd,-nudd:nudd)
      real factsn,factdnu
      real bpnu,bmnu,bpnn
      real amnu,apnu,apnm,amnm

      ci = (0.0e0,1.0e0)
      pi = acos(-1.0e0)
      sqrtpi = sqrt(4.0e0*pi)
c
      z = zz*k0
c
      if (z .gt. 1.0d-18) then
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesjh(z,nmx,sbesj,sbesh,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        alph(nup,1)=msign*sphh(nu,0)*sbesh(nu)*sqrtpi
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          alph(lmp,1)=msign*sphh(nu,-mu)*sbesh(nu)*sqrtpi
          alph(lmm,1)=msign*sphh(nu,mu)*sbesh(nu)*sqrtpi
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            alph(num+mu,npp)= (bpnu*alph(nub+mu-1,npm)+
     &                         bmnu*alph(nup+mu-1,npm))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(num-nu,npp)= (bmnu*alph(nup-nu-1,npm))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0e0/3.0e0)
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(1,npp)= (bmnu*alph(2,npm))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(nub+mu,nmp)
           al3=alph(nup+mu,nmp)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(num+mu,npp)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=alph(nup-nu,nmp)
          amnu = sqrt(1.0e0/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(num-nu,npp)= (amnu*al3)/apnm     
          al3=alph(nup+nu,nmp)
          alph(num+nu,npp)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(3,nmp)
          amnu = sqrt(1.0e0/3.0e0)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(1,npp)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(num+mu,nmm)
           al2=alph(nub+mu,nmp)
           al3=alph(nup+mu,nmp)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(num+mu,npp)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=alph(num-nu,nmm)
          al3=alph(nup-nu,nmp)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(num-nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
          al1=alph(num+nu,nmm)
          al3=alph(nup+nu,nmp)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(num+nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(1,nmm)
          al3=alph(3,nmp)
          amnu = sqrt(1.0e0/3.0e0)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(1,npp)=(-amnm*al1 + amnu * al3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            alph(nup,npp-m) = msign*(alph(nup,npp+m))
     &                             *exp(2.0e0*cI*(-m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(nup+mu,npp-m) = msign*musign*alph(nup-mu,npp+m)
     &                                *exp(2.0e0*ci*phi0*(-mu-m))
              alph(nup-mu,npp-m) = msign*musign*alph(nup+mu,npp+m)
     &                                *exp(2.0e0*ci*phi0*(mu-m))
 98         continue
 96       continue
 95     continue
 90   continue

      factsn = k0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*k0/float(2*jnp-1)
        endif
c>>>        factdn = 1.0e0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0e0
          do 110 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*k0/float(2*jnup+1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              alph(nup,np) = ci*alph(nup,np)*factsn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue

      else
c
      jnm = (nmax + 1)**2
      jnum = (numa + 1)**2
      do 300 jn = 1,jnm
        do 310 jnu = 1,jnum
          alph(jnu,jn) = (0.0e0,0.0e0)
 310    continue
        alph(jn,jn) = (1.0e0,0.0e0)
 300  continue
c
      endif
c
      return
      end
c**********************************************************************
c****module dsbeta
      subroutine dsbeta(zz,theta,phi,k0,nmax,numa,beta,ndim
     &                                      ,nudim,jtune,jcon) 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 30)
      complex beta(ndim,0:nudim)
      complex al1,al2,al3
      complex ci
      real z,zz,theta,phi,k0,costhe,theta0,phi0
      real pwork(0:nudd),pi,sqrtpi
      real sbesj(0:nudd)
      complex sphh(0:nudd,-nudd:nudd)
      real bpnu,bmnu,bpnn
      real amnu,apnu,apnm,amnm
      real factsn,factsnu
      real factdn,factdnu

      ci = (0.0e0,1.0e0)
      pi = acos(-1.0e0)
      sqrtpi = sqrt(4.0e0*pi)
      
      z = zz*k0

      if(z .gt. 1.0d-18) then
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of betaa (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesj(z,nmx,sbesj,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        beta(1,nup)=msign*sphh(nu,0)*sbesj(nu)*sqrtpi*nsign
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          beta(1,lmp)=msign*sphh(nu,-mu)*sbesj(nu)*sqrtpi
     &                *exp(ci*2.0e0*mu*phi0)*nsign                      
          beta(1,lmm)=msign*sphh(nu,mu)*sbesj(nu)*sqrtpi
     &                *exp(-ci*2.0e0*mu*phi0)*nsign                   
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            beta(npp,num+mu)= (bpnu*beta(npm,nub+mu-1)+
     &                         bmnu*beta(npm,nup+mu-1))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          beta(npp,num-nu)= (bmnu*beta(npm,nup-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0e0/3.0e0)
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          beta(npp,1)= (bmnu*beta(npm,2))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      jmp = m  
      do 60 n=jmp,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=beta(nmp,nub+mu)
           al3=beta(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           beta(npp,num+mu)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=beta(nmp,nup-nu)
          amnu = sqrt(1.0e0/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,num-nu)= (amnu*al3)/apnm     
          al3=beta(nmp,nup+nu)
          beta(npp,num+nu)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=beta(nmp,3)
          amnu = sqrt(1.0e0/3.0e0)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,1)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=beta(nmm,num+mu)
           al2=beta(nmp,nub+mu)
           al3=beta(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           beta(npp,num+mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=beta(nmm,num-nu)
          al3=beta(nmp,nup-nu)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,num-nu)=(-amnm*al1 + amnu * al3) / apnm     
          al1=beta(nmm,num+nu)
          al3=beta(nmp,nup+nu)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,num+nu)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=beta(nmm,1)
          al3=beta(nmp,3)
          amnu = sqrt(1.0e0/3.0e0)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,1)=(-amnm*al1+amnu*al3)/apnm 
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            beta(npp-m,nup) = msign*(beta(npp+m,nup))
     &                             *exp(2.0e0*ci*(m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              beta(npp-m,nup+mu) = msign*musign*beta(npp+m,nup-mu)
     &                                *exp(2.0e0*ci*phi0*(mu+m))
              beta(npp-m,nup-mu) = msign*musign*beta(npp+m,nup+mu)
     &                                *exp(2.0e0*ci*phi0*(m-mu))
 98         continue
 96       continue
 95     continue
 90   continue
  
      if(jcon .eq. 1) then

      factdn = 1.0e0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*k0/float(2*jnp+1)
        endif
c>>>>        factdn = 1.0e0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0e0
          do 110 jnup = 0,numa
c>>>>            factdnu = filld(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*float(2*jnup+1)/k0
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(np,nup) = beta(np,nup)*factdn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue

      else if(jcon .eq. 2) then

      factsn = 1.0e0/k0
      do 200 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*float(2*jnp-1)/k0
        endif
c>>>        factsn = 1.0e0/fills(jnp,k0)
        do 205 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = k0
          do 210 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*k0/float(2*jnup-1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 215 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(np,nup) = beta(np,nup)*factsn*factsnu
 215        continue
 210      continue
 205    continue
 200  continue

      else

        pause 'jcon must be 1 or 2 in sbeta subroutine'

      endif
c
      else
c
      jnm = (nmax + 1)**2
      jnum = (numa + 1)**2
      do 300 jn = 1,jnm
        do 310 jnu = 1,jnum
          beta(jn,jnu) = (0.0e0,0.0e0)
 310    continue
        beta(jn,jn) = (1.0e0,0.0e0)
 300  continue
c
      endif
c

      return
      end
c**********************************************************************
c****module dsalpha
      subroutine dsalpha(zz,theta,phi,k0,nmax,numa,alph,ndim
     &                                            ,nudim,jtune) 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 30)
      complex alph(ndim,0:nudim)
      complex al1,al2,al3
      complex ci
      real z,zz,theta,phi,k0,costhe,theta0,phi0
      real pwork(0:nudd),sbesj(0:nudd),pi,sqrtpi
      complex sbesh(0:nudd)
      complex sphh(0:nudd,-nudd:nudd)
      real factdn,factsnu
      real bpnu,bmnu,bpnn
      real amnu,apnu,apnm,amnm

      ci = (0.0e0,1.0e0)
      pi = acos(-1.0e0)
      sqrtpi = sqrt(4.0e0*pi)
c
      z = zz*k0
c
      if(z .gt. 1.0d-18) then
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesjh(z,nmx,sbesj,sbesh,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        alph(1,nup)=msign*sphh(nu,0)*sbesh(nu)*sqrtpi*nsign
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          alph(1,lmp)=msign*sphh(nu,-mu)*sbesh(nu)*sqrtpi
     &                *exp(ci*2.0e0*mu*phi0)*nsign                      
          alph(1,lmm)=msign*sphh(nu,mu)*sbesh(nu)*sqrtpi
     &                *exp(-ci*2.0e0*mu*phi0)*nsign                   
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            alph(npp,num+mu)= (bpnu*alph(npm,nub+mu-1)+
     &                         bmnu*alph(npm,nup+mu-1))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(npp,num-nu)= (bmnu*alph(npm,nup-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0e0/3.0e0)
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(npp,1)= (bmnu*alph(npm,2))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(nmp,nub+mu)
           al3=alph(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(npp,num+mu)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=alph(nmp,nup-nu)
          amnu = sqrt(1.0e0/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,num-nu)= (amnu*al3)/apnm     
          al3=alph(nmp,nup+nu)
          alph(npp,num+nu)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(nmp,3)
          amnu = sqrt(1.0e0/3.0e0)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,1)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(nmm,num+mu)
           al2=alph(nmp,nub+mu)
           al3=alph(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(npp,num+mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=alph(nmm,num-nu)
          al3=alph(nmp,nup-nu)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,num-nu)=(-amnm*al1 + amnu * al3) / apnm     
          al1=alph(nmm,num+nu)
          al3=alph(nmp,nup+nu)
          amnu = sqrt(1.0e0/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,num+nu)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(nmm,1)
          al3=alph(nmp,3)
          amnu = sqrt(1.0e0/3.0e0)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,1)=(-amnm*al1 + amnu * al3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            alph(npp-m,nup) = msign*(alph(npp+m,nup))
     &                             *exp(2.0e0*cI*(m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(npp-m,nup+mu) = msign*musign*alph(npp+m,nup-mu)
     &                                *exp(2.0e0*ci*phi0*(mu+m))
              alph(npp-m,nup-mu) = msign*musign*alph(npp+m,nup+mu)
     &                                *exp(2.0e0*ci*phi0*(m-mu))
 98         continue
 96       continue
 95     continue
 90   continue
  
      factdn = 1.0e0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*k0/float(2*jnp+1)
        endif
c>>>        factdn = 1.0e0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = k0
          do 110 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*k0/float(2*jnup-1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              alph(np,nup) = ci*alph(np,nup)*factdn*factsnu
 115        continue
 110      continue
 105    continue
 100  continue

      else
c
      jnm = (nmax + 1)**2
      jnum = (numa + 1)**2
      do 200 jn = 1,jnm
        do 210 jnu = 1,jnum
          alph(jn,jnu) = (0.0e0,0.0e0)
 210    continue
        alph(jn,jn) = (1.0e0,0.0e0)
 200  continue
c
      endif
c
      return
      end
c************************************************************************
c****module spharm
      SUBROUTINE SPHHARM(X,PHI,L,M,SPHH,LD1,LD2,PWORK)
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION PWORK(0:LD1)
      COMPLEX SPHH(0:LD1,-LD2:LD2), CI
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
CC
      CI = (0.0E0,1.0E0)
      PI = ACOS(-1.0E0)
      DO 10 LM = 0,M
        CALL DLEGENDR(X,L,LM,PWORK,LD1) 
        DO 20 LP = LM,L
          SPHH(LP,LM) = CMPLX(PWORK(LP),0.0E0)
 20     CONTINUE
 10   CONTINUE
C
      PIINV = 0.5D0/SQRT(PI)
C
      DO 30 LP = 0,L
        SPHH(LP,0) = PIINV*SQRT(FLOAT(2*LP+1))*SPHH(LP,0)
 30   CONTINUE
C
      IF(L .LT. 150) THEN
        PN = 1.
        DO 40 LP = 1,L
          SIGN = 1.0E0
          FACL = PIINV*SQRT(2.0E0*FLOAT(LP)+1.0E0)
          PN = PN*FLOAT(LP)
          PADD = SQRT(PN)
          PMIN = PN
          DO 50 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD*SQRT(FLOAT(LP+MP))
            PMIN = PMIN/FLOAT(LP-MP+1)   
            FAC = SIGN*FACL*SQRT(PMIN)/PADD
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 50       CONTINUE
 40     CONTINUE
      ELSE
        PN = 0.0
        DO 60 LP = 1,L
          SIGN = 1.0E0
          FACL = PIINV*SQRT(2.0E0*FLOAT(LP)+1.0E0)
          PN = PN + LOG(FLOAT(LP))
          PADD = PN
          PMIN = PN
          DO 70 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD + LOG(FLOAT(LP+MP))
            PMIN = PMIN - LOG(FLOAT(LP-MP+1))   
            FAC = SIGN*FACL*EXP(0.5D0*(PMIN-PADD))
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 70       CONTINUE
 60     CONTINUE
      ENDIF  
C
      RETURN
      END
c**********************************************************************
c****dlegendr
      SUBROUTINE DLEGENDR(X,L,M,PLGNDR,LD1)
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION PLGNDR(0:LD1)
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in DLEGENDR'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
      PMM=1.0E0
      IF(M.GT.0) THEN
        SOMX2=SQRT((1.-X)*(1.+X))
        FACT=1.
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.0E0
11      CONTINUE
      ENDIF
      IF(L.EQ.M) THEN
        PLGNDR(L)=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF(L.EQ.M+1) THEN
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
        ELSE
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PLGNDR(LL)=PLL
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

c****************************************************************
c****module dsbesjh
	subroutine dsbesjh(x,n,sj,csh,nd)
        implicit complex (c)
        implicit real (a-b,d-h,o-z)
        dimension sj(0:nd),csh(0:nd)

        ci = (0.0e0,1.0e0)

        call dsbesy(x,n,sj,nd)
c
        do 5 j = 0,n
          csh(j) = ci*sj(j)
  5     continue
c
        call dsbesj(x,n,sj,nd)
        
        do 10 j = 0,n
          csh(j) = sj(j) + csh(j)
 10     continue
c
        return
        end
c****************************************************************
c****module cdsbesj
        subroutine dsbesj(cx,n,csj,nd)
c>>>        implicit complex (c)
c>>>        implicit real (a-b,d-h,o-z)
        implicit real (a-h,o-z)
        dimension csj(0:nd)
        integer flag
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')

c --- Explicit calculation of low order Bessel functions.
        cxinv = 1.0e0/cx
        if (n.eq.0) then
            csj(0)=sin(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            return
        end if
        if (n.eq.2) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            csj(2)=(3.0e0/cx/cx-1.0e0)*csj(0) - 3.0e0*cos(cx)/cx/cx
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        csj(0)=sin(cx)*cxinv
        csj(1)=(csj(0)-cos(cx))*cxinv
        csjb=csj(0)
        csjm=csj(1)
        if (abs(cx).gt.float(n)) then
            do 11 j=2,n
                csjp=(2.0e0*float(j-1)+1.0e0)*cxinv*csjm-csjb
                csjb=csjm
                csjm=csjp
                csj(j)=csjm
  11        continue
        else
            csj1=csj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            csjm=0.0e0
            csjb=1.0e0
            i=0
            do 12 j=m,1,-1
                csjp=(2.0e0*float(j+1)+1.0e0)*cxinv*csjb-csjm
                csjm=csjb
                csjb=csjp
                if(j.le.n) csj(j)=csjp
c>>>>>                write(12,*) j, sjp
                if (abs(csjp).gt.bigno) then
                    csjm=csjm*1.d-10
                    csjb=csjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      csj(lp)=csj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (abs(csj(1)).eq.0.0e0) print *,'got 0 in SJ'
            cdp=csj1/csj(1)
            do 30 jp = 1,n
              csj(jp) = csj(jp)*cdp
  30        continue
        end if
  13    return
        end

c***************************************************************
c****module dsbesy
	subroutine dsbesy(cx,n,csy,nd)
c>>>        implicit complex (c)
c>>>        implicit real (a-b,d-h,o-z)
        implicit real (a-h,o-z)
        dimension csy(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
c
        cxinv = 1.0e0/cx
c        
c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            csy(0)=-cos(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csy(0)=-cos(cx)*cxinv
            csy(1)=csy(0)*cxinv-sin(cx)*cxinv
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        csy(0)=-cos(cx)*cxinv
        csy(1)=csy(0)*cxinv-sin(cx)*cxinv
        csyb=csy(0)
        csym=csy(1)
        do 11 j=2,n
          csyp=(2.0e0*float(j-1)+1.)*cxinv*csym-csyb
          csyb=csym
          csym=csyp
          csy(j)=csym
  11    continue
        return
        end
c------------------------------------------------------------------------
c****modified by W.C. Chew for complex matrices January 15, 1991.
c
      SUBROUTINE CGAUSSJ(A,N,NP,B,M,MP)
      IMPLICIT REAL (A-H,O-Z)
      PARAMETER (NMAX=850)
      complex a(np,np),b(np,mp),dum,pivinv 
      DIMENSION IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                PAUSE 'Singular matrix, IPIV(K).GT.1'
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (abs(A(ICOL,ICOL)).EQ.0.) PAUSE 'Singular matrix, 
     &  ABS(A)=0.'
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=(1.,0.)
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=(0.,0.)
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END

