      program predatvx
c
      parameter (ndim = 100000)
c
      real r(ndim),theta(ndim),phi(ndim),epsl(ndim)
      real xm(ndim),ym(ndim),zm(ndim)
      integer index(ndim)
c
      open(unit=12,file='mesh.dat',status='old')
      open(unit=14,file='phodat.dat',status='unknown')
      open(unit=15,file='thedat.dat',status='unknown')
      open(unit=16,file='phidat.dat',status='unknown')
      open(unit=17,file='raddat.dat',status='unknown')
      open(unit=18,file='posit2.dat',status='unknown')
      open(unit=20,file='posit.dat',status='unknown')
c
      read(12,*) np,xmax,ymax,zmax,step,rc
c
      pi = acos(-1.0d0)
c
      write(6,*) 'input coefficient to shrink spheres'
      read(5,*) rsh
      rad = rsh*(3.0d0/(4.0d0*pi))**(1.0d0/3.0d0)*step
      n = np**3
c
      k = 0
      do 10 i = 1,n
        read(12,98) j,epsl0,ei,x,y,z
        pho = sqrt(x*x+y*y+z*z)
        if(pho .lt. rc) then
        k = k + 1
        r(k) = pho
        theta(k) = atan2(sqrt(x*x+y*y),z)
        phi(k) = atan2(y,x)
        epsl(k) = epsl0
        xm(k) = x
        ym(k) = y
        zm(k) = z
        index(k) = k
        endif
 10   continue
c
 98   format(1x,I5,2x,F12.8,2X,F12.8,2X,F12.8,2X,F12.8,2X,F12.8)
c
      call sort2(k,r,index) 
c
      write(14,*) k
      write(18,*) k
      write(20,*) k
      jone = 1
c
      do 20 j = 1,k
c
        jp = index(j)
        write(14,*) r(j)
        write(15,*) theta(jp)
        write(16,*) phi(jp)
        write(17,*) rad
        write(18,99) xm(jp),ym(jp),zm(jp),rad,epsl(jp),jone 
        write(20,99) r(j),theta(jp),phi(jp),rad,epsl(jp),jone 
c
 20   continue
c
      write(17,100) xmax
c
  99  format(1p5e14.4,i4)
 100  format(2x,f12.8)
c
      stop 
      end 




c****module sort2
      SUBROUTINE SORT2(N,RA,IA)
      DIMENSION RA(N),IA(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          NIA=IA(L)
        ELSE
          RRA=RA(IR)
          NIA=IA(IR)
          RA(IR)=RA(1)
          IA(IR)=IA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            IA(1)=NIA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            IA(I)=IA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
        IA(I)=NIA
      GO TO 10
      END

