      program prepdat
c
      parameter (ndim = 100000)
c
      real r(ndim),theta(ndim),phi(ndim),epsl(ndim)
c
      open(unit=12,file='mesh.dat',status='old')
      open(unit=14,file='phodat.dat',status='unknown')
      open(unit=15,file='thedat.dat',status='unknown')
      open(unit=16,file='phidat.dat',status='unknown')
      open(unit=17,file='raddat.dat',status='unknown')
      open(unit=18,file='comp.dat',status='unknown')
c
      read(12,*) np,xmax,ymax,zmax,step,rc
c
      pi = acos(-1.0d0)
c
      write(6,*) 'input coefficient to shrink spheres'
      read(5,*) rsh
      rad = rsh*(3.0d0/(4.0d0*pi))**(1.0d0/3.0d0)*step
      n = np**3
c
      k = 0
      do 10 i = 1,n
        read(12,98) j,epsl0,ei,xm,ym,zm
        pho = sqrt(xm*xm+ym*ym+zm*zm)
        if(pho .lt. rc) then
        k = k + 1
        r(k) = pho
        theta(k) = atan2(sqrt(xm*xm+ym*ym),zm)
        phi(k) = atan2(ym,xm)
        epsl(k) = epsl0
        endif
 10   continue
c
 98   format(1x,I5,2x,F12.8,2X,F12.8,2X,F12.8,2X,F12.8,2X,F12.8)
c
      call sort4(k,r,theta,phi,epsl) 
c
      write(14,*) k
c
      do 20 j = 1,k
c
        write(14,*) r(j)
        write(15,*) theta(j)
        write(16,*) phi(j)
        write(17,*) rad
        write(18,99) j,r(j),theta(j),phi(j)
c
 20   continue
c
      write(17,100) xmax
c
 100  format(2x,f12.8)
 99   format(2x,i5,3f12.8)
c
      stop 
      end 




c****module sort3
      SUBROUTINE SORT3(N,RA,RB,RC)
      DIMENSION RA(N),RB(N),RC(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
          RRC=RC(L)
        ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RRC=RC(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          RC(IR)=RC(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RB(1)=RRB
            RC(1)=RRC
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            RB(I)=RB(J)
            RC(I)=RC(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
        RB(I)=RRB
        RC(I)=RRC
      GO TO 10
      END

