        program testsh
        implicit double precision (a-h,o-z)
        parameter (ndim = 100)
        complex*16 sh(0:ndim), sh1, acheck
        write(6,*) 'input nmax for spherical bessel function)'
        read(5,*) nmax
        write(6,*) 'input x '
        read(5,*) x
        call sbessh(x,nmax,sh,ndim)
        do 10 jp = 0,nmax
          acheck = sh1(jp,x)
          write(6,94) jp, sh(jp)
          write(6,96) acheck
 10     continue

 94     format(i4, 1p2d19.8)
 96     format(4x, 1p2d19.8)
        stop 
        end

	subroutine sbessh(x,n,sh,nd)
        implicit double precision (a-h,o-z)
        parameter (ndim = 100)
        real*8 x, sj(0:ndim), sy(0:ndim)
        complex*16 ci, sh(0:nd)

        ci = (0.,1.)

        call sbessj(x,n,sj,nd)
        call sbessy(x,n,sy,ndim)
        
        do 10 j = 0,n
          sh(j) = sj(j) + ci*sy(j)
 10     continue
c
        return
        end

	subroutine sbessj(x,n,sj,nd)
        implicit double precision (a-h,o-z)
        real*8 x, sj(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
        
c --- Explicit calculation of low order Bessel functions.
        xinv = 1./x
        if (n.eq.0) then
            sj(0)=sin(x)*xinv
            return
        end if
        if (n.eq.1) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            return
        end if
        if (n.eq.2) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            sj(3)=(3.0d0/x/x-1.0d0)*sj(0) - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        sj(0)=sin(x)*xinv
        sj(1)=sj(0)/x-cos(x)*xinv
        sjb=sj(0)
        sjm=sj(1)
        if (x.gt.dfloat(n)) then
            do 11 j=2,n
                sjp=(2.0d0*dfloat(j-1)+1.)*xinv*sjm-sjb
                sjb=sjm
                sjm=sjp
                sj(j)=sjm
  11        continue
        else
            sj1=sj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            sjm=0.0d0
            sjb=1.0d0
            i=0
            do 12 j=m,1,-1
                sjp=(2.0d0*dfloat(j+1)+1.)*xinv*sjb-sjm
                sjm=sjb
                sjb=sjp
                if(j.le.n) sj(j)=sjp
c>>>>>                write(12,*) j, sjp
                if (dabs(sjp).gt.bigno) then
                    sjm=sjm*1.d-10
                    sjb=sjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      sj(lp)=sj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (sj(1).eq.0.0d0) print *,'got 0 in SJ'
            dp=sj1/sj(1)
            do 30 jp = 1,n
              sj(jp) = sj(jp)*dp
  30        continue
        end if
  13    return
        end
c------------------------------------------------------------------------



	subroutine sbessy(x,n,sy,nd)
        implicit double precision (a-h,o-z)
        real*8 x, sy(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
c
        xinv = 1./x
c        
c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            sy(0)=-cos(x)*xinv
            return
        end if
        if (n.eq.1) then
            sy(0)=-cos(x)*xinv
            sy(1)=sy(0)*xinv-sin(x)*xinv
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        sy(0)=-cos(x)*xinv
        sy(1)=sy(0)*xinv-sin(x)*xinv
        syb=sy(0)
        sym=sy(1)
        do 11 j=2,n
          syp=(2.0d0*dfloat(j-1)+1.)*xinv*sym-syb
          syb=sym
          sym=syp
          sy(j)=sym
  11    continue
        return
        end
c------------------------------------------------------------------------

c****module sh1
C       GENERATES SPHERICAL HANKEL FUNCTIONS OF THE THIRD KIND
        COMPLEX*16 FUNCTION SH1(L,Z)
        complex*16 ai,wkh1(-1:100)
        real*8  z,SJ
        AI=CMPLX(0.0d0,1.0d0)
        DO 1 I=-1,L
          WKH1(I)=(0.0,0.0)
  1     continue
        WKH1(-1)=EXP(AI*Z)/Z
        WKH1(0)=-AI*EXP(AI*Z)/Z
        DO 2 I=0,L-1
          WKH1(I+1)=dfloat(2*I+1)/Z*WKH1(I)-WKH1(I-1)
  2     continue
        SH1=cmplx(SJ(l,z),dimag(WKH1(L)))
        RETURN
        END
c------------------------------------------------------------------------

        Double precision FUNCTION SJ(n,x)
        implicit double precision (d)
        real*8 db(0:100),x
        integer flag
        parameter (iacc=40)

c --- Small argument approximation.
        if (x.lt.0.1d0) then
          dfac=1.0d0
          do 1 i=1,2*n+1,2
            dfac=dfac*dfloat(i)
  1       continue
          SJ=(x**n)/dfac
          return
        end if

c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            SJ=sin(x)/x
            return
        end if
        if (n.eq.1) then
            SJ=sin(x)/x/x-cos(x)/x
            return
        end if
        if (n.eq.2) then
            SJ=(3.0d0/x/x-1.0d0)*sin(x)/x - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        dbessj0=cos(x)/x
        dbessj1=sin(x)/x
        if (x.gt.dfloat(n)) then
            dbjm=dbessj0
            dbj=dbessj1
            do 11 j=0,n-1
                dbjp=(2.0d0*dfloat(j)+1.)/x*dbj-dbjm
                dbjm=dbj
                dbj=dbjp
  11        continue
            SJ=dbj
        else
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            SJ=0.0d0
            db(m+1)=0.0d0
            db(m)=1.0d0
            i=0
            do 12 j=m,1,-1
                db(j-1)=(2.0d0*dfloat(j)+1.)/x*db(j)-db(j+1)
                if (dabs(db(j-1)).gt.1.d10) then
                    db(j-1)=db(j-1)*1.d-10
                    db(j)=db(j)*1.d-10
                    i=i+1
                end if
                if (j.eq.n) flag=i
  12        continue
            dr0=sin(x)/x
            if (db(0).eq.0.0d0) print *,'got 0 in SJ'
            dp=dr0/db(0)
            SJ=db(n)*dp*(1.d10)**(flag-i)
        end if
  13    return
        end
