      program bnet
c --- translation matrix calculated by using Chew's recursion for
c ---  scalar addition theorem coefficients
      parameter (nudim=20)
      parameter (ndim = (nudim+1)*(nudim+1))
      complex*16 betaa,beta(ndim,0:4*ndim)
      complex*16 acheck
      complex*16 al1,al2,al3
      real*8 pho,theta,phi,k0,kr,costhe,cosphi,sinphi
      complex*16 ci

      ci = (0.0d0,1.0d0)

      open (14,file='betaout',status='unknown')
      open (15,file='betadif',status='unknown')

      write(6,*) 'Enter n,m, and maximum value of nu.'
      read(5,*) ndest,mdest,numax
      mabs=iabs(mdest)

      write(6,*) 'Enter r,theta,phi.'
      read(5,*) pho,theta,phi

      write(6,*) 'Enter wavenumber k0.'
      read(5,*) k0

      write(6,*) 'Enter the control parameter'
      write(6,*) 'lpp = 1 for checking with direct method with output'
      write(6,*)
      write(6,*)'lpp = 2 for checking with direct method without output'
      write(6,*)
      write(6,*) 'lpp = 3  write output without checking'
      write(6,*)
      write(6,*) 'lpp = else  no output without checking'
      read(5,*) lpp

      kr=k0*pho
      costhe=cos(theta)
      cosphi=cos(phi)
      sinphi=sin(phi)
c
c --- Calculate and store initial values of betaa (n=m=0)
c
      call sbeta(kr,theta,phi,ndest,numax,beta,ndim,4*ndim)
c
c --- Write results to file called "betaout".

      if(lpp .eq. 1) then

      write(14,*)'n,m,numax   = ',ndest,mdest,numax
      write(14,*)'r,theta,phi = ',pho,theta,phi
      write(14,*)'wavenumber  = ',k0
      write(14,*)' '
      write(14,*)'First line is the recursively calculated coefficient.'
      write(14,*)'Second line is the directly calculated coefficient.'
      write(14,*)' '

      jnmatch = 0
      do 180 n = 0,ndest
      npp = (n+1)*(n+1) - n
      do 190 m = -n,n
      do 200 nu=0,numax
        nup = (nu+1)*(nu+1) - nu
        do 210 mu=-nu,nu
          write(14,990)n,m,nu,mu,beta(npp+m,nup+mu)
          acheck=betaa(n,m,nu,mu,pho,theta,phi,k0)
          write(14,995) acheck
          if (cdabs((beta(npp+m,nup+mu)-acheck)/acheck).ge.1.0d-3) then
              write(15,*)'Trouble. (n,m,nu,mu) =',n,m,nu,mu
              write(15,*)'           recursive =', beta(npp+m,nup+mu)
              write(15,*)'           direct    =',acheck
              jnmatch = jnmatch + 1
          end if
 210    continue
 200  continue
 190  continue
 180  continue

      write(15,*) 'Number of unmatched coefficients = ', jnmatch
      print *,' '
      print *,'Translation coefficients written to file "betaout"'
      print *,' '
      print *,'Any recursively calculated coefficients that do not',
     &        ' agree with the'
      print *,'directly calculated coefficients are written to file',
     &        ' "betadif"'
      print *,' '

      else if(lpp .eq. 2) then

      do 182 n = 0,ndest
      do 192 m = -n,n
      do 202 nu=0,numax
        do 212 mu=-nu,nu
          acheck=betaa(n,m,nu,mu,pho,theta,phi,k0)
 212    continue
 202  continue
 192  continue
 182  continue

      else if(lpp .eq. 3) then

      write(14,*)'n,m,numax   = ',ndest,mdest,numax
      write(14,*)'r,theta,phi = ',pho,theta,phi
      write(14,*)'wavenumber  = ',k0
      write(14,*)' '
      write(14,*)'First line is the recursively calculated coefficient.'
      write(14,*)' '

      do 185 n = 0,ndest
      npp = (n+1)*(n+1) - n
      do 195 m = -n,n
      do 205 nu=0,numax
        nup = (nu+1)*(nu+1) - nu
        do 215 mu=-nu,nu
          write(14,990)n,m,nu,mu,beta(npp+m,nup+mu)
 215    continue
 205  continue
 195  continue
 185  continue

 990  format(4i4, 1p2d19.8)
 995  format(16x, 1p2d19.8)
      print *,' '
      print *,'Translation coefficients written to file "betacout"'
      print *,' '

      endif

      stop
      end


      subroutine sbeta(z,theta,phi,nmax,numa,beta,ndim,nudim) 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 200)
      complex*16 beta(ndim,0:nudim)
      complex*16 al1,al2,al3
      real*8 theta,phi,z,costhe
      real*8 sbesj(0:nudd)
      real*8 pwork(0:nudd)
      complex*16 sphh(0:nudd,-nudd:nudd), ci

      ci = (0.0d0,1.0d0)

      costhe=cos(theta)
c
c --- Calculate and store initial values of betaa (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi,nmx,nmx,sphh,nudd,nudd,pwork)
      call sbessj(z,nmx,sbesj,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        beta(1,nup)=msign*sphh(nu,0)*sbesj(nu)*3.544907702d0
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          beta(1,lmp)=msign*sphh(nu,-mu)*sbesj(nu)*3.544907702d0
          beta(1,lmm)=msign*sphh(nu,mu)*sbesj(nu)*3.544907702d0
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            beta(npp,num+mu)= (bpnu*beta(npm,nub+mu-1)+
     &                         bmnu*beta(npm,nup+mu-1))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          beta(npp,num-nu)= (bmnu*beta(npm,nup-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(float(2)/float(3))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          beta(npp,1)= (bmnu*beta(npm,2))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=beta(nmp,nub+mu)
           al3=beta(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           beta(npp,num+mu)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=beta(nmp,nup-nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,num-nu)= (amnu*al3)/apnm     
          al3=beta(nmp,nup+nu)
          beta(npp,num+nu)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=beta(nmp,3)
          amnu = sqrt(1./3.)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,1)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=beta(nmm,num+mu)
           al2=beta(nmp,nub+mu)
           al3=beta(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           beta(npp,num+mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=beta(nmm,num-nu)
          al3=beta(nmp,nup-nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,num-nu)=(-amnm*al1 + amnu * al3) / apnm     
          al1=beta(nmm,num+nu)
          al3=beta(nmp,nup+nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,num+nu)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=beta(nmm,1)
          al3=beta(nmp,3)
          amnu = sqrt(1./3.)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,1)=(-amnm*al1 + amnu * al3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            beta(npp-m,nup) = msign*(beta(npp+m,nup))
     &                             *exp(2.*ci*(-m)*phi)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              beta(npp-m,nup+mu) = msign*musign*beta(npp+m,nup-mu)
     &                                *exp(2.*ci*phi*(-mu-m))
              beta(npp-m,nup-mu) = msign*musign*beta(npp+m,nup+mu)
     &                                *exp(2.*ci*phi*(mu-m))
 98         continue
 96       continue
 95     continue
 90   continue
  
      return
      end

c------------------------------------------------------------------------

      SUBROUTINE SPHHARM(X,PHI,L,M,SPHH,LD1,LD2,PWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PWORK(0:LD1)
      COMPLEX*16 SPHH(0:LD1,-LD2:LD2), CI
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
CC
      CI = (0.0D0,1.0D0)
      PI = ACOS(-1.0D0)
      DO 10 LM = 0,M
        CALL LEGENDR(X,L,LM,PWORK,LD1) 
        DO 20 LP = LM,L
          SPHH(LP,LM) = DCMPLX(PWORK(LP),0.0D0)
 20     CONTINUE
 10   CONTINUE
C
      PIINV = 0.5D0/SQRT(PI)
C
      DO 30 LP = 0,L
        SPHH(LP,0) = PIINV*SQRT(FLOAT(2*LP+1))*SPHH(LP,0)
 30   CONTINUE
C
      IF(L .LT. 150) THEN
        PN = 1.
        DO 40 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*FLOAT(LP)+1.0D0)
          PN = PN*FLOAT(LP)
          PADD = SQRT(PN)
          PMIN = PN
          DO 50 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD*SQRT(FLOAT(LP+MP))
            PMIN = PMIN/FLOAT(LP-MP+1)   
            FAC = SIGN*FACL*SQRT(PMIN)/PADD
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 50       CONTINUE
 40     CONTINUE
      ELSE
        PN = 0.0
        DO 60 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*FLOAT(LP)+1.0D0)
          PN = PN + LOG(FLOAT(LP))
          PADD = PN
          PMIN = PN
          DO 70 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD + LOG(FLOAT(LP+MP))
            PMIN = PMIN - LOG(FLOAT(LP-MP+1))   
            FAC = SIGN*FACL*EXP(0.5D0*(PMIN-PADD))
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 70       CONTINUE
 60     CONTINUE
      ENDIF  
C
      RETURN
      END


      SUBROUTINE LEGENDR(X,L,M,PLGNDR,LD1)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PLGNDR(0:LD1)
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in LEGENDR'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
      PMM=1.
      IF(M.GT.0) THEN
        SOMX2=SQRT((1.-X)*(1.+X))
        FACT=1.
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.
11      CONTINUE
      ENDIF
      IF(L.EQ.M) THEN
        PLGNDR(L)=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF(L.EQ.M+1) THEN
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
        ELSE
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PLGNDR(LL)=PLL
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
        ENDIF
      ENDIF
      RETURN
      END



	subroutine sbessj(x,n,sj,nd)
        implicit double precision (a-h,o-z)
        real*8 x, sj(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
        
c --- Explicit calculation of low order Bessel functions.
        xinv = 1./x
        if (n.eq.0) then
            sj(0)=sin(x)*xinv
            return
        end if
        if (n.eq.1) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            return
        end if
        if (n.eq.2) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            sj(2)=(3.0d0/x/x-1.0d0)*sj(0) - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        sj(0)=sin(x)*xinv
        sj(1)=sj(0)/x-cos(x)*xinv
        sjb=sj(0)
        sjm=sj(1)
        if (x.gt.dfloat(n)) then
            do 11 j=2,n
                sjp=(2.0d0*dfloat(j-1)+1.)*xinv*sjm-sjb
                sjb=sjm
                sjm=sjp
                sj(j)=sjm
  11        continue
        else
            sj1=sj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            sjm=0.0d0
            sjb=1.0d0
            i=0
            do 12 j=m,1,-1
                sjp=(2.0d0*dfloat(j+1)+1.)*xinv*sjb-sjm
                sjm=sjb
                sjb=sjp
                if(j.le.n) sj(j)=sjp
c>>>>>                write(12,*) j, sjp
                if (dabs(sjp).gt.bigno) then
                    sjm=sjm*1.d-10
                    sjb=sjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      sj(lp)=sj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (sj(1).eq.0.0d0) print *,'got 0 in SJ'
            dp=sj1/sj(1)
            do 30 jp = 1,n
              sj(jp) = sj(jp)*dp
  30        continue
        end if
  13    return
        end

c------------------------------------------------------------------------

      Complex*16 Function betaa(n,m,nu,mu,r,theta,phi,k0)
      complex*16 psum,temp,ai
      real*8 r,theta,phi,k0,fact2a,fact2b,sj,fac1,DRLGN1,gcoef
      integer n,m,nu,mu,p
      ai  =(0.0d0,1.0d0)
      psum=(0.0d0,0.0d0)
c --- Uncomment these two lines to use Fuller's Gaunt recursion.
c     As it stands now, Gaunt coefficients calculated directly in
c     subroutine "gcoef" (to play it safe).
c     call Fuller(m,n,-mu,nu,a)
      do 3 p=n+nu,max(abs(n-nu),abs(m-mu)),-2
c       temp=(ai**(p+nu-n))*a(p)*SJ(p,k0*r)*DRLGN1(cos(theta),p,m-mu)
        temp=(ai**(p+nu-n))*gcoef(m,n,-mu,nu,p)*SJ(p,k0*r)*
     &       DRLGN1(cos(theta),p,(m-mu))
        psum=psum+temp
  3   continue
      fact2a=((-1.0d0)**m)*sqrt(dfloat(2*n+1)*fac1(n-m)/fac1(n+m))
      fact2b=sqrt(dfloat(2*nu+1)*fac1(nu+mu)/fac1(nu-mu))
      betaa=psum*fact2a*fact2b*exp(ai*(m-mu)*phi)
      return
      end

c****module drlgn1
      REAL*8 FUNCTION DRLGN1(DX,N,M)
      real*8 an,am,sum,fac,prefac,pre,dx,algama

      IF (ABS(M) .LE. N) GOTO 60
      DRLGN1=0.0d0
      RETURN
 60   AN=dfloat(n)
      AM=dfloat(m)
      SUM=DX**(N-M)
      FAC=1.0d0
      PREFAC=(ABS((1.d0-DX*DX))**(M/2.d0))*((-1.0d0)**M)
      PRE=EXP(ALGAMA(AN+.5d0)-ALGAMA(.5d0)-ALGAMA(AN-AM+1.d0))*PREFAC
      IF (N-M .LT. 2) GOTO 90
      DO 80 K=2,N-M,2
       FAC=-FAC*dfloat((N-M-K+1)*(N-M-K+2))/dfloat(K*(2*N-K+1))
       SUM=SUM+FAC*(DX**(N-M-K))
 80   CONTINUE
 90   DRLGN1=SUM*PRE*(2.0d0**N)
      RETURN
      END


c------------------------------------------------------------------------

      Real*8 Function GCOEF(m,n,mu,nu,p)

      integer m,n,mu,nu,p
      real*8 x1,x2,x3,fac3,threej

      if (m.ge.0) x1=fac3(n+m,n-m+1)
      if (m.lt.0) x1=1.0/fac3(n-m,n+m+1)

      if (mu.ge.0) x2=fac3(nu+mu,nu-mu+1)
      if (mu.lt.0) x2=1.0/fac3(nu-mu,nu+mu+1)

      if (m+mu.ge.0) x3=1.0/fac3(p+m+mu,p-m-mu+1)
      if (m+mu.lt.0) x3=fac3(p-m-mu,p+m+mu+1)

      gcoef=((-1.0d0)**(m+mu))*dfloat(2*p+1)*sqrt(x1*x2*x3)*
     &      ThreeJ(n,nu,p,0,0,0)*ThreeJ(n,nu,p,m,mu,-m-mu)

      return
      end
c------------------------------------------------------------------------

C       THREEJ(J1,J2,J3,M1,M2,M3)                       JULY 31, 1984
C       THIS SUBROUTINE GENERATES THE 3-J COEFFICIENTS.
C       REF: GOTTFRIED:QUANTUM MECHANICS(VOL.1)
C
        Real*8 FUNCTION THREEJ(J1,J2,J3,M1,M2,M3)
        real*8 clgo
        integer j1,j2,j3,m1,m2,m3
        THREEJ=((-1.0d0)**(J1-J2-M3))/SQRT(dfloat(2*J3+1))*
     &         CLGO(J1,M1,J2,M2,J3,-M3)
        RETURN
        END
c------------------------------------------------------------------------

      Double precision FUNCTION ALGAMA(XX)
c     from pg. 157 of "Numerical Recipes" by Press,
c     Flannery, Teukolsky, and Vettering.
      real *8 cof(6),stp,half,one,fpf,tmp,ser,pi,xx,algama0,x
      integer nflag,j
      data cof,stp/76.18009173d0,-86.50532033d0,24.01409822d0,
     &   -1.231739516d0,.120858003d-2,-.536382d-5,2.50662827465d0/
      data half,one,fpf/0.5d0,1.0d0,5.5d0/
      algama0=0.0
      pi=4.0d0*atan2(1.0d0,1.0d0)
      nflag=0
      if (xx .eq. 0.0d0) then
        algama=algama0
        go to 1000
      else if (xx .lt. 1.0d0) then
        xx=-xx+1.0d0
        nflag=1
      end if
      x=xx-one
      tmp=x+fpf
      tmp=(x+half)*log(tmp)-tmp
      ser=one
      do 10 j=1,6
        x=x+one
        ser=ser+cof(j)/x
 10   continue
      algama=tmp+log(stp*ser)
      if (nflag .eq. 1) then
        algama=log(pi)-algama-log(sin(pi*xx))
      end if
 1000 return
      end
c------------------------------------------------------------------------

        Double precision FUNCTION SJ(n,x)
        implicit double precision (d)
        real*8 db(0:100),x
        integer flag
        parameter (iacc=40)

c --- Small argument approximation.
        if (x.lt.0.1d0) then
          dfac=1.0d0
          do 1 i=1,2*n+1,2
            dfac=dfac*dfloat(i)
  1       continue
          SJ=(x**n)/dfac
          return
        end if

c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            SJ=sin(x)/x
            return
        end if
        if (n.eq.1) then
            SJ=sin(x)/x/x-cos(x)/x
            return
        end if
        if (n.eq.2) then
            SJ=(3.0d0/x/x-1.0d0)*sin(x)/x - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        dbessj0=cos(x)/x
        dbessj1=sin(x)/x
        if (x.gt.dfloat(n)) then
            dbjm=dbessj0
            dbj=dbessj1
            do 11 j=0,n-1
                dbjp=(2.0d0*dfloat(j)+1.)/x*dbj-dbjm
                dbjm=dbj
                dbj=dbjp
  11        continue
            SJ=dbj
        else
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            SJ=0.0d0
            db(m+1)=0.0d0
            db(m)=1.0d0
            i=0
            do 12 j=m,1,-1
                db(j-1)=(2.0d0*dfloat(j)+1.)/x*db(j)-db(j+1)
                if (dabs(db(j-1)).gt.1.d10) then
                    db(j-1)=db(j-1)*1.d-10
                    db(j)=db(j)*1.d-10
                    i=i+1
                end if
                if (j.eq.n) flag=i
  12        continue
            dr0=sin(x)/x
            if (db(0).eq.0.0d0) print *,'got 0 in SJ'
            dp=dr0/db(0)
            SJ=db(n)*dp*(1.d10)**(flag-i)
        end if
  13    return
        end

c------------------------------------------------------------------------

      Real*8Function FAC1(n)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(n),1.0d0,-1.0d0
        i=i*j
  1   continue
      fac1=i
      return
      end

      Real*8 Function FAC2(n)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(n),1.0d0,-2.0d0
        i=i*j
  1   continue
      fac2=i
      return
      end

      Real*8 Function FAC3(ns,ne)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(ns),dfloat(ne),-1.0d0
        i=i*j
  1   continue
      fac3=i
      return
      end

      Real*8 Function FAC4(ns,ne)
      real*8 i,j
      i=1.0d0
      do 1 j=dfloat(ns),dfloat(ne),-2.0d0
        i=i*j
  1   continue
      fac4=i
      return
      end

c------------------------------------------------------------------------

C       CLGO(J1,M1,J2,M2,J,M)                           AUG. 31, 1984
C       THIS SUBROUTINE GENERATES THE CG-COEFFICIENTS.
C       REF: M.ABRAMOWITZ, ET.AL. HANDBOOK.... ETC.

        Real*8 FUNCTION CLGO(J1,M1,J2,M2,J,M)
        real*8 sum,alfac,algama,alfo
        integer j,j1,j2,m,m1,m2,k
        IF((J1+J2-J).LT.0)GO TO 100
        IF((J1-J2+J).LT.0)GO TO 100
        IF((-J1+J2+J).LT.0)GO TO 100
        IF(IABS(M1).GT.J1)GO TO 100
        IF(IABS(M2).GT.J2)GO TO 100
        IF(IABS(M).GT.J)GO TO 100
        IF((M1+M2).NE.M)GO TO 100

        SUM=0.0d0
        DO 150 K=0,10000
        IF((J1+J2-J-K).LT.0)GO TO 200
        IF((J1-M1-K).LT.0)GO TO 200
        IF((J2+M2-K).LT.0)GO TO 200
        IF((J-J2+M1+K).LT.0)GO TO 150
        IF((J-J1-M2+K).LT.0)GO TO 150

        ALFAC=.5d0*(ALGAMA(dFLOAT(J1+M1+1))+ALGAMA(dFLOAT(J1-M1+1))
     1        +ALGAMA(dFLOAT(J2+M2+1))
     2        +ALGAMA(dFLOAT(J2-M2+1))     +ALGAMA(dFLOAT(J+M+1))
     3        +ALGAMA(dFLOAT(J-M+1)))     -(ALGAMA(dFLOAT(K+1))
     4        +ALGAMA(dFLOAT(J1+J2-J-K+1))
     5        +ALGAMA(dFLOAT(J1-M1-K+1))   +ALGAMA(dFLOAT(J2+M2-K+1))
     6        +ALGAMA(dFLOAT(J-J2+M1+K+1)) +ALGAMA(dFLOAT(J-J1-M2+K+1)))
        SUM=SUM+EXP(ALFAC)*((-1.0d0)**K)
150     CONTINUE
200     continue
        ALFO=.5d0*(ALGAMA(dFLOAT(J1+J2-J+1))+ALGAMA(dFLOAT(J+J1-J2+1))
     1            +ALGAMA(dFLOAT(J+J2-J1+1))-ALGAMA(dFLOAT(J+J1+J2+2)))
        CLGO=SUM*EXP(ALFO)*SQRT(dfloat(2*J+1))
        GO TO 120

100     CLGO=0.0d0
120     RETURN
        END

