c****module mainh2
      PROGRAM MAINH2 
                   
c  ***        nst is total # of spheres in grouping             ***
c  ***           mdm & pdm are matrix dimensions                ***
c  ***                iwa must be >3xmdm                        ***

c --- mdm and pdm must be perfect squares (not necessarily the same)
c
      integer mdm,pdm,iwa,nst,i,j,n,ntm,ntp
      parameter ( nst=200, iwa=100 )
      parameter ( mdm=4,  pdm=36)
      parameter ( nptt = 64 )
      parameter ( jnmax = nst*mdm ) 

      complex*16 caji(jnmax,jnmax),cbj(jnmax,pdm)
      complex*16 ab1(mdm,0:nptt),ab2(0:nptt,mdm)
      complex*16 t1(mdm,mdm),taun(pdm,pdm),Tatau(mdm,pdm),taua(pdm,mdm)
      complex*16 btb(pdm,pdm),dple,one,ai,tau
      complex*16 eps(nst),epb,einc(pdm),a3,b3,c3
      complex*16 an0(mdm,pdm),a0n(pdm,mdm),anm(mdm,mdm),w2(mdm,pdm)
      complex*16 bn0(mdm,pdm),b0n(pdm,mdm),ID(mdm,mdm),epsef2,epsef1
      complex*16 temp1(pdm,mdm),temp2(mdm,pdm),taun1(pdm,pdm),w(mdm,mdm)
      complex*16 wtemp(mdm,mdm),temp3(mdm,mdm)
      complex*16 czero(mdm,pdm)
      complex*16 cft1(mdm,pdm),cft2(mdm,pdm),cft4(pdm,pdm)
      real*8 r(nst),pho(nst),phi(nst),theta(nst),fv,tolrs,deltr
      real*8 pi,k0,ee,rg,fq,fqeo,pho1,theta1,phi1,ka
      real*8 pho2,theta2,phi2
      real*8 pho3,theta3,phi3
      real*8 epsr1,sigma1,epsr2,sigma2,fvv
c>>>      complex*16 alphn0(mdm,pdm) 
c>>>      complex*16 betan0(mdm,pdm) 

      open(8,file='phidat')
      open(9,file='thedat')
      open(10,file='phodat')
      open(11,file='raddat')
      open(12,file='epsdat_')
      open(13,file='linout')
      open(14,file='dples')

      ntm=int(sqrt(dfloat(mdm)))-1
      ntp=int(sqrt(dfloat(pdm)))-1
      pi=4.0d0*atan2(1.0d0,1.0d0)
      ee=sqrt(.75d0/pi)
      ai  =(0.0,1.0)
      one =(1.0,0.0)
  
c --- Read in sphere position, size, and epsilon data.

      fvv = 0.0d0
      do 1 i=1,nst
        read(8,*)  PHI(i)
        read(9,*)  THETA(i)
        read(10,*) PHO(i)
        read(11,*) R(i)
        read(12,3) EPS(i)
        fvv = fvv + r(i)**3
  1   continue
      read(11,*) RG
      read(12,3) EPB
      read(12,4) FQ
  3   Format(f11.4,d9.4)
  4   Format(d9.4)

      write(6,*) 'Input the thickness of shells'
      read(5,*) tolrs
      k0=2.0e0*pi*fq/3.0d8
      fqeo=fq*8.8419d-12
      fv=(r(1)/rg)**3
      fvv = fvv/pho(nst)**3

      write(*,*) 'grp rad.=',rg,'   epb=',conjg(epb),'  M =',mdm
      write(13,*)'grp rad.=',rg,'   epb=',conjg(epb),'  M =',mdm
      write(*,*) 'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',pdm
      write(13,*)'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',pdm
      write(*,*) 'spread  =',pho(3)-pho(2)
      write(13,*)'spread  =',pho(3)-pho(2)
      write(*,*) ' '
      write(13,*)' '

      write(*,*)  'Fractional Volume    ', fvv,  '   Dipole Term'
      write(*,*)  'new eff. permittivity         new eff. conductivity'
      write(13,*) 'Fractional Volume    ', fvv,  '   Dipole Term'
      write(13,*) 'new eff. permittivity         new eff. conductivity'
      write(13,*)' '

      do 115 i = 1,mdm
        do 116 j = 1,pdm
          czero(i,j) = (0.0d0,0.0d0)
 116    continue
 115  continue
c
      do 122 i=1,pdm
        do 121 j=1,pdm
          taun(i,j)=(0.0d0,0.0d0)
 121    continue
 122  continue

      do 124 i=1,mdm
        do 123 j=1,mdm
          ID(i,j)=cmplx(0.0d0,0.0d0)
 123    continue
          ID(i,i)=cmplx(1.0d0,0.0d0)
 124  continue

c --- Calculate normalized einc [Px1]

      call fieldin(pdm,einc)
c
      nsct = 0
      do 1000 n=0,nst

c --- Find the number of scatterers in each shell

      np = 0
      if(tolrs .gt. 1.0d-12) then
      do 14 ln = nsct+1, nst
        lnp = ln
        deltr = pho(lnp+1) - pho(lnp)
        if(deltr .gt. tolrs) goto 15
 14   continue
      else
        ln = nsct+1
        lnp = ln
      endif
 15   np = lnp - nsct

      do 25 jsh = nsct+1,lnp

c --- Calculate normalized 1 sphere scattering matrix for sphere n+1
c     t1static    = (1/S) * t1dynamic    * D

      lp = jsh
c      call t1sub(t1,mdm,ntm,fq,epb,eps(lp),r(lp),k0)
      call stmatrx(t1,mdm,mdm,fq,epb,eps(lp),r(lp),k0)
     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex*16 identity matrix [MxM].
c --- Calculate the normalization matrices (diagonal => column vectors)
c     alphastatic = (1/D) * alphadynamic * S
c     betastaticn0= (1/D) * betadynamic  * D
c     betastatic0n= (1/S) * betadynamic  * S
 
c --- an0 is alpha(n+1,0)    [MxP]

      phi1  =phi(lp)
      theta1=theta(lp)
      pho1  =pho(lp)
c
      call dsalpha(pho1,theta1,phi1,k0,ntm,ntp,ab1,mdm,nptt,1)
      call movemtrx(ab1,mdm,nptt,an0,mdm,pdm,mdm,pdm)
c
c --- find T_j(1)*alph_j0*tau_(n) and store the result in cft2	
c
      call mtrxmult(t1,mdm,mdm,an0,mdm,pdm,cft1)
      call mtrxmult(cft1,mdm,pdm,taun,pdm,pdm,cft2)
c
      j1 = (lp-nsct-1)*mdm + 1
c
      do 20 ish = nsct+1,lnp
c
      lq = ish
      phi2  = phi(lq)
      theta2= theta(lq)
      pho2  =pho(lq)
c
c --- a0n is alpha(0,n+1)    [PxM]
c
      call dsalphap(pho2,theta2,phi2,k0,ntp,ntm,ab2,nptt,mdm,-1)
      call movemtrxp(ab2,nptt,mdm,a0n,pdm,mdm,pdm,mdm)
c
c --- find T_j(1)*alph_j0*tau_(n)*alph_0i 
c       and store the result in wtemp 
c
      call mtrxmult(cft2,mdm,pdm,a0n,pdm,mdm,wtemp)
c   
      if(ish .eq. jsh) then
c    
        call mtrxadd(wtemp,mdm,mdm,id,mdm,mdm,w,-1)
c
      else
c
c
        call recrdnt(pho1,theta1,phi1,pho2,theta2,phi2,
     &                                 pho3,theta3,phi3)
        call dsalpha(pho3,theta3,phi3,k0,ntm,ntm,ab1,mdm,nptt,-1)
        call movemtrx(ab1,mdm,nptt,anm,mdm,mdm,mdm,mdm)
        call mtrxmult(t1,mdm,mdm,anm,mdm,mdm,temp3)
        call mtrxadd(wtemp,mdm,mdm,temp3,mdm,mdm,w,1)
c
      endif
c
c --- w is A_ji in the paper "Generalized Recursive Algorithm ..."
c     now, we need to move to a big matrix caji        
c
      i1 = (lq-nsct-1)*mdm + 1
c
      call movesl(w,caji,mdm,mdm,jnmax,jnmax,mdm,mdm,j1,i1)      
c
 20   continue
c
c --- form the right hand of the equation (9)
c
c --- bn0 is beta(n+1,0)   [MxP]

      call dsbeta(pho1,theta1,phi1,k0,ntm,ntp,ab1,mdm,nptt,1,1)
      call movemtrx(ab1,mdm,nptt,bn0,mdm,pdm,mdm,pdm)

      call mtrxmult(t1,mdm,mdm,bn0,mdm,pdm,w2)
      call mtrxadd(w2,mdm,pdm,cft2,mdm,pdm,temp2,1)
      call mtrxadd(czero,mdm,pdm,temp2,mdm,pdm,cft2,-1)
c
      call movesl(cft2,cbj,mdm,pdm,jnmax,pdm,mdm,pdm,j1,1)      
c
 25   continue
c
      jlm = np*mdm
c
      write(6,*) 'the size of the matrix is = ',jlm,'X',jlm
c
c --- linear equations solver
c
      call cgaussj(caji,jlm,jnmax,cbj,pdm,pdm)
c
      call cinitmtrx(cft4,pdm,pdm)
c
      do 30 ish = nsct+1,lnp
c
c --- b0n is beta(0,n+1)   [PxM]
c
      lq = ish
      phi2  = phi(lq)
      theta2= theta(lq)
      pho2  = pho(lq)
c
      call dsbetap(pho2,theta2,phi2,k0,ntp,ntm,ab2,nptt,mdm,-1,2)
      call movemtrxp(ab2,nptt,mdm,b0n,pdm,mdm,pdm,mdm)
c
      call dsalphap(pho2,theta2,phi2,k0,ntp,ntm,ab2,nptt,mdm,-1)
      call movemtrxp(ab2,nptt,mdm,a0n,pdm,mdm,pdm,mdm)

      call mtrxmult(taun,pdm,pdm,a0n,pdm,mdm,temp1)
      call mtrxadd(temp1,pdm,mdm,b0n,pdm,mdm,taua,1)

      i1 = (lq-nsct-1)*mdm + 1
      call movels(cbj,tatau,jnmax,pdm,mdm,pdm,mdm,pdm,i1,1)      
      call mtrxmult(taua,pdm,mdm,tatau,mdm,pdm,btb)
      call mtrxadd(cft4,pdm,pdm,btb,pdm,pdm,cft4,1)
c
 30   continue
c
      call mtrxadd(cft4,pdm,pdm,taun,pdm,pdm,taun1,1)
c
c --- Calculate the dipole term:  row 3 of tau(n+1) * einc

      dple=(0.0,0.0)
      do 200 j=1,pdm
        dple=dple+taun1(3,j)*einc(j)
  200 continue

c --- Calculate effective permittivity and conductivity

      dple  = dple*ee/ai/k0/rg**3
c----------------------------------------------------------------------
      ka = k0 * rg
      tau= dple*(ka**3)/3.0/ai
      A3 =  15.0*(ka**3) - 18.0*(ka**5) -  45.0*ai*tau -  5.0*ai*(ka**6)
      B3 =  15.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau + 10.0*ai*(ka**6)
      C3 = -30.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau -  5.0*ai*(ka**6)
c----------------------------------------------------------------------
      epsef1= ((1.0+2.0*Dple)/(1.0-Dple))*epb
      epsr1 = real(epsef1)
      sigma1= -dimag(epsef1)*fqeo*2.0*pi
      epsef2= epb * ( -B3 + sqrt(B3*B3-4.0*A3*C3) ) / (2.0*A3)
      epsr2 = real(epsef2)
      sigma2= -dimag(epsef2)*fqeo*2.0*pi
      fv=fv+(r(n+1)/rg)**3

      write(14,*) dple
      write(*,*)  'sphere #',nsct+np,'      dple =',dple
      write(*,*)  '                   ',epsr2,sigma2
      write(13,*) 'sphere #',n+1,'      dple =',dple
      write(13,*) '                   ',epsr2,sigma2

c     write(*,*) 'eff. permit. =',epsr,'    conductivity =',sigma
c     write(*,*) 'dipole term  =',dple
c     write(13,*)'eff. permit. =',epsr,'    conductivity =',sigma
c     write(13,*)'dipole term  =',dple

c      if (nsct.eq.nst-1) go to 1000

c --- Set tau(n) = tau(n+1) before next pass through loop

      do 300 i=1,mdm
        do 301 j=1,pdm
          taun(i,j)=taun1(i,j)
 301    continue
 300  continue
      nsct = nsct + np
      if(nsct .ge. nst) goto 666

 1000 continue
 666  stop
      end
c****module fieldin
      subroutine fieldin(lpdm,ceinc)
c
      implicit complex*16 (c)
      implicit real*8 (a-b,d-h,o-z)
c
      dimension ceinc(lpdm)
c
      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
c
      ntp = int(sqrt(dfloat(lpdm))) - 1
      k = 1
      cp = 1.0d0
      do 10 jn = 0,ntp
        do 20 jm = -jn,jn
          ceinc(k) = (0.0d0,0.0d0)
          k = k + 1
 20     continue
        ceinc((jn+1)*(jn+1)-jn) = cp*sqrt(4.0d0*pi*dfloat(2*jn+1))
        cp = cp*ci
 10   continue
c
      return
      end
c****module lowfappx
      SUBROUTINE LOWFAPPX(l,f,a,epb,eps,apprx)
      complex*16 apprx,epb,eps,epsr,ai
      real*8 k0,f,a,x1,x2,k,ka,k1,krel

      ai   = dcmplx(0.0d0,1.0d0)
      epsr = eps/epb
      k0   = 8.0d0*atan2(1.0d0,1.0d0)*f/3.0d8
      k    = k0*sqrt(dreal(epb))
      k1   = k0*sqrt(dreal(eps))
      ka   = k*a
      krel = k1/k

      x2 = 1.0d0
      do 1 j = 1,l+l-1,2
          x2 = x2*dfloat(j)
  1   continue
      x1 = x2*dfloat(l+l+1)

c     top1 = epsr*dfloat(l)* (k1**(l+1))* (k**(l-1))* (a**(l+l-1))/x1/x1
c     top2 =      dfloat(l)* (k1**l)*     (k**l)*     (a**(l+l-1))/x1/x1
c     bot1 = ai * dfloat(l+1) * (krel**l) / dfloat(2*l+1) / k / (a**2)
c     bot2 = -ai*epsr*dfloat(l)* (krel**(l+1))/ k/ dfloat(2*l+1)/ (a**2)
c     apprx=-(top1-top2)/(bot1-bot2)

c --- apprx given below is same as -(top1-top2)/(bot1-bot2)
c     this normalizes to a slightly different number than the static #
c     apprx=-ai*dfloat(l) * (ka**(2*l+1)) * (1.0d0-epsr*krel) / x1 / x2
c    &      / ( 1.0d0 + dfloat(l) * (1.0d0 + epsr * krel) )

c --- apprx given below normalizes to exactly the static approximation
      apprx=-ai * dfloat(l) * (ka**(2*l+1)) * (1.0d0-epsr) / x1 / x2
     &      / ( 1.0d0 + dfloat(l) * (1.0d0 + epsr ) )

      return
      end
c****module mtrxmult      
      Subroutine Mtrxmult(a,ar,ac,b,br,bc,c)
      integer ar,ac,br,bc
      complex*16 a,b,c,temp
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ac.ne.br) then
        print *,'*****  Matrix multiplication not defined.  *****'
      end if
      do 1 i=1,ar
        do 2 j=1,bc
          temp=cmplx(0.0d0,0.0d0)
          do 3 k=1,ac
            temp=temp+a(i,k)*b(k,j)
  3       continue
          c(i,j)=temp
  2     continue
  1   continue
      return
      end
      
c****module mtrxadd
      Subroutine Mtrxadd(a,ar,ac,b,br,bc,c,isign)
      integer ar,ac,br,bc,isign
      complex*16 a,b,c
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ar.ne.br.OR.ac.ne.bc) then
        print *,'*****  Matrix addition not defined.  *****'
      end if
      do 1 i=1,ar
        do 2 j=1,bc
            c(i,j)=a(i,j)+isign*b(i,j)
  2     continue
  1   continue
      return
      end
c****module cinitmtrx
      subroutine cinitmtrx(a,jrow,jcol)
      complex*16 a
      dimension a(jrow,jcol)
      do 10 jc = 1,jcol
        do 20 jr = 1,jrow
          a(jr,jc) = (0.0d0,0.0d0)
 20     continue
 10   continue
      return
      end
c****module prntmtrx
      subroutine prntmtrx(a,irow,icol)
      complex*16 a
      dimension a(irow,icol)
c     do 1 i=1,irow
c       do 2 j=1,icol
      do 1 i=1,16
        do 2 j=1,16
          write(14,*) i,j,a(i,j)
  2     continue
  1   continue
      return
      end
c****module filld
      REAL*8 FUNCTION FILLD(i,k0)
      real*8 k0,fac
      integer i
      fac=1.0d0
      do 1 j=1,i+i+1,2
          fac=fac*dfloat(j)
 1    continue
      filld=fac/(k0**i)
      return
      end

c****module fills
      COMPLEX*16 FUNCTION FILLS(i,k0)
      real*8 k0,fac
      integer i
      fac=1.0d0
      do 1 j=1,i+i-1,2
          fac=fac*dfloat(j)
 1    continue
      fills=cmplx(0.0d0,(k0**(i+1))/fac)
      return
      end
c****module onespht
      SUBROUTINE ONESPHT(i,f,r,epb,eps,t1)
      complex*16 epb,eps,t1,Hank,Hankd,SH1,denom,num,epsr
      real*8 k0,k,k1,kr,k1r,SJ,f,r,krel,sjdkr,sjdk1r

      k0   = 8.0d0*atan2(1.0d0,1.0d0)*f/3.0d8
      k    = k0*sqrt(dreal(epb))
      k1   = k0*sqrt(dreal(eps))
      kr   = k*r
      k1r  = k1*r
      krel = k1/k
      epsr = eps/epb

      Hank   = SH1(i,kr)
      sjdkr  = (i/r) * SJ(i,kr)  - k  * SJ(i+1,kr)
      sjdk1r = (i/r) * SJ(i,k1r) - k1 * SJ(i+1,k1r)
      Hankd  = (i/r) * Hank      - k  * SH1(i+1,kr)

      num   = epsr * krel * sjdk1r * SJ(i,kr) - SJ(i,k1r) * sjdkr
      denom = SJ(i,k1r) * Hankd - epsr * krel * sjdk1r * Hank
      t1    = - num / denom
      return
      end
c****module t1sub
c     Subroutine t1sub(t1,mdm,pdm,ntm,fq,epb,eps,r,k0)
      Subroutine t1sub(t1,mdm,ntm,fq,epb,eps,r,k0)
      complex*16 t1,epb,eps,temp,FILLS
      real*8 fq,r,k0,FILLD,div
      parameter(div=1.0d6)
c     integer mdm,ntm,i,k,kk,nq,pdm
      integer mdm,ntm,i,k,kk,nq
c     dimension t1(mdm,pdm)
      dimension t1(mdm,mdm)

      do 1 i=1,mdm
c       do 2 j=1,pdm
        do 2 j=1,mdm
          t1(i,j)=cmplx(0.0d0,0.0d0)
 2      continue
 1    continue

      k=1
      do 10 i=0,ntm
c       if (fq.le.div) call LOWFAPPX(i,fq,r,epb,eps,temp)
c       if (fq.gt.div) call ONESPHT(i,fq,r,epb,eps,temp)
        call LOWFAPPX(i,fq,r,epb,eps,temp)
c       call ONESPHT(i,fq,r,epb,eps,temp)
        nq=(2*i)+1
        do 20 kk=1,nq
          t1(k,k)=FILLD(i,k0)*temp/FILLS(i,k0)
c         t1(k,k)=temp
          k=k+1
 20     continue
 10   continue
      return
      end
c****module stmatrx
      subroutine stmatrx(ct1,mdm,ndm,fq,cepb,ceps,r,wk0)
      implicit complex*16 (c)
      implicit real*8 (a-b,d-h,o-z)
      parameter (mpp = 20)
c
      complex*16 fills
      dimension csbjb(0:mpp+1),csbhb(0:mpp+1)
      dimension csbjs(0:mpp+1),csbhs(0:mpp+1)
      dimension ctemp(0:mpp)
      dimension ct1(ndm,ndm)

      ntm = int(sqrt(float(mdm))) - 1
      wkb  = wk0*sqrt(dreal(cepb))
      wks  = wk0*sqrt(dreal(ceps))
      wkrb  = wkb*r
      wkrs = wks*r
      ckr = wks/wkb
      cepr = ceps/cepb
c   
      do 1 i=1,mdm
c       do 2 j=1,pdm
        do 2 j=1,mdm
          ct1(i,j)=cmplx(0.0d0,0.0d0)
 2      continue
 1    continue
c
      call dsbesjh(wkrb,ntm+1,csbjb,csbhb,mpp+1)
      call dsbesjh(wkrs,ntm+1,csbjs,csbhs,mpp+1)
c
      do 20 jn = 0,ntm
        cdjb = -csbjb(jn+1) + jn*csbjb(jn)/wkrb
        cdhb = -csbhb(jn+1) + jn*csbhb(jn)/wkrb
        cdjs = -csbjs(jn+1) + jn*csbjs(jn)/wkrs
        cdhs = -csbhs(jn+1) + jn*csbhs(jn)/wkrs
        cden = csbjs(jn)*cdhb - cepr*ckr*cdjs*csbhb(jn)
        cnum = cepr*ckr*cdjs*csbjb(jn) - csbjs(jn)*cdjb
        ctemp(jn) = cnum/cden
 20   continue
c
      do 30 jn = 0,ntm
        np = (jn+1)*(jn+1) - jn
        do 25 jm = -jn,jn
          nq = np + jm
          ct1(nq,nq) = filld(jn,wk0)*ctemp(jn)/fills(jn,wk0)
 25     continue
 30   continue
c
      return
      end
c****module cminvl
c cminvl in matman1 in hftlib may be used instead if one has access to
c IMSLIB.
c
c transfer 'c' to the next line to get determinant on the matrix.
c     subroutine cminvl(ca,cb,cd,wa,n,ia)
      subroutine cminvl(ca,cb,wa,n,ia,mp,iwork)
      implicit complex*16 (c)
      real*8 wa
      integer mp,iwork
      dimension ca(mp,mp),cb(mp,mp),cdet(2),wa(iwork)
c
c     cminvl is a driver program that finds the inverse of a matrix
c     by calling cgefa and cgedi from linpack.
c
c     on entry
c
c      ca  a complex matrix preserved on output.
c
c      cb  a complex matrix containing the inverse
c          on output.
c
c      cd  contains the determinant of the matrix ca on
c          output.  If the determinant is not needed, the
c          lower line can be used for the subroutine statement.
c
c      wa  a work real vector of length at least 3*n.
c
c      n   the order of the matrices  ca  and  cb.
c
c      ia  the actual row dimension of the array declared for ca and cb.
c
c     written by W.C. Chew on May 3, 1987.
c
c     transfer from ca to cb.
c
      do 10 i=1,n
      do 10 j=1,n
      cb(i,j)=ca(i,j)
   10 continue
c
c     calls cgefa to condition the matrix.
c
      call cgefa(cb,ia,n,wa(1),info)
c
c     if info is greater than zero, the matrix is singular.
c
      if(info.gt.0) goto 15
c
c     calls cgedi to find inverse and determinant.
c
      call cgedi(cb,ia,n,wa(1),cdet,wa(n+1),11)
c     cd=cdet(1)*10.0**cdet(2)
      return
   15 continue
c
      return
      end
      subroutine caxpy(n,ca,cx,incx,cy,incy)
c
c     constant times a vector plus a vector.
c     jack dongarra, linpack, 3/11/78.
c
      complex*16 cx(1),cy(1),ca
      integer i,incx,incy,ix,iy,n
c
      if(n.le.0)return
c     if (cdabs(dreal(ca)) + cdabs(dimag(ca)) .eq. 0.0d0 ) return
      if (ca.eq.(0.0d0,0.0d0)) return
      if(incx.eq.1.and.incy.eq.1)go to 20
 
c        code for unequal increments or equal increments not equal to 1
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        cy(iy) = cy(iy) + ca*cx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
 
c        code for both increments equal to 1
   20 do 30 i = 1,n
        cy(i) = cy(i) + ca*cx(i)
   30 continue
      return
      end
c-----------------------------------------------------------------

      subroutine cgedi(a,lda,n,ipvt,det,work,job)
      integer lda,n,ipvt(1),job
      complex*16 a(lda,1),det(2),work(1)
c
c     cgedi computes the determinant and inverse of a matrix
c     using the factors computed by cgeco or cgefa.
c
c     on entry
c
c        a       complex(lda, n)
c                the output from cgeco or cgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from cgeco or cgefa.
c
c        work    complex(n)
c                work vector.  contents destroyed.
c
c        job     integer
c                = 11   both determinant and inverse.
c                = 01   inverse only.
c                = 10   determinant only.
c
c     on return
c
c        a       inverse of original matrix if requested.
c                otherwise unchanged.
c
c        det     complex(2)
c                determinant of original matrix if requested.
c                otherwise not referenced.
c                determinant = det(1) * 10.0**det(2)
c                with  1.0 .le. cabs1(det(1)) .lt. 10.0
c                or  det(1) .eq. 0.0 .
c
c     error condition
c
c        a division by zero will occur if the input factor contains
c        a zero on the diagonal and the inverse is requested.
c        it will not occur if the subroutines are called correctly
c        and if cgeco has set rcond .gt. 0.0 or cgefa has set
c        info .eq. 0 .
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas caxpy,cscal,cswap
c     fortran abs,aimag,cmplx,mod,real
c
c     internal variables
c
      complex*16 t,zdum
      real*8 ten,cabs1
      integer i,j,k,kb,kp1,l,nm1
c
c     cabs1(zdum) = cdabs(dreal(zdum)) + cdabs(dimag(zdum))
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))
c
c     compute determinant
c
      if (job/10 .eq. 0) go to 70
         det(1) = (1.0d0,0.0d0)
         det(2) = (0.0d0,0.0d0)
         ten = 10.0d0
         do 50 i = 1, n
            if (ipvt(i) .ne. i) det(1) = -det(1)
            det(1) = a(i,i)*det(1)
c        ...exit
            if (cabs1(det(1)) .eq. 0.0d0) go to 60
   10       if (cabs1(det(1)) .ge. 1.0d0) go to 20
               det(1) = cmplx(ten,0.0d0)*det(1)
               det(2) = det(2) - (1.0d0,0.0d0)
            go to 10
   20       continue
   30       if (cabs1(det(1)) .lt. ten) go to 40
               det(1) = det(1)/cmplx(ten,0.0d0)
               det(2) = det(2) + (1.0d0,0.0d0)
            go to 30
   40       continue
   50    continue
   60    continue
   70 continue
c
c     compute inverse(u)
c
      if (mod(job,10) .eq. 0) go to 150
         do 100 k = 1, n
            a(k,k) = (1.0d0,0.0d0)/a(k,k)
            t = -a(k,k)
            call cscal(k-1,t,a(1,k),1)
            kp1 = k + 1
            if (n .lt. kp1) go to 90
            do 80 j = kp1, n
               t = a(k,j)
               a(k,j) = (0.0d0,0.0d0)
               call caxpy(k,t,a(1,k),1,a(1,j),1)
   80       continue
   90       continue
  100    continue
c
c        form inverse(u)*inverse(l)
c
         nm1 = n - 1
         if (nm1 .lt. 1) go to 140
         do 130 kb = 1, nm1
            k = n - kb
            kp1 = k + 1
            do 110 i = kp1, n
               work(i) = a(i,k)
               a(i,k) = (0.0d0,0.0d0)
  110       continue
            do 120 j = kp1, n
               t = work(j)
               call caxpy(n,t,a(1,j),1,a(1,k),1)
  120       continue
            l = ipvt(k)
            if (l .ne. k) call cswap(n,a(1,k),1,a(1,l),1)
  130    continue
  140    continue
  150 continue
      return
      end
c-----------------------------------------------------------------

      subroutine cgefa(a,lda,n,ipvt,info)
      integer lda,n,ipvt(1),info
      complex*16 a(lda,1)
c
c     cgefa factors a complex matrix by gaussian elimination.
c
c     cgefa is usually called by cgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for cgeco) = (1 + 9/n)*(time for cgefa) .
c
c     on entry
c
c        a       complex(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that cgesl or cgedi will divide by zero
c                     if called.  use  rcond  in cgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas caxpy,cscal,icamax
c     fortran abs,aimag,real
c
c     internal variables
c
      complex*16 t
      integer icamax,j,k,kp1,l,nm1
c
      complex*16 zdum
      real*8 cabs1
c     cabs1(zdum) = abs(real(zdum)) + abs(aimag(zdum))
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))

c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = icamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (cabs1(a(l,k)) .eq. 0.0d0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -(1.0d0,0.0d0)/a(k,k)
            call cscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call caxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (cabs1(a(n,n)) .eq. 0.0d0) info = n
      return
      end
c---------------------------------------------------------------------

      subroutine  cscal(n,ca,cx,incx)
 
c     scales a vector by a constant.
c     jack dongarra, linpack,  3/11/78.
      complex*16 ca,cx(1)
      integer i,incx,n,nincx
 
      if(n.le.0)return
      if(incx.eq.1)go to 20
 
c        code for increment not equal to 1
      nincx = n*incx
      do 10 i = 1,nincx,incx
        cx(i) = ca*cx(i)
   10 continue
      return
 
c        code for increment equal to 1
   20 do 30 i = 1,n
        cx(i) = ca*cx(i)
   30 continue
      return
      end
c---------------------------------------------------------------------

      subroutine  cswap (n,cx,incx,cy,incy)
c     interchanges two vectors.
c     jack dongarra, linpack, 3/11/78.
 
      complex*16 cx(1),cy(1),ctemp
      integer i,incx,incy,ix,iy,n
 
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
 
c       code for unequal increments or equal increments not equal to 1
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        ctemp = cx(ix)
        cx(ix) = cy(iy)
        cy(iy) = ctemp
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
 
c       code for both increments equal to 1
   20 do 30 i = 1,n
        ctemp = cx(i)
        cx(i) = cy(i)
        cy(i) = ctemp
   30 continue
      return
      end
c---------------------------------------------------------------------

      integer function icamax(n,cx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c
      complex*16 cx(1)
      real*8 smax
      integer i,incx,ix,n
      complex*16 zdum
      real*8 cabs1
c     cabs1(zdum) = abs(real(zdum)) + abs(aimag(zdum))
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))
c
      icamax = 0
      if( n .lt. 1 ) return
      icamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = cabs1(cx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(cabs1(cx(ix)).le.smax) go to 5
         icamax = i
         smax = cabs1(cx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = cabs1(cx(1))
      do 30 i = 2,n
         if(cabs1(cx(i)).le.smax) go to 30
         icamax = i
         smax = cabs1(cx(i))
   30 continue
      return
      end
c****module movemtrx
      subroutine movemtrx(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex*16 ca(ja1,0:ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb2
        do 15 jm = 1,jb1
          cb(jm,jn) = (0.0d0,0.0d0)
 15     continue
 10   continue
      do 20 jn = 1,n2
        do 25 jm = 1,n1
          cb(jm,jn) = ca(jm,jn)
 25     continue
 20   continue
c
      return
      end
c****module movemtrxp
      subroutine movemtrxp(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex*16 ca(0:ja1,ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb2
        do 15 jm = 1,jb1
          cb(jm,jn) = (0.0d0,0.0d0)
 15     continue
 10   continue
      do 20 jn = 1,n2
        do 25 jm = 1,n1
          cb(jm,jn) = ca(jm,jn)
 25     continue
 20   continue
c
      return
      end
c****module sj
        Double precision FUNCTION SJ(n,x)
        implicit double precision (d)
        real*8 db(0:100),x
        integer flag
        parameter (iacc=40)

c --- Small argument approximation.
        if (x.lt.0.1d0) then
          dfac=1.0d0
          do 1 i=1,2*n+1,2
            dfac=dfac*dfloat(i)
  1       continue
          SJ=(x**n)/dfac
          return
        end if

c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            SJ=sin(x)/x
            return
        end if
        if (n.eq.1) then
            SJ=sin(x)/x/x-cos(x)/x
            return
        end if
        if (n.eq.2) then
            SJ=(3.0d0/x/x-1.0d0)*sin(x)/x - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        dbessj0=cos(x)/x
        dbessj1=sin(x)/x
        if (x.gt.dfloat(n)) then
            dbjm=dbessj0
            dbj=dbessj1
            do 11 j=0,n-1
                dbjp=(2.0d0*dfloat(j)+1.)/x*dbj-dbjm
                dbjm=dbj
                dbj=dbjp
  11        continue
            SJ=dbj
        else
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            SJ=0.0d0
            db(m+1)=0.0d0
            db(m)=1.0d0
            i=0
            do 12 j=m,1,-1
                db(j-1)=(2.0d0*dfloat(j)+1.)/x*db(j)-db(j+1)
                if (dabs(db(j-1)).gt.1.d10) then
                    db(j-1)=db(j-1)*1.d-10
                    db(j)=db(j)*1.d-10
                    i=i+1
                end if
                if (j.eq.n) flag=i
  12        continue
            dr0=sin(x)/x
            if (db(0).eq.0.0d0) print *,'got 0 in SJ'
            dp=dr0/db(0)
            SJ=db(n)*dp*(1.d10)**(flag-i)
        end if
  13    return
        end
c****module sh1
C       GENERATES SPHERICAL HANKEL FUNCTIONS OF THE THIRD KIND
        COMPLEX*16 FUNCTION SH1(L,Z)
        complex*16 ai,wkh1(-1:100)
        real *8 z,SJ
        AI=CMPLX(0.0d0,1.0d0)
        DO 1 I=-1,L
          WKH1(I)=(0.0d0,0.0d0)
  1     continue
        WKH1(-1)=EXP(AI*Z)/Z
        WKH1(0)=-AI*EXP(AI*Z)/Z
        DO 2 I=0,L-1
          WKH1(I+1)=dfloat(2*I+1)/Z*WKH1(I)-WKH1(I-1)
  2     continue
        SH1=cmplx(SJ(l,z),dimag(WKH1(L)))
        RETURN
        END

c****module recrdnt
      subroutine recrdnt(ra,thta,phia,rb,thtb,phib,rc,thtc,phic)
c
      real*8 ra,rb,rc
      real*8 thta,thtb,thtc
      real*8 phia,phib,phic
      real*8 xa,ya,za,xb,yb,zb,xc,yc,zc

      xa = ra*sin(thta)*cos(phia)
      ya = ra*sin(thta)*sin(phia)
      za = ra*cos(thta)
      xb = rb*sin(thtb)*cos(phib)
      yb = rb*sin(thtb)*sin(phib)
      zb = rb*cos(thtb)
c
      xc = xb - xa
      yc = yb - ya
      zc = zb - za
c
      rc = sqrt(xc*xc+yc*yc+zc*zc)
      thtc = atan2(sqrt(xc*xc+yc*yc),zc)
      phic = atan2(yc,xc)
c
      return
      end
c****module movesl
      subroutine movesl(ca,cb,jaa,jab,jba,jbb,iar,iac,is,js)
c
c     move data from a small matrix ca to a large matrix cb
c
      implicit complex*16 (c)
c
      dimension ca(jaa,jab),cb(jba,jbb)
c
      do 20 j = 1,iac
        do 10 i = 1,iar
          cb(i+is-1,j+js-1) = ca(i,j)
 10     continue
 20   continue
c
      return
      end
c****module movels
      subroutine movels(ca,cb,jaa,jab,jba,jbb,ibr,ibc,is,js)
c
      implicit complex*16 (c)
c
c     move data from a large matrix ca to a small matrix cb
c
      dimension ca(jaa,jab),cb(jba,jbb)
c
      do 20 j = 1,ibc
        do 10 i = 1,ibr
          cb(i,j) = ca(i+is-1,j+js-1)
 10     continue
 20   continue
c
      return
      end

c**********************************************************************
c****module dsbeta
      subroutine dsbetap(zz,theta,phi,k0,numa,nmax,beta,nudim
     &                                      ,ndim,jtune,jcon) 
c
c     this routine is for numa > nmax 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 21)
      complex*16 beta(0:nudim,ndim)
      complex*16 al1,al2,al3
      complex*16 ci
      real*8 z,zz,theta,phi,k0,costhe,theta0,phi0
      real*8 pwork(0:nudd),pi,sqrtpi
      real*8 sbesj(0:nudd)
      complex*16 sphh(0:nudd,-nudd:nudd)
      real*8 factsn,factsnu
      real*8 factdn,factdnu
      real*8 bpnu,bmnu,bpnn
      real*8 amnu,apnu,apnm,amnm

      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
      sqrtpi = sqrt(4.0d0*pi)
      
      z = zz*k0
c
      if(z .gt. 1.0d-18) then

      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of betaa (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesj(z,nmx,sbesj,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        beta(nup,1)=msign*sphh(nu,0)*sbesj(nu)*sqrtpi
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          beta(lmp,1)=msign*sphh(nu,-mu)*sbesj(nu)*sqrtpi
          beta(lmm,1)=msign*sphh(nu,mu)*sbesj(nu)*sqrtpi
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(dfloat((nu+mu)*(nu+mu-1))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(dfloat((nu-mu+2)*(nu-mu+1))
     &                 /dfloat((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
            beta(num+mu,npp)= (bpnu*beta(nub+mu-1,npm)+
     &                         bmnu*beta(nup+mu-1,npm))/bpnn
 50       continue
          bmnu = sqrt(dfloat((nu+nu+2)*(nu+nu+1))
     &               /dfloat((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          beta(num-nu,npp)= (bmnu*beta(nup-nu-1,npm))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0d0/3.0d0)
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          beta(1,npp)= (bmnu*beta(2,npm))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      jmp = m  
      do 60 n=jmp,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=beta(nub+mu,nmp)
           al3=beta(nup+mu,nmp)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           beta(num+mu,npp)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=beta(nup-nu,nmp)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(num-nu,npp)= (amnu*al3)/apnm     
          al3=beta(nup+nu,nmp)
          beta(num+nu,npp)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=beta(3,nmp)
          amnu = sqrt(1.0d0/3.0d0)
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(1,npp)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=beta(num+mu,nmm)
           al2=beta(nub+mu,nmp)
           al3=beta(nup+mu,nmp)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           amnm = sqrt(dfloat((n+m)*(n-m))
     &                 /dfloat((2*n+1)*(2*n-1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           beta(num+mu,npp)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=beta(num-nu,nmm)
          al3=beta(nup-nu,nmp)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(num-nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
          al1=beta(num+nu,nmm)
          al3=beta(nup+nu,nmp)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(num+nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=beta(1,nmm)
          al3=beta(3,nmp)
          amnu = sqrt(1.d0/3.0d0)
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(1,npp)=(-amnm*al1+amnu*al3)/apnm 
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            beta(nup,npp-m) = msign*(beta(nup,npp+m))
     &                             *exp(2.0d0*ci*(-m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              beta(nup+mu,npp-m) = msign*musign*beta(nup-mu,npp+m)
     &                                *exp(2.0d0*ci*phi0*(-mu-m))
              beta(nup-mu,npp-m) = msign*musign*beta(nup+mu,npp+m)
     &                                *exp(2.0d0*ci*phi0*(mu-m))
 98         continue
 96       continue
 95     continue
 90   continue
  
      if(jcon .eq. 1) then

      factdn = 1.0d0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*dfloat(2*jnp+1)/k0
        endif
c>>>>        factdn = 1.0d0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0d0
          do 110 jnup = 0,numa
c>>>>            factdnu = filld(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*k0/dfloat(2*jnup+1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(nup,np) = beta(nup,np)*factdn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue
  
      else if(jcon .eq. 2) then

      factsn = k0
      do 200 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*k0/dfloat(2*jnp-1)
        endif
c>>>        factsn = 1.0d0/fills(jnp,k0)
        do 205 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = 1.0d0/k0
          do 210 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*dfloat(2*jnup-1)/k0
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 215 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(nup,np) = beta(nup,np)*factsn*factsnu
 215        continue
 210      continue
 205    continue
 200  continue
 
      else

        pause 'jcon must be 1 or 2 in sbeta subroutine'
 
      endif
c
      else
c
      jnm = (nmax + 1)**2
      jnum = (numa + 1)**2
      do 300 jn = 1,jnm
        do 310 jnu = 1,jnum
          beta(jnu,jn) = (0.0d0,0.0d0)
 310    continue
        beta(jn,jn) = (1.0d0,0.0d0)
 300  continue
c
      endif
c
      return
      end
c**********************************************************************
c****module dsalphap
      subroutine dsalphap(zz,theta,phi,k0,numa,nmax,alph,nudim,
     &                                           ndim,jtune) 
c
c     this routine is for numa > nmax.
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 21)
      complex*16 alph(0:nudim,ndim)
      complex*16 al1,al2,al3
      complex*16 ci
      real*8 z,zz,theta,phi,k0,costhe,theta0,phi0
      real*8 pwork(0:nudd),sbesj(0:nudd),pi,sqrtpi
      complex*16 sbesh(0:nudd)
      complex*16 sphh(0:nudd,-nudd:nudd)
      real*8 factsn,factdnu
      real*8 bpnu,bmnu,bpnn
      real*8 amnu,apnu,apnm,amnm

      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
      sqrtpi = sqrt(4.0d0*pi)
c
      z = zz*k0
c
      if (z .gt. 1.0d-18) then
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesjh(z,nmx,sbesj,sbesh,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        alph(nup,1)=msign*sphh(nu,0)*sbesh(nu)*sqrtpi
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          alph(lmp,1)=msign*sphh(nu,-mu)*sbesh(nu)*sqrtpi
          alph(lmm,1)=msign*sphh(nu,mu)*sbesh(nu)*sqrtpi
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(dfloat((nu+mu)*(nu+mu-1))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(dfloat((nu-mu+2)*(nu-mu+1))
     &                 /dfloat((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
            alph(num+mu,npp)= (bpnu*alph(nub+mu-1,npm)+
     &                         bmnu*alph(nup+mu-1,npm))/bpnn
 50       continue
          bmnu = sqrt(dfloat((nu+nu+2)*(nu+nu+1))
     &               /dfloat((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          alph(num-nu,npp)= (bmnu*alph(nup-nu-1,npm))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0d0/3.0d0)
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          alph(1,npp)= (bmnu*alph(2,npm))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(nub+mu,nmp)
           al3=alph(nup+mu,nmp)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           alph(num+mu,npp)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=alph(nup-nu,nmp)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(num-nu,npp)= (amnu*al3)/apnm     
          al3=alph(nup+nu,nmp)
          alph(num+nu,npp)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(3,nmp)
          amnu = sqrt(1.0d0/3.0d0)
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(1,npp)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(num+mu,nmm)
           al2=alph(nub+mu,nmp)
           al3=alph(nup+mu,nmp)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           amnm = sqrt(dfloat((n+m)*(n-m))
     &                 /dfloat((2*n+1)*(2*n-1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           alph(num+mu,npp)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=alph(num-nu,nmm)
          al3=alph(nup-nu,nmp)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(num-nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
          al1=alph(num+nu,nmm)
          al3=alph(nup+nu,nmp)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(num+nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(1,nmm)
          al3=alph(3,nmp)
          amnu = sqrt(1.0d0/3.0d0)
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(1,npp)=(-amnm*al1 + amnu * al3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            alph(nup,npp-m) = msign*(alph(nup,npp+m))
     &                             *exp(2.0d0*cI*(-m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(nup+mu,npp-m) = msign*musign*alph(nup-mu,npp+m)
     &                                *exp(2.0d0*ci*phi0*(-mu-m))
              alph(nup-mu,npp-m) = msign*musign*alph(nup+mu,npp+m)
     &                                *exp(2.0d0*ci*phi0*(mu-m))
 98         continue
 96       continue
 95     continue
 90   continue
  
      factsn = k0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*k0/dfloat(2*jnp-1)
        endif
c>>>        factdn = 1.0d0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0d0
          do 110 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*k0/dfloat(2*jnup+1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              alph(nup,np) = ci*alph(nup,np)*factsn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue
             
      else
c
      jnm = (nmax + 1)**2
      jnum = (numa + 1)**2
      do 300 jn = 1,jnm
        do 310 jnu = 1,jnum
          alph(jnu,jn) = (0.0d0,0.0d0)
 310    continue
        alph(jn,jn) = (1.0d0,0.0d0)
 300  continue
c
      endif
c
      return
      end
c**********************************************************************
c****module dsbeta
      subroutine dsbeta(zz,theta,phi,k0,nmax,numa,beta,ndim
     &                                      ,nudim,jtune,jcon) 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 21)
      complex*16 beta(ndim,0:nudim)
      complex*16 al1,al2,al3
      complex*16 ci
      real*8 z,zz,theta,phi,k0,costhe,theta0,phi0
      real*8 pwork(0:nudd),pi,sqrtpi
      real*8 sbesj(0:nudd)
      complex*16 sphh(0:nudd,-nudd:nudd)
      real*8 factsn,factsnu
      real*8 factdn,factdnu
      real*8 bpnu,bmnu,bpnn
      real*8 amnu,apnu,apnm,amnm

      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
      sqrtpi = sqrt(4.0d0*pi)
      
      z = zz*k0

      if(z .gt. 1.0d-18) then
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of betaa (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesj(z,nmx,sbesj,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        beta(1,nup)=msign*sphh(nu,0)*sbesj(nu)*sqrtpi*nsign
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          beta(1,lmp)=msign*sphh(nu,-mu)*sbesj(nu)*sqrtpi
     &                *exp(ci*2.0d0*mu*phi0)*nsign                      
          beta(1,lmm)=msign*sphh(nu,mu)*sbesj(nu)*sqrtpi
     &                *exp(-ci*2.0d0*mu*phi0)*nsign                   
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(dfloat((nu+mu)*(nu+mu-1))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(dfloat((nu-mu+2)*(nu-mu+1))
     &                 /dfloat((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
            beta(npp,num+mu)= (bpnu*beta(npm,nub+mu-1)+
     &                         bmnu*beta(npm,nup+mu-1))/bpnn
 50       continue
          bmnu = sqrt(dfloat((nu+nu+2)*(nu+nu+1))
     &               /dfloat((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          beta(npp,num-nu)= (bmnu*beta(npm,nup-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0d0/3.0d0)
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          beta(npp,1)= (bmnu*beta(npm,2))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      jmp = m  
      do 60 n=jmp,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=beta(nmp,nub+mu)
           al3=beta(nmp,nup+mu)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           beta(npp,num+mu)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=beta(nmp,nup-nu)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(npp,num-nu)= (amnu*al3)/apnm     
          al3=beta(nmp,nup+nu)
          beta(npp,num+nu)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=beta(nmp,3)
          amnu = sqrt(1.0d0/3.0d0)
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(npp,1)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=beta(nmm,num+mu)
           al2=beta(nmp,nub+mu)
           al3=beta(nmp,nup+mu)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           amnm = sqrt(dfloat((n+m)*(n-m))
     &                 /dfloat((2*n+1)*(2*n-1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           beta(npp,num+mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=beta(nmm,num-nu)
          al3=beta(nmp,nup-nu)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(npp,num-nu)=(-amnm*al1 + amnu * al3) / apnm     
          al1=beta(nmm,num+nu)
          al3=beta(nmp,nup+nu)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(npp,num+nu)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=beta(nmm,1)
          al3=beta(nmp,3)
          amnu = sqrt(1.d0/3.0d0)
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          beta(npp,1)=(-amnm*al1+amnu*al3)/apnm 
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            beta(npp-m,nup) = msign*(beta(npp+m,nup))
     &                             *exp(2.0d0*ci*(m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              beta(npp-m,nup+mu) = msign*musign*beta(npp+m,nup-mu)
     &                                *exp(2.0d0*ci*phi0*(mu+m))
              beta(npp-m,nup-mu) = msign*musign*beta(npp+m,nup+mu)
     &                                *exp(2.0d0*ci*phi0*(m-mu))
 98         continue
 96       continue
 95     continue
 90   continue
  
      if(jcon .eq. 1) then

      factdn = 1.0d0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*k0/dfloat(2*jnp+1)
        endif
c>>>>        factdn = 1.0d0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0d0
          do 110 jnup = 0,numa
c>>>>            factdnu = filld(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*dfloat(2*jnup+1)/k0
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(np,nup) = beta(np,nup)*factdn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue
  
      else if(jcon .eq. 2) then

      factsn = 1.0d0/k0
      do 200 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*dfloat(2*jnp-1)/k0
        endif
c>>>        factsn = 1.0d0/fills(jnp,k0)
        do 205 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = k0
          do 210 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*k0/dfloat(2*jnup-1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 215 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(np,nup) = beta(np,nup)*factsn*factsnu
 215        continue
 210      continue
 205    continue
 200  continue
 
      else

        pause 'jcon must be 1 or 2 in sbeta subroutine'
 
      endif
  
      else
c
      jnm = (nmax + 1)**2
      jnum = (numa + 1)**2
      do 300 jn = 1,jnm
        do 310 jnu = 1,jnum
          beta(jn,jnu) = (0.0d0,0.0d0)
 310    continue
        beta(jn,jn) = (1.0d0,0.0d0)
 300  continue
c
      endif
c

      return
      end
c**********************************************************************
c****module dsalpha
      subroutine dsalpha(zz,theta,phi,k0,nmax,numa,alph,ndim
     &                                            ,nudim,jtune) 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 21)
      complex*16 alph(ndim,0:nudim)
      complex*16 al1,al2,al3
      complex*16 ci
      real*8 z,zz,theta,phi,k0,costhe,theta0,phi0
      real*8 pwork(0:nudd),sbesj(0:nudd),pi,sqrtpi
      complex*16 sbesh(0:nudd)
      complex*16 sphh(0:nudd,-nudd:nudd)
      real*8 factdn,factsnu
      real*8 bpnu,bmnu,bpnn
      real*8 amnu,apnu,apnm,amnm

      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
      sqrtpi = sqrt(4.0d0*pi)
c
      z = zz*k0
c
      if(z .gt. 1.0d-18) then
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesjh(z,nmx,sbesj,sbesh,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        alph(1,nup)=msign*sphh(nu,0)*sbesh(nu)*sqrtpi*nsign
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          alph(1,lmp)=msign*sphh(nu,-mu)*sbesh(nu)*sqrtpi
     &                *exp(ci*2.0d0*mu*phi0)*nsign                      
          alph(1,lmm)=msign*sphh(nu,mu)*sbesh(nu)*sqrtpi
     &                *exp(-ci*2.0d0*mu*phi0)*nsign                   
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(dfloat((nu+mu)*(nu+mu-1))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(dfloat((nu-mu+2)*(nu-mu+1))
     &                 /dfloat((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
            alph(npp,num+mu)= (bpnu*alph(npm,nub+mu-1)+
     &                         bmnu*alph(npm,nup+mu-1))/bpnn
 50       continue
          bmnu = sqrt(dfloat((nu+nu+2)*(nu+nu+1))
     &               /dfloat((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          alph(npp,num-nu)= (bmnu*alph(npm,nup-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0d0/3.0d0)
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          alph(npp,1)= (bmnu*alph(npm,2))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(nmp,nub+mu)
           al3=alph(nmp,nup+mu)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           alph(npp,num+mu)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=alph(nmp,nup-nu)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,num-nu)= (amnu*al3)/apnm     
          al3=alph(nmp,nup+nu)
          alph(npp,num+nu)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(nmp,3)
          amnu = sqrt(1.0d0/3.0d0)
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,1)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(nmm,num+mu)
           al2=alph(nmp,nub+mu)
           al3=alph(nmp,nup+mu)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           amnm = sqrt(dfloat((n+m)*(n-m))
     &                 /dfloat((2*n+1)*(2*n-1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           alph(npp,num+mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=alph(nmm,num-nu)
          al3=alph(nmp,nup-nu)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,num-nu)=(-amnm*al1 + amnu * al3) / apnm     
          al1=alph(nmm,num+nu)
          al3=alph(nmp,nup+nu)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,num+nu)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(nmm,1)
          al3=alph(nmp,3)
          amnu = sqrt(1.0d0/3.0d0)
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,1)=(-amnm*al1 + amnu * al3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            alph(npp-m,nup) = msign*(alph(npp+m,nup))
     &                             *exp(2.0d0*cI*(m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(npp-m,nup+mu) = msign*musign*alph(npp+m,nup-mu)
     &                                *exp(2.0d0*ci*phi0*(mu+m))
              alph(npp-m,nup-mu) = msign*musign*alph(npp+m,nup+mu)
     &                                *exp(2.0d0*ci*phi0*(m-mu))
 98         continue
 96       continue
 95     continue
 90   continue
  
      factdn = 1.0d0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*k0/dfloat(2*jnp+1)
        endif
c>>>        factdn = 1.0d0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = k0
          do 110 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*k0/dfloat(2*jnup-1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              alph(np,nup) = ci*alph(np,nup)*factdn*factsnu
 115        continue
 110      continue
 105    continue
 100  continue
             
      else
c
      jnm = (nmax + 1)**2
      jnum = (numa + 1)**2
      do 200 jn = 1,jnm
        do 210 jnu = 1,jnum
          alph(jn,jnu) = (0.0d0,0.0d0)
 210    continue
        alph(jn,jn) = (1.0d0,0.0d0)
 200  continue
c
      endif
c
      return
      end
c************************************************************************
c****module spharm
      SUBROUTINE SPHHARM(X,PHI,L,M,SPHH,LD1,LD2,PWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PWORK(0:LD1)
      COMPLEX*16 SPHH(0:LD1,-LD2:LD2), CI
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
CC
      CI = (0.0D0,1.0D0)
      PI = ACOS(-1.0D0)
      DO 10 LM = 0,M
        CALL DLEGENDR(X,L,LM,PWORK,LD1) 
        DO 20 LP = LM,L
          SPHH(LP,LM) = DCMPLX(PWORK(LP),0.0D0)
 20     CONTINUE
 10   CONTINUE
C
      PIINV = 0.5D0/SQRT(PI)
C
      DO 30 LP = 0,L
        SPHH(LP,0) = PIINV*SQRT(DFLOAT(2*LP+1))*SPHH(LP,0)
 30   CONTINUE
C
      IF(L .LT. 150) THEN
        PN = 1.
        DO 40 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*DFLOAT(LP)+1.0D0)
          PN = PN*DFLOAT(LP)
          PADD = SQRT(PN)
          PMIN = PN
          DO 50 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD*SQRT(DFLOAT(LP+MP))
            PMIN = PMIN/DFLOAT(LP-MP+1)   
            FAC = SIGN*FACL*SQRT(PMIN)/PADD
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 50       CONTINUE
 40     CONTINUE
      ELSE
        PN = 0.0
        DO 60 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*DFLOAT(LP)+1.0D0)
          PN = PN + LOG(DFLOAT(LP))
          PADD = PN
          PMIN = PN
          DO 70 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD + LOG(DFLOAT(LP+MP))
            PMIN = PMIN - LOG(DFLOAT(LP-MP+1))   
            FAC = SIGN*FACL*EXP(0.5D0*(PMIN-PADD))
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 70       CONTINUE
 60     CONTINUE
      ENDIF  
C
      RETURN
      END
c**********************************************************************
c****dlegendr
      SUBROUTINE DLEGENDR(X,L,M,PLGNDR,LD1)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PLGNDR(0:LD1)
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in DLEGENDR'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
      PMM=1.0D0
      IF(M.GT.0) THEN
        SOMX2=SQRT((1.-X)*(1.+X))
        FACT=1.
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.0D0
11      CONTINUE
      ENDIF
      IF(L.EQ.M) THEN
        PLGNDR(L)=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF(L.EQ.M+1) THEN
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
        ELSE
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PLGNDR(LL)=PLL
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

c****************************************************************
c****module dsbesjh
	subroutine dsbesjh(x,n,sj,csh,nd)
        implicit complex*16 (c)
        implicit real*8 (a-b,d-h,o-z)
        dimension sj(0:nd),csh(0:nd)

        ci = (0.0d0,1.0d0)

        call dsbesy(x,n,sj,nd)
c
        do 5 j = 0,n
          csh(j) = ci*sj(j)
  5     continue
c
        call dsbesj(x,n,sj,nd)
        
        do 10 j = 0,n
          csh(j) = sj(j) + csh(j)
 10     continue
c
        return
        end
c****************************************************************
c****module cdsbesj
        subroutine dsbesj(cx,n,csj,nd)
c>>>        implicit complex*16 (c)
c>>>        implicit real*8 (a-b,d-h,o-z)
        implicit real*8 (a-h,o-z)
        dimension csj(0:nd)
        integer flag
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')

c --- Explicit calculation of low order Bessel functions.
        cxinv = 1.0d0/cx
        if (n.eq.0) then
            csj(0)=sin(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            return
        end if
        if (n.eq.2) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            csj(2)=(3.0d0/cx/cx-1.0d0)*csj(0) - 3.0d0*cos(cx)/cx/cx
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        csj(0)=sin(cx)*cxinv
        csj(1)=(csj(0)-cos(cx))*cxinv
        csjb=csj(0)
        csjm=csj(1)
        if (abs(cx).gt.dfloat(n)) then
            do 11 j=2,n
                csjp=(2.0d0*dfloat(j-1)+1.0d0)*cxinv*csjm-csjb
                csjb=csjm
                csjm=csjp
                csj(j)=csjm
  11        continue
        else
            csj1=csj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            csjm=0.0d0
            csjb=1.0d0
            i=0
            do 12 j=m,1,-1
                csjp=(2.0d0*dfloat(j+1)+1.d0)*cxinv*csjb-csjm
                csjm=csjb
                csjb=csjp
                if(j.le.n) csj(j)=csjp
c>>>>>                write(12,*) j, sjp
                if (abs(csjp).gt.bigno) then
                    csjm=csjm*1.d-10
                    csjb=csjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      csj(lp)=csj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (abs(csj(1)).eq.0.0e0) print *,'got 0 in SJ'
            cdp=csj1/csj(1)
            do 30 jp = 1,n
              csj(jp) = csj(jp)*cdp
  30        continue
        end if
  13    return
        end

c***************************************************************
c****module dsbesy
	subroutine dsbesy(cx,n,csy,nd)
c>>>        implicit complex*16 (c)
c>>>        implicit real*8 (a-b,d-h,o-z)
        implicit real*8 (a-h,o-z)
        dimension csy(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
c
        cxinv = 1.0d0/cx
c        
c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            csy(0)=-cos(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csy(0)=-cos(cx)*cxinv
            csy(1)=csy(0)*cxinv-sin(cx)*cxinv
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        csy(0)=-cos(cx)*cxinv
        csy(1)=csy(0)*cxinv-sin(cx)*cxinv
        csyb=csy(0)
        csym=csy(1)
        do 11 j=2,n
          csyp=(2.0e0*float(j-1)+1.)*cxinv*csym-csyb
          csyb=csym
          csym=csyp
          csy(j)=csym
  11    continue
        return
        end
c------------------------------------------------------------------------
c****modified by W.C. Chew for complex matrices January 15, 1991.
c
      SUBROUTINE CGAUSSJ(A,N,NP,B,M,MP)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NMAX=850)
      complex*16 a(np,np),b(np,np),dum,pivinv 
      DIMENSION IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                PAUSE 'Singular matrix, IPIV(K).GT.1'
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (abs(A(ICOL,ICOL)).EQ.0.) PAUSE 'Singular matrix, 
     &  ABS(A)=0.'
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=(1.,0.)
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=(0.,0.)
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END

