c****module mainw2
      PROGRAM MAINW2 
                   
c  ***        nst is total # of spheres in grouping             ***
c  ***           mdm & pdm are matrix dimensions                ***
c  ***                iwa must be >3xmdm                        ***

c --- mdm and pdm must be perfect squares (not necessarily the same)
      integer mdm,pdm,iwa,nst,i,j,k,n,ntm,ntp,nq
      parameter ( nst=18, iwa=100 )
      parameter ( mdm=4,  pdm=16)
      parameter ( nptt = 36 )
 
      complex*16 ab1(mdm,0:nptt),ab2(0:nptt,mdm)
      complex*16 t1(mdm,mdm),taun(pdm,pdm),Tatau(mdm,pdm),taua(pdm,mdm)
      complex*16 tb(mdm,pdm),btb(pdm,pdm),dple,one,ai,tau
      complex*16 eps(nst),epb,einc(pdm),winv(mdm,mdm),a3,b3,c3
      complex*16 an0(mdm,pdm),a0n(pdm,mdm),w2(mdm,pdm),epsef1
      complex*16 bn0(mdm,pdm),b0n(pdm,mdm),ID(mdm,mdm),epsef2
      complex*16 temp1(pdm,mdm),temp2(mdm,pdm),taun1(pdm,pdm),w(mdm,mdm)
      complex*16 wtemp(mdm,mdm),w2temp(mdm,pdm),temp3(mdm,mdm)
      real*8 r(nst),pho(nst),phi(nst),theta(nst),filld,fv
      real*8 wa(iwa),pi,k0,ee,rg,fq,fqeo,pho1,theta1,phi1,ka
      real*8 epsr1,sigma1,epsr2,sigma2
c>>>      complex*16 alphn0(mdm,pdm) 
c>>>      complex*16 betan0(mdm,pdm) 

      open(8,file='phidat')
      open(9,file='thedat')
      open(10,file='phodat')
      open(11,file='raddat')
      open(12,file='epsdat_')
      open(13,file='linout')
      open(14,file='dples')

      ntm=int(sqrt(dfloat(mdm)))-1
      ntp=int(sqrt(dfloat(pdm)))-1
      pi=4.0d0*atan2(1.0d0,1.0d0)
      ee=sqrt(.75d0/pi)
      ai  =(0.0,1.0)
      one =(1.0,0.0)
  
c --- Read in sphere position, size, and epsilon data.

      do 1 i=1,nst
        read(8,*)  PHI(i)
        read(9,*)  THETA(i)
        read(10,*) PHO(i)
        read(11,*) R(i)
        read(12,3) EPS(i)
  1   continue
      read(11,*) RG
      read(12,3) EPB
      read(12,4) FQ
  3   Format(f11.4,d9.4)
  4   Format(d9.4)

      k0=2.0e0*pi*fq/3.0d8
      fqeo=fq*8.8419d-12
      fv=(r(1)/rg)**3

      write(*,*) 'grp rad.=',rg,'   epb=',conjg(epb),'  M =',mdm
      write(13,*)'grp rad.=',rg,'   epb=',conjg(epb),'  M =',mdm
      write(*,*) 'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',pdm
      write(13,*)'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',pdm
      write(*,*) 'spread  =',pho(3)-pho(2)
      write(13,*)'spread  =',pho(3)-pho(2)
      write(*,*) ' '
      write(13,*)' '

      write(*,*)  'Fractional Volume             Dipole Term'
      write(*,*)  'new eff. permittivity         new eff. conductivity'
      write(13,*) 'Fractional Volume             Dipole Term'
      write(13,*) 'new eff. permittivity         new eff. conductivity'
      write(13,*)' '

      n = 0
c
      call t1sub(t1,mdm,ntm,fq,epb,eps(n+1),r(n+1),k0)
     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex*16 identity matrix [MxM].

      do 122 i=1,pdm
        do 121 j=1,pdm
          taun(i,j)=(0.0,0.0)
 121    continue
 122  continue

      do 124 i=1,mdm
        do 123 j=1,mdm
          taun(i,j)=t1(i,j)
          ID(i,j)=cmplx(0.0,0.0)
 123    continue
          ID(i,i)=cmplx(1.0,0.0)
 124  continue

c --- Calculate normalized einc [Px1]
      k=1
      do 31 i=0,ntp
        nq=2*i+1
        do 32 j=1,nq
          if(j.eq.(i+1)) einc(k)=(ai**i)*sqrt(4.0e0*pi*dfloat(i+i+1))/
     &                             FILLD(i,k0)
          if(j.ne.(i+1)) einc(k)=(0.0,0.0)
          k=k+1
 32     continue
 31   continue

      do 1000 n=1,nst-1

c --- Calculate normalized 1 sphere scattering matrix for sphere n+1
c     t1static    = (1/S) * t1dynamic    * D

      lp = n
      call t1sub(t1,mdm,ntm,fq,epb,eps(lp+1),r(lp+1),k0)
     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex*16 identity matrix [MxM].

c --- Calculate the normalization matrices (diagonal => column vectors)
c     alphastatic = (1/D) * alphadynamic * S
c     betastaticn0= (1/D) * betadynamic  * D
c     betastatic0n= (1/S) * betadynamic  * S
 
c --- an0 is alpha(n+1,0)    [MxP]

      phi1  =phi(n+1)
      theta1=theta(n+1)
      pho1  =pho(n+1)
c>>>>      call COMAT(an0,mdm,pdm,phi1,theta1,pho1,k0,1,1)
      call dsalpha(pho1,theta1,phi1,k0,ntm,ntp,ab1,mdm,nptt,1)
      call movemtrx(ab1,mdm,nptt,an0,mdm,pdm,mdm,pdm)

c>>      do 500 np = 1,pdm
c>>        do 510 mp = 1,mdm
c>>          alphn0(mp,np) = an0(mp,np)
c>> 510    continue
c>> 500  continue

c --- a0n is alpha(0,n+1)    [PxM]

c>>      phi1  =pi+phi(n+1)
c>>      theta1=pi-theta(n+1)
c>>      pho1  =pho(n+1)
c>>>>      call COMAT(a0n,pdm,mdm,phi1,theta1,pho1,k0,1,1)
      call dsalphap(pho1,theta1,phi1,k0,ntp,ntm,ab2,nptt,mdm,-1)
      call movemtrxp(ab2,nptt,mdm,a0n,pdm,mdm,pdm,mdm)

c --- bn0 is beta(n+1,0)   [MxP]

c>>      phi1  =pi+phi(n+1)
c>>      theta1=theta(n+1)
c>>      pho1  =pho(n+1)
c>>>>      call COMAT(bn0,mdm,pdm,phi1,theta1,pho1,k0,2,1)
      call dsbeta(pho1,theta1,phi1,k0,ntm,ntp,ab1,mdm,nptt,1,1)
      call movemtrx(ab1,mdm,nptt,bn0,mdm,pdm,mdm,pdm)

c>>      do 520 np = 1,pdm
c>>        do 525 mp = 1,mdm
c>>          betan0(mp,np) = bn0(mp,np)
c>> 525    continue
c>> 520  continue

c
c --- b0n is beta(0,n+1)   [PxM]

c>>      phi1  =pi+phi(n+1)
c>>      theta1=pi-theta(n+1)
c>>      pho1  =pho(n+1)
c>>>>      call COMAT(b0n,pdm,mdm,phi1,theta1,pho1,k0,2,2)
      call dsbetap(pho1,theta1,phi1,k0,ntp,ntm,ab2,nptt,mdm,-1,2)
      call movemtrxp(ab2,nptt,mdm,b0n,pdm,mdm,pdm,mdm)

c --- Calculate T(n+1,1)*alpha(n+1,0)*tau(n)   [MxP]

      call mtrxmult(t1,mdm,mdm,an0,mdm,pdm,temp2)
      call mtrxmult(temp2,mdm,pdm,taun,pdm,pdm,Tatau)

c --- Calculate I - T(n+1,1)*alpha(n+1,0)*tau(n)*alpha(0,n+1) [MxM]

      call mtrxmult(Tatau,mdm,pdm,a0n,pdm,mdm,wtemp)
      call mtrxadd(ID,mdm,mdm,wtemp,mdm,mdm,w,-1)

c --- Invert last matrix calculated   [MxM]

      call cminvl(w,winv,wa,mdm,mdm,mdm,iwa)

c --- Calculate beta(n+1,0)+alpha(n+1,0)*tau(n)   [MxP]

c>>      call mtrxmult(an0,mdm,pdm,taun,pdm,pdm,w2temp)
      call mtrxmult(an0,mdm,pdm,taun,pdm,pdm,w2temp)
      call mtrxadd(w2temp,mdm,pdm,bn0,mdm,pdm,w2,1)

c --- Calculate T(n+1,n+1)*beta(n+1,0)   [MxP]

      call mtrxmult(winv,mdm,mdm,t1,mdm,mdm,temp3)
      call mtrxmult(temp3,mdm,mdm,w2,mdm,pdm,tb)
        
c --- Calculate tau(n)*alpha(0,n+1)   [PxM]

      call mtrxmult(taun,pdm,pdm,a0n,pdm,mdm,taua)

c --- Calculate beta(0,n+1)*T(n+1,n+1)*beta(n+1,0)  +       [PxP] 
c               tau(n)*alpha(0,n+1)*T(n+1,n+1)*beta(n+1,0)  [PxP]

      call mtrxadd(b0n,pdm,mdm,taua,pdm,mdm,temp1)
      call mtrxmult(temp1,pdm,mdm,tb,mdm,pdm,btb)
      
c --- Calculate tau(n+1)   [PxP]

      call mtrxadd(taun,pdm,pdm,btb,pdm,pdm,taun1)
c
c --- Calculate the dipole term:  row 3 of tau(n+1) * einc

      dple=(0.0,0.0)
      do 200 j=1,pdm
        dple=dple+taun1(3,j)*einc(j)
  200 continue

c --- Calculate effective permittivity and conductivity

      dple  = dple*ee/ai/k0/rg**3
c----------------------------------------------------------------------
      ka = k0 * rg
      tau= dple*(ka**3)/3.0/ai
      A3 =  15.0*(ka**3) - 18.0*(ka**5) -  45.0*ai*tau -  5.0*ai*(ka**6)
      B3 =  15.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau + 10.0*ai*(ka**6)
      C3 = -30.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau -  5.0*ai*(ka**6)
c----------------------------------------------------------------------
      epsef1= ((1.0+2.0*Dple)/(1.0-Dple))*epb
      epsr1 = real(epsef1)
      sigma1= -dimag(epsef1)*fqeo*2.0*pi
      epsef2= epb * ( -B3 + sqrt(B3*B3-4.0*A3*C3) ) / (2.0*A3)
      epsr2 = real(epsef2)
      sigma2= -dimag(epsef2)*fqeo*2.0*pi
      fv=fv+(r(n+1)/rg)**3

      write(14,*) dple
      write(*,*)  'sphere #',n+1,'      dple =',dple
      write(*,*)  '                   ',epsr2,sigma2
      write(13,*) 'sphere #',n+1,'      dple =',dple
      write(13,*) '                   ',epsr2,sigma2

c     write(*,*) 'eff. permit. =',epsr,'    conductivity =',sigma
c     write(*,*) 'dipole term  =',dple
c     write(13,*)'eff. permit. =',epsr,'    conductivity =',sigma
c     write(13,*)'dipole term  =',dple

      if (n.eq.nst-1) go to 1000

c --- Set tau(n) = tau(n+1) before next pass through loop

      do 300 i=1,mdm
        do 301 j=1,pdm
          taun(i,j)=taun1(i,j)
 301    continue
 300  continue

 1000 continue
      stop
      end

      SUBROUTINE LOWFAPPX(l,f,a,epb,eps,apprx)
      complex*16 apprx,epb,eps,epsr,ai
      real*8 k0,f,a,x1,x2,k,ka,k1,krel

      ai   = dcmplx(0.0d0,1.0d0)
      epsr = eps/epb
      k0   = 8.0d0*atan2(1.0d0,1.0d0)*f/3.0d8
      k    = k0*sqrt(dreal(epb))
      k1   = k0*sqrt(dreal(eps))
      ka   = k*a
      krel = k1/k

      x2 = 1.0d0
      do 1 j = 1,l+l-1,2
          x2 = x2*dfloat(j)
  1   continue
      x1 = x2*dfloat(l+l+1)

c     top1 = epsr*dfloat(l)* (k1**(l+1))* (k**(l-1))* (a**(l+l-1))/x1/x1
c     top2 =      dfloat(l)* (k1**l)*     (k**l)*     (a**(l+l-1))/x1/x1
c     bot1 = ai * dfloat(l+1) * (krel**l) / dfloat(2*l+1) / k / (a**2)
c     bot2 = -ai*epsr*dfloat(l)* (krel**(l+1))/ k/ dfloat(2*l+1)/ (a**2)
c     apprx=-(top1-top2)/(bot1-bot2)

c --- apprx given below is same as -(top1-top2)/(bot1-bot2)
c     this normalizes to a slightly different number than the static #
c     apprx=-ai*dfloat(l) * (ka**(2*l+1)) * (1.0d0-epsr*krel) / x1 / x2
c    &      / ( 1.0d0 + dfloat(l) * (1.0d0 + epsr * krel) )

c --- apprx given below normalizes to exactly the static approximation
      apprx=-ai * dfloat(l) * (ka**(2*l+1)) * (1.0d0-epsr) / x1 / x2
     &      / ( 1.0d0 + dfloat(l) * (1.0d0 + epsr ) )

      return
      end
      
      Subroutine Mtrxmult(a,ar,ac,b,br,bc,c)
      integer ar,ac,br,bc
      complex*16 a,b,c,temp
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ac.ne.br) then
        print *,'*****  Matrix multiplication not defined.  *****'
      end if
      do 1 i=1,ar
        do 2 j=1,bc
          temp=cmplx(0.0d0,0.0d0)
          do 3 k=1,ac
            temp=temp+a(i,k)*b(k,j)
  3       continue
          c(i,j)=temp
  2     continue
  1   continue
      return
      end
      
      Subroutine Mtrxadd(a,ar,ac,b,br,bc,c,isign)
      integer ar,ac,br,bc,isign
      complex*16 a,b,c
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ar.ne.br.OR.ac.ne.bc) then
        print *,'*****  Matrix addition not defined.  *****'
      end if
      do 1 i=1,ar
        do 2 j=1,bc
            c(i,j)=a(i,j)+isign*b(i,j)
  2     continue
  1   continue
      return
      end

      subroutine prntmtrx(a,irow,icol)
      complex*16 a
      dimension a(irow,icol)
c     do 1 i=1,irow
c       do 2 j=1,icol
      do 1 i=1,16
        do 2 j=1,16
          write(14,*) i,j,a(i,j)
  2     continue
  1   continue
      return
      end

      REAL*8 FUNCTION FILLD(i,k0)
      real*8 k0,fac
      integer i
      fac=1.0d0
      do 1 j=1,i+i+1,2
          fac=fac*dfloat(j)
 1    continue
      filld=fac/(k0**i)
      return
      end


      COMPLEX*16 FUNCTION FILLS(i,k0)
      real*8 k0,fac
      integer i
      fac=1.0d0
      do 1 j=1,i+i-1,2
          fac=fac*dfloat(j)
 1    continue
      fills=cmplx(0.0d0,(k0**(i+1))/fac)
      return
      end
      SUBROUTINE ONESPHT(i,f,r,epb,eps,t1)
      complex*16 epb,eps,t1,Hank,Hankd,SH1,denom,num,epsr
      real*8 k0,k,k1,kr,k1r,SJ,f,r,krel,sjdkr,sjdk1r

      k0   = 8.0d0*atan2(1.0d0,1.0d0)*f/3.0d8
      k    = k0*sqrt(dreal(epb))
      k1   = k0*sqrt(dreal(eps))
      kr   = k*r
      k1r  = k1*r
      krel = k1/k
      epsr = eps/epb

      Hank   = SH1(i,kr)
      sjdkr  = (i/r) * SJ(i,kr)  - k  * SJ(i+1,kr)
      sjdk1r = (i/r) * SJ(i,k1r) - k1 * SJ(i+1,k1r)
      Hankd  = (i/r) * Hank      - k  * SH1(i+1,kr)

      num   = epsr * krel * sjdk1r * SJ(i,kr) - SJ(i,k1r) * sjdkr
      denom = SJ(i,k1r) * Hankd - epsr * krel * sjdk1r * Hank
      t1    = - num / denom
      return
      end
c     Subroutine t1sub(t1,mdm,pdm,ntm,fq,epb,eps,r,k0)
      Subroutine t1sub(t1,mdm,ntm,fq,epb,eps,r,k0)
      complex*16 t1,epb,eps,temp,FILLS
      real*8 fq,r,k0,FILLD,div
      parameter(div=1.0d6)
c     integer mdm,ntm,i,k,kk,nq,pdm
      integer mdm,ntm,i,k,kk,nq
c     dimension t1(mdm,pdm)
      dimension t1(mdm,mdm)

      do 1 i=1,mdm
c       do 2 j=1,pdm
        do 2 j=1,mdm
          t1(i,j)=cmplx(0.0d0,0.0d0)
 2      continue
 1    continue

      k=1
      do 10 i=0,ntm
c       if (fq.le.div) call LOWFAPPX(i,fq,r,epb,eps,temp)
c       if (fq.gt.div) call ONESPHT(i,fq,r,epb,eps,temp)
        call LOWFAPPX(i,fq,r,epb,eps,temp)
c       call ONESPHT(i,fq,r,epb,eps,temp)
        nq=(2*i)+1
        do 20 kk=1,nq
          t1(k,k)=FILLD(i,k0)*temp/FILLS(i,k0)
c         t1(k,k)=temp
          k=k+1
 20     continue
 10   continue
      return
      end
c cminvl in matman1 in hftlib may be used instead if one has access to
c IMSLIB.
c
c transfer 'c' to the next line to get determinant on the matrix.
c     subroutine cminvl(ca,cb,cd,wa,n,ia)
      subroutine cminvl(ca,cb,wa,n,ia,mp,iwork)
      implicit complex*16 (c)
      real*8 wa
      integer mp,iwork
      dimension ca(mp,mp),cb(mp,mp),cdet(2),wa(iwork)
c
c     cminvl is a driver program that finds the inverse of a matrix
c     by calling cgefa and cgedi from linpack.
c
c     on entry
c
c         ca     a complex matrix preserved on output.
c
c         cb     a complex matrix containing the inverse
c                on output.
c
c         cd     contains the determinant of the matrix ca on
c                output.  If the determinant is not needed, the
c                lower line can be used for the subroutine statement.
c
c         wa     a work real vector of length at least 3*n.
c
c         n      the order of the matrices  ca  and  cb.
c
c         ia     the actual row dimension of the array declared for ca and cb.
c
c     written by W.C. Chew on May 3, 1987.
c
c     transfer from ca to cb.
c
      do 10 i=1,n
      do 10 j=1,n
      cb(i,j)=ca(i,j)
   10 continue
c
c     calls cgefa to condition the matrix.
c
      call cgefa(cb,ia,n,wa(1),info)
c
c     if info is greater than zero, the matrix is singular.
c
      if(info.gt.0) goto 15
c
c     calls cgedi to find inverse and determinant.
c
      call cgedi(cb,ia,n,wa(1),cdet,wa(n+1),11)
c     cd=cdet(1)*10.0**cdet(2)
      return
   15 continue
c
c     write to terminal on Harris.  Need to be changed on other computers.
c
c     write(*,*) ' ** the matrix is singular in cminvl ** '
      return
      end
      subroutine caxpy(n,ca,cx,incx,cy,incy)
c
c     constant times a vector plus a vector.
c     jack dongarra, linpack, 3/11/78.
c
      complex*16 cx(1),cy(1),ca
      integer i,incx,incy,ix,iy,n
c
      if(n.le.0)return
c     if (cdabs(dreal(ca)) + cdabs(dimag(ca)) .eq. 0.0d0 ) return
      if (ca.eq.(0.0d0,0.0d0)) return
      if(incx.eq.1.and.incy.eq.1)go to 20
 
c        code for unequal increments or equal increments not equal to 1
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        cy(iy) = cy(iy) + ca*cx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
 
c        code for both increments equal to 1
   20 do 30 i = 1,n
        cy(i) = cy(i) + ca*cx(i)
   30 continue
      return
      end
c-----------------------------------------------------------------

      subroutine cgedi(a,lda,n,ipvt,det,work,job)
      integer lda,n,ipvt(1),job
      complex*16 a(lda,1),det(2),work(1)
c
c     cgedi computes the determinant and inverse of a matrix
c     using the factors computed by cgeco or cgefa.
c
c     on entry
c
c        a       complex(lda, n)
c                the output from cgeco or cgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from cgeco or cgefa.
c
c        work    complex(n)
c                work vector.  contents destroyed.
c
c        job     integer
c                = 11   both determinant and inverse.
c                = 01   inverse only.
c                = 10   determinant only.
c
c     on return
c
c        a       inverse of original matrix if requested.
c                otherwise unchanged.
c
c        det     complex(2)
c                determinant of original matrix if requested.
c                otherwise not referenced.
c                determinant = det(1) * 10.0**det(2)
c                with  1.0 .le. cabs1(det(1)) .lt. 10.0
c                or  det(1) .eq. 0.0 .
c
c     error condition
c
c        a division by zero will occur if the input factor contains
c        a zero on the diagonal and the inverse is requested.
c        it will not occur if the subroutines are called correctly
c        and if cgeco has set rcond .gt. 0.0 or cgefa has set
c        info .eq. 0 .
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas caxpy,cscal,cswap
c     fortran abs,aimag,cmplx,mod,real
c
c     internal variables
c
      complex*16 t,zdum
      real*8 ten,cabs1
      integer i,j,k,kb,kp1,l,nm1
c
c     cabs1(zdum) = cdabs(dreal(zdum)) + cdabs(dimag(zdum))
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))
c
c     compute determinant
c
      if (job/10 .eq. 0) go to 70
         det(1) = (1.0d0,0.0d0)
         det(2) = (0.0d0,0.0d0)
         ten = 10.0d0
         do 50 i = 1, n
            if (ipvt(i) .ne. i) det(1) = -det(1)
            det(1) = a(i,i)*det(1)
c        ...exit
            if (cabs1(det(1)) .eq. 0.0d0) go to 60
   10       if (cabs1(det(1)) .ge. 1.0d0) go to 20
               det(1) = cmplx(ten,0.0d0)*det(1)
               det(2) = det(2) - (1.0d0,0.0d0)
            go to 10
   20       continue
   30       if (cabs1(det(1)) .lt. ten) go to 40
               det(1) = det(1)/cmplx(ten,0.0d0)
               det(2) = det(2) + (1.0d0,0.0d0)
            go to 30
   40       continue
   50    continue
   60    continue
   70 continue
c
c     compute inverse(u)
c
      if (mod(job,10) .eq. 0) go to 150
         do 100 k = 1, n
            a(k,k) = (1.0d0,0.0d0)/a(k,k)
            t = -a(k,k)
            call cscal(k-1,t,a(1,k),1)
            kp1 = k + 1
            if (n .lt. kp1) go to 90
            do 80 j = kp1, n
               t = a(k,j)
               a(k,j) = (0.0d0,0.0d0)
               call caxpy(k,t,a(1,k),1,a(1,j),1)
   80       continue
   90       continue
  100    continue
c
c        form inverse(u)*inverse(l)
c
         nm1 = n - 1
         if (nm1 .lt. 1) go to 140
         do 130 kb = 1, nm1
            k = n - kb
            kp1 = k + 1
            do 110 i = kp1, n
               work(i) = a(i,k)
               a(i,k) = (0.0d0,0.0d0)
  110       continue
            do 120 j = kp1, n
               t = work(j)
               call caxpy(n,t,a(1,j),1,a(1,k),1)
  120       continue
            l = ipvt(k)
            if (l .ne. k) call cswap(n,a(1,k),1,a(1,l),1)
  130    continue
  140    continue
  150 continue
      return
      end
c-----------------------------------------------------------------

      subroutine cgefa(a,lda,n,ipvt,info)
      integer lda,n,ipvt(1),info
      complex*16 a(lda,1)
c
c     cgefa factors a complex matrix by gaussian elimination.
c
c     cgefa is usually called by cgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for cgeco) = (1 + 9/n)*(time for cgefa) .
c
c     on entry
c
c        a       complex(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that cgesl or cgedi will divide by zero
c                     if called.  use  rcond  in cgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas caxpy,cscal,icamax
c     fortran abs,aimag,real
c
c     internal variables
c
      complex*16 t
      integer icamax,j,k,kp1,l,nm1
c
      complex*16 zdum
      real*8 cabs1
c     cabs1(zdum) = abs(real(zdum)) + abs(aimag(zdum))
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))

c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = icamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (cabs1(a(l,k)) .eq. 0.0d0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -(1.0d0,0.0d0)/a(k,k)
            call cscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call caxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (cabs1(a(n,n)) .eq. 0.0d0) info = n
      return
      end
c---------------------------------------------------------------------

      subroutine  cscal(n,ca,cx,incx)
 
c     scales a vector by a constant.
c     jack dongarra, linpack,  3/11/78.
      complex*16 ca,cx(1)
      integer i,incx,n,nincx
 
      if(n.le.0)return
      if(incx.eq.1)go to 20
 
c        code for increment not equal to 1
      nincx = n*incx
      do 10 i = 1,nincx,incx
        cx(i) = ca*cx(i)
   10 continue
      return
 
c        code for increment equal to 1
   20 do 30 i = 1,n
        cx(i) = ca*cx(i)
   30 continue
      return
      end
c---------------------------------------------------------------------

      subroutine  cswap (n,cx,incx,cy,incy)
c     interchanges two vectors.
c     jack dongarra, linpack, 3/11/78.
 
      complex*16 cx(1),cy(1),ctemp
      integer i,incx,incy,ix,iy,n
 
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
 
c       code for unequal increments or equal increments not equal to 1
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        ctemp = cx(ix)
        cx(ix) = cy(iy)
        cy(iy) = ctemp
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
 
c       code for both increments equal to 1
   20 do 30 i = 1,n
        ctemp = cx(i)
        cx(i) = cy(i)
        cy(i) = ctemp
   30 continue
      return
      end
c---------------------------------------------------------------------

      integer function icamax(n,cx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c
      complex*16 cx(1)
      real*8 smax
      integer i,incx,ix,n
      complex*16 zdum
      real*8 cabs1
c     cabs1(zdum) = abs(real(zdum)) + abs(aimag(zdum))
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))
c
      icamax = 0
      if( n .lt. 1 ) return
      icamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = cabs1(cx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(cabs1(cx(ix)).le.smax) go to 5
         icamax = i
         smax = cabs1(cx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = cabs1(cx(1))
      do 30 i = 2,n
         if(cabs1(cx(i)).le.smax) go to 30
         icamax = i
         smax = cabs1(cx(i))
   30 continue
      return
      end

      subroutine movemtrx(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex*16 ca(ja1,0:ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb2
        do 15 jm = 1,jb1
          cb(jm,jn) = (0.0d0,0.0d0)
 15     continue
 10   continue
      do 20 jn = 1,n2
        do 25 jm = 1,n1
          cb(jm,jn) = ca(jm,jn)
 25     continue
 20   continue
c
      return
      end

      subroutine movemtrxp(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex*16 ca(0:ja1,ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb2
        do 15 jm = 1,jb1
          cb(jm,jn) = (0.0d0,0.0d0)
 15     continue
 10   continue
      do 20 jn = 1,n2
        do 25 jm = 1,n1
          cb(jm,jn) = ca(jm,jn)
 25     continue
 20   continue
c
      return
      end

        Double precision FUNCTION SJ(n,x)
        implicit double precision (d)
        real*8 db(0:100),x
        integer flag
        parameter (iacc=40)

c --- Small argument approximation.
        if (x.lt.0.1d0) then
          dfac=1.0d0
          do 1 i=1,2*n+1,2
            dfac=dfac*dfloat(i)
  1       continue
          SJ=(x**n)/dfac
          return
        end if

c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            SJ=sin(x)/x
            return
        end if
        if (n.eq.1) then
            SJ=sin(x)/x/x-cos(x)/x
            return
        end if
        if (n.eq.2) then
            SJ=(3.0d0/x/x-1.0d0)*sin(x)/x - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        dbessj0=cos(x)/x
        dbessj1=sin(x)/x
        if (x.gt.dfloat(n)) then
            dbjm=dbessj0
            dbj=dbessj1
            do 11 j=0,n-1
                dbjp=(2.0d0*dfloat(j)+1.)/x*dbj-dbjm
                dbjm=dbj
                dbj=dbjp
  11        continue
            SJ=dbj
        else
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            SJ=0.0d0
            db(m+1)=0.0d0
            db(m)=1.0d0
            i=0
            do 12 j=m,1,-1
                db(j-1)=(2.0d0*dfloat(j)+1.)/x*db(j)-db(j+1)
                if (dabs(db(j-1)).gt.1.d10) then
                    db(j-1)=db(j-1)*1.d-10
                    db(j)=db(j)*1.d-10
                    i=i+1
                end if
                if (j.eq.n) flag=i
  12        continue
            dr0=sin(x)/x
            if (db(0).eq.0.0d0) print *,'got 0 in SJ'
            dp=dr0/db(0)
            SJ=db(n)*dp*(1.d10)**(flag-i)
        end if
  13    return
        end

C       GENERATES SPHERICAL HANKEL FUNCTIONS OF THE THIRD KIND
        COMPLEX*16 FUNCTION SH1(L,Z)
        complex*16 ai,wkh1(-1:100)
        real *8 z,SJ
        AI=CMPLX(0.0d0,1.0d0)
        DO 1 I=-1,L
          WKH1(I)=(0.0d0,0.0d0)
  1     continue
        WKH1(-1)=EXP(AI*Z)/Z
        WKH1(0)=-AI*EXP(AI*Z)/Z
        DO 2 I=0,L-1
          WKH1(I+1)=dfloat(2*I+1)/Z*WKH1(I)-WKH1(I-1)
  2     continue
        SH1=cmplx(SJ(l,z),dimag(WKH1(L)))
        RETURN
        END

