c****module mainw3
      PROGRAM MAINW3
                   
c  ***        nst is total # of spheres in grouping             ***
c  ***           mdm & pdm are matrix dimensions                ***
c  ***                iwa must be >3xmdm                        ***

c --- mdm and pdm must be perfect squares (not necessarily the same)
      integer mdm,pdm,iwa,nst,i,j,k,n,ntm,ntp,nq
      parameter ( nst=18, iwa=100 )
      parameter ( mdm=4,  pdm=36)
      parameter ( nptt = 86 )
 
      complex*16 ab1(mdm,0:nptt),ap1(0:nptt,mdm)
      complex*16 ab2(mdm,0:nptt),ap2(0:nptt,mdm)
      complex*16 t1(mdm,mdm),taun(pdm,pdm),Tatau(mdm,pdm),taua(pdm,mdm)
      complex*16 tb(mdm,pdm),btb(pdm,pdm),dple,one,ai,tau
      complex*16 eps(nst),epb,einc(pdm),winv(mdm,mdm),a3,b3,c3
      complex*16 an0(mdm,pdm),a0n(pdm,mdm),w2(mdm,pdm),epsef1
      complex*16 bn0(mdm,pdm),b0n(pdm,mdm),ID(mdm,mdm),epsef2
      complex*16 temp1(pdm,mdm),temp2(mdm,pdm),taun1(pdm,pdm),w(mdm,mdm)
      complex*16 wtemp(mdm,mdm),w2temp(mdm,pdm),temp3(mdm,mdm)
      real*8 r(nst),pho(nst),phi(nst),theta(nst),filld,fv
      real*8 wa(iwa),pi,k0,ee,rg,fq,fqeo,pho1,theta1,phi1,ka
      real*8 epsr1,sigma1,epsr2,sigma2
c>>>      complex*16 alphn0(mdm,pdm) 
c>>>      complex*16 betan0(mdm,pdm) 

      open(8,file='phidat')
      open(9,file='thedat')
      open(10,file='phodat')
      open(11,file='raddat')
      open(12,file='epsdat')
      open(13,file='linout')
      open(14,file='dples')

      ntm=int(sqrt(dfloat(mdm)))-1
      ntp=int(sqrt(dfloat(pdm)))-1
      pi=4.0d0*atan2(1.0d0,1.0d0)
      ee=sqrt(.750d0/pi)
      ai  =(0.0d0,1.0d0)
      one =(1.0d0,0.0d0)
  
c --- Read in sphere position, size, and epsilon data.

      do 1 i=1,nst
        read(8,*)  PHI(i)
        read(9,*)  THETA(i)
        read(10,*) PHO(i)
        read(11,*) R(i)
        read(12,3) EPS(i)
  1   continue
      read(11,*) RG
      read(12,3) EPB
      read(12,4) FQ
  3   Format(f11.4,e9.4)
  4   Format(e9.4)

      k0=2.0d0*pi*fq/3.0e+8
      fqeo=fq*8.8419e-12
      fv=(r(1)/rg)**3

      write(*,*) 'grp rad.=',rg,'   epb=',conjg(epb),'  M =',mdm
c>>>>      write(13,*)'grp rad.=',rg,'   epb=',conjg(epb),'  M =',mdm
      write(*,*) 'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',pdm
c>>>>      write(13,*)'freq    =',fq,'   eps=',conjg(eps(1)),'  P =',pdm
      write(*,*) 'spread  =',pho(3)-pho(2)
c>>>>      write(13,*)'spread  =',pho(3)-pho(2)
      write(*,*) ' '
c>>>>      write(13,*)' '

      write(*,*)  'Fractional Volume             Dipole Term'
      write(*,*)  'new eff. permittivity         new eff. conductivity'
c>>>>      write(13,*) 'Fractional Volume             Dipole Term'
c>>>>      write(13,*) 'new eff. permittivity         new eff. conductivity'
c>>>>      write(13,*)' '

      n = 0
c
      call t1sub(t1,mdm,ntm,fq,epb,eps(n+1),r(n+1),k0)
     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex*16 identity matrix [MxM].

      do 122 i=1,pdm
        do 121 j=1,pdm
          taun(i,j)=(0.0d0,0.0d0)
 121    continue
 122  continue

      do 124 i=1,mdm
        do 123 j=1,mdm
          taun(i,j)=t1(i,j)
          ID(i,j)=(0.0d0,0.0d0)
 123    continue
          ID(i,i)=(1.0d0,0.0d0)
 124  continue

c --- Calculate normalized einc [Px1]
      k=1
      do 31 i=0,ntp
        nq=2*i+1
        do 32 j=1,nq
          if(j.eq.(i+1)) einc(k)=(ai**i)*sqrt(4.0d0*pi*dfloat(i+i+1))/
     &                             FILLD(i,k0)
          if(j.ne.(i+1)) einc(k)=(0.0d0,0.0d0)
          k=k+1
 32     continue
 31   continue

      do 1000 n=1,nst-1

c --- Calculate normalized 1 sphere scattering matrix for sphere n+1
c     t1static    = (1/S) * t1dynamic    * D

      lp = n
      call t1sub(t1,mdm,ntm,fq,epb,eps(lp+1),r(lp+1),k0)
     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex*16 identity matrix [MxM].

c --- Calculate the normalization matrices (diagonal => column vectors)
c     alphastatic = (1/D) * alphadynamic * S
c     betastaticn0= (1/D) * betadynamic  * D
c     betastatic0n= (1/S) * betadynamic  * S
 
c --- an0 is alpha(n+1,0)    [MxP]
c --- bn0 is beta(n+1,0)   [MxP]

      phi1  =phi(n+1)
      theta1=theta(n+1)
      pho1  =pho(n+1)
c>>>>      call COMAT(an0,mdm,pdm,phi1,theta1,pho1,k0,1,1)
      call dalphbt(pho1,theta1,phi1,k0,ntm,ntp,ab1,ab2,mdm,nptt,1,1)
      call movemtrx(ab1,mdm,nptt,an0,mdm,pdm,mdm,pdm)
      call movemtrx(ab2,mdm,nptt,bn0,mdm,pdm,mdm,pdm)

c --- a0n is alpha(0,n+1)    [PxM]
c --- b0n is beta(0,n+1)   [PxM]

      call dalphbtf(pho1,theta1,phi1,k0,ntp,ntm,ap1,ap2,nptt,mdm,-1,2)
      call movemtrxp(ap1,nptt,mdm,a0n,pdm,mdm,pdm,mdm)
      call movemtrxp(ap2,nptt,mdm,b0n,pdm,mdm,pdm,mdm)

c --- Calculate T(n+1,1)*alpha(n+1,0)*tau(n)   [MxP]

      call mtrxmult(t1,mdm,mdm,an0,mdm,pdm,temp2)
      call mtrxmult(temp2,mdm,pdm,taun,pdm,pdm,Tatau)

c --- Calculate I - T(n+1,1)*alpha(n+1,0)*tau(n)*alpha(0,n+1) [MxM]

      call mtrxmult(Tatau,mdm,pdm,a0n,pdm,mdm,wtemp)
      call mtrxadd(ID,mdm,mdm,wtemp,mdm,mdm,w,-1)

c --- Invert last matrix calculated   [MxM]

      call cminvl(w,winv,wa,mdm,mdm,mdm,iwa)

c --- Calculate beta(n+1,0)+alpha(n+1,0)*tau(n)   [MxP]

c>>      call mtrxmult(an0,mdm,pdm,taun,pdm,pdm,w2temp)
      call mtrxmult(an0,mdm,pdm,taun,pdm,pdm,w2temp)
      call mtrxadd(w2temp,mdm,pdm,bn0,mdm,pdm,w2,1)

c --- Calculate T(n+1,n+1)*beta(n+1,0)   [MxP]

      call mtrxmult(winv,mdm,mdm,t1,mdm,mdm,temp3)
      call mtrxmult(temp3,mdm,mdm,w2,mdm,pdm,tb)
        
c --- Calculate tau(n)*alpha(0,n+1)   [PxM]

      call mtrxmult(taun,pdm,pdm,a0n,pdm,mdm,taua)

c --- Calculate beta(0,n+1)*T(n+1,n+1)*beta(n+1,0)  +       [PxP] 
c               tau(n)*alpha(0,n+1)*T(n+1,n+1)*beta(n+1,0)  [PxP]

      call mtrxadd(b0n,pdm,mdm,taua,pdm,mdm,temp1,1)
      call mtrxmult(temp1,pdm,mdm,tb,mdm,pdm,btb)
      
c --- Calculate tau(n+1)   [PxP]

      call mtrxadd(taun,pdm,pdm,btb,pdm,pdm,taun1,1)
c
c --- Calculate the dipole term:  row 3 of tau(n+1) * einc

      dple=(0.0d0,0.0d0)
      do 200 j=1,pdm
        dple=dple+taun1(3,j)*einc(j)
  200 continue

c --- Calculate effective permittivity and conductivity

      dple  = dple*ee/ai/k0/rg**3
c----------------------------------------------------------------------
      ka = k0 * rg
      tau= dple*(ka**3)/3.0d0/ai
      A3=-4.50e1*ai*tau+((-5.0d0*ai*ka-1.8e1)*ka*ka+1.5e1)*ka*ka*ka
      B3=-1.80e2*ai*tau+((1.0e+1*ai*ka+9.0d0)*ka*ka+1.5e1)*ka*ka*ka
      C3=-1.80e2*ai*tau+((-5.0d0*ai*ka+9.0d0)*ka*ka-3.0e1)*ka*ka*ka 
c>>>      A3 =  15.0*(ka**3) - 18.0*(ka**5) -  45.0*ai*tau -  5.0*ai*(ka**6)
c>>>      B3 =  15.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau + 10.0*ai*(ka**6)
c>>>      C3 = -30.0*(ka**3) +  9.0*(ka**5) - 180.0*ai*tau -  5.0*ai*(ka**6)
c----------------------------------------------------------------------
      epsef1= ((1.0+2.0*Dple)/(1.0-Dple))*epb
      epsr1 = dreal(epsef1)
      sigma1= -dimag(epsef1)*fqeo*2.0*pi
      epsef2= epb * ( -B3 + sqrt(B3*B3-4.0*A3*C3) ) / (2.0*A3)
      epsr2 = dreal(epsef2)
      sigma2= -dimag(epsef2)*fqeo*2.0*pi
      fv=fv+(r(n+1)/rg)**3

      write(14,*) dple
      write(*,*)  'sphere #',n+1,'      dple =',dple
      write(*,*)  '                   ',epsr2,sigma2
c>>>>      write(13,*) 'sphere #',n+1,'      dple =',dple
c>>>>      write(13,*) '                   ',epsr2,sigma2

c     write(*,*) 'eff. permit. =',epsr,'    conductivity =',sigma
c     write(*,*) 'dipole term  =',dple
c     write(13,*)'eff. permit. =',epsr,'    conductivity =',sigma
c     write(13,*)'dipole term  =',dple

      if (n.eq.nst-1) go to 1000

c --- Set tau(n) = tau(n+1) before next pass through loop

      do 300 i=1,mdm
        do 301 j=1,pdm
          taun(i,j)=taun1(i,j)
 301    continue
 300  continue

 1000 continue
      stop
      end

      SUBROUTINE LOWFAPPX(l,f,a,epb,eps,apprx)
      complex*16 apprx,epb,eps,epsr,ai
      real*8 k0,f,a,x1,x2,k,ka,k1,krel

      ai   = cmplx(0.0d0,1.0d0)
      epsr = eps/epb
      k0   = 8.0d0*atan2(1.0d0,1.0d0)*f/3.0d8
      k    = k0*sqrt(dreal(epb))
      k1   = k0*sqrt(dreal(eps))
      ka   = k*a
      krel = k1/k

      x2 = 1.0d0
      do 1 j = 1,l+l-1,2
          x2 = x2*dfloat(j)
  1   continue
      x1 = x2*dfloat(l+l+1)

c     top1 = epsr*dfloat(l)* (k1**(l+1))* (k**(l-1))* (a**(l+l-1))/x1/x1
c     top2 =      dfloat(l)* (k1**l)*     (k**l)*     (a**(l+l-1))/x1/x1
c     bot1 = ai * dfloat(l+1) * (krel**l) / dfloat(2*l+1) / k / (a**2)
c     bot2 = -ai*epsr*dfloat(l)* (krel**(l+1))/ k/ dfloat(2*l+1)/ (a**2)
c     apprx=-(top1-top2)/(bot1-bot2)

c --- apprx given below is same as -(top1-top2)/(bot1-bot2)
c     this normalizes to a slightly different number than the static #
c     apprx=-ai*dfloat(l) * (ka**(2*l+1)) * (1.0d0-epsr*krel) / x1 / x2
c    &      / ( 1.0d0 + dfloat(l) * (1.0d0 + epsr * krel) )

c --- apprx given below normalizes to exactly the static approximation
      apprx=-ai * dfloat(l) * (ka**(2*l+1)) * (1.0d0-epsr) / x1 / x2
     &      / ( 1.0d0 + dfloat(l) * (1.0d0 + epsr ) )

      return
      end
      
      Subroutine mtrxmult(a,ar,ac,b,br,bc,c)
      integer ar,ac,br,bc
      complex*16 a,b,c
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ac.ne.br) then
        print *,'*****  Matrix multiplication not defined.  *****'
      end if
c
      if (ar .ge. bc) then

      do 60 i = 1,bc
          do 50 j = 1,ar
            c(j,i) = (0.0d0,0.0d0)
 50     continue
 60   continue
c
      do 30 i = 1,ac
          do 20 k = 1,bc
            do 10 j = 1,ar
                c(j,k) = c(j,k)+a(j,i)*b(i,k)
 10       continue
 20     continue
 30   continue
c
      else
c
      do 160 i = 1,ar
          do 150 j = 1,bc
            c(i,j) = (0.0d0,0.0d0)
 150    continue
 160  continue
c
      do 130 i = 1,ac
          do 120 k = 1,ar
            do 110 j = 1,bc
                c(k,j) = c(k,j)+a(k,i)*b(i,j)
 110      continue
 120    continue
 130  continue
c
      endif
c
c>>>      do 1 i=1,ar
c>>>        do 2 j=1,bc
c>>>          temp=cmplx(0.0d0,0.0d0)
c>>>          do 3 k=1,ac
c>>>            temp=temp+a(i,k)*b(k,j)
c>>>  3       continue
c>>>          c(i,j)=temp
c>>>  2     continue
c>>>  1   continue
      return
      end
      
      Subroutine mtrxadd(a,ar,ac,b,br,bc,c,isign)
      integer ar,ac,br,bc,isign
      complex*16 a,b,c
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ar.ne.br.OR.ac.ne.bc) then
        print *,'*****  Matrix addition not defined.  *****'
      end if
      do 1 i=1,ar
        do 2 j=1,bc
            c(i,j)=a(i,j)+isign*b(i,j)
  2     continue
  1   continue
      return
      end

      subroutine prntmtrx(a,irow,icol)
      complex*16 a
      dimension a(irow,icol)
c     do 1 i=1,irow
c       do 2 j=1,icol
      do 1 i=1,16
        do 2 j=1,16
          write(14,*) i,j,a(i,j)
  2     continue
  1   continue
      return
      end

      REAL*8 FUNCTION FILLD(i,k0)
      real*8 k0,fac
      integer i
      fac=1.0d0
      do 1 j=1,i+i+1,2
          fac=fac*dfloat(j)
 1    continue
      filld=fac/(k0**i)
      return
      end


      COMPLEX*16 FUNCTION FILLS(i,k0)
      real*8 k0,fac
      integer i
      fac=1.0d0
      do 1 j=1,i+i-1,2
          fac=fac*dfloat(j)
 1    continue
      fills=cmplx(0.0d0,(k0**(i+1))/fac)
      return
      end
      SUBROUTINE ONESPHT(i,f,r,epb,eps,t1)
      complex*16 epb,eps,t1,Hank,Hankd,SH1,denom,num,epsr
      real*8 k0,k,k1,kr,k1r,SJ,f,r,krel,sjdkr,sjdk1r

      k0   = 8.0d0*atan2(1.0d0,1.0d0)*f/3.0d8
      k    = k0*sqrt(dreal(epb))
      k1   = k0*sqrt(dreal(eps))
      kr   = k*r
      k1r  = k1*r
      krel = k1/k
      epsr = eps/epb

      Hank   = SH1(i,kr)
      sjdkr  = (i/r) * SJ(i,kr)  - k  * SJ(i+1,kr)
      sjdk1r = (i/r) * SJ(i,k1r) - k1 * SJ(i+1,k1r)
      Hankd  = (i/r) * Hank      - k  * SH1(i+1,kr)

      num   = epsr * krel * sjdk1r * SJ(i,kr) - SJ(i,k1r) * sjdkr
      denom = SJ(i,k1r) * Hankd - epsr * krel * sjdk1r * Hank
      t1    = - num / denom
      return
      end
c     Subroutine t1sub(t1,mdm,pdm,ntm,fq,epb,eps,r,k0)
      Subroutine t1sub(t1,mdm,ntm,fq,epb,eps,r,k0)
      complex*16 t1,epb,eps,temp,FILLS
      real*8 fq,r,k0,FILLD,div
      parameter(div=1.0d6)
c     integer mdm,ntm,i,k,kk,nq,pdm
      integer mdm,ntm,i,k,kk,nq
c     dimension t1(mdm,pdm)
      dimension t1(mdm,mdm)

      do 1 i=1,mdm
c       do 2 j=1,pdm
        do 2 j=1,mdm
          t1(i,j)=cmplx(0.0d0,0.0d0)
 2      continue
 1    continue

      k=1
      do 10 i=0,ntm
c       if (fq.le.div) call LOWFAPPX(i,fq,r,epb,eps,temp)
c       if (fq.gt.div) call ONESPHT(i,fq,r,epb,eps,temp)
        call LOWFAPPX(i,fq,r,epb,eps,temp)
c       call ONESPHT(i,fq,r,epb,eps,temp)
        nq=(2*i)+1
        do 20 kk=1,nq
          t1(k,k)=FILLD(i,k0)*temp/FILLS(i,k0)
c         t1(k,k)=temp
          k=k+1
 20     continue
 10   continue
      return
      end
c cminvl in matman1 in hftlib may be used instead if one has access to
c IMSLIB.
c
c transfer 'c' to the next line to get determinant on the matrix.
c     subroutine cminvl(ca,cb,cd,wa,n,ia)
      subroutine cminvl(ca,cb,wa,n,ia,mp,iwork)
      implicit complex*16 (c)
      real*8 wa
      integer mp,iwork
      dimension ca(mp,mp),cb(mp,mp),cdet(2),wa(iwork)
c
c     cminvl is a driver program that finds the inverse of a matrix
c     by calling cgefa and cgedi from linpack.
c
c     on entry
c
c         ca     a complex*16 matrix preserved on output.
c
c         cb     a complex*16 matrix containing the inverse
c                on output.
c
c         cd     contains the determinant of the matrix ca on
c                output.  If the determinant is not needed, the
c                lower line can be used for the subroutine statement.
c
c         wa     a work real*8 vector of length at least 3*n.
c
c         n      the order of the matrices  ca  and  cb.
c
c         ia     the actual row dimension of the array declared for ca and cb.
c
c     written by W.C. Chew on May 3, 1987.
c
c     transfer from ca to cb.
c
      do 10 i=1,n
      do 10 j=1,n
      cb(i,j)=ca(i,j)
   10 continue
c
c     calls cgefa to condition the matrix.
c
      call cgefa(cb,ia,n,wa(1),info)
c
c     if info is greater than zero, the matrix is singular.
c
      if(info.gt.0) goto 15
c
c     calls cgedi to find inverse and determinant.
c
      call cgedi(cb,ia,n,wa(1),cdet,wa(n+1),11)
c     cd=cdet(1)*10.0**cdet(2)
      return
   15 continue
c
c     write to terminal on Harris.  Need to be changed on other computers.
c
c     write(*,*) ' ** the matrix is singular in cminvl ** '
      return
      end

      subroutine movemtrx(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex*16 ca(ja1,0:ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb1
        do 15 jm = 1,jb2
          cb(jn,jm) = (0.0d0,0.0d0)
 15     continue
 10   continue
      do 20 jn = 1,n1
        do 25 jm = 1,n2
          cb(jn,jm) = ca(jn,jm)
 25     continue
 20   continue
c
      return
      end

      subroutine movemtrxp(ca,ja1,ja2,cb,jb1,jb2,n1,n2)
c
      integer ja1,ja2,jb1,jb2,n1,n2
      complex*16 ca(0:ja1,ja2),cb(jb1,jb2)
c
      do 10 jn = 1,jb2
        do 15 jm = 1,jb1
          cb(jm,jn) = (0.0d0,0.0d0)
 15     continue
 10   continue
      do 20 jn = 1,n2
        do 25 jm = 1,n1
          cb(jm,jn) = ca(jm,jn)
 25     continue
 20   continue
c
      return
      end

        Double precision FUNCTION SJ(n,x)
        implicit double precision (d)
        real*8 db(0:100),x
        integer flag
        parameter (iacc=40)

c --- Small argument approximation.
        if (x.lt.0.1d0) then
          dfac=1.0d0
          do 1 i=1,2*n+1,2
            dfac=dfac*dfloat(i)
  1       continue
          SJ=(x**n)/dfac
          return
        end if

c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            SJ=sin(x)/x
            return
        end if
        if (n.eq.1) then
            SJ=sin(x)/x/x-cos(x)/x
            return
        end if
        if (n.eq.2) then
            SJ=(3.0d0/x/x-1.0d0)*sin(x)/x - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        dbessj0=cos(x)/x
        dbessj1=sin(x)/x
        if (x.gt.dfloat(n)) then
            dbjm=dbessj0
            dbj=dbessj1
            do 11 j=0,n-1
                dbjp=(2.0d0*dfloat(j)+1.)/x*dbj-dbjm
                dbjm=dbj
                dbj=dbjp
  11        continue
            SJ=dbj
        else
            m=2*((n+int(sqrt(dfloat(iacc*n))))/2)
            SJ=0.0d0
            db(m+1)=0.0d0
            db(m)=1.0d0
            i=0
            do 12 j=m,1,-1
                db(j-1)=(2.0d0*dfloat(j)+1.)/x*db(j)-db(j+1)
                if (abs(db(j-1)).gt.1.d10) then
                    db(j-1)=db(j-1)*1.d-10
                    db(j)=db(j)*1.d-10
                    i=i+1
                end if
                if (j.eq.n) flag=i
  12        continue
            dr0=sin(x)/x
            if (db(0).eq.0.0d0) print *,'got 0 in SJ'
            dp=dr0/db(0)
            SJ=db(n)*dp*(1.d10)**(flag-i)
        end if
  13    return
        end

C       GENERATES SPHERICAL HANKEL FUNCTIONS OF THE THIRD KIND
        COMPLEX*16 FUNCTION SH1(L,Z)
        complex*16 ai,wkh1(-1:100)
        real*8 z,SJ
        AI=CMPLX(0.0d0,1.0d0)
        DO 1 I=-1,L
          WKH1(I)=(0.0d0,0.0d0)
  1     continue
        WKH1(-1)=EXP(AI*Z)/Z
        WKH1(0)=-AI*EXP(AI*Z)/Z
        DO 2 I=0,L-1
          WKH1(I+1)=dfloat(2*I+1)/Z*WKH1(I)-WKH1(I-1)
  2     continue
        SH1=cmplx(SJ(l,z),dimag(WKH1(L)))
        RETURN
        END

c**********************************************************************
c****module dalphbt
      subroutine dalphbt(zz,theta,phi,k0,nmax,numa,alph,beta,ndim
     &                                            ,nudim,jtune,jcon) 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 21)
      complex*16 alph(ndim,0:nudim)
      complex*16 beta(ndim,0:nudim)
      complex*16 al1,al2,al3
      complex*16 bl1,bl2,bl3
      complex*16 ci
      real*8 z,zz,theta,phi,k0,costhe,theta0,phi0
      real*8 pwork(0:nudd),sbesj(0:nudd),pi,sqrtpi
      complex*16 sbesh(0:nudd)
      complex*16 sphh(0:nudd,-nudd:nudd)
      real*8 factdn,factdnu,factsn,factsnu
      real*8 bpnu,bmnu,bpnn
      real*8 amnu,apnu,apnm,amnm

      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
      sqrtpi = sqrt(4.0d0*pi)
c
      z = zz*k0
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesjh(z,nmx,sbesj,sbesh,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        alph(1,nup)=msign*sphh(nu,0)*sbesh(nu)*sqrtpi*nsign
        beta(1,nup)=msign*sphh(nu,0)*sbesj(nu)*sqrtpi*nsign
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          alph(1,lmp)=msign*sphh(nu,-mu)*sbesh(nu)*sqrtpi
     &                *exp(ci*2.0d0*mu*phi0)*nsign                      
          alph(1,lmm)=msign*sphh(nu,mu)*sbesh(nu)*sqrtpi
     &                *exp(-ci*2.0d0*mu*phi0)*nsign                   
          beta(1,lmp)=msign*sphh(nu,-mu)*sbesj(nu)*sqrtpi
     &                *exp(ci*2.0d0*mu*phi0)*nsign                      
          beta(1,lmm)=msign*sphh(nu,mu)*sbesj(nu)*sqrtpi
     &                *exp(-ci*2.0d0*mu*phi0)*nsign                   
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(dfloat((nu+mu)*(nu+mu-1))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(dfloat((nu-mu+2)*(nu-mu+1))
     &                 /dfloat((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
            alph(npp,num+mu)= (bpnu*alph(npm,nub+mu-1)+
     &                         bmnu*alph(npm,nup+mu-1))/bpnn
            beta(npp,num+mu)= (bpnu*beta(npm,nub+mu-1)+
     &                         bmnu*beta(npm,nup+mu-1))/bpnn
 50       continue
          bmnu = sqrt(dfloat((nu+nu+2)*(nu+nu+1))
     &               /dfloat((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          alph(npp,num-nu)= (bmnu*alph(npm,nup-nu-1))/bpnn
          beta(npp,num-nu)= (bmnu*beta(npm,nup-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0d0/3.0d0)
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          alph(npp,1)= (bmnu*alph(npm,2))/bpnn
          beta(npp,1)= (bmnu*beta(npm,2))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(nmp,nub+mu)
           al3=alph(nmp,nup+mu)
           bl2=beta(nmp,nub+mu)
           bl3=beta(nmp,nup+mu)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           alph(npp,num+mu)= (apnu*al2 + amnu*al3)/apnm     
           beta(npp,num+mu)= (apnu*bl2 + amnu*bl3)/apnm     
 80       continue
          al3=alph(nmp,nup-nu)
          bl3=beta(nmp,nup-nu)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,num-nu)= (amnu*al3)/apnm     
          beta(npp,num-nu)= (amnu*bl3)/apnm     
          al3=alph(nmp,nup+nu)
          bl3=beta(nmp,nup+nu)
          alph(npp,num+nu)= (amnu*al3)/apnm     
          beta(npp,num+nu)= (amnu*bl3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(nmp,3)
          bl3=beta(nmp,3)
          amnu = sqrt(1.0d0/3.0d0)
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,1)= (amnu*al3)/apnm     
          beta(npp,1)= (amnu*bl3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(nmm,num+mu)
           al2=alph(nmp,nub+mu)
           al3=alph(nmp,nup+mu)
           bl1=beta(nmm,num+mu)
           bl2=beta(nmp,nub+mu)
           bl3=beta(nmp,nup+mu)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           amnm = sqrt(dfloat((n+m)*(n-m))
     &                 /dfloat((2*n+1)*(2*n-1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           alph(npp,num+mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
           beta(npp,num+mu)=(-amnm*bl1 + apnu * bl2
     &                     + amnu * bl3) / apnm     
 85       continue
          al1=alph(nmm,num-nu)
          al3=alph(nmp,nup-nu)
          bl1=beta(nmm,num-nu)
          bl3=beta(nmp,nup-nu)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,num-nu)=(-amnm*al1 + amnu * al3) / apnm     
          beta(npp,num-nu)=(-amnm*bl1 + amnu * bl3) / apnm     
          al1=alph(nmm,num+nu)
          al3=alph(nmp,nup+nu)
          bl1=beta(nmm,num+nu)
          bl3=beta(nmp,nup+nu)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,num+nu)=(-amnm*al1 + amnu * al3) / apnm     
          beta(npp,num+nu)=(-amnm*bl1 + amnu * bl3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(nmm,1)
          al3=alph(nmp,3)
          bl1=beta(nmm,1)
          bl3=beta(nmp,3)
          amnu = sqrt(1.0d0/3.0d0)
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(npp,1)=(-amnm*al1 + amnu * al3) / apnm     
          beta(npp,1)=(-amnm*bl1 + amnu * bl3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            alph(npp-m,nup) = msign*(alph(npp+m,nup))
     &                             *exp(2.0d0*ci*(m)*phi0)
            beta(npp-m,nup) = msign*(beta(npp+m,nup))
     &                             *exp(2.0d0*ci*(m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(npp-m,nup+mu) = msign*musign*alph(npp+m,nup-mu)
     &                                *exp(2.0d0*ci*phi0*(mu+m))
              alph(npp-m,nup-mu) = msign*musign*alph(npp+m,nup+mu)
     &                                *exp(2.0d0*ci*phi0*(m-mu))
              beta(npp-m,nup+mu) = msign*musign*beta(npp+m,nup-mu)
     &                                *exp(2.0d0*ci*phi0*(mu+m))
              beta(npp-m,nup-mu) = msign*musign*beta(npp+m,nup+mu)
     &                                *exp(2.0d0*ci*phi0*(m-mu))
 98         continue
 96       continue
 95     continue
 90   continue

      if(jcon .eq. 1) then

      factdn = 1.0d0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*k0/dfloat(2*jnp+1)
        endif
c>>>>        factdn = 1.0d0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0d0
          do 110 jnup = 0,numa
c>>>>            factdnu = filld(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*dfloat(2*jnup+1)/k0
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(np,nup) = beta(np,nup)*factdn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue

      else if(jcon .eq. 2) then

      factsn = 1.0d0/k0
      do 200 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*dfloat(2*jnp-1)/k0
        endif
c>>>        factsn = 1.0d0/fills(jnp,k0)
        do 205 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = k0
          do 210 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*k0/dfloat(2*jnup-1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 215 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(np,nup) = beta(np,nup)*factsn*factsnu
 215        continue
 210      continue
 205    continue
 200  continue

      else

        pause 'jcon must be 1 or 2 in sbeta subroutine'

      endif

  
      factdn = 1.0d0
      do 300 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*k0/dfloat(2*jnp+1)
        endif
c>>>        factdn = 1.0d0/filld(jnp,k0)
        do 305 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = k0
          do 310 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*k0/dfloat(2*jnup-1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 315 jmup = -jnup,jnup
              nup = nupp + jmup
              alph(np,nup) = ci*alph(np,nup)*factdn*factsnu
 315        continue
 310      continue
 305    continue
 300  continue
             
      return
      end
c************************************************************************
c****module spharm
      SUBROUTINE SPHHARM(X,PHI,L,M,SPHH,LD1,LD2,PWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PWORK(0:LD1)
      COMPLEX*16 SPHH(0:LD1,-LD2:LD2), CI
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
CC
      CI = (0.0D0,1.0D0)
      PI = ACOS(-1.0D0)
      DO 10 LM = 0,M
        CALL DLEGENDR(X,L,LM,PWORK,LD1) 
        DO 20 LP = LM,L
          SPHH(LP,LM) = CMPLX(PWORK(LP),0.0D0)
 20     CONTINUE
 10   CONTINUE
C
      PIINV = 0.5D0/SQRT(PI)
C
      DO 30 LP = 0,L
        SPHH(LP,0) = PIINV*SQRT(DFLOAT(2*LP+1))*SPHH(LP,0)
 30   CONTINUE
C
      IF(L .LT. 150) THEN
        PN = 1.
        DO 40 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*DFLOAT(LP)+1.0D0)
          PN = PN*DFLOAT(LP)
          PADD = SQRT(PN)
          PMIN = PN
          DO 50 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD*SQRT(DFLOAT(LP+MP))
            PMIN = PMIN/DFLOAT(LP-MP+1)   
            FAC = SIGN*FACL*SQRT(PMIN)/PADD
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 50       CONTINUE
 40     CONTINUE
      ELSE
        PN = 0.0
        DO 60 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*DFLOAT(LP)+1.0D0)
          PN = PN + LOG(DFLOAT(LP))
          PADD = PN
          PMIN = PN
          DO 70 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD + LOG(DFLOAT(LP+MP))
            PMIN = PMIN - LOG(DFLOAT(LP-MP+1))   
            FAC = SIGN*FACL*EXP(0.5D0*(PMIN-PADD))
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 70       CONTINUE
 60     CONTINUE
      ENDIF  
C
      RETURN
      END
c**********************************************************************
c****dlegendr
      SUBROUTINE DLEGENDR(X,L,M,PLGNDR,LD1)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PLGNDR(0:LD1)
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in DLEGENDR'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
      PMM=1.0D0
      IF(M.GT.0) THEN
        SOMX2=SQRT((1.-X)*(1.+X))
        FACT=1.
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.0D0
11      CONTINUE
      ENDIF
      IF(L.EQ.M) THEN
        PLGNDR(L)=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF(L.EQ.M+1) THEN
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
        ELSE
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PLGNDR(LL)=PLL
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

c****************************************************************
c****module dsbesjh
	subroutine dsbesjh(x,n,sj,csh,nd)
        implicit complex*16 (c)
        implicit real*8 (a-b,d-h,o-z)
        dimension sj(0:nd),csh(0:nd)

        ci = (0.0d0,1.0d0)

        call dsbesy(x,n,sj,nd)
c
        do 5 j = 0,n
          csh(j) = ci*sj(j)
  5     continue
c
        call dsbesj(x,n,sj,nd)
        
        do 10 j = 0,n
          csh(j) = sj(j) + csh(j)
 10     continue
c
        return
        end
c****************************************************************
c****module cdsbesj
        subroutine dsbesj(cx,n,csj,nd)
c>>>        implicit complex*16 (c)
c>>>        implicit real*8 (a-b,d-h,o-z)
        implicit real*8 (a-h,o-z)
        dimension csj(0:nd)
        integer flag
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')

c --- Explicit calculation of low order Bessel functions.
        cxinv = 1.0d0/cx
        if (n.eq.0) then
            csj(0)=sin(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            return
        end if
        if (n.eq.2) then
            csj(0)=sin(cx)*cxinv
            csj(1)=csj(0)*cxinv-cos(cx)*cxinv
            csj(2)=(3.0d0/cx/cx-1.0d0)*csj(0) - 3.0d0*cos(cx)/cx/cx
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        flag=0
        csj(0)=sin(cx)*cxinv
        csj(1)=(csj(0)-cos(cx))*cxinv
        csjb=csj(0)
        csjm=csj(1)
        if (abs(cx).gt.dfloat(n)) then
            do 11 j=2,n
                csjp=(2.0d0*dfloat(j-1)+1.0d0)*cxinv*csjm-csjb
                csjb=csjm
                csjm=csjp
                csj(j)=csjm
  11        continue
        else
            csj1=csj(1)
            m=2*((n+int(sqrt(dfloat(iacc*n))))/2)
            csjm=0.0d0
            csjb=1.0d0
            i=0
            do 12 j=m,1,-1
                csjp=(2.0d0*dfloat(j+1)+1.d0)*cxinv*csjb-csjm
                csjm=csjb
                csjb=csjp
                if(j.le.n) csj(j)=csjp
c>>>>>                write(12,*) j, sjp
                if (abs(csjp).gt.bigno) then
                    csjm=csjm*1.d-10
                    csjb=csjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      csj(lp)=csj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (abs(csj(1)).eq.0.0d0) print *,'got 0 in SJ'
            cdp=csj1/csj(1)
            do 30 jp = 1,n
              csj(jp) = csj(jp)*cdp
  30        continue
        end if
  13    return
        end

c***************************************************************
c****module dsbesy
	subroutine dsbesy(cx,n,csy,nd)
c>>>        implicit complex*16 (c)
c>>>        implicit real*8 (a-b,d-h,o-z)
        implicit real*8 (a-h,o-z)
        dimension csy(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
c
        cxinv = 1.0d0/cx
c        
c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            csy(0)=-cos(cx)*cxinv
            return
        end if
        if (n.eq.1) then
            csy(0)=-cos(cx)*cxinv
            csy(1)=csy(0)*cxinv-sin(cx)*cxinv
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        csy(0)=-cos(cx)*cxinv
        csy(1)=csy(0)*cxinv-sin(cx)*cxinv
        csyb=csy(0)
        csym=csy(1)
        do 11 j=2,n
          csyp=(2.0d0*dfloat(j-1)+1.)*cxinv*csym-csyb
          csyb=csym
          csym=csyp
          csy(j)=csym
  11    continue
        return
        end
c------------------------------------------------------------------------
c**********************************************************************
c****module dsalpha
      subroutine dalphbtf(zz,theta,phi,k0,numa,nmax,alph,beta,nudim,
     &                                           ndim,jtune,jcon) 
c
c     this routine is for numa > nmax.
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 21)
      complex*16 alph(0:nudim,ndim)
      complex*16 beta(0:nudim,ndim)
      complex*16 al1,al2,al3
      complex*16 bl1,bl2,bl3
      complex*16 ci
      real*8 z,zz,theta,phi,k0,costhe,theta0,phi0
      real*8 pwork(0:nudd),sbesj(0:nudd),pi,sqrtpi
      complex*16 sbesh(0:nudd)
      complex*16 sphh(0:nudd,-nudd:nudd)
      real*8 factsn,factsnu,factdn,factdnu
      real*8 bpnu,bmnu,bpnn
      real*8 amnu,apnu,apnm,amnm

      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
      sqrtpi = sqrt(4.0d0*pi)
c
      z = zz*k0
c
      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call dsbesjh(z,nmx,sbesj,sbesh,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        alph(nup,1)=msign*sphh(nu,0)*sbesh(nu)*sqrtpi
        beta(nup,1)=msign*sphh(nu,0)*sbesj(nu)*sqrtpi
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          alph(lmp,1)=msign*sphh(nu,-mu)*sbesh(nu)*sqrtpi
          alph(lmm,1)=msign*sphh(nu,mu)*sbesh(nu)*sqrtpi
          beta(lmp,1)=msign*sphh(nu,-mu)*sbesj(nu)*sqrtpi
          beta(lmm,1)=msign*sphh(nu,mu)*sbesj(nu)*sqrtpi
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(dfloat((nu+mu)*(nu+mu-1))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(dfloat((nu-mu+2)*(nu-mu+1))
     &                 /dfloat((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
            alph(num+mu,npp)= (bpnu*alph(nub+mu-1,npm)+
     &                         bmnu*alph(nup+mu-1,npm))/bpnn
            beta(num+mu,npp)= (bpnu*beta(nub+mu-1,npm)+
     &                         bmnu*beta(nup+mu-1,npm))/bpnn
 50       continue
          bmnu = sqrt(dfloat((nu+nu+2)*(nu+nu+1))
     &               /dfloat((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          alph(num-nu,npp)= (bmnu*alph(nup-nu-1,npm))/bpnn
          beta(num-nu,npp)= (bmnu*beta(nup-nu-1,npm))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(2.0d0/3.0d0)
          bpnn = sqrt(dfloat(n+n+2)/dfloat(2*n+3))
          alph(1,npp)= (bmnu*alph(2,npm))/bpnn
          beta(1,npp)= (bmnu*beta(2,npm))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(nub+mu,nmp)
           al3=alph(nup+mu,nmp)
           bl2=beta(nub+mu,nmp)
           bl3=beta(nup+mu,nmp)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           alph(num+mu,npp)= (apnu*al2 + amnu*al3)/apnm     
           beta(num+mu,npp)= (apnu*bl2 + amnu*bl3)/apnm     
 80       continue
          al3=alph(nup-nu,nmp)
          bl3=beta(nup-nu,nmp)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(num-nu,npp)= (amnu*al3)/apnm     
          beta(num-nu,npp)= (amnu*bl3)/apnm     
          al3=alph(nup+nu,nmp)
          bl3=beta(nup+nu,nmp)
          alph(num+nu,npp)= (amnu*al3)/apnm     
          beta(num+nu,npp)= (amnu*bl3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(3,nmp)
          bl3=beta(3,nmp)
          amnu = sqrt(1.0d0/3.0d0)
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(1,npp)= (amnu*al3)/apnm     
          beta(1,npp)= (amnu*bl3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(num+mu,nmm)
           al2=alph(nub+mu,nmp)
           al3=alph(nup+mu,nmp)
           bl1=beta(num+mu,nmm)
           bl2=beta(nub+mu,nmp)
           bl3=beta(nup+mu,nmp)
           amnu = sqrt(dfloat((nu+mu+1)*(nu-mu+1))
     &                 /dfloat((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(dfloat((nu+mu)*(nu-mu))
     &                 /dfloat((2*nu-1)*(2*nu+1)))
           amnm = sqrt(dfloat((n+m)*(n-m))
     &                 /dfloat((2*n+1)*(2*n-1)))
           apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                 /dfloat((2*n+1)*(2*n+3)))
           alph(num+mu,npp)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
           beta(num+mu,npp)=(-amnm*bl1 + apnu * bl2
     &                     + amnu * bl3) / apnm     
 85       continue
          al1=alph(num-nu,nmm)
          al3=alph(nup-nu,nmp)
          bl1=beta(num-nu,nmm)
          bl3=beta(nup-nu,nmp)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(num-nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
          beta(num-nu,npp)=(-amnm*bl1 + amnu * bl3) / apnm     
          al1=alph(num+nu,nmm)
          al3=alph(nup+nu,nmp)
          bl1=beta(num+nu,nmm)
          bl3=beta(nup+nu,nmp)
          amnu = sqrt(1.0d0/dfloat(2*nu+3))
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(num+nu,npp)=(-amnm*al1 + amnu * al3) / apnm     
          beta(num+nu,npp)=(-amnm*bl1 + amnu * bl3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(1,nmm)
          al3=alph(3,nmp)
          bl1=beta(1,nmm)
          bl3=beta(3,nmp)
          amnu = sqrt(1.0d0/3.0d0)
          amnm = sqrt(dfloat((n+m)*(n-m))
     &                /dfloat((2*n+1)*(2*n-1)))
          apnm = -sqrt(dfloat((n+m+1)*(n-m+1))
     &                /dfloat((2*n+1)*(2*n+3)))
          alph(1,npp)=(-amnm*al1 + amnu * al3) / apnm     
          beta(1,npp)=(-amnm*bl1 + amnu * bl3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            alph(nup,npp-m) = msign*(alph(nup,npp+m))
     &                             *exp(2.0d0*ci*(-m)*phi0)
            beta(nup,npp-m) = msign*(beta(nup,npp+m))
     &                             *exp(2.0d0*ci*(-m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(nup+mu,npp-m) = msign*musign*alph(nup-mu,npp+m)
     &                                *exp(2.0d0*ci*phi0*(-mu-m))
              alph(nup-mu,npp-m) = msign*musign*alph(nup+mu,npp+m)
     &                                *exp(2.0d0*ci*phi0*(mu-m))
              beta(nup+mu,npp-m) = msign*musign*beta(nup-mu,npp+m)
     &                                *exp(2.0d0*ci*phi0*(-mu-m))
              beta(nup-mu,npp-m) = msign*musign*beta(nup+mu,npp+m)
     &                                *exp(2.0d0*ci*phi0*(mu-m))
 98         continue
 96       continue
 95     continue
 90   continue
  
      if(jcon .eq. 1) then

      factdn = 1.0d0
      do 100 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factdn = factdn*dfloat(2*jnp+1)/k0
        endif
c>>>>        factdn = 1.0d0/filld(jnp,k0)
        do 105 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0d0
          do 110 jnup = 0,numa
c>>>>            factdnu = filld(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*k0/dfloat(2*jnup+1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 115 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(nup,np) = beta(nup,np)*factdn*factdnu
 115        continue
 110      continue
 105    continue
 100  continue
  
      else if(jcon .eq. 2) then

      factsn = k0
      do 200 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*k0/dfloat(2*jnp-1)
        endif
c>>>        factsn = 1.0d0/fills(jnp,k0)
        do 205 jmp = -jnp,jnp
          np = npp + jmp
          factsnu = 1.0d0/k0
          do 210 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factsnu = factsnu*dfloat(2*jnup-1)/k0
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 215 jmup = -jnup,jnup
              nup = nupp + jmup
              beta(nup,np) = beta(nup,np)*factsn*factsnu
 215        continue
 210      continue
 205    continue
 200  continue
 
      else

        pause 'jcon must be 1 or 2 in sbeta subroutine'
 
      endif
  
      factsn = k0
      do 300 jnp = 0,nmax
        npp = (jnp+1)*(jnp+1) - jnp
        if(jnp .ne. 0) then
          factsn = factsn*k0/dfloat(2*jnp-1)
        endif
c>>>        factdn = 1.0d0/filld(jnp,k0)
        do 305 jmp = -jnp,jnp
          np = npp + jmp
          factdnu = 1.0d0
          do 310 jnup = 0,numa
c>>>            factsnu = fills(jnup,k0)
            if(jnup .ne. 0) then
              factdnu = factdnu*k0/dfloat(2*jnup+1)
            endif
            nupp = (jnup+1)*(jnup+1) - jnup
            do 315 jmup = -jnup,jnup
              nup = nupp + jmup
              alph(nup,np) = ci*alph(nup,np)*factsn*factdnu
 315        continue
 310      continue
 305    continue
 300  continue
             
      return
      end
