      subroutine sbeta(zz,theta,phi,k0,nmax,numa,beta,ndim,nudim,
     &                                           jtune,jcon) 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 40)
      complex beta(ndim,0:nudim)
      complex al1,al2,al3
      real theta,phi,z,costhe,theta0,phi0
      real sbesj(0:nudd)
      real pwork(0:nudd),pi,k0
      real filld,factdn,factdnu
      complex fills,factsn,factsnu
      complex sphh(0:nudd,-nudd:nudd), ci

      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
      z = zz*k0

      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of betaa (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call sbessj(z,nmx,sbesj,nudd)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        beta(1,nup)=msign*sphh(nu,0)*sbesj(nu)*3.544907702d0
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          beta(1,lmp)=msign*sphh(nu,-mu)*sbesj(nu)*3.544907702d0
          beta(1,lmm)=msign*sphh(nu,mu)*sbesj(nu)*3.544907702d0
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            beta(npp,num+mu)= (bpnu*beta(npm,nub+mu-1)+
     &                         bmnu*beta(npm,nup+mu-1))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          beta(npp,num-nu)= (bmnu*beta(npm,nup-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(float(2)/float(3))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          beta(npp,1)= (bmnu*beta(npm,2))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=beta(nmp,nub+mu)
           al3=beta(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           beta(npp,num+mu)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=beta(nmp,nup-nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,num-nu)= (amnu*al3)/apnm     
          al3=beta(nmp,nup+nu)
          beta(npp,num+nu)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=beta(nmp,3)
          amnu = sqrt(1./3.)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,1)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=beta(nmm,num+mu)
           al2=beta(nmp,nub+mu)
           al3=beta(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           beta(npp,num+mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=beta(nmm,num-nu)
          al3=beta(nmp,nup-nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,num-nu)=(-amnm*al1 + amnu * al3) / apnm     
          al1=beta(nmm,num+nu)
          al3=beta(nmp,nup+nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,num+nu)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=beta(nmm,1)
          al3=beta(nmp,3)
          amnu = sqrt(1./3.)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          beta(npp,1)=(-amnm*al1 + amnu * al3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            beta(npp-m,nup) = msign*(beta(npp+m,nup))
     &                             *exp(2.*ci*(-m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              beta(npp-m,nup+mu) = msign*musign*beta(npp+m,nup-mu)
     &                                *exp(2.*ci*phi0*(-mu-m))
              beta(npp-m,nup-mu) = msign*musign*beta(npp+m,nup+mu)
     &                                *exp(2.*ci*phi0*(mu-m))
 98         continue
 96       continue
 95     continue
 90   continue
  
      if(jcon .eq. 2) then
c
      do 100 n = 0,nmax
        np = (n+1)*(n+1) - n
        factsn = 1./fills(n,k0)
        do 105 m = -n,n
          npp = np + m
          do 110 nu = 0,numa
            nup = (nu+1)*(nu+1) - nu
            factsnu = fills(nu,k0)
            do 115 mu = -nu,nu
              nupp = nup + mu
              beta(npp,nupp) = beta(npp,nupp)*factsn*factsnu
 115        continue
 110      continue
 105    continue
 100  continue
c
      else if(jcon .eq. 1) then
c
      do 140 n = 0,nmax
        np = (n+1)*(n+1) - n
        factdn = 1./filld(n,k0)
        do 145 m = -n,n
          npp = np + m
          do 150 nu = 0,numa
            nup = (nu+1)*(nu+1) - nu
            factdnu = filld(nu,k0)
            do 155 mu = -nu,nu
              nupp = nup + mu
              beta(npp,nupp) = beta(npp,nupp)*factdn*factdnu
 155        continue
 150      continue
 145    continue
 140  continue
c
      else 
        pause 'jcon must be 1 or 2'
        return
      endif
  
      return
      end

      subroutine salpha(zz,theta,phi,k0,nmax,numa,alph,ndim,nudim,jtune) 
c --- translation matrix calculated by using Chew's recursion for 
c ---  scalar addition theorem coefficients
      parameter (nudd = 40)
      complex alph(ndim,0:nudim)
      complex al1,al2,al3
      real theta,phi,z,costhe,theta0,phi0
      real pwork(0:nudd), pi,k0
      real filld,factn
      complex sbesh(0:nudd), ci
      complex sphh(0:nudd,-nudd:nudd)
      complex fills,factnu

      ci = (0.0d0,1.0d0)
      pi = acos(-1.0d0)
      z = zz*k0

      if(jtune .eq. -1) then
        theta0 = pi - theta
        phi0 = phi + pi
      else if(jtune .eq. 1) then
        theta0 = theta
        phi0 = phi
      else
        pause 'jtune must be 1 or -1'
        return
      endif

      costhe=cos(theta0)
c
c --- Calculate and store initial values of alpha (n=m=0)
c
      nmx = numa+nmax
      call sphharm(costhe,phi0,nmx,nmx,sphh,nudd,nudd,pwork)
      call sbessh(z,nmx,sbesh,nudd,pwork)
      nsign = -1
      nup = 0
      do 10 nu=0,numa+nmax
        nup = (nu+1)*(nu+1) - nu 
        nsign = -nsign
        msign = nsign
        alph(1,nup)=msign*sphh(nu,0)*sbesh(nu)*3.544907702d0
        do 20 mu=1,nu
          lmp = nup + mu
          lmm = nup - mu
          msign = -msign
          alph(1,lmp)=msign*sphh(nu,-mu)*sbesh(nu)*3.544907702d0
          alph(1,lmm)=msign*sphh(nu,mu)*sbesh(nu)*3.544907702d0
 20     continue
 10   continue
c
c --- Use Eq.(27) to move along n=m line from n=m=0 to n=m=mabs.
c
      do 30 n=0,nmax-1
        npm = (n+1)*(n+1) 
        npp = (n+2)*(n+2)
        do 40 nu=0,numa+nmax
          nup = (nu+2)*(nu+2) - (nu+1)
          num = (nu+1)*(nu+1) - nu
          nub = nu*nu - (nu-1) 
          if(nu .ne. 0) then
          do 50 mu=-(nu-1),nu
            bpnu = sqrt(float((nu+mu)*(nu+mu-1))
     &                 /float((2*nu-1)*(2*nu+1)))
            bmnu = sqrt(float((nu-mu+2)*(nu-mu+1))
     &                 /float((2*nu+3)*(2*nu+1)))
            bpnn = sqrt(float(n+n+2)/float(2*n+3))
            alph(npp,num+mu)= (bpnu*alph(npm,nub+mu-1)+
     &                         bmnu*alph(npm,nup+mu-1))/bpnn
 50       continue
          bmnu = sqrt(float((nu+nu+2)*(nu+nu+1))
     &               /float((2*nu+3)*(2*nu+1)))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(npp,num-nu)= (bmnu*alph(npm,nup-nu-1))/bpnn
          else if(nu .eq. 0) then
          bmnu = sqrt(float(2)/float(3))
          bpnn = sqrt(float(n+n+2)/float(2*n+3))
          alph(npp,1)= (bmnu*alph(npm,2))/bpnn
          endif
 40     continue
 30   continue
c
c --- Use Eq.(23) to move vertically up along m=mdest line to n=ndest.
c
      do 55 m=0,nmax
      do 60 n=m,nmax-1
       npp = (n+2)*(n+2) - (n+1) + m
       nmp = (n+1)*(n+1) - n + m
       nmm = n*n - (n-1) + m
       if(n.eq.m) then
        do 70 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 80 mu=-(nu-1),nu-1
           al2=alph(nmp,nub+mu)
           al3=alph(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(npp,num+mu)= (apnu*al2 + amnu*al3)/apnm     
 80       continue
          al3=alph(nmp,nup-nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,num-nu)= (amnu*al3)/apnm     
          al3=alph(nmp,nup+nu)
          alph(npp,num+nu)= (amnu*al3)/apnm     
         else if(nu .eq. 0) then
          al3=alph(nmp,3)
          amnu = sqrt(1./3.)
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,1)= (amnu*al3)/apnm     
         endif
 70     continue
       else if(n .ne. m) then
        do 75 nu=0,numa+nmax-m
         nup = (nu+2)*(nu+2) - (nu+1)
         num = (nu+1)*(nu+1) - nu
         nub = nu*nu - (nu-1)
         if(nu .ne. 0) then
          do 85 mu=-(nu-1),nu-1
           al1=alph(nmm,num+mu)
           al2=alph(nmp,nub+mu)
           al3=alph(nmp,nup+mu)
           amnu = sqrt(float((nu+mu+1)*(nu-mu+1))
     &                 /float((2*nu+1)*(2*nu+3)))
           apnu = -sqrt(float((nu+mu)*(nu-mu))
     &                 /float((2*nu-1)*(2*nu+1)))
           amnm = sqrt(float((n+m)*(n-m))
     &                 /float((2*n+1)*(2*n-1)))
           apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                 /float((2*n+1)*(2*n+3)))
           alph(npp,num+mu)=(-amnm*al1 + apnu * al2
     &                     + amnu * al3) / apnm     
 85       continue
          al1=alph(nmm,num-nu)
          al3=alph(nmp,nup-nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,num-nu)=(-amnm*al1 + amnu * al3) / apnm     
          al1=alph(nmm,num+nu)
          al3=alph(nmp,nup+nu)
          amnu = sqrt(float(1)/float(2*nu+3))
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,num+nu)=(-amnm*al1 + amnu * al3) / apnm     
         else if(nu .eq. 0) then
          al1=alph(nmm,1)
          al3=alph(nmp,3)
          amnu = sqrt(1./3.)
          amnm = sqrt(float((n+m)*(n-m))
     &                /float((2*n+1)*(2*n-1)))
          apnm = -sqrt(float((n+m+1)*(n-m+1))
     &                /float((2*n+1)*(2*n+3)))
          alph(npp,1)=(-amnm*al1 + amnu * al3) / apnm     
         endif
 75     continue
       endif
 60   continue
 55   continue

      msign = -1
      do 90 m=0,nmax
        msign = -msign
        do 95 n=m,nmax
          npp = (n+1)*(n+1) - n
          do 96 nu=0,numa
            nup = (nu+1)*(nu+1) - nu
            alph(npp-m,nup) = msign*(alph(npp+m,nup))
     &                             *exp(2.*ci*(-m)*phi0)
            musign = 1
            do 98 mu=1,nu
              musign = -musign
              alph(npp-m,nup+mu) = msign*musign*alph(npp+m,nup-mu)
     &                                *exp(2.*ci*phi0*(-mu-m))
              alph(npp-m,nup-mu) = msign*musign*alph(npp+m,nup+mu)
     &                                *exp(2.*ci*phi0*(mu-m))
 98         continue
 96       continue
 95     continue
 90   continue
  
      do 100 n = 0,nmax
        np = (n+1)*(n+1) - n
        factn = 1./filld(n,k0)
        do 105 m = -n,n
          npp = np + m
          do 110 nu = 0,numa
            nup = (nu+1)*(nu+1) - nu
            factnu = fills(nu,k0)
            do 115 mu = -nu,nu
              nupp = nup + mu
              alph(npp,nupp) = alph(npp,nupp)*factn*factnu
 115        continue
 110      continue
 105    continue
 100  continue
c
      return
      end

c------------------------------------------------------------------------

      SUBROUTINE SPHHARM(X,PHI,L,M,SPHH,LD1,LD2,PWORK)
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION PWORK(0:LD1)
      COMPLEX SPHH(0:LD1,-LD2:LD2), CI
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
CC
      CI = (0.0D0,1.0D0)
      PI = ACOS(-1.0D0)
      DO 10 LM = 0,M
        CALL LEGENDR(X,L,LM,PWORK,LD1) 
        DO 20 LP = LM,L
          SPHH(LP,LM) = DCMPLX(PWORK(LP),0.0D0)
 20     CONTINUE
 10   CONTINUE
C
      PIINV = 0.5D0/SQRT(PI)
C
      DO 30 LP = 0,L
        SPHH(LP,0) = PIINV*SQRT(FLOAT(2*LP+1))*SPHH(LP,0)
 30   CONTINUE
C
      IF(L .LT. 150) THEN
        PN = 1.
        DO 40 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*FLOAT(LP)+1.0D0)
          PN = PN*FLOAT(LP)
          PADD = SQRT(PN)
          PMIN = PN
          DO 50 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD*SQRT(FLOAT(LP+MP))
            PMIN = PMIN/FLOAT(LP-MP+1)   
            FAC = SIGN*FACL*SQRT(PMIN)/PADD
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 50       CONTINUE
 40     CONTINUE
      ELSE
        PN = 0.0
        DO 60 LP = 1,L
          SIGN = 1.0D0
          FACL = PIINV*SQRT(2.0D0*FLOAT(LP)+1.0D0)
          PN = PN + LOG(FLOAT(LP))
          PADD = PN
          PMIN = PN
          DO 70 MP = 1,LP
            SIGN = -SIGN
            PADD = PADD + LOG(FLOAT(LP+MP))
            PMIN = PMIN - LOG(FLOAT(LP-MP+1))   
            FAC = SIGN*FACL*EXP(0.5D0*(PMIN-PADD))
            SPHH(LP,MP) = FAC*SPHH(LP,MP)*EXP(CI*MP*PHI) 
            SPHH(LP,-MP) = SIGN*CONJG(SPHH(LP,MP)) 
 70       CONTINUE
 60     CONTINUE
      ENDIF  
C
      RETURN
      END


      SUBROUTINE LEGENDR(X,L,M,PLGNDR,LD1)
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION PLGNDR(0:LD1)
      IF(M.LT.0.OR.M.GT.L.OR.ABS(X).GT.1.)PAUSE
     &               'bad arguments in legendr'
      IF(L.GT.LD1) PAUSE 'L is large than LD1'
      PMM=1.
      IF(M.GT.0) THEN
        SOMX2=SQRT((1.-X)*(1.+X))
        FACT=1.
        DO 11 I=1,M
          PMM=-PMM*FACT*SOMX2
          FACT=FACT+2.
11      CONTINUE
      ENDIF
      IF(L.EQ.M) THEN
        PLGNDR(L)=PMM
      ELSE
        PMMP1=X*(2*M+1)*PMM
        IF(L.EQ.M+1) THEN
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
        ELSE
          PLGNDR(M)=PMM
          PLGNDR(M+1)=PMMP1
          DO 12 LL=M+2,L
            PLL=(X*(2*LL-1)*PMMP1-(LL+M-1)*PMM)/(LL-M)
            PLGNDR(LL)=PLL
            PMM=PMMP1
            PMMP1=PLL
12        CONTINUE
        ENDIF
      ENDIF
      RETURN
      END


	subroutine sbessh(x,n,sh,nd,sj)
        real x, sj(0:nd)
        complex ci, sh(0:nd)

        ci = (0.0d0,1.0d0)

        call sbessj(x,n,sj,nd)
        
        do 10 j = 0,n
          sh(j) = sj(j)
 10     continue
c
        call sbessy(x,n,sj,nd)
c
        do 20 j = 0,n
          sh(j) = sh(j) + ci*sj(j)
 20     continue

        return
        end

	subroutine sbessj(x,n,sj,nd)
        implicit real*8 (d)
        real x, sj(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
        
c --- Explicit calculation of low order Bessel functions.
        xinv = 1./x
        if (n.eq.0) then
            sj(0)=sin(x)*xinv
            return
        end if
        if (n.eq.1) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            return
        end if
        if (n.eq.2) then
            sj(0)=sin(x)*xinv
            sj(1)=sj(0)*xinv-cos(x)*xinv
            sj(2)=(3.0d0/x/x-1.0d0)*sj(0) - 3.0d0*cos(x)/x/x
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        dx = x
        dxinv = 1.0/dx
        dsj0 = sin(dx)*dxinv
        dsj1 = (dsj0 - cos(dx))*dxinv
c>>>        sj(0)=sin(x)*xinv
c>>>        sj(1)=(sj(0)-cos(x))*xinv
        sj(0) = dsj0
        sj(1) = dsj1
        sjb=sj(0)
        sjm=sj(1)
        if (x.gt.float(n)) then
            do 11 j=2,n
                sjp=(2.0d0*float(j-1)+1.)*xinv*sjm-sjb
                sjb=sjm
                sjm=sjp
                sj(j)=sjm
  11        continue
        else
            sj1=sj(1)
            m=2*((n+int(sqrt(float(iacc*n))))/2)
            sjm=0.0d0
            sjb=1.0d0
            i=0
            do 12 j=m,1,-1
                sjp=(2.0d0*float(j+1)+1.)*xinv*sjb-sjm
                sjm=sjb
                sjb=sjp
                if(j.le.n) sj(j)=sjp
c>>>>>                write(12,*) j, sjp
                if (abs(sjp).gt.bigno) then
                    sjm=sjm*1.d-10
                    sjb=sjb*1.d-10
                    if(j .le. n) then
                    do 20 lp = j,n
                      sj(lp)=sj(lp)*bigni
  20                continue
                    endif
                end if
  12        continue
            if (sj(1).eq.0.0d0) print *,'got 0 in SJ'
            dp=sj1/sj(1)
            do 30 jp = 1,n
              sj(jp) = sj(jp)*dp
  30        continue
        end if
  13    return
        end
c------------------------------------------------------------------------



	subroutine sbessy(x,n,sy,nd)
        real x, sy(0:nd)
        parameter (iacc=40,bigni=1.d-10,bigno=1.d+10)
c>>>>>        open(unit=12,file='junk.out',status='unknown')
c
        xinv = 1./x
c        
c --- Explicit calculation of low order Bessel functions.
        if (n.eq.0) then
            sy(0)=-cos(x)*xinv
            return
        end if
        if (n.eq.1) then
            sy(0)=-cos(x)*xinv
            sy(1)=sy(0)*xinv-sin(x)*xinv
            return
        end if

c --- Recurrence relations used to calculate higher orders.
        sy(0)=-cos(x)*xinv
        sy(1)=sy(0)*xinv-sin(x)*xinv
        syb=sy(0)
        sym=sy(1)
        do 11 j=2,n
          syp=(2.0d0*float(j-1)+1.)*xinv*sym-syb
          syb=sym
          sym=syp
          sy(j)=sym
  11    continue
        return
        end
