c****module cmmult1
      SUBROUTINE CMMULT1(CA,CB,IA,IB,N,M,L,CZ,IZ,IP)
C***********************************************
C     COMPLEX MATRIX MULTIPLICATION
C
C     CZ=CA*CB or CZ=CAT*CB
C     WHERE CAT IS THE COMJUGATE TRANSPOSE OF CA
C
C     IP = 1,   CZ=CA*CB
C     IP = 2,   CZ=CAT*CB
C
C     INPUT
C     IA = LEADING DIMENSION OF CA
C     IB = LEADING DIMENSION OF CB
C     IZ = THE SECOND DIMENSION OF CB(OR CZ)
C     N = NUMBER OF ROWS OF CA
C     M = NUMBER OF ROWS OF CB
C     L = NUMBER OF COLLOMN OF CB(OR CZ)
C***********************************************
      IMPLICIT COMPLEX (C)
      DIMENSION CA(IA,IB),CB(IB,IZ),CZ(IA,IZ)
      DO 60 I = 1,L
        DO 50 J = 1,N
          CZ(J,I) = (0.0E0,0.0E0)
 50     CONTINUE
 60   CONTINUE
C
      IF(IP.EQ.2) GOTO 55
C
      DO 30 I = 1,M
        DO 20 K = 1,L
          DO 10 J = 1,N
                CZ(J,K) = CZ(J,K)+CA(J,I)*CB(I,K)
 10       CONTINUE
 20     CONTINUE
 30   CONTINUE
C
      GOTO 99
 55   DO 90 I = 1,M
        DO 80 K = 1,L
          DO 70 J = 1,N
                CZ(J,K) = CZ(J,K)+CONJG(CA(I,J))*CB(I,K)
 70       CONTINUE
 80     CONTINUE
 90   CONTINUE

 99   RETURN
      END
