c****module mainss
c
c    This program is written for calculating the scattering field 
c    from a single scatterer. The incident field is a plane wave 
c    propagating at the positive z-axis. The E-field is at x-axis 
c    and the H-field is at y-axis. The field is expanded by using 
c    M and N (See definition in Chew's book). 
c
c    Input files:   main.inp 
c
      program mainss 
c                   
      implicit real (a-b,d-h,o-z)
      implicit complex (c)
      integer mdm,pdm,nst,ntm,ntp
      parameter ( nst=1200, iwa=100 )
      parameter ( mdm=900,  pdm=900)
      parameter ( nptt = 484)
      parameter ( jnmax = 150*mdm ) 
      parameter ( err = 1.0e-35)

      complex cvbs(pdm,5),cvbs2(pdm,5),cvbs3(pdm,5)
      complex cfinc(pdm,2)
      complex ctm(pdm,2)
      real pi,k0,fq
c
      luinp = 26
      open(unit=luinp,file='main.inp',status='unknown')
c
      pi=4.0e0*atan2(1.0e0,1.0e0)
      dg=180.0e0/pi
      e0=8.8541853e-12
      u0=pi*4.0e-7
      dg=180.0/pi
      ci  =(0.0,1.0)
c  
      read(26,*)
      read(26,*) a 
      read(26,*)
      read(26,*) pho, theta, phi
      read(26,*)
      read(26,*) epb, eps 
      read(26,*)
      read(26,*) fq 
      read(26,*)
      read(26,*) lmod 
      read(26,*)
      read(26,*) nmod
      read(26,*)
      read(26,*) jrsv 
      read(26,*)
      read(26,*) jtune
      read(26,*)
      read(26,*) jtsph
c     
      theta = theta/dg
      phi = phi/dg
c
      close(unit=luinp)
c
      ntm=int(sqrt(float(lmod)))
      ntp=int(sqrt(float(nmod)))
      ntmm = (ntm+1)*(ntm+1)
      ntpp = (ntp+1)*(ntp+1)
c 
      omega = 2.0e0*pi*fq
      k0 = 2.0e0*pi*fq*sqrt(e0*u0)
c
      call fldinc(pdm,cfinc,lmod)
      call vtmtrx(ctm,lmod,pdm,epb,eps,a,k0,jtsph)
c
      if(jtsph .eq. 2) then
c
      lusctx = 20
      luscty = 25
      lusctz = 30
      lusphx = 35
      lusphy = 40
      lusphz = 45
c
      open(unit=lusctx,file='sctx.dat',status='unknown')
      open(unit=luscty,file='scty.dat',status='unknown')
      open(unit=lusctz,file='sctz.dat',status='unknown')
      open(unit=lusphx,file='sphx.dat',status='unknown')
      open(unit=lusphy,file='sphy.dat',status='unknown')
      open(unit=lusphz,file='sphz.dat',status='unknown')
c     
      else if(jtsph.eq.-1 .or. jtsph.eq.-2 .or. jtsph.eq.1) then
c
      lusthe = 20
      lusphi = 25
      luphthe = 35
      luphphi = 40
      luinthe = 45 
      luinphi = 50 
      luinphthe = 55 
      luinphphi = 60 
c
      open(unit=lusthe,file='sthe.dat',status='unknown')
      open(unit=lusphi,file='sphi.dat',status='unknown')
      open(unit=luphthe,file='phthe.dat',status='unknown')
      open(unit=luphphi,file='phphi.dat',status='unknown')
      open(unit=luinthe,file='finthe.dat',status='unknown')
      open(unit=luinphi,file='finphi.dat',status='unknown')
      open(unit=luinphthe,file='finphthe.dat',status='unknown')
      open(unit=luinphphi,file='finphphi.dat',status='unknown')
c
      endif
c
      if(jtune .eq. 1) then
c       
        deltth = pi/float(jrsv)
        theta0 = 0.0
c
        do 50 jv = 1,jrsv+1
c
          call vbassf(pho,theta0,phi,cvbs,pdm,lmod,k0,2)
          call vbassf(pho,theta0,phi,cvbs3,pdm,lmod,k0,1)
          call vbassf(pho,theta0,phi+pi,cvbs2,pdm,lmod,k0,2)
c
          cm1 = (0.0,0.0)
          cm2 = (0.0,0.0)
          cm3 = (0.0,0.0)
          cm4 = (0.0,0.0)
          cm5 = (0.0,0.0)
c
          cn1 = (0.0,0.0)
          cn2 = (0.0,0.0)
          cn3 = (0.0,0.0)
          cn4 = (0.0,0.0)
          cn5 = (0.0,0.0)
c
          cin1 = (0.0,0.0)
          cin2 = (0.0,0.0)
          cin3 = (0.0,0.0)
          cin4 = (0.0,0.0)
          cin5 = (0.0,0.0)
c
          do 40 jp = 1,lmod-1
            cm1 = cm1+cvbs(jp,1)*ctm(jp,1)*cfinc(jp,1) 
            cm2 = cm2+cvbs(jp,2)*ctm(jp,1)*cfinc(jp,1) 
            cm3 = cm3+cvbs(jp,3)*ctm(jp,2)*cfinc(jp,2) 
            cm4 = cm4+cvbs(jp,4)*ctm(jp,2)*cfinc(jp,2) 
            cm5 = cm5+cvbs(jp,5)*ctm(jp,2)*cfinc(jp,2) 
c
            cn1 = cn1+cvbs2(jp,1)*ctm(jp,1)*cfinc(jp,1) 
            cn2 = cn2+cvbs2(jp,2)*ctm(jp,1)*cfinc(jp,1) 
            cn3 = cn3+cvbs2(jp,3)*ctm(jp,2)*cfinc(jp,2) 
            cn4 = cn4+cvbs2(jp,4)*ctm(jp,2)*cfinc(jp,2) 
            cn5 = cn5+cvbs2(jp,5)*ctm(jp,2)*cfinc(jp,2) 
c
            cin1 = cin1+cvbs3(jp,1)*cfinc(jp,1) 
            cin2 = cin2+cvbs3(jp,2)*cfinc(jp,1) 
            cin3 = cin3+cvbs3(jp,3)*cfinc(jp,2) 
            cin4 = cin4+cvbs3(jp,4)*cfinc(jp,2) 
            cin5 = cin5+cvbs3(jp,5)*cfinc(jp,2) 
  40      continue
c
          if(jtsph .eq. 2) then
c
          cex = (cm1+cm4)*cos(theta0)*cos(phi)
     &         -(cm2+cm5)*sin(phi)
     &         +cm3*sin(theta0)*cos(phi)
          cey = cm3*sin(theta0)*sin(phi)
     &         +(cm1+cm4)*cos(theta0)*sin(phi)
     &         +(cm2+cm5)*cos(phi)
          cez = cm3*cos(theta0)
     &         -(cm1+cm4)*sin(theta0)
c
          cnx = (cn1+cn4)*cos(theta0)*cos(phi)
     &         -(cn2+cn5)*sin(phi)
     &         +cn3*sin(theta0)*cos(phi)
          cny = cn3*sin(theta0)*sin(phi)
     &         +(cn1+cn4)*cos(theta0)*sin(phi)
     &         +(cn2+cn5)*cos(phi)
          cnz = cn3*cos(theta0)
     &         -(cn1+cn4)*sin(theta0)
c
          cinx = (cin1+cin4)*cos(theta0)*cos(phi)
     &         -(cin2+cin5)*sin(phi)
     &         +cin3*sin(theta0)*cos(phi)
          ciny = cin3*sin(theta0)*sin(phi)
     &         +(cin1+cin4)*cos(theta0)*sin(phi)
     &         +(cin2+cin5)*cos(phi)
          cinz = cin3*cos(theta0)
     &         -(cin1+cin4)*sin(theta0)
c
          write(10,900) theta0*dg,abs(cinx)
          write(15,900) theta0*dg,abs(ciny)
          write(18,900) theta0*dg,abs(cinz)
          write(lusctx,900) theta0*dg,abs(cex),abs(cnx)
          write(luscty,900) theta0*dg,abs(cey),abs(cny)
          write(lusctz,900) theta0*dg,abs(cez),abs(cnz)
          write(lusphx,900) theta0*dg,atan2(aimag(cex),real(cex))*dg
     &                           ,atan2(aimag(cnx),real(cex))*dg
          write(lusphy,900) theta0*dg,atan2(aimag(cey),real(cey))*dg
     &                           ,atan2(aimag(cny),real(cey))*dg
          write(lusphz,900) theta0*dg,atan2(aimag(cez),real(cez))*dg
     &                           ,atan2(aimag(cnz),real(cez))*dg
c
          else if(jtsph .eq. -1 .or. jtsph .eq. 1) then
c
          write(lusthe,900) theta0*dg,abs(cm1+cm4),abs(cn1+cn4)
          write(lusphi,900) theta0*dg,abs(cm2+cm5),abs(cn2+cn5)
          write(luphthe,900) theta0*dg,
     &                       atan2(aimag(cm1+cm4),real(cm1+cm4))*dg
          write(luphphi,900) theta0*dg,
     &                 atan2(aimag(cm2+cm5+err),real(cm2+cm5)+err)*dg
          write(luinthe,900) theta0*dg,abs(cin1+cin4)
          write(luinphi,900) theta0*dg,abs(cin2+cin5)
          write(luinphthe,900) theta0*dg,
     &                       atan2(aimag(cin1+cin4),real(cin1+cin4))*dg
          write(luinphphi,900) theta0*dg,
     &              atan2(aimag(cin2+cin5+err),real(cin2+cin5+err))*dg
c
          else if(jtsph .eq. -2) then
c
          ch1 = (0.0,0.0)
          ch2 = (0.0,0.0)
          ch3 = (0.0,0.0)
          ch4 = (0.0,0.0)
          ch5 = (0.0,0.0)
c
          chn1 = (0.0,0.0)
          chn2 = (0.0,0.0)
          chn3 = (0.0,0.0)
          chn4 = (0.0,0.0)
          chn5 = (0.0,0.0)
c
          chin1 = (0.0,0.0)
          chin2 = (0.0,0.0)
          chin3 = (0.0,0.0)
          chin4 = (0.0,0.0)
          chin5 = (0.0,0.0)
c
          do 45 jp = 1,lmod-1
            ch1 = ch1+cvbs(jp,1)*ctm(jp,2)*cfinc(jp,2)
            ch2 = ch2+cvbs(jp,2)*ctm(jp,2)*cfinc(jp,2)
            ch3 = ch3+cvbs(jp,3)*ctm(jp,1)*cfinc(jp,1)
            ch4 = ch4+cvbs(jp,4)*ctm(jp,1)*cfinc(jp,1)
            ch5 = ch5+cvbs(jp,5)*ctm(jp,1)*cfinc(jp,1)
c
            chn1 = chn1+cvbs2(jp,1)*ctm(jp,2)*cfinc(jp,2)
            chn2 = chn2+cvbs2(jp,2)*ctm(jp,2)*cfinc(jp,2)
            chn3 = chn3+cvbs2(jp,3)*ctm(jp,1)*cfinc(jp,1)
            chn4 = chn4+cvbs2(jp,4)*ctm(jp,1)*cfinc(jp,1)
            chn5 = chn5+cvbs2(jp,5)*ctm(jp,1)*cfinc(jp,1)
c
            chin1 = chin1+cvbs3(jp,1)*cfinc(jp,2)
            chin2 = chin2+cvbs3(jp,2)*cfinc(jp,2)
            chin3 = chin3+cvbs3(jp,3)*cfinc(jp,1)
            chin4 = chin4+cvbs3(jp,4)*cfinc(jp,1)
            chin5 = chin5+cvbs3(jp,5)*cfinc(jp,1)
  45      continue
c
          chf = k0/(ci*omega*u0)
c
          write(lusthe,900) theta0*dg,abs(chf*(ch1+ch4))
          write(lusphi,900) theta0*dg,abs(chf*(ch2+ch5))
          write(luphthe,900) theta0*dg,atan2(aimag(chf*(ch1+ch4)),
     &                                 real(chf*(ch1+ch4)))*dg
          write(luphphi,900) theta0*dg,atan2(aimag(chf*(ch2+ch5)),
     &                                 real(chf*(ch2+ch5)))*dg
          write(luinthe,900) theta0*dg,abs(chf*(chin1+chin4))
          write(luinphi,900) theta0*dg,abs(chf*(chin2+chin5))
          write(luinphthe,900) theta0*dg,atan2(aimag(chf*(chin1+chin4)),
     &                                   real(chf*(chin1+chin4)))*dg
          write(luinphphi,900) theta0*dg,atan2(aimag(chf*(chin2+chin5)),
     &                                   real(chf*(chin2+chin5)))*dg
c
          endif
c
          theta0 = theta0+deltth
  50    continue
c
      else if(jtune .eq. 2) then
c

        deltphi = pi/float(jrsv)
        phi0 = 0.0e0 
c
        do 80 jv = 1,2*jrsv+1
c
          call vbassf(pho,theta,phi0,cvbs,pdm,lmod,k0,2)
c
          cm1 = (0.0,0.0)
          cm2 = (0.0,0.0)
          cm3 = (0.0,0.0)
          cm4 = (0.0,0.0)
          cm5 = (0.0,0.0)
c
          do 60 jp = 1,lmod-1
            cm1 = cm1+cvbs(jp,1)*ctm(jp,1)*cfinc(jp,1)
            cm2 = cm2+cvbs(jp,2)*ctm(jp,1)*cfinc(jp,1)
            cm3 = cm3+cvbs(jp,3)*ctm(jp,2)*cfinc(jp,2)
            cm4 = cm4+cvbs(jp,4)*ctm(jp,2)*cfinc(jp,2)
            cm5 = cm5+cvbs(jp,5)*ctm(jp,2)*cfinc(jp,2)
  60      continue
c
          cex = (cm1+cm4)*cos(theta)*cos(phi0)
     &         -(cm2+cm5)*sin(phi0)
     &           +cm3*sin(theta)*cos(phi0)
          cey = cm3*sin(theta)*sin(phi0)
     &         +(cm1+cm4)*cos(theta)*sin(phi0)
     &         +(cm2+cm5)*cos(phi0)
          cmz = cm3*cos(theta)
     &         -(cm1+cm4)*sin(theta)
c
          write(lusctx,900) theta0*dg,abs(cex),abs(cnx)
          write(luscty,900) theta0*dg,abs(cey),abs(cny)
          write(lusctz,900) theta0*dg,abs(cez),abs(cnz)
c
          write(lusphx,900) theta0*dg,atan2(aimag(cex),real(cex))*dg
          write(lusphy,900) theta0*dg,atan2(aimag(cey),real(cey))*dg
          write(lusphz,900) theta0*dg,atan2(aimag(cez),real(cez))*dg
c
          phi0 = phi0+deltphi
  80    continue
c
      else
        pause 'jtune should be 1 or 2'
      endif
c
 900  format(f6.2,1p2e15.4)
 950  format(f5.2,2f6.0,1p2e15.4)
c
      stop 
      end
