c****module mainv
c     this is the main program for calculating the scattering
c     field from a cluster of spheres. the code has been validated
c     by the closed form solution. 
c
c     update records:
c     modified from mainv.f in september, 1992
c     the calculation of rcs has been included.
c

      program mainv 
c
      implicit real (a-b,d-h,o-z)
      implicit complex (c)
      integer mdm,pdm,iwa,nst,ntm,ntp
      parameter ( nst=150, iwa=100 )
      parameter ( mdm=16,  pdm=100)
      parameter ( jmdm = 2*mdm )
      parameter ( jpdm = 2*pdm )
      parameter ( nptt = 169)
      parameter ( jnmax = 54*jmdm ) 
c
      common /positn/ pho(nst),theta(nst),phi(nst),radii(nst)
      common /epslon/ eps(nst),epb,jts(nst),wk0
      common /paramt/ pi,e0,u0,omega
      common /ctaunm/ ctaun(jpdm,jpdm)
c
      dimension cfinc(pdm,2),cvbs(pdm,5),cvbs2(pdm,5),cvbs3(pdm,5)
      dimension cbinf(pdm,4),cbinf2(pdm,4)
      dimension camp(pdm,2)
c
      lupost = 10
      lupara = 25
      open(unit=lupost,file='posit.dat',status='unknown')
      open(lupara,file='para.inp',status='unknown')
c
      pi=4.0e0*atan2(1.0e0,1.0e0)
      e0=8.8541853e-12
      u0=pi*4.0e-7
      dg=180.0e0/pi
      ci  =(0.0,1.0)
      one =(1.0,0.0)
c  
c --- Read in sphere position, size, and epsilon data.
c
      fvv = 0.0e0
c
      read(10,*) nscatt
      do 1 i=1,nscatt
        read(lupost,*) pho(i),theta(i),phi(i),radii(i),eps(i),jts(i)
  1   continue
c
      read(lupara,*)
      read(lupara,*) tolrs
      read(lupara,*)
      read(lupara,*) epb
      read(lupara,*)
      read(lupara,*) fq
      read(lupara,*)
      read(lupara,*) rr
      read(lupara,*)
      read(lupara,*) phir 
      read(lupara,*)
      read(lupara,*) jrsv 
      read(lupara,*)
      read(lupara,*) lmod 
      read(lupara,*)
      read(lupara,*) nmod
c
      phir = phir/dg
      ntm=int(sqrt(float(lmod)))-1
      ntp=int(sqrt(float(nmod)))-1
      omega=2.0e0*pi*fq
      wk0=2.0e0*pi*fq*sqrt(e0*u0)
      fqeo=fq*8.8419d-12
c
      call taumtx(lmod,nmod,nscatt,tolrs)
c
c --- Calculate normalized einc [Px1]
c
      call fldinc(pdm,cfinc,nmod)
c
c*****calculate the scattering field from the composite medium
c
      lusthe = 20
      lusphi = 25
      luphthe = 35
      luphphi = 40
      luinthe = 45
      luinphi = 50
      luinphthe = 55
      luinphphi = 60
      lurcs = 70
c
      open(unit=lusthe,file='sthe.dat',status='unknown')
      open(unit=lusphi,file='sphi.dat',status='unknown')
      open(unit=luphthe,file='phthe.dat',status='unknown')
      open(unit=luphphi,file='phphi.dat',status='unknown')
      open(unit=luinthe,file='finthe.dat',status='unknown')
      open(unit=luinphi,file='finphi.dat',status='unknown')
      open(unit=luinphthe,file='finphthe.dat',status='unknown')
      open(unit=luinphphi,file='finphphi.dat',status='unknown')
      open(unit=lurcs,file='rcs.dat',status='unknown')
c
      do jp = 1,nmod-1
        camp(jp,1) = (0.0,0.0)
        camp(jp,2) = (0.0,0.0)
      enddo
c
      do 45 jp = 1,nmod-1
        do 42 jq = 1,nmod-1
          camp(jp,1) = camp(jp,1)+ctaun(jp,jq)*cfinc(jq,1)
     &                +ctaun(jp,jq+nmod-1)*cfinc(jq,2)
          camp(jp,2) = camp(jp,2)+ctaun(jp+nmod-1,jq)*cfinc(jq,1)
     &                +ctaun(jp+nmod-1,jq+nmod-1)*cfinc(jq,2)
  42    continue
  45  continue
c
        phor = rr
        deltth = pi/float(jrsv)
        thetar = 0.0
c
        do 50 jv = 1,jrsv+1
c
          call vbassf(phor,thetar,phir,cvbs,pdm,nmod,wk0,2)
          call vbassf(phor,thetar,phir,cvbs3,pdm,nmod,wk0,1)
          call vbassf(phor,thetar,phir+pi,cvbs2,pdm,nmod,wk0,2)
c
          call vbassf2(phor,thetar,phir,cbinf,pdm,nmod,wk0)
          call vbassf2(phor,thetar,phir+pi,cbinf2,pdm,nmod,wk0)
c
          cm1 = (0.0,0.0)
          cm2 = (0.0,0.0)
          cm3 = (0.0,0.0)
          cm4 = (0.0,0.0)
          cm5 = (0.0,0.0)
c
          cn1 = (0.0,0.0)
          cn2 = (0.0,0.0)
          cn3 = (0.0,0.0)
          cn4 = (0.0,0.0)
          cn5 = (0.0,0.0)
c
          cin1 = (0.0,0.0)
          cin2 = (0.0,0.0)
          cin3 = (0.0,0.0)
          cin4 = (0.0,0.0)
          cin5 = (0.0,0.0)
c
          crth1 = (0.0,0.0)
          crph1 = (0.0,0.0)
c
          crth2 = (0.0,0.0)
          crph2 = (0.0,0.0)
c
          chth1 = (0.0,0.0)
          chph1 = (0.0,0.0)
c
          chth2 = (0.0,0.0)
          chph2 = (0.0,0.0)
c
          do 40 jp = 1,nmod-1
            cm1 = cm1+cvbs(jp,1)*camp(jp,1)
            cm2 = cm2+cvbs(jp,2)*camp(jp,1)
            cm3 = cm3+cvbs(jp,3)*camp(jp,2)
            cm4 = cm4+cvbs(jp,4)*camp(jp,2)
            cm5 = cm5+cvbs(jp,5)*camp(jp,2)
c
            cn1 = cn1+cvbs2(jp,1)*camp(jp,1)
            cn2 = cn2+cvbs2(jp,2)*camp(jp,1)
            cn3 = cn3+cvbs2(jp,3)*camp(jp,2)
            cn4 = cn4+cvbs2(jp,4)*camp(jp,2)
            cn5 = cn5+cvbs2(jp,5)*camp(jp,2)
c
            cin1 = cin1+cvbs3(jp,1)*cfinc(jp,1)
            cin2 = cin2+cvbs3(jp,2)*cfinc(jp,1)
            cin3 = cin3+cvbs3(jp,3)*cfinc(jp,2)
            cin4 = cin4+cvbs3(jp,4)*cfinc(jp,2)
            cin5 = cin5+cvbs3(jp,5)*cfinc(jp,2)
c
            crth1 = crth1+cbinf(jp,1)*camp(jp,1)
     &                   +cbinf(jp,3)*camp(jp,2)
            crth2 = crth2+cbinf2(jp,1)*camp(jp,1)
     &                   +cbinf2(jp,3)*camp(jp,2)
c
            crph1 = crph1+cbinf(jp,2)*camp(jp,1)
     &                   +cbinf(jp,4)*camp(jp,2)
            crph2 = crph2+cbinf2(jp,2)*camp(jp,1)
     &                   +cbinf2(jp,4)*camp(jp,2)
c
            chth1 = chth1-ci*cbinf(jp,3)*camp(jp,1)
     &                   -ci*cbinf(jp,1)*camp(jp,2)
            chth2 = chth2-ci*cbinf2(jp,3)*camp(jp,1)
     &                   -ci*cbinf2(jp,1)*camp(jp,2)
c
            chph1 = chph1-ci*cbinf(jp,4)*camp(jp,1)
     &                   -ci*cbinf(jp,2)*camp(jp,2)
            chph2 = chph2-ci*cbinf2(jp,4)*camp(jp,1)
     &                   -ci*cbinf2(jp,2)*camp(jp,2)
c
  40      continue
c
          write(lusthe,900) thetar*dg,abs(cm1+cm4)
     &                               ,abs(cn1+cn4)
          write(lusphi,900) thetar*dg,abs(cm2+cm5)
     &                               ,abs(cn2+cn5)
          write(luphthe,900) thetar*dg,
     &                       atan2(aimag(cm1+cm4),real(cm1+cm4))*dg
     &                      ,atan2(aimag(cn1+cn4),real(cn1+cn4))*dg
          write(luphphi,900) thetar*dg,
     &                       atan2(aimag(cm2+cm5),real(cm2+cm5))*dg
     &                      ,atan2(aimag(cn2+cn5),real(cn2+cn5))*dg
          write(luinthe,900) thetar*dg,abs(cin1+cin4)
          write(luinphi,900) thetar*dg,abs(cin2+cin5)
c          
          rcs1 = 4.0*pi*abs(crth1*conjg(chph1)-crph1*conjg(chth1))
          rcs2 = 4.0*pi*abs(crth2*conjg(chph2)-crph2*conjg(chth2))
c
          write(lurcs,910) thetar*dg,rcs1,rcs2
c>>>          write(luinphthe,900) thetar*dg,
c>>>     &                       atan2(aimag(cin1+cin4),real(cin1+cin4))*dg
c>>>          write(luinphphi,900) thetar*dg,
c>>>     &                       atan2(aimag(cin2+cin5),real(cin2+cin5))*dg
c
          thetar = thetar + deltth
c
  50    continue
c
 900  format(f6.2,1p2e15.4)
 910  format(f6.2,1p2e15.4)
c
      stop
      end
c****module taumtx
      subroutine taumtx(lmod,nmod,nscatt,tolrs) 
c
      implicit real (a-b,d-h,o-z)
      implicit complex (c)
c
      integer pdm
      parameter ( nst=150, iwa=100 )
      parameter ( mdm=16,  pdm=100)
      parameter ( jpdm = 2*pdm )
      parameter ( jmdm = 2*mdm )
      parameter ( nmtt = 25 )
      parameter ( nptt = 169)
      parameter ( jnmax = 54*jmdm ) 

      common /positn/ pho(nst),theta(nst),phi(nst),radii(nst)
      common /epslon/ eps(nst),epb,jts(nst),wk0
      common /paramt/ pi,e0,u0,omega
      common /ctaunm/ ctaun(jpdm,jpdm)
c
      dimension cab1(mdm,0:nptt),cab2(pdm,0:nptt)
      dimension ct1(mdm,2),ctm(jmdm,jmdm)
      dimension calbt1(mdm,pdm,2)
      dimension calbt2(pdm,mdm,2)
      dimension calbt3(mdm,mdm,2)
      dimension ca0n(jpdm,jmdm),can0(jmdm,jpdm),canm(jmdm,jmdm)
      dimension cb0n(jpdm,jmdm),cbn0(jmdm,jpdm)
      dimension ctmp(jmdm,jmdm),ctmp1(jpdm,jmdm)
      dimension ctmp2(jmdm,jpdm),ctmp3(jmdm,jmdm)
      dimension cft1(jmdm,jpdm),cft2(jmdm,jpdm)
      dimension cft4(jpdm,jpdm)
      dimension ctau(jpdm,jmdm)
      dimension czero(jmdm,jpdm)
      dimension cid(jmdm,jmdm)
      dimension cw(jmdm,jmdm),cw2(jmdm,jpdm),cw3(jpdm,jpdm)
      dimension caji(jnmax,jnmax),cbj(jnmax,jpdm),ctb(jnmax,jpdm)
c
      dimension cwork(jnmax),ipvt(jnmax),cdet(2)
c
      pk0 = wk0
      lmod1 = lmod - 1
      nmod1 = nmod - 1
      lmod2 = 2*lmod-2
      nmod2 = 2*nmod-2
      ntm=int(sqrt(float(lmod)))-1
      ntp=int(sqrt(float(nmod)))-1
c
      call cinitm(ctaun,jpdm,jpdm)
      call cinitm(czero,jpdm,jpdm)
      call cinitm(cid,jmdm,jmdm)
c
      do jp = 1,lmod2
        cid(jp,jp) = (1.0,0.0)
      enddo
c
      nsct = 0
      do 1000 n=0,nscatt
c
c --- Find the number of scatterers in each shell
c
      np = 0
      if(tolrs .gt. 1.0d-12) then
      do 14 ln = nsct+1, nscatt
        lnp = ln
        deltr = pho(lnp+1) - pho(lnp)
        if(deltr .gt. tolrs) goto 15
 14   continue
      else
        ln = nsct+1
        lnp = ln
      endif
 15   np = lnp - nsct
c
      do 25 jsh = nsct+1,lnp
c
      lp = jsh
      jtsph = jts(lp)
      rad = radii(lp)
      epsln = eps(lp)
      call vtmtrx(ct1,lmod,mdm,epb,epsln,rad,pk0,jtsph)
      call movevt(ct1,lmod1,mdm,ctm,jmdm) 
c     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex identity matrix [MxM].
c 
c --- an0 is alpha(n+1,0)    [MxP]
c
      phi1  =phi(lp)
      theta1=theta(lp)
      pho1  =pho(lp)
c
      call valph(pho1,theta1,phi1,pk0,ntm,ntp,calbt1,mdm,pdm,1,
     &                cab1,nptt)
c>>>     &                cab1,mdm,nptt)
      call mvalbt(calbt1,lmod1,nmod1,mdm,pdm,can0,jmdm,jpdm)
c
c --- find T_j(1)*alph_j0*tau_(n) and store the result in cft2	
c
      call cmmult1(ctm,can0,jmdm,jmdm,lmod2,lmod2,nmod2,cft1,jpdm,1)
      call cmmult1(cft1,ctaun,jmdm,jpdm,lmod2,nmod2,nmod2,cft2,jpdm,1)
c
      j1 = (lp-nsct-1)*lmod2 + 1
c
      do 20 ish = nsct+1,lnp
c
      lq = ish
      phi2  = phi(lq)
      theta2= theta(lq)
      pho2  =pho(lq)
c
c --- a0n is alpha(0,n+1)    [PxM]
c
      call valph(pho2,theta2,phi2,pk0,ntp,ntm,calbt2,pdm,mdm,-1,
     &                cab2,nptt)
c>>>     &                cab2,pdm,nptt)
      call mvalbt(calbt2,nmod1,lmod1,pdm,mdm,ca0n,jpdm,jmdm)
c
c --- find T_j(1)*alph_j0*tau_(n)*alph_0i 
c       and store the result in ctmp 
c
      call cmmult1(cft2,ca0n,jmdm,jpdm,lmod2,nmod2,lmod2,ctmp,jmdm,1)
c   
      if(ish .eq. jsh) then
c    
        call mtrxadd(ctmp,jmdm,jmdm,cid,jmdm,jmdm,cw,lmod2,lmod2,-1)
c
      else
c
        call recrdnt(pho1,theta1,phi1,pho2,theta2,phi2,
     &                                 pho3,theta3,phi3)
        call valph(pho3,theta3,phi3,pk0,ntm,ntm,calbt3,mdm,mdm,-1,
     &                cab1,nptt)
c>>>     &                cab1,mdm,nptt)
        call mvalbt(calbt3,lmod1,lmod1,mdm,mdm,canm,jmdm,jmdm)
        call cmmult1(ctm,canm,jmdm,jmdm,lmod2,lmod2,lmod2,ctmp3,jmdm,1)
        call mtrxadd(ctmp,jmdm,jmdm,ctmp3,jmdm,jmdm,cw,lmod2,lmod2,1)
c
      endif
c
c --- cw is A_ji in the paper "Generalized Recursive Algorithm ..."
c     now, we need to move to a big matrix caji        
c
      i1 = (lq-nsct-1)*lmod2 + 1
c
      call movesl(cw,caji,jmdm,jmdm,jnmax,jnmax,lmod2,lmod2,j1,i1)
c
 20   continue
c
c --- form the right hand of the equation (9)
c
c --- bn0 is beta(n+1,0)   [MxP]

      call vbeta(pho1,theta1,phi1,pk0,ntm,ntp,calbt1,mdm,pdm,1,
c>>>     &                cab1,nptt)
     &                cab1,mdm,nptt)
      call mvalbt(calbt1,lmod1,nmod1,mdm,pdm,cbn0,jmdm,jpdm)

      call cmmult1(ctm,cbn0,jmdm,jmdm,lmod2,lmod2,nmod2,cw2,jpdm,1)
      call mtrxadd(cw2,jmdm,jpdm,cft2,jmdm,jpdm,ctmp2,lmod2,nmod2,1)
      call mtrxadd(czero,jmdm,jpdm,ctmp2,jmdm,jpdm,cft2,lmod2,nmod2,-1)
c
      call movesl(cft2,cbj,jmdm,jpdm,jnmax,jpdm,lmod2,nmod2,j1,1)
c
 25   continue
c
      jlm = np*lmod2
c
      write(6,*) 'the size of the matrix is = ',jlm,'X',jlm
c
c --- linear equations solver
c
      call cgefa(caji,jnmax,jlm,ipvt,info)
      call cgedi(caji,jnmax,jlm,ipvt,cdet,cwork,01)
c
      call cmmult1(caji,cbj,jnmax,jnmax,jlm,jlm,nmod2,ctb,jpdm,1)
c>>>      call cgaussj(caji,jlm,jnmax,cbj,nmod,pdm)
c
      call cinitm(cft4,jpdm,jpdm)
c
      do 30 ish = nsct+1,lnp
c
c --- b0n is beta(0,n+1)   [PxM]
c
      lq = ish
      phi2  = phi(lq)
      theta2= theta(lq)
      pho2  = pho(lq)
c
      call vbeta(pho2,theta2,phi2,pk0,ntp,ntm,calbt2,pdm,mdm,-1,
     &                cab2,nptt)
c>>>     &                cab2,pdm,nptt)
      call mvalbt(calbt2,nmod1,lmod1,pdm,mdm,cb0n,jpdm,jmdm)
c
      call valph(pho2,theta2,phi2,pk0,ntp,ntm,calbt2,pdm,mdm,-1,
     &                cab2,nptt)
c>>>     &                cab2,pdm,nptt)
      call mvalbt(calbt2,nmod1,lmod1,pdm,mdm,ca0n,jpdm,jmdm)

      call cmmult1(ctaun,ca0n,jpdm,jpdm,nmod2,nmod2,lmod2,ctmp1,jmdm,1)
      call mtrxadd(ctmp1,jpdm,jmdm,cb0n,jpdm,jmdm,ctau,nmod2,lmod2,1)

      i1 = (lq-nsct-1)*lmod2 + 1
      call movels(ctb,cft2,jnmax,jpdm,jmdm,jpdm,lmod2,nmod2,i1,1)
      call cmmult1(ctau,cft2,jpdm,jmdm,nmod2,lmod2,nmod2,cw3,jpdm,1)
      call mtrxadd(cft4,jpdm,jpdm,cw3,jpdm,jpdm,cft4,nmod2,nmod2,1)
c
 30   continue
c
      do 300 i=1,nmod2
        do 301 j=1,nmod2
          ctaun(i,j)=ctaun(i,j)+cft4(i,j)
 301    continue
 300  continue
c
      nsct = nsct + np
      if(nsct .ge. nscatt) goto 666
c
 1000 continue
c
  666 continue
c
      return
      end
c****module movevt
      subroutine movevt(ca,ja,jad,cb,jbd)
c
      complex ca(jad,2),cb(jbd,jbd)
c
      do 30 jp = 1,jbd
        do 20 jq = 1,jbd
          cb(jq,jp) = (0.0,0.0)
  20    continue
  30  continue
c
      do 40 jp = 1,ja
        jq = jp + ja
        cb(jp,jp) = ca(jp,1)
        cb(jq,jq) = ca(jp,2)
  40  continue
c
      return
      end
c****module mvalbt
      subroutine mvalbt(ca,m1,m2,ja1,ja2,cb,jb1,jb2)
c
      complex ca(ja1,ja2,2),cb(jb1,jb2)
c
      do 40 jq = 1,m2
        do 30 jp = 1,m1
          cb(jp,jq) = ca(jp,jq,1)
          cb(jp,jq+m2) = ca(jp,jq,2)
          cb(jp+m1,jq) = ca(jp,jq,2)
          cb(jp+m1,jq+m2) = ca(jp,jq,1)
  30    continue
  40  continue
c
      return
      end
c****module cinitm
      subroutine cinitm(ca,ja1,ja2)
c
      complex ca(ja1,ja2)
c
      do 20 jq = 1,ja2
        do 10 jp = 1,ja1
          ca(jp,jq) = (0.0,0.0)
  10    continue
  20  continue
c
      return
      end
c****module movesl
      subroutine movesl(ca,cb,jaa,jab,jba,jbb,iar,iac,is,js)
c
c     move data from a small matrix ca to a large matrix cb
c
      implicit complex (c)
c
      dimension ca(jaa,jab),cb(jba,jbb)
c
      do 20 j = 1,iac
        do 10 i = 1,iar
          cb(i+is-1,j+js-1) = ca(i,j)
 10     continue
 20   continue
c
      return
      end
c****module movels
      subroutine movels(ca,cb,jaa,jab,jba,jbb,ibr,ibc,is,js)
c
      implicit complex (c)
c
c     move data from a large matrix ca to a small matrix cb
c
      dimension ca(jaa,jab),cb(jba,jbb)
c
      do 20 j = 1,ibc
        do 10 i = 1,ibr
          cb(i,j) = ca(i+is-1,j+js-1)
 10     continue
 20   continue
c
      return
      end
c****module mtrxadd
      Subroutine Mtrxadd(a,ar,ac,b,br,bc,c,j1,j2,isign)
      integer ar,ac,br,bc,isign
      complex a,b,c
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ar.ne.br .or. ac.ne.bc) then
        print *,'*****  Matrix addition not defined.  *****'
      end if
      do 1 i=1,j1
        do 2 j=1,j2
            c(i,j)=a(i,j)+isign*b(i,j)
  2     continue
  1   continue
      return
      end
c****module recrdnt
      subroutine recrdnt(ra,thta,phia,rb,thtb,phib,rc,thtc,phic)
c
      real ra,rb,rc
      real thta,thtb,thtc
      real phia,phib,phic
      real xa,ya,za,xb,yb,zb,xc,yc,zc

      xa = ra*sin(thta)*cos(phia)
      ya = ra*sin(thta)*sin(phia)
      za = ra*cos(thta)
      xb = rb*sin(thtb)*cos(phib)
      yb = rb*sin(thtb)*sin(phib)
      zb = rb*cos(thtb)
c
      xc = xb - xa
      yc = yb - ya
      zc = zb - za
c
      rc = sqrt(xc*xc+yc*yc+zc*zc)
      if (abs(xc) .lt. 1.0d-18 .and. abs(yc) .lt. 1.0d-18) then
        phic = 0.0e0
        if(abs(zc) .lt. 1.0d-18) then
          thtc = 0.0e0
        else
          thtc = atan2(sqrt(xc*xc+yc*yc),zc)
        endif
      else
        thtc = atan2(sqrt(xc*xc+yc*yc),zc)
        phic = atan2(yc,xc)
      endif
c
      return
      end
c****module cmmult1
      SUBROUTINE CMMULT1(CA,CB,IA,IB,N,M,L,CZ,IZ,IP)
C***********************************************
C     COMPLEX MATRIX MULTIPLICATION
C
C     CZ=CA*CB or CZ=CAT*CB
C     WHERE CAT IS THE COMJUGATE TRANSPOSE OF CA
C
C     IP = 1,   CZ=CA*CB
C     IP = 2,   CZ=CAT*CB
C
C     INPUT
C     IA = LEADING DIMENSION OF CA
C     IB = LEADING DIMENSION OF CB
C     IZ = THE SECOND DIMENSION OF CB(OR CZ)
C     N = NUMBER OF ROWS OF CA
C     M = NUMBER OF ROWS OF CB
C     L = NUMBER OF COLLOMN OF CB(OR CZ)
C***********************************************
      IMPLICIT COMPLEX (C)
      DIMENSION CA(IA,IB),CB(IB,IZ),CZ(IA,IZ)
      DO 60 I = 1,L
        DO 50 J = 1,N
          CZ(J,I) = (0.0E0,0.0E0)
 50     CONTINUE
 60   CONTINUE
C
      IF(IP.EQ.2) GOTO 55
C
      DO 30 I = 1,M
        DO 20 K = 1,L
          DO 10 J = 1,N
                CZ(J,K) = CZ(J,K)+CA(J,I)*CB(I,K)
 10       CONTINUE
 20     CONTINUE
 30   CONTINUE
C
      GOTO 99
 55   DO 90 I = 1,M
        DO 80 K = 1,L
          DO 70 J = 1,N
                CZ(J,K) = CZ(J,K)+CONJG(CA(I,J))*CB(I,K)
 70       CONTINUE
 80     CONTINUE
 90   CONTINUE

 99   RETURN
      END
