c****module taumtx
      subroutine taumtx(lmod,nmod,nscatt,tolrs) 
c
      implicit real (a-b,d-h,o-z)
      implicit complex (c)
c
      integer pdm
      parameter ( nst=1200, iwa=100 )
      parameter ( mdm=9,  pdm=64)
      parameter ( jpdm = 2*pdm )
      parameter ( jmdm = 2*mdm )
      parameter ( nmtt = 25 )
      parameter ( nptt = 100)
      parameter ( jnmax = 50*jmdm ) 

      common /positn/ pho(nst),theta(nst),phi(nst),radii(nst)
      common /epslon/ eps(nst),epb,jts(nst),wk0
      common /paramt/ pi,e0,u0,omega
      common /ctaunm/ ctaun(jpdm,jpdm)
c
      dimension cab1(mdm,0:nptt),cab2(pdm,0:nptt)
      dimension ct1(mdm,2),ctm(jmdm,jmdm)
      dimension calbt1(mdm,pdm,2)
      dimension calbt2(pdm,mdm,2)
      dimension calbt3(mdm,mdm,2)
      dimension ca0n(jpdm,jmdm),can0(jmdm,jpdm),canm(jmdm,jmdm)
      dimension cb0n(jpdm,jmdm),cbn0(jmdm,jpdm)
      dimension ctmp(jmdm,jmdm),ctmp1(jpdm,jmdm)
      dimension ctmp2(jmdm,jpdm),ctmp3(jmdm,jmdm)
      dimension cft1(jmdm,jpdm),cft2(jmdm,jpdm)
      dimension cft4(jpdm,jpdm)
      dimension ctau(jpdm,jmdm)
      dimension czero(jmdm,jpdm)
      dimension cid(jmdm,jmdm)
      dimension cw(jmdm,jmdm),cw2(jmdm,jpdm)
      dimension caji(jnmax,jnmax),cbj(jnmax,pdm),ctb(jnmax,pdm)
c
      dimension cwork(jnmax),ipvt(jnmax),cdet(2)
c
      lmod1 = lmod - 1
      nmod1 = nmod - 1
      lmod2 = 2*lmod-2
      nmod2 = 2*nmod-2
      ntm=int(sqrt(float(lmod)))-1
      ntp=int(sqrt(float(nmod)))-1
c
      call cinitm(ctaun,jpdm,jpdm)
      call cinitm(czero,jpdm,jpdm)
      call cinitm(cid,jmdm,jmdm)
c
      do jp = 1,lmod2
        cid(jp,jp) = (1.0,0.0)
      enddo
c
      nsct = 0
      do 1000 n=0,nscatt
c
c --- Find the number of scatterers in each shell
c
      np = 0
      if(tolrs .gt. 1.0d-12) then
      do 14 ln = nsct+1, nscatt
        lnp = ln
        deltr = pho(lnp+1) - pho(lnp)
        if(deltr .gt. tolrs) goto 15
 14   continue
      else
        ln = nsct+1
        lnp = ln
      endif
 15   np = lnp - nsct
c
      do 25 jsh = nsct+1,lnp
c
      lp = jsh
      jtsph = jts(lp)
      rad = radii(lp)
      epsln = eps(lp)
      call vtmtrx(ct1,lmod,mdm,epb,epsln,rad,wk0,jtsph)
      call movevt(ct1,lmod1,mdm,ctm,jmdm) 
c     
c --- Set tau(1) equal to t1 of 1st sphere (both are diagonal).
c     However, tau is PxP and t1 is only MxM => tau has 0's on diagonal
c     after the Mth row.  Also, create complex identity matrix [MxM].
c 
c --- an0 is alpha(n+1,0)    [MxP]
c
      phi1  =phi(lp)
      theta1=theta(lp)
      pho1  =pho(lp)
c
      call valph(pho1,theta1,phi1,wk0,ntm,ntp,calbt1,mdm,pdm,1,
     &                cab1,mdm,nptt)
      call mvalbt(calbt1,lmod1,nmod1,mdm,pdm,can0,jmdm,jpdm)
c
c --- find T_j(1)*alph_j0*tau_(n) and store the result in cft2	
c
      call cmmult1(ctm,can0,jmdm,jmdm,lmod2,lmod2,nmod2,cft1,jpdm,1)
      call cmmult1(cft1,ctaun,jmdm,jpdm,lmod2,nmod2,nmod2,cft2,jpdm,1)
c
      j1 = (lp-nsct-1)*lmod2 + 1
c
      do 20 ish = nsct+1,lnp
c
      lq = ish
      phi2  = phi(lq)
      theta2= theta(lq)
      pho2  =pho(lq)
c
c --- a0n is alpha(0,n+1)    [PxM]
c
      call valph(pho2,theta2,phi2,wk0,ntp,ntm,calbt2,pdm,mdm,-1,
     &                cab2,pdm,nptt)
      call mvalbt(calbt2,nmod1,lmod1,pdm,mdm,ca0n,jpdm,jmdm)
c
c --- find T_j(1)*alph_j0*tau_(n)*alph_0i 
c       and store the result in ctmp 
c
      call cmmult1(cft2,ca0n,jmdm,jpdm,lmod2,nmod2,lmod2,ctmp,jmdm,1)
c   
      if(ish .eq. jsh) then
c    
        call mtrxadd(ctmp,jmdm,jmdm,cid,jmdm,jmdm,cw,lmod2,lmod2,-1)
c
      else
c
        call recrdnt(pho1,theta1,phi1,pho2,theta2,phi2,
     &                                 pho3,theta3,phi3)
        call valph(pho3,theta3,phi3,wk0,ntm,ntm,calbt3,mdm,mdm,-1,
     &                cab1,mdm,nptt)
        call mvalbt(calbt3,lmod1,lmod1,jmdm,jmdm,canm,jmdm,jmdm)
        call cmmult1(ctm,canm,jmdm,jmdm,lmod2,lmod2,lmod2,ctmp3,jmdm,1)
        call mtrxadd(ctmp,jmdm,jmdm,ctmp3,jmdm,jmdm,cw,lmod2,lmod2,1)
c
      endif
c
c --- cw is A_ji in the paper "Generalized Recursive Algorithm ..."
c     now, we need to move to a big matrix caji        
c
      i1 = (lq-nsct-1)*lmod2 + 1
c
      call movesl(cw,caji,jmdm,jmdm,jnmax,jnmax,lmod2,lmod2,j1,i1)
c
 20   continue
c
c --- form the right hand of the equation (9)
c
c --- bn0 is beta(n+1,0)   [MxP]

      call vbeta(pho1,theta1,phi1,k0,ntm,ntp,calbt1,mdm,pdm,1,
     &                cab1,mdm,nptt)
      call mvalbt(calbt1,lmod1,nmod1,mdm,pdm,cbn0,jmdm,jpdm)

      call cmmult1(ctm,cbn0,jmdm,jmdm,lmod2,lmod2,nmod2,cw2,jpdm,1)
      call mtrxadd(cw2,jmdm,jpdm,cft2,jmdm,jpdm,ctmp2,lmod2,nmod2,1)
      call mtrxadd(czero,jmdm,jpdm,ctmp2,jmdm,jpdm,cft2,lmod2,nmod2,-1)
c
      call movesl(cft2,cbj,jmdm,jpdm,jnmax,jpdm,lmod2,nmod2,j1,1)
c
 25   continue
c
      jlm = np*lmod2
c
      write(6,*) 'the size of the matrix is = ',jlm,'X',jlm
c
c --- linear equations solver
c
      call cgefa(caji,jnmax,jlm,ipvt,info)
      call cgedi(caji,jnmax,jlm,ipvt,cdet,cwork,01)
c
      call cmmult1(caji,cbj,jnmax,jnmax,jlm,jlm,nmod2,ctb,jpdm,1)
c>>>      call cgaussj(caji,jlm,jnmax,cbj,nmod,pdm)
c
      call cinitm(cft4,jpdm,jpdm)
c
      do 30 ish = nsct+1,lnp
c
c --- b0n is beta(0,n+1)   [PxM]
c
      lq = ish
      phi2  = phi(lq)
      theta2= theta(lq)
      pho2  = pho(lq)
c
      call vbeta(pho2,theta2,phi2,wk0,ntp,ntm,calbt2,pdm,mdm,-1,
     &                cab2,pdm,nptt)
      call mvalbt(calbt2,nmod1,lmod1,pdm,mdm,cb0n,jpdm,jmdm)
c
      call valph(pho2,theta2,phi2,wk0,ntp,ntm,calbt2,pdm,mdm,-1,
     &                cab2,pdm,nptt)
      call mvalbt(calbt2,nmod1,lmod1,pdm,mdm,ca0n,jpdm,jmdm)

      call cmmult1(ctaun,ca0n,jpdm,jpdm,nmod2,nmod2,lmod2,ctmp1,jmdm,1)
      call mtrxadd(ctmp1,jpdm,jmdm,cb0n,jpdm,jmdm,ctau,nmod2,lmod2,1)

      i1 = (lq-nsct-1)*lmod2 + 1
      call movels(ctb,cft2,jnmax,jpdm,jmdm,jpdm,lmod2,nmod2,i1,1)
      call cmmult1(ctau,cft2,jpdm,jmdm,nmod2,lmod2,nmod2,cft1,jpdm,1)
      call mtrxadd(cft4,jpdm,jpdm,cft1,jpdm,jpdm,cft4,nmod2,nmod2,1)
c
 30   continue
c
      do 300 i=1,nmod2
        do 301 j=1,nmod2
          ctaun(i,j)=ctaun(i,j)+cft4(i,j)
 301    continue
 300  continue
c
      nsct = nsct + np
      if(nsct .ge. nscatt) goto 666
c
 1000 continue
c
  666 continue
c
      return
      end
c****module movevt
      subroutine movevt(ca,ja,jad,cb,jbd)
c
      complex ca(jad,2),cb(jbd,jbd)
c
      do 30 jp = 1,jbd
        do 20 jq = 1,jbd
          cb(jq,jp) = (0.0,0.0)
  20    continue
  30  continue
c
      do 40 jp = 1,ja
        jq = jp + ja
        cb(jp,jp) = ca(jp,1)
        cb(jq,jq) = ca(jp,2)
  40  continue
c
      return
      end
c****module mvalbt
      subroutine mvalbt(ca,m1,m2,ja1,ja2,cb,jb1,jb2)
c
      complex ca(ja1,ja2,2),cb(jb1,jb2)
c
      do 40 jq = 1,m2
        do 30 jp = 1,m1
          cb(jp,jq) = ca(jp,jq,1)
          cb(jp,jq+m2) = ca(jp,jq,2)
          cb(jp+m1,jq) = ca(jp,jq,2)
          cb(jp+m1,jq+m2) = ca(jp,jq,1)
  30    continue
  40  continue
c
      return
      end
c****module cinitm
      subroutine cinitm(ca,ja1,ja2)
c
      complex ca(ja1,ja2)
c
      do 20 jq = 1,ja2
        do 10 jp = 1,ja1
          ca(jp,jq) = (0.0,0.0)
  10    continue
  20  continue
c
      return
      end
c****module movesl
      subroutine movesl(ca,cb,jaa,jab,jba,jbb,iar,iac,is,js)
c
c     move data from a small matrix ca to a large matrix cb
c
      implicit complex (c)
c
      dimension ca(jaa,jab),cb(jba,jbb)
c
      do 20 j = 1,iac
        do 10 i = 1,iar
          cb(i+is-1,j+js-1) = ca(i,j)
 10     continue
 20   continue
c
      return
      end
c****module movels
      subroutine movels(ca,cb,jaa,jab,jba,jbb,ibr,ibc,is,js)
c
      implicit complex (c)
c
c     move data from a large matrix ca to a small matrix cb
c
      dimension ca(jaa,jab),cb(jba,jbb)
c
      do 20 j = 1,ibc
        do 10 i = 1,ibr
          cb(i,j) = ca(i+is-1,j+js-1)
 10     continue
 20   continue
c
      return
      end
c****module mtrxadd
      Subroutine Mtrxadd(a,ar,ac,b,br,bc,c,j1,j2,isign)
      integer ar,ac,br,bc,isign
      complex a,b,c
      dimension a(ar,ac),b(br,bc),c(ar,bc)
      if (ar.ne.br .or. ac.ne.bc) then
        print *,'*****  Matrix addition not defined.  *****'
      end if
      do 1 i=1,j1
        do 2 j=1,j2
            c(i,j)=a(i,j)+isign*b(i,j)
  2     continue
  1   continue
      return
      end
c****module recrdnt
      subroutine recrdnt(ra,thta,phia,rb,thtb,phib,rc,thtc,phic)
c
      real ra,rb,rc
      real thta,thtb,thtc
      real phia,phib,phic
      real xa,ya,za,xb,yb,zb,xc,yc,zc

      xa = ra*sin(thta)*cos(phia)
      ya = ra*sin(thta)*sin(phia)
      za = ra*cos(thta)
      xb = rb*sin(thtb)*cos(phib)
      yb = rb*sin(thtb)*sin(phib)
      zb = rb*cos(thtb)
c
      xc = xb - xa
      yc = yb - ya
      zc = zb - za
c
      rc = sqrt(xc*xc+yc*yc+zc*zc)
      if (abs(xc) .lt. 1.0d-18 .and. abs(yc) .lt. 1.0d-18) then
        phic = 0.0e0
        if(abs(zc) .lt. 1.0d-18) then
          thtc = 0.0e0
        else
          thtc = atan2(sqrt(xc*xc+yc*yc),zc)
        endif
      else
        thtc = atan2(sqrt(xc*xc+yc*yc),zc)
        phic = atan2(yc,xc)
      endif
c
      return
      end
