        program balls
CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

CC	BBSHAKE.FOR [Bolsterli's Balls - with SHAKE parameter]

CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

C       include 'comm.for'
c       Subject: common block for sphere packing program
c       Status: RO
c
C       comm.for
	implicit real*4 (a-h,o-z)
	logical ldrop, lrol1, lrol2, lcon3, lstable, lststk, stick   
	LOGICAL TROUBLE,sticky
	parameter (nbaldrp = 1000, xlenpar = 30.0, ylenpar = 30.0)

c --- nbaldrp is number of balls in distribution to be created.
c     If you wish to change this number, you must also change it in the
c     numerous subroutines which have it in parameter statements also.
c     xlenpar and ylenpar are the length and width of the bin into which
c     the balls will be "dropped."
c     nshake is a variable which you set to influence the packing density.
c     nshake=1 has the balls stop wherever stable equilibrium is reached.
c     nshake>1 is the computer's way of shaking the bin to cause the balls
c     to settle as far down as possible.
c     nshake=5 is reasonable. The greater nshake is, the longer it take to run.

	parameter ( ntot = nbaldrp)   
CC	parameter ( rmin = 0.881, rmax = 2.9871, sticky = .false.)
	parameter ( rmin = 1.00, rmax = 2.00, sticky = .false.)
	common /ccl/ ldrop,lrol1,lrol2,lcon3,lstable,LSTSTK,TROUBLE
	common /cund/ iu(3), xu(3,3), nu
	common /chit/ ih, chh, xh(3), xhh
	common /cnew/ rn, xn(3)
	common /cstk/ ns, rs(ntot), xs(3,ntot), xlen(2)	 
	common /crol/ cph, cth, sph, sth, xc(3)
	common /crom/ chmax, chst, rcton, rcton2
	common /cron/ xax(3), xcton(3), xou(3), xup(3)
	common /cenr/ menrol, mhrol, xnen(3)
	common /ctar/ xt(3)
	common /cran/ kdum
	common /cpi/ pio2,c2pi
	DIMENSION XTEMP(20,3),RTEMP(20) 
	CHARACTER * 16 FILENAME
	CHARACTER * 1 SHNUM
	CHARACTER * 3 R1NUM
	CHARACTER * 3 R2NUM

        print *,'enter kdum to initialize RAN'
        read *,kdum
        fff=ran(kdum)
c       TYPE 50
c 50	FORMAT(2X,'WHAT IS NSHAKE?')
c       ACCEPT	51, NSHAKE
c 51	FORMAT(I)
c       TYPE 51, NSHAKE
        write(*,*) '  WHAT IS NSHAKE?'
        read *,nshake
        write(*,*)' '

	ENCODE(1,52,SHNUM) NSHAKE
52	FORMAT(I1)

	IIRL = (100.0)*(RMIN + 0.001)
	ENCODE(3,53,R1NUM) IIRL
	IIRU = (100.0)*(RMAX + 0.001)
	ENCODE(3,53,R2NUM) IIRU
53	FORMAT(I3)

	FILENAME = 'BBSH'//SHNUM//'RL'//R1NUM//'.'//'RU'//R2NUM

	pio2 = atan2(1.0,0.0)
	c2pi = 4.0*pio2
c       kdum = 91517567		
	tem =ran(kdum)
	xlen(1) = xlenpar
	xlen(2) = ylenpar
	stick = sticky
C	call fixbal	
	do n=1, nbaldrp	
	IF( MOD(N,1000) .EQ. 0) write(*,*) 'Nball =',N

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC	CHOOSE NEW BALL WITH A FIXED RADIUS			 CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CC	  RN = RMIN				!!MOVED FROM NEWBAL

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC	CHOOSE NEW BALL FROM A CONTINUOUS DISTRIBUTION           CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CC	  RN = RAN(KDUM)*(RMAX - RMIN) + RMIN	!!MOVED FROM NEWBAL

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC	OR, CHOOSE NEW BALL FROM A BINARY DISTRIBUTION           CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	  TEST = RAN(KDUM)
	  IF(TEST .LT. 0.50) THEN
	    RN = RMAX
	  ELSE
	    RN = RMIN
	  END IF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC	SET UP LARGE - SMALL - LARGE SEQUENCE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	IF(N .LT. 2000 .OR. N .GT. 8000) THEN
C	  RN = RMAX
C	ELSE
C	  RN = RMIN
C	END IF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC	READY TO GO!						CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	  DO M = 1, NSHAKE			
	
	    TROUBLE = .FALSE.

100	    call newbal
C	    print *, ' '
C	    print *, 'newball',ns+1,' at ',(xn(k), k=1,2),' rn', rn
	    do while(.not. lstable .and. .not. lststk)
	      if(ldrop) call drop
	      if(lrol1) call rol1

	      IF(TROUBLE) THEN
	        TROUBLE = .FALSE.
	        GO TO 100
	      END IF

	      if(lrol2) call rol2

	      IF(TROUBLE) THEN
	        TROUBLE = .FALSE.
	        GO TO 100
	      END IF

	      if(lcon3) call con3
	      lststk = stick .and. lrol2
	    end do
	  
	    RTEMP(M) = RN
	    DO K = 1,3
	      XTEMP(M,K) = XN(K)	   
	    END DO

	  END DO 

	  ZMIN = 1000.0
	  DO M = 1,NSHAKE
	    IF( XTEMP(M,3) .LT. ZMIN ) THEN
	      MFINAL = M
	      ZMIN = XTEMP(M,3)
	    END IF
	  END DO

	  RN = RTEMP(MFINAL)
	  DO K = 1,3
	    XN(K) = XTEMP(MFINAL,K)
	  END DO	

	  call endbal
	  
	  IF(MOD(N,20) .EQ. 0) print *, 'endball',ns,xn,rn

1003	FORMAT(2X,'NS =',I5,2X,'RN =',E15.6,2X,'XN =',3(E15.6,2X))

	end do

CC	write results to output file

c       TYPE 1004
c 1004	FORMAT(2X,'STARTING TO WRITE OUTPUT') 
        write(*,*)'  STARTING TO WRITE OUTPUT' 
c       OPEN (UNIT = 10, FILE = FILENAME, TYPE = 'NEW',
c    &        form = 'unformatted')
        open (10,file='ballout')
	WRITE(10,*) NBALDRP, NSHAKE
	WRITE(10,*) xlenpar,ylenpar
c       WRITE(10,*) ((rs(ii),xs(kk,ii),kk=1,3),ii=1,nbaldrp)
        do ii=1,nbaldrp
            write(10,*) rs(ii),xs(1,ii),xs(2,ii),xs(3,ii)
        end do
           
	CLOSE(UNIT = 10)

c       TYPE 1005
c1005	FORMAT(2X,'FINISHED WRITING OUTPUT') 
        write(*,*)'  FINISHED WRITING OUTPUT'
        stop
	end

CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C	subroutine fixbal
C	include 'comm.for'
C	return
C	end
CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	subroutine newbal
c       include 'comm.for'
c       Subject: common block for sphere packing program
c       Status: RO
c
C       comm.for
	implicit real*4 (a-h,o-z)
	logical ldrop, lrol1, lrol2, lcon3, lstable, lststk, stick   
	LOGICAL TROUBLE,sticky
	parameter (nbaldrp = 1000, xlenpar = 30.0, ylenpar = 30.0)
	parameter ( ntot = nbaldrp)   
CC	parameter ( rmin = 0.881, rmax = 2.9871, sticky = .false.)
	parameter ( rmin = 1.00, rmax = 2.00, sticky = .false.)
	common /ccl/ ldrop,lrol1,lrol2,lcon3,lstable,LSTSTK,TROUBLE
	common /cund/ iu(3), xu(3,3), nu
	common /chit/ ih, chh, xh(3), xhh
	common /cnew/ rn, xn(3)
	common /cstk/ ns, rs(ntot), xs(3,ntot), xlen(2)	 
	common /crol/ cph, cth, sph, sth, xc(3)
	common /crom/ chmax, chst, rcton, rcton2
	common /cron/ xax(3), xcton(3), xou(3), xup(3)
	common /cenr/ menrol, mhrol, xnen(3)
	common /ctar/ xt(3)
	common /cran/ kdum
	common /cpi/ pio2,c2pi
	lstable = .false.
	lststk = .false.
	ldrop = .true.
	lrol1 = .false.
	lrol2 = .false.
	lcon3 = .false.
	xn(3) = 1.0e10 			
	do k = 1,2		
          xn(k) = ran(kdum)*xlen(k)
        end do  

CC	rn = ran(kdum)*(rmax - rmin) + rmin	

	nu = 0  		
	return
	end

CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	subroutine drop
c       include 'comm.for'

c       Subject: common block for sphere packing program
c       Status: RO
c
C       comm.for
	implicit real*4 (a-h,o-z)
	logical ldrop, lrol1, lrol2, lcon3, lstable, lststk, stick   
	LOGICAL TROUBLE,sticky
	parameter (nbaldrp = 1000, xlenpar = 30.0, ylenpar = 30.0)
	parameter ( ntot = nbaldrp)   
CC	parameter ( rmin = 0.881, rmax = 2.9871, sticky = .false.)
	parameter ( rmin = 1.00, rmax = 2.00, sticky = .false.)
	common /ccl/ ldrop,lrol1,lrol2,lcon3,lstable,LSTSTK,TROUBLE
	common /cund/ iu(3), xu(3,3), nu
	common /chit/ ih, chh, xh(3), xhh
	common /cnew/ rn, xn(3)
	common /cstk/ ns, rs(ntot), xs(3,ntot), xlen(2)	 
	common /crol/ cph, cth, sph, sth, xc(3)
	common /crom/ chmax, chst, rcton, rcton2
	common /cron/ xax(3), xcton(3), xou(3), xup(3)
	common /cenr/ menrol, mhrol, xnen(3)
	common /ctar/ xt(3)
	common /cran/ kdum
	common /cpi/ pio2,c2pi
	ldrop = .false.
	ih = 0					
	xhh = rn				
	do is = ns,1,-1
	  if(xs(3,is) .lt. xn(3) .and. xs(3,is) + rs(is) + rn .gt. xhh) then

	     do k = 1,3			
	       xt(k) = xs(k,is)
	     end do
             do k = 1,2
	       if(xn(k)-xt(k).lt.-0.5*xlen(k))xt(k)=xt(k)-xlen(k)
	       if(xn(k)-xt(k).gt. 0.5*xlen(k))xt(k)=xt(k)+xlen(k)
	     end do 
	     xp2 = (xn(1) - xt(1))**2 + (xn(2) - xt(2))**2
	     rtn2 = (rn + rs(is))**2
	     if( xp2 .lt. rtn2 ) then
	       hh = sqrt(rtn2 - xp2) + xt(3)		
	       if( hh .gt. xhh .and. hh .lt. xn(3)) then
		 ih = is
		 xhh = hh
		 do k = 1,3
		   xh(k) = xt(k)
		 end do
	       end if
	     end if
	   end if
         end do
	if ( ih .eq. 0) then			
	  xn(3) = rn
	  lstable = .true.
C	  print *, 'drop to floor'
	else				
	  xn(3) = xhh
	  nu = 1				
	  iu(1) = ih
	  do k=1,3
	    xu(k,1) = xh(k)
	  end do 
	  lrol1 = .true.
	end if
	return
	end

CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	subroutine rol1
c       include 'comm.for'
c       Subject: common block for sphere packing program
c       Status: RO
c
C       comm.for
	implicit real*4 (a-h,o-z)
	logical ldrop, lrol1, lrol2, lcon3, lstable, lststk, stick   
	LOGICAL TROUBLE,sticky
	parameter (nbaldrp = 1000, xlenpar = 30.0, ylenpar = 30.0)
	parameter ( ntot = nbaldrp)   
CC	parameter ( rmin = 0.881, rmax = 2.9871, sticky = .false.)
	parameter ( rmin = 1.00, rmax = 2.00, sticky = .false.)
        common /ccl/ ldrop,lrol1,lrol2,lcon3,lstable,LSTSTK,TROUBLE
	common /cund/ iu(3), xu(3,3), nu
	common /chit/ ih, chh, xh(3), xhh
	common /cnew/ rn, xn(3)
	common /cstk/ ns, rs(ntot), xs(3,ntot), xlen(2)	 
	common /crol/ cph, cth, sph, sth, xc(3)
	common /crom/ chmax, chst, rcton, rcton2
	common /cron/ xax(3), xcton(3), xou(3), xup(3)
	common /cenr/ menrol, mhrol, xnen(3)
	common /ctar/ xt(3)
	common /cran/ kdum
	common /cpi/ pio2,c2pi
C	print *, 'rol1 from', xn
C	print *, 'nu(rol1)', nu, (iu(ku), (xu(k,ku),k=1,3),ku = 1,nu)
	lrol1 = .false.
	do k = 1,3	
	  xc(k) = xu(k,1)
	end do 
	do k = 1,3
	  xcton(k) = xn(k) - xc(k)
	end do

	TTT1 = ABS( XCTON(1) )
	TTT2 = ABS( XCTON(2) )
	IF (TTT1 .LT. 0.00001 .AND. TTT2 .LT. 0.00001) THEN
	  TROUBLE = .TRUE.
c         TYPE 99
          write(*,*)'***'
	  RETURN
	END IF	
c 99	FORMAT(2X,'TROUBLE at ATAN in ROL1')

	phi = atan2(xcton(1), -xcton(2))
	sph = sin(phi)
	cph = cos(phi)
	xou(1) = sph		
	xou(2) = -cph
	cth = 0.0	
	sth = 1.0
	xctonou = sph*xcton(1) - cph*xcton(2)	
	rcton = rn + rs(iu(1))
	rcton2 = rcton**2

	TEST1 = XCTONOU/RCTON
	ATEST1 = ABS(TEST1)
	IF(ATEST1 .GT. 1.000) THEN
	  TROUBLE = .TRUE.
c         TYPE 101
          write(*,*)'  We have hit TROUBLE at TEST1'
	  RETURN
	ENDIF

100	FORMAT(2X,'ROUNDOFF ERROR AT TEST1')
c 101	FORMAT(2X,'We have hit TROUBLE at TEST1')

 1000	CHST = ASIN(TEST1)		
C	chst = asin(xctonou/rcton)
	if(rn .gt. xu(3,1)) then
	  menrol = 1
	  chmax = acos((rn - xc(3))/(rcton*sth))
	  xnen(3) = rn
	else				
	  menrol = 2			
	  chmax = pio2
	  xnen(3) = min(xn(3),xu(3,1))	
	endif
	mhrol = 4		
	call roll
	return
	end

CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
	subroutine rol2
c       include 'comm.for'
c       Subject: common block for sphere packing program
c       Status: RO
c
C       comm.for
	implicit real*4 (a-h,o-z)
	logical ldrop, lrol1, lrol2, lcon3, lstable, lststk, stick   
	LOGICAL TROUBLE,sticky
	parameter (nbaldrp = 1000, xlenpar = 30.0, ylenpar = 30.0)
	parameter ( ntot = nbaldrp)   
CC	parameter ( rmin = 0.881, rmax = 2.9871, sticky = .false.)
	parameter ( rmin = 1.00, rmax = 2.00, sticky = .false.)
	common /ccl/ ldrop,lrol1,lrol2,lcon3,lstable,LSTSTK,TROUBLE
	common /cund/ iu(3), xu(3,3), nu
	common /chit/ ih, chh, xh(3), xhh
	common / cnew/ rn, xn(3)
	common /cstk/ ns, rs(ntot), xs(3,ntot), xlen(2)	 
	common /crol/ cph, cth, sph, sth, xc(3)
	common /crom/ chmax, chst, rcton, rcton2
	common /cron/ xax(3), xcton(3), xou(3), xup(3)
	common /cenr/menrol, mhrol, xnen(3)
	common /ctar/ xt(3)
	common /cran/ kdum
	common /cpi/ pio2,c2pi
C	print *, 'rol2 from', xn
C	print *, 'nu(rol2)',nu, (iu(ku),(xu(k,ku),k=1,3),ku=1,nu)
	lrol2 = .false.
	if(xu(3,2) .lt. xu(3,1)) then		
	  item = iu(1)
	  iu(1) = iu(2)
	  iu(2) = item
	  do k = 1,3
	    xtem = xu(k,1)
	    xu(k,1) = xu(k,2)
	    xu(k,2) = xtem
	  end do
	end if
	rax2 = 0.0			
	do k = 1,3
	  xax(k) = xu(k,2) - xu(k,1)
	  rax2 = rax2 + xax(k)**2
	end do
	rax = sqrt(rax2)
	do k = 1,3
	  xax(k) = xax(k)/rax
	end do
	cth = xax(3)
	sth = sqrt(1.0 - cth**2)
	cph = xax(1)/sth
	sph = xax(2)/sth
	alph = (0.5)*(1.0 + ((rn + rs(iu(1)))**2 - (rn + rs(iu(2)))**2)/rax2)
	do k = 1,3	
	  xc(k) = (1.0 - alph)*xu(k,1) + alph*xu(k,2)
	  xcton(k) = xn(k) - xc(k)
	end do
	xou(1) = sph		
	xou(2) = -cph
	xctonou = xou(1)*xcton(1) + xou(2)*xcton(2)
	if(xctonou .lt. 0.0) then
	  xou(1) = -xou(1)
	  xou(2) = -xou(2)
	  xctonou = -xctonou  
	end if
	rcton2 = 0.0
	do k = 1,3
	  rcton2 = rcton2 + xcton(k)**2
	end do
	rcton = sqrt(rcton2)

	TEST2 = XCTONOU/RCTON
	ATEST2 = ABS(TEST2)
	IF(ATEST2 .GT. 1.000) THEN
	  TROUBLE = .TRUE.
c         TYPE 103
          write(*,*)'We have hit TROUBLE at TEST2'
	  RETURN
	ENDIF

102	FORMAT(2X,'ROUNDOFF ERROR AT TEST2')
c 103	FORMAT(2X,'We have hit TROUBLE at TEST2')

 2000	CHST = ASIN(TEST2)

C	chst = asin(xctonou/rcton)
	xnum = rcton*cth
	xden = alph*rax*sth

	IF(XNUM/XDEN .LT. -1.0) THEN
c         TYPE 104
          write(*,*)'  We have hit TROUBLE!!!'
	  TROUBLE = .TRUE.
	  RETURN
	END IF
c 104	FORMAT(2X,'We have hit TROUBLE!!!')

	chmax = acos(min(xnum/xden, 1.0))	
					
	if(chmax .le. chst) then
	  lrol1 = .true.
	  nu = 1
	  return
	end if
	xnen(3) = xc(3) + rcton*(xnum/xden)*sth	
			
	if(xnen(3) .lt. rn) then		
	  menrol = 1
	  chmax = acos((rn - xc(3))/(rcton*sth))
	  xnen(3) = rn
	else
	  if(xu(3,2) .eq. xu(3,1)) then		
	    menrol = 2
	  else					
	    menrol = 3
	  end if
	endif
	mhrol = 5				
	call roll
	return
	end

CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	subroutine endbal
C       include 'comm.for'
c       Subject: common block for sphere packing program
c       Status: RO
c
C       comm.for
	implicit real*4 (a-h,o-z)
	logical ldrop, lrol1, lrol2, lcon3, lstable, lststk, stick   
	LOGICAL TROUBLE,sticky
	parameter (nbaldrp = 1000, xlenpar = 30.0, ylenpar = 30.0)
	parameter ( ntot = nbaldrp)   
CC	parameter ( rmin = 0.881, rmax = 2.9871, sticky = .false.)
	parameter ( rmin = 1.00, rmax = 2.00, sticky = .false.)
	common /ccl/ ldrop,lrol1,lrol2,lcon3,lstable,LSTSTK,TROUBLE
	common /cund/ iu(3), xu(3,3), nu
	common /chit/ ih, chh, xh(3), xhh
	common /cnew/ rn, xn(3)
	common /cstk/ ns, rs(ntot), xs(3,ntot), xlen(2)	 
	common /crol/ cph, cth, sph, sth, xc(3)
	common /crom/ chmax, chst, rcton, rcton2
	common /cron/ xax(3), xcton(3), xou(3), xup(3)
	common /cenr/ menrol, mhrol, xnen(3)
	common /ctar/ xt(3)
	common /cran/ kdum
	common /cpi/ pio2,c2pi
C	call dchk
	ns = ns + 1
	do k=1,3
	  xs(k,ns) = xn(k)
	end do
	rs(ns) = rn
	return
	end

CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
C	subroutine dchk
C	include 'comm.for'
C	do is=1,ns
C	  r2min=(rn+rs(is))**2
C	  d2t=(xn(3)-xs(3,is))**2
C	  if (d2t.lt.r2min) then
C	    do ix=-1,1
C	      d2x=d2t+(xn(1)-xs(1,is)-ix*xlen(1))**2
C	      if(d2x.lt.r2min) then
C	        do iy=-1,1
C	          if((xn(2)-xs(2,is)-iy*xlen(2))**2+d2x.lt.r2min-5.e-6)
C    1               print *,'too close',is,ix,iy,
C    2               (xn(2)-xs(2,is)-iy*xlen(2))**2+d2x,r2min
C	        end do
C	      end if
C	    end do
C	  end if
C	end do
C	return
C	end

CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	subroutine roll
c       include 'comm.for'
c       Subject: common block for sphere packing program
c       Status: RO
c
C       comm.for
	implicit real*4 (a-h,o-z)
	logical ldrop, lrol1, lrol2, lcon3, lstable, lststk, stick   
	LOGICAL TROUBLE,sticky
	parameter (nbaldrp = 1000, xlenpar = 30.0, ylenpar = 30.0)
	parameter ( ntot = nbaldrp)   
CC	parameter ( rmin = 0.881, rmax = 2.9871, sticky = .false.)
	parameter ( rmin = 1.00, rmax = 2.00, sticky = .false.)
	common /ccl/ ldrop,lrol1,lrol2,lcon3,lstable,LSTSTK,TROUBLE
	common /cund/ iu(3), xu(3,3), nu
	common /chit/ ih, chh, xh(3), xhh
	common /cnew/ rn, xn(3)
	common /cstk/ ns, rs(ntot), xs(3,ntot), xlen(2)	 
	common /crol/ cph, cth, sph, sth, xc(3)
	common /crom/ chmax, chst, rcton, rcton2
	common /cron/ xax(3), xcton(3), xou(3), xup(3)
	common /cenr/ menrol, mhrol, xnen(3)
	common /ctar/ xt(3)
	common /cran/ kdum
	common /cpi/ pio2,c2pi
	logical ldiff
	dimension xctot(3)			
	xou(3)=0.		
	xup(1)=-cph*cth
	xup(2)=-sph*cth
	xup(3)=sth
	ih=0				
	chh=chmax 				
	do k=1,2 
	  xnen(k)=xc(k)+rcton*(cos(chmax)*xup(k)+sin(chmax)*xou(k))
	end do
	do is=ns,1,-1
	  if(xs(3,is)+rs(is)+rn.gt.xnen(3).and.
     1    xs(3,is)-rs(is)-rcton.lt.xc(3)) then
	    pmx=rcton+rn+rs(is)			
	    xt(3)=xs(3,is)
	    xctot(3)=xt(3)-xc(3)
	    do ix=-1,1				
	      xt(1)=xs(1,is)+ix*xlen(1)
	      xctot(1)=xt(1)-xc(1)
	      do iy=-1,1
	        xt(2)=xs(2,is)+iy*xlen(2)
		ldiff=.true. 			
	        do ku=1,nu
	          if(iu(ku) .eq. is .and.
     1 		  abs(xt(1)-xu(1,ku)) .lt. (0.5)*xlen(1) .and.
     2            abs(xt(2)-xu(2,ku)) .lt. (0.5)*xlen(2)) ldiff=.false.
	        end do
	        xctot(2)=xt(2)-xc(2)
	        xctotou=xou(1)*xctot(1)+xou(2)*xctot(2)
	        xctott=cph*xctot(1)+sph*xctot(2)
	        xctotax=sth*xctott+cth*xctot(3)
	        if(ldiff .and. abs(xctotou) .lt. pmx
     1		   .and. abs(xctotax) .lt. rn+rs(is)) then
	          xctotup=-cth*xctott+sth*xctot(3)
	          xctotp2=xctotou**2+xctotup**2
	          xctotuo=sqrt(xctotp2)
 	          rctot2=xctotp2+xctotax**2
	          xnum=rctot2+rcton2-(rn+rs(is))**2
	          xden=2.*rcton*xctotuo
		  if(abs(xnum).lt.xden) then			
		    cht=mod(atan2(xctotou,xctotup)+c2pi,c2pi)
     1  	    -acos(xnum/xden)
		    if(cht.lt.chh.and.cht.gt.chst) then
		      xhh=xc(3)+rcton*cos(chh)*sth
		      if(xhh.lt.xn(3)) then	
		        ih=is
			chh=cht
			do k=1,3
			  xh(k)=xt(k)
		  	  xnen(k)= xc(k) + rcton*(cos(chh)*xup(k)
     1  			 + sin(chh)*xou(k))
			end do
		      end if
		    end if
		  end if
		end if
	      end do
	    end do
 	  end if
	end do
	do k=1,3				
	  xn(k)=xnen(k)
	end do
	if(ih .eq. 0) then			
	  nu=0
	  if(menrol .eq. 1) then
	    lstable=.true.
C	    print*,'roll to floor'
	  else if (menrol .eq. 2) then
	    ldrop = .true.
C	    print*, 'roll to edge of ball'
C	    print*, 'drop from',xn
	  else if(menrol .eq. 3) then
	    lrol1=.true.
	    nu=1
C	    print*, 'rol2 to rol1'
	  end if
	else
	if(mhrol .eq. 4) then		
	  if((xn(1)-xc(1))*(xh(1)-xc(1)) +
     1       (xn(2)-xc(2))*(xh(2)-xc(2)) .lt.
     2       (xh(1)-xc(1))**2 + (xh(2)-xc(2))**2) then
	    lrol2 = .true.
	  else
	    nu=0
	    lrol1 = .true.
	  end if
	else if(mhrol .eq. 5) then	
	  lcon3=.true.
	end if
	nu = nu+1				
	iu(nu)=ih
C	print*,nu,(iu(ku),ku=1,nu)
	do k=1,3
	  xu(k,nu)=xh(k)
	end do
	end if
	do k=1,2 			
	  if(xn(k) .lt. 0.0) then
	    xn(k)=xn(k)+xlen(k)
	    do ku=1,nu
	      xu(k,ku)=xu(k,ku)+xlen(k)
	    end do
	  else if(xn(k).gt.xlen(k))then
	    xn(k)=xn(k)-xlen(k)
	    do ku=1,nu
	      xu(k,ku)=xu(k,ku)-xlen(k)
	    end do
	  end if
	end do
	return
	end

CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	subroutine con3				
c       include 'comm.for'
c       Subject: common block for sphere packing program
c       Status: RO
c
C       comm.for
	implicit real*4 (a-h,o-z)
	logical ldrop, lrol1, lrol2, lcon3, lstable, lststk, stick   
	LOGICAL TROUBLE,sticky
	parameter (nbaldrp = 1000, xlenpar = 30.0, ylenpar = 30.0)
	parameter ( ntot = nbaldrp)   
CC	parameter ( rmin = 0.881, rmax = 2.9871, sticky = .false.)
	parameter ( rmin = 1.00, rmax = 2.00, sticky = .false.)
	common /ccl/ ldrop,lrol1,lrol2,lcon3,lstable,LSTSTK,TROUBLE
	common /cund/ iu(3), xu(3,3), nu
	common /chit/ ih, chh, xh(3), xhh
	common / cnew/ rn, xn(3)
	common /cstk/ ns, rs(ntot), xs(3,ntot), xlen(2)	 
	common /crol/ cph, cth, sph, sth, xc(3)
	common /crom/ chmax, chst, rcton, rcton2
	common /cron/ xax(3), xcton(3), xou(3), xup(3)
	common /cenr/menrol, mhrol, xnen(3)
	common /ctar/ xt(3)
	common /cran/ kdum
	common /cpi/ pio2,c2pi
	dimension xopp(2,2),sg(2)
	lcon3=.false.
C	print*, 'nu(con3)',nu,(iu(ku),(xu(k,ku),k=1,3),ku=1,nu)
	do k=1,2
	  xopp(k,1)=xu(k,3)-xu(k,2)
	  xopp(k,2)=xu(k,3)-xu(k,1)
	end do
	do jopp=1,2 					
	  phi=atan2(xopp(2,jopp),xopp(1,jopp))
	  sphp=sin(phi)
	  cphp=cos(phi)
	  xstd=-sphp*xopp(1,3-jopp)+cphp*xopp(2,3-jopp)
	  if(xstd .lt. 0.0) then
	    sphp=-sphp
	    cphp=-cphp
	    xstd=-xstd
	  end if
	  sg(jopp) = sign(1.0,-(xn(1)-xu(1,jopp))*sphp
     1                        +(xn(2)-xu(2,jopp))*cphp - xstd)
	end do
	if(sg(1) .eq. -1.0 .and. sg(2) .eq. -1.0) then
	  lstable = .true.
	else
	  if(sg(1) .eq. 1.0 .and. sg(2) .eq. 1.0) then
	    if(cph*(xu(1,3)-xc(1)) + sph*(xu(2,3)-xc(2)) .gt. 0.0) then
	      sg(1) = -1.0
	    end if
	  end if
	  nu = 2  				
	  lrol2 = .true.
	  if(sg(1) .eq. 1.0) then 		
	    iu(1)=iu(2)
	    do k=1,3
	      xu(k,1)=xu(k,2)
	    end do
	  end if 				
	iu(2)=iu(3)
	do k=1,3
	  xu(k,2)=xu(k,3)
	end do
	end if
	return
	end

      FUNCTION RAN(IDUM)
C         IMPLICIT REAL*4(M)
C         PARAMETER (MBIG=4000000.,MSEED=1618033.,MZ=0.,FAC=2.5E-7)
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1.E-9)
      DIMENSION MA(55)
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
        IFF=1
        MJ=MSEED-IABS(IDUM)
        MJ=MOD(MJ,MBIG)
        MA(55)=MJ
        MK=1
        DO 11 I=1,54
          II=MOD(21*I,55)
          MA(II)=MK
          MK=MJ-MK
          IF(MK.LT.MZ)MK=MK+MBIG
          MJ=MA(II)
 11      CONTINUE
        DO 13 K=1,4
          DO 12 I=1,55
            MA(I)=MA(I)-MA(1+MOD(I+30,55))
            IF(MA(I).LT.MZ)MA(I)=MA(I)+MBIG
 12        CONTINUE
 13      CONTINUE
        INEXT=0
        INEXTP=31
        IDUM=1
      ENDIF
      INEXT=INEXT+1
      IF(INEXT.EQ.56)INEXT=1
      INEXTP=INEXTP+1
      IF(INEXTP.EQ.56)INEXTP=1
      MJ=MA(INEXT)-MA(INEXTP)
      IF(MJ.LT.MZ)MJ=MJ+MBIG
      MA(INEXT)=MJ
      RAN=MJ*FAC
      RETURN
      END
